*** WeiDU-185/obj-tk/x86_LINUX/dparser.ml	1970-01-01 01:00:00.000000000 +0100
--- WeiDU/obj-tk/x86_LINUX/dparser.ml	2007-07-16 21:49:57.000000000 +0200
***************
*** 0 ****
--- 1,1953 ----
+ type token =
+   | ADD_STATE_TRIGGER
+   | ADD_TRANS_TRIGGER
+   | ADD_TRANS_ACTION
+   | APPEND
+   | APPEND_EARLY
+   | APPENDI
+   | BEGIN
+   | BRANCH
+   | CHAIN2
+   | CHAIN3
+   | COPY_TRANS
+   | DO
+   | END
+   | EQUALS
+   | EQUALSEQUALS
+   | EXIT
+   | EXTEND_BOTTOM
+   | EXTEND_BOTTOM_REGEXP
+   | EXTEND_TOP
+   | EXTEND_TOP_REGEXP
+   | EXTERN
+   | FLAGS
+   | GOTO
+   | IF
+   | IF_FILE_EXISTS
+   | INTERJECT
+   | INTERJECT_COPY_TRANS
+   | INTERJECT_COPY_TRANS2
+   | INTERJECT_COPY_TRANS3
+   | INTERJECT_COPY_TRANS4
+   | JOURNAL
+   | SOLVED_JOURNAL
+   | UNSOLVED_JOURNAL
+   | PLUS
+   | REPLACE
+   | REPLACE_ACTION_TEXT
+   | REPLACE_ACTION_TEXT_PROCESS
+   | REPLACE_ACTION_TEXT_REGEXP
+   | REPLACE_ACTION_TEXT_PROCESS_REGEXP
+   | REPLACE_SAY
+   | REPLACE_STATE_TRIGGER
+   | REPLACE_TRANS_ACTION
+   | REPLACE_TRIGGER_TEXT
+   | REPLACE_TRIGGER_TEXT_REGEXP
+   | REPLY
+   | SAY
+   | SET_WEIGHT
+   | STRING_CONCAT
+   | THEN
+   | WEIGHT
+   | EOF
+   | SOUND of (string)
+   | STRING of (string)
+   | INLINED_FILE of (string * string)
+   | STRING_REF of (int)
+   | TRANS_REF of (int)
+   | FORCED_STRING_REF of (int)
+ 
+ open Parsing;;
+ # 2 "src/dparser.mly"
+ 
+ open Util
+ open Load
+ 
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.dparser.mly.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
+ (*** input handle ***)
+ 
+ let current_unit = ref None
+ 
+ (*** Error handling ***)
+ let parse_error = Util.parse_error
+ 
+ let get_current_unit () = match !current_unit with
+   Some(s) -> s
+ | None -> parse_error "No current unit (use BEGIN)" 
+ 
+ type trans_opt_type =
+     Trans_Reply of Dlg.tlk_string option
+   | Trans_Do of string option
+   | Trans_Journal of (Dlg.journal_type * Dlg.tlk_string) option
+   | Trans_Flags of int
+ 
+ let extra_actions = ref []
+ 
+ let verify_trigger_list s =
+   let con = the_context () in
+   let filename = (Printf.sprintf "trigger list near line %d, column %d of %s"
+     con.line con.col con.filename) in
+   let lexbuf = lex_init_from_internal_string filename s in
+   let lexbuf = Lexing.from_string (String.copy s) in
+   let result = try
+     let res = Bafparser.trigger_list Baflexer.initial lexbuf in
+     let buff = Buffer.create (String.length s) in
+     Bcs.print_script_text (the_game()) (Bcs.Save_BCS_Buffer(buff))
+         (Bcs.BCS_Print_TriggerList(res)) false None ;
+     let result = Buffer.contents buff in
+     result
+   with e ->
+     log_and_print "WARNING: cannot verify trigger ~%s~: %s\n" s
+       (Printexc.to_string e) ;
+     s
+   in 
+   pop_context () ;
+   result  
+ 
+ let verify_action_list s =
+   let con = the_context () in 
+   let filename = (Printf.sprintf "action list near line %d, column %d of %s"
+     con.line con.col con.filename) in 
+   let lexbuf = lex_init_from_internal_string filename s in
+   let result = try 
+     let res = Bafparser.action_list Baflexer.initial lexbuf in
+     let buff = Buffer.create (String.length s) in
+     Bcs.print_script_text (the_game()) (Bcs.Save_BCS_Buffer(buff))
+         (Bcs.BCS_Print_ActionList(res)) false None ;
+     Buffer.contents buff 
+   with e ->
+     log_and_print "WARNING: cannot verify action ~%s~: %s\n" s
+       (Printexc.to_string e) ;
+     s
+   in
+   pop_context () ;
+   (*
+   (if result = "" then begin
+     let warn = con.warn_only in
+     con.warn_only <- true ;
+     (try parse_error "Empty Action (may confuse some utilities, like NI)"
+     with _ -> () ) ;
+     con.warn_only <- warn
+   end) ;
+   *)
+   result
+ 
+ # 143 "src/dparser.ml"
+ let yytransl_const = [|
+   257 (* ADD_STATE_TRIGGER *);
+   258 (* ADD_TRANS_TRIGGER *);
+   259 (* ADD_TRANS_ACTION *);
+   260 (* APPEND *);
+   261 (* APPEND_EARLY *);
+   262 (* APPENDI *);
+   263 (* BEGIN *);
+   264 (* BRANCH *);
+   265 (* CHAIN2 *);
+   266 (* CHAIN3 *);
+   267 (* COPY_TRANS *);
+   268 (* DO *);
+   269 (* END *);
+   270 (* EQUALS *);
+   271 (* EQUALSEQUALS *);
+   272 (* EXIT *);
+   273 (* EXTEND_BOTTOM *);
+   274 (* EXTEND_BOTTOM_REGEXP *);
+   275 (* EXTEND_TOP *);
+   276 (* EXTEND_TOP_REGEXP *);
+   277 (* EXTERN *);
+   278 (* FLAGS *);
+   279 (* GOTO *);
+   280 (* IF *);
+   281 (* IF_FILE_EXISTS *);
+   282 (* INTERJECT *);
+   283 (* INTERJECT_COPY_TRANS *);
+   284 (* INTERJECT_COPY_TRANS2 *);
+   285 (* INTERJECT_COPY_TRANS3 *);
+   286 (* INTERJECT_COPY_TRANS4 *);
+   287 (* JOURNAL *);
+   288 (* SOLVED_JOURNAL *);
+   289 (* UNSOLVED_JOURNAL *);
+   290 (* PLUS *);
+   291 (* REPLACE *);
+   292 (* REPLACE_ACTION_TEXT *);
+   293 (* REPLACE_ACTION_TEXT_PROCESS *);
+   294 (* REPLACE_ACTION_TEXT_REGEXP *);
+   295 (* REPLACE_ACTION_TEXT_PROCESS_REGEXP *);
+   296 (* REPLACE_SAY *);
+   297 (* REPLACE_STATE_TRIGGER *);
+   298 (* REPLACE_TRANS_ACTION *);
+   299 (* REPLACE_TRIGGER_TEXT *);
+   300 (* REPLACE_TRIGGER_TEXT_REGEXP *);
+   301 (* REPLY *);
+   302 (* SAY *);
+   303 (* SET_WEIGHT *);
+   304 (* STRING_CONCAT *);
+   305 (* THEN *);
+   306 (* WEIGHT *);
+     0 (* EOF *);
+     0|]
+ 
+ let yytransl_block = [|
+   307 (* SOUND *);
+   308 (* STRING *);
+   309 (* INLINED_FILE *);
+   310 (* STRING_REF *);
+   311 (* TRANS_REF *);
+   312 (* FORCED_STRING_REF *);
+     0|]
+ 
+ let yylhs = "\255\255\
+ \001\000\010\000\010\000\004\000\004\000\005\000\005\000\032\000\
+ \032\000\026\000\026\000\027\000\027\000\028\000\028\000\007\000\
+ \007\000\029\000\029\000\006\000\033\000\034\000\034\000\035\000\
+ \036\000\037\000\037\000\008\000\009\000\009\000\009\000\009\000\
+ \011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
+ \011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
+ \011\000\011\000\011\000\011\000\011\000\018\000\018\000\041\000\
+ \041\000\040\000\040\000\040\000\040\000\040\000\038\000\038\000\
+ \019\000\019\000\039\000\039\000\039\000\039\000\012\000\012\000\
+ \016\000\016\000\042\000\042\000\043\000\043\000\044\000\013\000\
+ \013\000\013\000\031\000\017\000\017\000\017\000\021\000\021\000\
+ \014\000\014\000\024\000\024\000\024\000\024\000\024\000\024\000\
+ \025\000\025\000\045\000\046\000\046\000\015\000\015\000\015\000\
+ \023\000\023\000\023\000\023\000\023\000\047\000\047\000\020\000\
+ \020\000\020\000\020\000\020\000\022\000\022\000\002\000\002\000\
+ \003\000\030\000\030\000\030\000\000\000\000\000\000\000"
+ 
+ let yylen = "\002\000\
+ \001\000\000\000\002\000\002\000\003\000\002\000\003\000\002\000\
+ \003\000\000\000\002\000\000\000\002\000\000\000\002\000\004\000\
+ \004\000\000\000\001\000\002\000\005\000\000\000\002\000\006\000\
+ \005\000\004\000\005\000\004\000\004\000\004\000\004\000\004\000\
+ \002\000\003\000\003\000\003\000\003\000\004\000\001\000\001\000\
+ \001\000\009\000\010\000\004\000\004\000\003\000\003\000\004\000\
+ \004\000\005\000\005\000\005\000\005\000\003\000\005\000\000\000\
+ \002\000\003\000\003\000\003\000\001\000\002\000\000\000\004\000\
+ \003\000\000\000\000\000\004\000\005\000\006\000\000\000\002\000\
+ \000\000\002\000\000\000\001\000\000\000\001\000\001\000\010\000\
+ \003\000\007\000\002\000\001\000\003\000\003\000\001\000\003\000\
+ \000\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
+ \000\000\002\000\001\000\001\000\000\000\005\000\006\000\003\000\
+ \002\000\002\000\003\000\004\000\001\000\001\000\003\000\002\000\
+ \004\000\001\000\001\000\002\000\000\000\001\000\000\000\004\000\
+ \001\000\000\000\004\000\005\000\002\000\002\000\002\000"
+ 
+ let yydefred = "\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\125\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\001\000\000\000\000\000\039\000\
+ \041\000\040\000\000\000\000\000\126\000\000\000\127\000\121\000\
+ \000\000\000\000\000\000\000\000\006\000\000\000\008\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\033\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\003\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\000\
+ \009\000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \083\000\000\000\000\000\072\000\000\000\034\000\037\000\000\000\
+ \099\000\000\000\100\000\000\000\036\000\090\000\000\000\000\000\
+ \000\000\000\000\000\000\061\000\000\000\046\000\047\000\035\000\
+ \000\000\000\000\000\000\114\000\115\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\074\000\000\000\000\000\
+ \026\000\011\000\019\000\017\000\016\000\028\000\029\000\030\000\
+ \031\000\032\000\000\000\000\000\000\000\000\000\038\000\000\000\
+ \000\000\048\000\049\000\044\000\000\000\079\000\000\000\081\000\
+ \104\000\076\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\062\000\000\000\065\000\045\000\000\000\116\000\000\000\
+ \000\000\118\000\000\000\120\000\000\000\123\000\025\000\000\000\
+ \000\000\064\000\027\000\000\000\050\000\051\000\052\000\053\000\
+ \021\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \068\000\060\000\058\000\059\000\111\000\057\000\000\000\000\000\
+ \124\000\000\000\024\000\000\000\015\000\000\000\000\000\000\000\
+ \000\000\078\000\000\000\092\000\096\000\093\000\094\000\095\000\
+ \091\000\098\000\109\000\000\000\000\000\000\000\102\000\000\000\
+ \000\000\069\000\055\000\113\000\023\000\000\000\000\000\000\000\
+ \000\000\085\000\086\000\000\000\000\000\000\000\105\000\106\000\
+ \103\000\070\000\013\000\000\000\000\000\082\000\000\000\000\000\
+ \107\000\042\000\000\000\000\000\000\000\108\000\043\000\000\000\
+ \000\000\088\000\080\000"
+ 
+ let yydgoto = "\004\000\
+ \030\000\045\000\047\000\031\000\032\000\033\000\034\000\035\000\
+ \036\000\037\000\038\000\080\000\081\000\088\000\089\000\108\000\
+ \227\000\097\000\098\000\228\000\045\001\211\000\015\001\236\000\
+ \237\000\112\000\023\001\221\000\172\000\048\000\082\000\039\000\
+ \040\000\251\000\041\000\042\000\043\000\058\000\092\000\150\000\
+ \209\000\195\000\003\001\191\000\138\000\140\000\160\000"
+ 
+ let yysindex = "\103\000\
+ \115\255\225\254\238\254\000\000\244\254\247\254\015\255\242\254\
+ \245\254\028\255\055\255\032\255\041\255\046\255\056\255\062\255\
+ \072\255\077\255\084\255\094\255\095\255\096\255\097\255\113\255\
+ \114\255\125\255\126\255\134\255\136\255\000\000\091\255\091\255\
+ \091\255\044\255\027\255\027\255\000\000\115\255\091\255\000\000\
+ \000\000\000\000\144\255\177\255\000\000\138\255\000\000\000\000\
+ \141\255\142\255\190\255\146\255\000\000\154\255\000\000\164\255\
+ \155\255\248\254\170\255\170\255\171\255\172\255\173\255\175\255\
+ \176\255\000\000\178\255\179\255\180\255\181\255\182\255\183\255\
+ \206\255\184\255\186\255\187\255\188\255\189\255\155\255\000\000\
+ \091\255\091\255\207\255\208\255\191\255\192\255\193\255\213\255\
+ \044\255\194\255\249\254\110\255\216\255\000\000\229\255\195\255\
+ \027\255\147\255\147\255\196\255\197\255\199\255\170\255\000\000\
+ \000\000\000\000\198\255\201\255\203\255\204\255\170\255\200\255\
+ \200\255\205\255\214\255\223\255\225\255\230\255\251\255\253\255\
+ \254\255\255\255\147\255\003\000\170\255\010\000\013\000\020\000\
+ \000\000\024\000\029\000\000\000\235\255\000\000\000\000\052\000\
+ \000\000\057\000\000\000\071\000\000\000\000\000\100\000\058\000\
+ \144\255\065\000\002\255\000\000\068\000\000\000\000\000\000\000\
+ \057\000\110\255\061\000\000\000\000\000\147\255\117\000\080\000\
+ \225\254\084\000\170\255\170\255\146\000\000\000\120\000\108\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\126\000\126\000\126\000\126\000\000\000\170\255\
+ \167\000\000\000\000\000\000\000\147\255\000\000\057\000\000\000\
+ \000\000\000\000\050\255\147\255\027\255\144\255\027\255\133\000\
+ \161\000\000\000\164\000\000\000\000\000\169\000\000\000\170\000\
+ \209\000\000\000\169\000\000\000\042\255\000\000\000\000\213\000\
+ \220\000\000\000\000\000\126\000\000\000\000\000\000\000\000\000\
+ \000\000\221\000\216\000\059\255\223\000\180\000\186\000\147\255\
+ \147\255\147\255\147\255\050\255\016\255\050\255\226\000\027\255\
+ \000\000\000\000\000\000\000\000\000\000\000\000\144\255\080\000\
+ \000\000\170\255\000\000\188\000\000\000\188\000\200\000\147\255\
+ \147\255\000\000\203\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\250\254\204\000\205\000\000\000\016\255\
+ \027\255\000\000\000\000\000\000\000\000\188\000\245\000\246\000\
+ \208\000\000\000\000\000\217\000\210\000\219\000\000\000\000\000\
+ \000\000\000\000\000\000\222\000\224\000\000\000\147\255\225\000\
+ \000\000\000\000\227\000\005\001\044\255\000\000\000\000\147\255\
+ \009\001\000\000\000\000"
+ 
+ let yyrindex = "\000\000\
+ \025\002\027\002\028\002\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\252\254\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\206\001\016\001\
+ \016\001\017\001\174\255\019\001\000\000\025\002\016\001\000\000\
+ \000\000\000\000\156\255\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\001\
+ \125\255\000\000\255\254\255\254\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\125\255\000\000\
+ \054\001\016\001\000\000\000\000\000\000\000\000\004\001\000\000\
+ \102\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \174\255\000\000\000\000\000\000\000\000\000\000\026\001\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\207\000\078\255\
+ \078\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\026\001\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\054\255\000\000\000\000\000\000\000\000\000\000\000\000\
+ \156\255\000\000\253\001\000\000\000\000\000\000\000\000\000\000\
+ \163\255\000\000\001\000\000\000\000\000\000\000\159\255\056\000\
+ \027\002\028\002\052\002\157\001\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\099\002\099\002\099\002\099\002\000\000\052\002\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\255\000\000\
+ \000\000\000\000\148\255\000\000\019\001\156\255\174\255\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \168\255\000\000\111\000\000\000\028\002\000\000\000\000\147\002\
+ \000\000\000\000\000\000\099\002\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\027\001\001\001\000\000\000\000\000\000\
+ \000\000\000\000\000\000\148\255\000\000\148\255\000\000\174\255\
+ \000\000\000\000\000\000\000\000\000\000\000\000\156\255\160\000\
+ \000\000\052\002\000\000\028\001\000\000\028\001\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \174\255\000\000\000\000\000\000\000\000\028\001\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\079\255\017\001\000\000\000\000\000\000\
+ \000\000\000\000\000\000"
+ 
+ let yygindex = "\000\000\
+ \000\000\155\001\000\000\000\000\000\000\000\000\000\000\000\000\
+ \000\000\024\002\000\000\239\255\000\000\169\255\000\000\240\001\
+ \127\255\116\255\000\000\161\255\018\001\073\001\052\001\000\000\
+ \153\255\202\255\029\255\105\255\212\001\102\255\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\220\255\172\001\
+ \000\000\112\255\000\000\000\000\000\000\000\000\070\255"
+ 
+ let yytablesize = 962
+ let yytable = "\093\000\
+ \110\000\142\000\159\000\161\000\199\000\113\000\075\000\214\000\
+ \204\000\010\000\052\000\010\000\085\000\054\000\083\000\084\000\
+ \109\000\144\000\029\001\245\000\063\000\095\000\010\000\044\000\
+ \248\000\086\000\024\001\183\000\222\000\223\000\224\000\011\001\
+ \010\000\046\000\090\000\087\000\012\001\053\000\013\001\049\000\
+ \055\000\091\000\050\000\110\000\145\000\030\001\229\000\063\000\
+ \165\000\014\001\035\001\075\000\010\000\201\000\085\000\117\000\
+ \170\000\240\000\249\000\202\000\154\000\230\000\207\000\132\000\
+ \133\000\075\000\051\000\086\000\253\000\075\000\185\000\231\000\
+ \000\001\001\001\075\000\075\000\075\000\087\000\057\000\056\000\
+ \232\000\233\000\234\000\059\000\075\000\075\000\075\000\075\000\
+ \018\000\087\000\018\000\087\000\060\000\046\000\235\000\100\000\
+ \077\000\061\000\075\000\078\000\238\000\018\000\087\000\001\000\
+ \002\000\003\000\019\001\062\000\215\000\216\000\112\000\018\000\
+ \087\000\063\000\079\000\005\000\006\000\007\000\008\000\009\000\
+ \146\000\010\000\147\000\064\000\011\000\148\000\026\001\027\001\
+ \065\000\225\000\149\000\012\000\010\001\013\000\016\001\066\000\
+ \006\001\007\001\008\001\009\001\014\000\015\000\016\000\017\000\
+ \018\000\067\000\068\000\069\000\070\000\019\000\020\000\021\000\
+ \022\000\023\000\024\000\025\000\026\000\027\000\028\000\117\000\
+ \239\000\029\000\241\000\097\000\071\000\072\000\056\000\096\000\
+ \097\000\056\000\097\000\056\000\056\000\056\000\056\000\054\000\
+ \073\000\074\000\054\000\056\000\054\000\097\000\054\000\054\000\
+ \067\000\075\000\067\000\076\000\054\000\067\000\099\000\100\000\
+ \101\000\102\000\067\000\021\001\103\000\104\000\155\000\044\001\
+ \156\000\157\000\158\000\018\001\107\000\105\000\010\000\066\000\
+ \044\001\066\000\066\000\066\000\125\000\049\001\075\000\106\000\
+ \075\000\075\000\075\000\134\000\135\000\111\000\114\000\115\000\
+ \116\000\141\000\117\000\118\000\151\000\119\000\120\000\121\000\
+ \122\000\123\000\124\000\126\000\034\001\127\000\128\000\129\000\
+ \130\000\152\000\136\000\137\000\139\000\143\000\153\000\192\000\
+ \163\000\162\000\164\000\166\000\167\000\171\000\168\000\169\000\
+ \174\000\110\000\110\000\110\000\110\000\110\000\004\000\110\000\
+ \110\000\175\000\110\000\110\000\110\000\110\000\110\000\110\000\
+ \110\000\110\000\176\000\110\000\177\000\110\000\110\000\110\000\
+ \110\000\178\000\110\000\110\000\110\000\110\000\110\000\110\000\
+ \110\000\110\000\110\000\110\000\110\000\110\000\110\000\110\000\
+ \110\000\110\000\110\000\110\000\110\000\110\000\179\000\110\000\
+ \180\000\181\000\182\000\110\000\110\000\071\000\184\000\110\000\
+ \117\000\117\000\117\000\117\000\117\000\186\000\117\000\117\000\
+ \187\000\117\000\117\000\117\000\117\000\117\000\117\000\117\000\
+ \117\000\188\000\117\000\189\000\117\000\117\000\117\000\117\000\
+ \190\000\117\000\117\000\117\000\117\000\117\000\117\000\117\000\
+ \117\000\117\000\117\000\117\000\117\000\117\000\117\000\117\000\
+ \117\000\117\000\117\000\117\000\117\000\089\000\117\000\193\000\
+ \196\000\194\000\197\000\117\000\206\000\198\000\117\000\112\000\
+ \112\000\112\000\112\000\112\000\200\000\112\000\112\000\203\000\
+ \112\000\112\000\112\000\112\000\112\000\112\000\112\000\112\000\
+ \208\000\112\000\210\000\112\000\112\000\112\000\112\000\213\000\
+ \112\000\112\000\112\000\112\000\112\000\112\000\112\000\112\000\
+ \112\000\112\000\112\000\112\000\112\000\112\000\112\000\112\000\
+ \112\000\112\000\112\000\112\000\010\000\112\000\217\000\219\000\
+ \117\000\117\000\117\000\117\000\117\000\112\000\117\000\117\000\
+ \218\000\117\000\117\000\117\000\117\000\117\000\117\000\117\000\
+ \117\000\220\000\117\000\226\000\117\000\117\000\117\000\117\000\
+ \242\000\117\000\117\000\117\000\117\000\117\000\117\000\117\000\
+ \117\000\117\000\117\000\117\000\117\000\117\000\117\000\117\000\
+ \117\000\117\000\117\000\117\000\117\000\071\000\117\000\010\000\
+ \010\000\010\000\010\000\010\000\243\000\010\000\117\000\244\000\
+ \010\000\010\000\010\000\010\000\155\000\246\000\247\000\010\000\
+ \250\000\010\000\252\000\254\000\255\000\002\001\010\000\004\001\
+ \010\000\010\000\010\000\010\000\010\000\005\001\017\001\022\001\
+ \010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
+ \010\000\010\000\010\000\025\001\089\000\010\000\028\001\031\001\
+ \032\001\036\001\037\001\038\001\010\000\040\001\039\001\004\000\
+ \004\000\004\000\004\000\004\000\004\000\004\000\041\001\004\000\
+ \004\000\042\001\048\001\043\001\046\001\051\001\047\001\004\000\
+ \002\000\004\000\119\000\122\000\071\000\089\000\004\000\067\000\
+ \004\000\004\000\004\000\004\000\004\000\101\000\010\000\084\000\
+ \012\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
+ \004\000\004\000\004\000\010\000\077\000\004\000\071\000\071\000\
+ \071\000\071\000\071\000\212\000\071\000\094\000\131\000\071\000\
+ \020\001\050\001\071\000\033\001\173\000\205\000\071\000\000\000\
+ \071\000\000\000\000\000\000\000\000\000\000\000\000\000\071\000\
+ \071\000\071\000\071\000\071\000\000\000\000\000\000\000\000\000\
+ \071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
+ \071\000\071\000\014\000\000\000\071\000\000\000\089\000\089\000\
+ \089\000\089\000\089\000\000\000\089\000\000\000\000\000\089\000\
+ \000\000\000\000\089\000\000\000\000\000\000\000\089\000\000\000\
+ \089\000\000\000\000\000\000\000\000\000\000\000\000\000\089\000\
+ \089\000\089\000\089\000\089\000\000\000\000\000\000\000\000\000\
+ \089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
+ \089\000\089\000\022\000\000\000\089\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\010\000\010\000\010\000\
+ \010\000\010\000\000\000\010\000\000\000\000\000\010\000\000\000\
+ \010\000\000\000\000\000\000\000\000\000\010\000\000\000\010\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\010\000\010\000\
+ \010\000\010\000\010\000\000\000\000\000\000\000\000\000\010\000\
+ \010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
+ \010\000\000\000\000\000\010\000\000\000\000\000\071\000\071\000\
+ \071\000\071\000\071\000\000\000\071\000\000\000\000\000\071\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\071\000\000\000\
+ \071\000\000\000\000\000\000\000\000\000\000\000\000\000\071\000\
+ \071\000\071\000\071\000\071\000\000\000\000\000\000\000\000\000\
+ \071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
+ \071\000\071\000\000\000\000\000\071\000\089\000\089\000\089\000\
+ \089\000\089\000\000\000\089\000\000\000\000\000\089\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\089\000\000\000\089\000\
+ \000\000\000\000\000\000\000\000\000\000\000\000\089\000\089\000\
+ \089\000\089\000\089\000\000\000\000\000\000\000\000\000\089\000\
+ \089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
+ \089\000\000\000\000\000\089\000\000\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\010\000\010\000\010\000\010\000\
+ \010\000\000\000\010\000\000\000\000\000\010\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\010\000\000\000\010\000\000\000\
+ \000\000\000\000\000\000\000\000\000\000\010\000\010\000\010\000\
+ \010\000\010\000\000\000\000\000\000\000\000\000\010\000\010\000\
+ \010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
+ \000\000\000\000\010\000\014\000\014\000\014\000\014\000\014\000\
+ \000\000\014\000\000\000\000\000\014\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\014\000\000\000\014\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\014\000\014\000\014\000\014\000\
+ \014\000\000\000\000\000\000\000\000\000\014\000\014\000\014\000\
+ \014\000\014\000\014\000\014\000\014\000\014\000\014\000\000\000\
+ \000\000\014\000\000\000\022\000\022\000\022\000\022\000\022\000\
+ \000\000\022\000\000\000\000\000\022\000\000\000\000\000\000\000\
+ \000\000\000\000\000\000\022\000\000\000\022\000\000\000\000\000\
+ \000\000\000\000\000\000\000\000\022\000\022\000\022\000\022\000\
+ \022\000\000\000\000\000\000\000\000\000\022\000\022\000\022\000\
+ \022\000\022\000\022\000\022\000\022\000\022\000\022\000\000\000\
+ \000\000\022\000"
+ 
+ let yycheck = "\036\000\
+ \000\000\089\000\098\000\099\000\145\000\060\000\007\001\162\000\
+ \153\000\011\001\025\001\013\001\011\001\025\001\032\000\033\000\
+ \025\001\025\001\025\001\206\000\025\001\039\000\024\001\055\001\
+ \211\000\024\001\254\000\123\000\180\000\181\000\182\000\016\001\
+ \034\001\052\001\008\001\034\001\021\001\052\001\023\001\052\001\
+ \052\001\015\001\052\001\052\001\052\001\052\001\191\000\052\001\
+ \103\000\034\001\022\001\052\001\054\001\052\001\011\001\000\000\
+ \111\000\198\000\213\000\147\000\097\000\012\001\158\000\081\000\
+ \082\000\012\001\052\001\024\001\220\000\016\001\125\000\022\001\
+ \014\001\015\001\021\001\022\001\023\001\034\001\024\001\052\001\
+ \031\001\032\001\033\001\052\001\031\001\032\001\033\001\034\001\
+ \011\001\011\001\013\001\013\001\052\001\052\001\045\001\054\001\
+ \006\001\052\001\045\001\009\001\196\000\024\001\024\001\001\000\
+ \002\000\003\000\247\000\052\001\163\000\164\000\000\000\034\001\
+ \034\001\052\001\024\001\001\001\002\001\003\001\004\001\005\001\
+ \011\001\007\001\013\001\052\001\010\001\016\001\000\001\001\001\
+ \052\001\184\000\021\001\017\001\236\000\019\001\238\000\052\001\
+ \232\000\233\000\234\000\235\000\026\001\027\001\028\001\029\001\
+ \030\001\052\001\052\001\052\001\052\001\035\001\036\001\037\001\
+ \038\001\039\001\040\001\041\001\042\001\043\001\044\001\000\000\
+ \197\000\047\001\199\000\016\001\052\001\052\001\008\001\024\001\
+ \021\001\011\001\023\001\013\001\014\001\015\001\016\001\008\001\
+ \052\001\052\001\011\001\021\001\013\001\034\001\015\001\016\001\
+ \011\001\052\001\013\001\052\001\021\001\016\001\014\001\054\001\
+ \052\001\052\001\021\001\250\000\007\001\052\001\052\001\039\001\
+ \054\001\055\001\056\001\240\000\050\001\052\001\000\000\052\001\
+ \048\001\054\001\055\001\056\001\007\001\045\001\052\001\052\001\
+ \054\001\055\001\056\001\013\001\013\001\052\001\052\001\052\001\
+ \052\001\013\001\052\001\052\001\013\001\052\001\052\001\052\001\
+ \052\001\052\001\052\001\052\001\017\001\052\001\052\001\052\001\
+ \052\001\013\001\052\001\052\001\052\001\052\001\052\001\013\001\
+ \052\001\054\001\052\001\054\001\052\001\054\001\052\001\052\001\
+ \052\001\001\001\002\001\003\001\004\001\005\001\000\000\007\001\
+ \008\001\052\001\010\001\011\001\012\001\013\001\014\001\015\001\
+ \016\001\017\001\052\001\019\001\052\001\021\001\022\001\023\001\
+ \024\001\052\001\026\001\027\001\028\001\029\001\030\001\031\001\
+ \032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
+ \040\001\041\001\042\001\043\001\044\001\045\001\052\001\047\001\
+ \052\001\052\001\052\001\051\001\052\001\000\000\052\001\055\001\
+ \001\001\002\001\003\001\004\001\005\001\052\001\007\001\008\001\
+ \052\001\010\001\011\001\012\001\013\001\014\001\015\001\016\001\
+ \017\001\054\001\019\001\052\001\021\001\022\001\023\001\024\001\
+ \052\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
+ \033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
+ \041\001\042\001\043\001\044\001\045\001\000\000\047\001\052\001\
+ \034\001\049\001\007\001\052\001\048\001\052\001\055\001\001\001\
+ \002\001\003\001\004\001\005\001\052\001\007\001\008\001\052\001\
+ \010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
+ \012\001\019\001\051\001\021\001\022\001\023\001\024\001\052\001\
+ \026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
+ \034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
+ \042\001\043\001\044\001\045\001\000\000\047\001\013\001\052\001\
+ \001\001\002\001\003\001\004\001\005\001\055\001\007\001\008\001\
+ \049\001\010\001\011\001\012\001\013\001\014\001\015\001\016\001\
+ \017\001\052\001\019\001\013\001\021\001\022\001\023\001\024\001\
+ \052\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
+ \033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
+ \041\001\042\001\043\001\044\001\045\001\000\000\047\001\001\001\
+ \002\001\003\001\004\001\005\001\052\001\007\001\055\001\052\001\
+ \010\001\011\001\012\001\013\001\052\001\052\001\014\001\017\001\
+ \012\001\019\001\007\001\007\001\013\001\007\001\024\001\052\001\
+ \026\001\027\001\028\001\029\001\030\001\052\001\013\001\052\001\
+ \034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
+ \042\001\043\001\044\001\052\001\000\000\047\001\052\001\052\001\
+ \052\001\013\001\013\001\052\001\054\001\052\001\046\001\001\001\
+ \002\001\003\001\004\001\005\001\006\001\007\001\052\001\009\001\
+ \010\001\052\001\014\001\052\001\052\001\013\001\052\001\017\001\
+ \000\000\019\001\000\000\000\000\013\001\013\001\024\001\013\001\
+ \026\001\027\001\028\001\029\001\030\001\034\001\013\001\013\001\
+ \013\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
+ \042\001\043\001\044\001\000\000\052\001\047\001\001\001\002\001\
+ \003\001\004\001\005\001\161\000\007\001\038\000\079\000\010\001\
+ \248\000\048\001\013\001\016\001\113\000\154\000\017\001\255\255\
+ \019\001\255\255\255\255\255\255\255\255\255\255\255\255\026\001\
+ \027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
+ \035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
+ \043\001\044\001\000\000\255\255\047\001\255\255\001\001\002\001\
+ \003\001\004\001\005\001\255\255\007\001\255\255\255\255\010\001\
+ \255\255\255\255\013\001\255\255\255\255\255\255\017\001\255\255\
+ \019\001\255\255\255\255\255\255\255\255\255\255\255\255\026\001\
+ \027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
+ \035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
+ \043\001\044\001\000\000\255\255\047\001\255\255\255\255\255\255\
+ \255\255\255\255\255\255\255\255\255\255\001\001\002\001\003\001\
+ \004\001\005\001\255\255\007\001\255\255\255\255\010\001\255\255\
+ \012\001\255\255\255\255\255\255\255\255\017\001\255\255\019\001\
+ \255\255\255\255\255\255\255\255\255\255\255\255\026\001\027\001\
+ \028\001\029\001\030\001\255\255\255\255\255\255\255\255\035\001\
+ \036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
+ \044\001\255\255\255\255\047\001\255\255\255\255\001\001\002\001\
+ \003\001\004\001\005\001\255\255\007\001\255\255\255\255\010\001\
+ \255\255\255\255\255\255\255\255\255\255\255\255\017\001\255\255\
+ \019\001\255\255\255\255\255\255\255\255\255\255\255\255\026\001\
+ \027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
+ \035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
+ \043\001\044\001\255\255\255\255\047\001\001\001\002\001\003\001\
+ \004\001\005\001\255\255\007\001\255\255\255\255\010\001\255\255\
+ \255\255\255\255\255\255\255\255\255\255\017\001\255\255\019\001\
+ \255\255\255\255\255\255\255\255\255\255\255\255\026\001\027\001\
+ \028\001\029\001\030\001\255\255\255\255\255\255\255\255\035\001\
+ \036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
+ \044\001\255\255\255\255\047\001\255\255\255\255\255\255\255\255\
+ \255\255\255\255\255\255\255\255\001\001\002\001\003\001\004\001\
+ \005\001\255\255\007\001\255\255\255\255\010\001\255\255\255\255\
+ \255\255\255\255\255\255\255\255\017\001\255\255\019\001\255\255\
+ \255\255\255\255\255\255\255\255\255\255\026\001\027\001\028\001\
+ \029\001\030\001\255\255\255\255\255\255\255\255\035\001\036\001\
+ \037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
+ \255\255\255\255\047\001\001\001\002\001\003\001\004\001\005\001\
+ \255\255\007\001\255\255\255\255\010\001\255\255\255\255\255\255\
+ \255\255\255\255\255\255\017\001\255\255\019\001\255\255\255\255\
+ \255\255\255\255\255\255\255\255\026\001\027\001\028\001\029\001\
+ \030\001\255\255\255\255\255\255\255\255\035\001\036\001\037\001\
+ \038\001\039\001\040\001\041\001\042\001\043\001\044\001\255\255\
+ \255\255\047\001\255\255\001\001\002\001\003\001\004\001\005\001\
+ \255\255\007\001\255\255\255\255\010\001\255\255\255\255\255\255\
+ \255\255\255\255\255\255\017\001\255\255\019\001\255\255\255\255\
+ \255\255\255\255\255\255\255\255\026\001\027\001\028\001\029\001\
+ \030\001\255\255\255\255\255\255\255\255\035\001\036\001\037\001\
+ \038\001\039\001\040\001\041\001\042\001\043\001\044\001\255\255\
+ \255\255\047\001"
+ 
+ let yynames_const = "\
+   ADD_STATE_TRIGGER\000\
+   ADD_TRANS_TRIGGER\000\
+   ADD_TRANS_ACTION\000\
+   APPEND\000\
+   APPEND_EARLY\000\
+   APPENDI\000\
+   BEGIN\000\
+   BRANCH\000\
+   CHAIN2\000\
+   CHAIN3\000\
+   COPY_TRANS\000\
+   DO\000\
+   END\000\
+   EQUALS\000\
+   EQUALSEQUALS\000\
+   EXIT\000\
+   EXTEND_BOTTOM\000\
+   EXTEND_BOTTOM_REGEXP\000\
+   EXTEND_TOP\000\
+   EXTEND_TOP_REGEXP\000\
+   EXTERN\000\
+   FLAGS\000\
+   GOTO\000\
+   IF\000\
+   IF_FILE_EXISTS\000\
+   INTERJECT\000\
+   INTERJECT_COPY_TRANS\000\
+   INTERJECT_COPY_TRANS2\000\
+   INTERJECT_COPY_TRANS3\000\
+   INTERJECT_COPY_TRANS4\000\
+   JOURNAL\000\
+   SOLVED_JOURNAL\000\
+   UNSOLVED_JOURNAL\000\
+   PLUS\000\
+   REPLACE\000\
+   REPLACE_ACTION_TEXT\000\
+   REPLACE_ACTION_TEXT_PROCESS\000\
+   REPLACE_ACTION_TEXT_REGEXP\000\
+   REPLACE_ACTION_TEXT_PROCESS_REGEXP\000\
+   REPLACE_SAY\000\
+   REPLACE_STATE_TRIGGER\000\
+   REPLACE_TRANS_ACTION\000\
+   REPLACE_TRIGGER_TEXT\000\
+   REPLACE_TRIGGER_TEXT_REGEXP\000\
+   REPLY\000\
+   SAY\000\
+   SET_WEIGHT\000\
+   STRING_CONCAT\000\
+   THEN\000\
+   WEIGHT\000\
+   EOF\000\
+   "
+ 
+ let yynames_block = "\
+   SOUND\000\
+   STRING\000\
+   INLINED_FILE\000\
+   STRING_REF\000\
+   TRANS_REF\000\
+   FORCED_STRING_REF\000\
+   "
+ 
+ let yyact = [|
+   (fun _ -> failwith "parser")
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : Dc.action list) in
+     Obj.repr(
+ # 183 "src/dparser.mly"
+                        ( let answer = _1 @ !extra_actions in
+                          extra_actions := [] ;
+                          answer )
+ # 701 "src/dparser.ml"
+                : Dc.action list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 188 "src/dparser.mly"
+                         ( [] )
+ # 707 "src/dparser.ml"
+                : Dc.action list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : Dc.action) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dc.action list) in
+     Obj.repr(
+ # 189 "src/dparser.mly"
+                         ( _1 :: _2 )
+ # 715 "src/dparser.ml"
+                : Dc.action list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 193 "src/dparser.mly"
+                            ( current_unit := Some(String.uppercase _2); (String.uppercase _2,0) )
+ # 722 "src/dparser.ml"
+                : (string * int)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 194 "src/dparser.mly"
+                             ( current_unit := Some(String.uppercase _2); (String.uppercase _2,my_int_of_string _3) )
+ # 730 "src/dparser.ml"
+                : (string * int)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 198 "src/dparser.mly"
+       ( current_unit := Some(String.uppercase _2) ;
+         (String.uppercase _2,false) )
+ # 738 "src/dparser.ml"
+                : (string * bool)))
+ ; (fun __caml_parser_env ->
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 201 "src/dparser.mly"
+       ( current_unit := Some(String.uppercase _3) ;
+         (String.uppercase _3,true) )
+ # 746 "src/dparser.ml"
+                : (string * bool)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 205 "src/dparser.mly"
+       ( current_unit := Some(String.uppercase _2) ;
+         (String.uppercase _2,false) )
+ # 754 "src/dparser.ml"
+                : 'append_safe_prologue))
+ ; (fun __caml_parser_env ->
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 208 "src/dparser.mly"
+       ( current_unit := Some(String.uppercase _3) ;
+         (String.uppercase _3,true) )
+ # 762 "src/dparser.ml"
+                : 'append_safe_prologue))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 212 "src/dparser.mly"
+                          ( [] )
+ # 768 "src/dparser.ml"
+                : string list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 213 "src/dparser.mly"
+                       ( _1 :: _2 )
+ # 776 "src/dparser.ml"
+                : string list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 216 "src/dparser.mly"
+             ( [] )
+ # 782 "src/dparser.ml"
+                : int list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : int list) in
+     Obj.repr(
+ # 217 "src/dparser.mly"
+                    ( (my_int_of_string _1) :: _2 )
+ # 790 "src/dparser.ml"
+                : int list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 220 "src/dparser.mly"
+                                ( [] )
+ # 796 "src/dparser.ml"
+                : string list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 221 "src/dparser.mly"
+                             ( (String.uppercase _1) :: _2 )
+ # 804 "src/dparser.ml"
+                : string list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string list) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 226 "src/dparser.mly"
+     ( current_unit := Some(String.uppercase _2) ;
+     (true,String.uppercase _2,_3,_4) )
+ # 814 "src/dparser.ml"
+                : (bool * string * (string list) * int)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string list) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 229 "src/dparser.mly"
+     ( current_unit := Some(String.uppercase _2) ;
+     (false,String.uppercase _2,_3,_4) )
+ # 824 "src/dparser.ml"
+                : (bool * string * (string list) * int)))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 233 "src/dparser.mly"
+                               ( 0 )
+ # 830 "src/dparser.ml"
+                : int))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 234 "src/dparser.mly"
+                               ( _1 )
+ # 837 "src/dparser.ml"
+                : int))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 238 "src/dparser.mly"
+     ( current_unit := Some(String.uppercase _2); (String.uppercase _2) )
+ # 844 "src/dparser.ml"
+                : (string)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 242 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); 
+     (String.uppercase _2,_3 :: _5,_4) )
+ # 855 "src/dparser.ml"
+                : 'replace_state_trigger_prologue))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 246 "src/dparser.mly"
+                         ( [] )
+ # 861 "src/dparser.ml"
+                : 'opt_do_string_list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 247 "src/dparser.mly"
+                         ( _2 )
+ # 868 "src/dparser.ml"
+                : 'opt_do_string_list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 4 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 1 : string list) in
+     let _6 = (Parsing.peek_val __caml_parser_env 0 : 'opt_do_string_list) in
+     Obj.repr(
+ # 252 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); 
+     (String.uppercase _2,_3 :: _5,_4,_6) )
+ # 880 "src/dparser.ml"
+                : 'add_trans_trigger_prologue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 256 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); 
+     (String.uppercase _2,_3 :: _5,_4) 
+   )
+ # 892 "src/dparser.ml"
+                : 'add_state_trigger_prologue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : 'optional_weighted_condition) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 262 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _3); (_2,String.uppercase _3,_4,false) )
+ # 901 "src/dparser.ml"
+                : 'chain3_prologue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : 'optional_weighted_condition) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 264 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _4); (_2,String.uppercase _4,_5,true) )
+ # 910 "src/dparser.ml"
+                : 'chain3_prologue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 268 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); (String.uppercase _2,_3,_4,false,false) )
+ # 919 "src/dparser.ml"
+                : (string * string * string * bool * bool)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 272 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); (String.uppercase _2,_3,_4,false,false) )
+ # 928 "src/dparser.ml"
+                : (string * string * string * bool * bool)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 276 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); (String.uppercase _2,_3,_4,true,false) )
+ # 937 "src/dparser.ml"
+                : (string * string * string * bool * bool)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 278 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); (String.uppercase _2,_3,_4,false,true) )
+ # 946 "src/dparser.ml"
+                : (string * string * string * bool * bool)))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 280 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2); (String.uppercase _2,_3,_4,true,true) )
+ # 955 "src/dparser.ml"
+                : (string * string * string * bool * bool)))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : (string * int)) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.state list) in
+     Obj.repr(
+ # 284 "src/dparser.mly"
+                           ( let name,flags = _1 in Dc.Create(
+   { Dlg.name = name ;
+     Dlg.state = Array.of_list _2 ;
+     Dlg.dlg_flags = flags ; }))
+ # 966 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * bool)) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : Dlg.state list) in
+     Obj.repr(
+ # 289 "src/dparser.mly"
+   (let a,b=_1 in current_unit := None ; Dc.Append( a,b , _2 ) )
+ # 974 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : 'append_safe_prologue) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : Dlg.state list) in
+     Obj.repr(
+ # 291 "src/dparser.mly"
+   ( let a,b=_1 in current_unit := None ; Dc.Append_Early( a,b , _2 ) )
+ # 982 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : (bool * string * (string list) * int)) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : Dlg.transition list) in
+     Obj.repr(
+ # 293 "src/dparser.mly"
+   ( let top,ext_unit,ext_label,number = _1 in
+     current_unit := None ; 
+     if top then 
+       Dc.Extend_Top( String.uppercase ext_unit, ext_label, number, _2 )
+     else
+       Dc.Extend_Bottom( String.uppercase ext_unit, ext_label, number, _2 ) 
+   )
+ # 996 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : (string)) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : Dlg.state list) in
+     Obj.repr(
+ # 301 "src/dparser.mly"
+   ( current_unit := None ;
+     Dc.Replace(_1, _2) )
+ # 1005 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 304 "src/dparser.mly"
+   ( Dc.Replace_Say(_2,_3,_4) )
+ # 1014 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : 'replace_state_trigger_prologue) in
+     Obj.repr(
+ # 306 "src/dparser.mly"
+   ( let f,s,t = _1 in 
+     let verified_t = verify_trigger_list t in 
+     current_unit := None ; 
+     Dc.Replace_State_Trigger(f,s,verified_t) )
+ # 1024 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : 'add_state_trigger_prologue) in
+     Obj.repr(
+ # 311 "src/dparser.mly"
+   ( let f,s,t = _1 in 
+     let verified_t = verify_trigger_list t in 
+     current_unit := None ; 
+     Dc.Add_State_Trigger(f,s,verified_t) )
+ # 1034 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : 'add_trans_trigger_prologue) in
+     Obj.repr(
+ # 316 "src/dparser.mly"
+   ( let f,s,t,tl = _1 in 
+     let verified_t = verify_trigger_list t in
+     current_unit := None ; 
+     Dc.Add_Trans_Trigger(f,s,verified_t,tl) )
+ # 1044 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 7 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 5 : string list) in
+     let _7 = (Parsing.peek_val __caml_parser_env 2 : int list) in
+     let _9 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 321 "src/dparser.mly"
+   ( current_unit := Some(String.uppercase _2);
+     let verified_a = verify_action_list _9 in
+     current_unit := None ; 
+     Dc.Add_Trans_Action(String.uppercase _2,_4,_7,verified_a) )
+ # 1057 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 8 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 6 : string list) in
+     let _7 = (Parsing.peek_val __caml_parser_env 3 : int list) in
+     let _9 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _10 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 326 "src/dparser.mly"
+ ( current_unit := Some(String.uppercase _2);
+     current_unit := None ; 
+     Dc.Replace_Trans_Action(String.uppercase _2,_4,_7,_9,_10) )
+ # 1070 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 330 "src/dparser.mly"
+   ( Dc.Set_Weight(_2,_3,_4) )
+ # 1079 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 3 : 'chain3_prologue) in
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : ((string option) * Dlg.tlk_string * (string option)) list) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : 'compound_chain3_list) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : 'chain3_epilogue) in
+     Obj.repr(
+ # 332 "src/dparser.mly"
+   ( let (entry_weight,entry_cond),file,state,ifexist = _1 in
+     let first_part = List.map (fun (cond,says,action) ->
+       {
+         Dc.c3du_speaker = file ;
+         Dc.c3du_condition = cond ;
+         Dc.c3du_action = action ;
+         Dc.c3du_say = says ;
+         Dc.c3du_id = Dc.get_c3du_counter () ;
+         Dc.c3du_ifexists = false ;
+       } ) _2 in
+     Dc.Chain3
+     {
+       Dc.c3_entry_condition = entry_cond;
+       Dc.c3_entry_weight = entry_weight;
+       Dc.c3_iffileexists = ifexist;
+       Dc.c3_entry_file = file ;
+       Dc.c3_entry_label = state ;
+       Dc.c3_dialogue = first_part @ _3 ;
+       Dc.c3_variable = None ;
+       Dc.c3_exit_trans = _4 ;
+       Dc.c3_keep_first_do_with_first_speaker = false;
+       Dc.c3_append_all = false ;
+     }
+   )
+ # 1112 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * string * string * bool * bool)) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound_chain3_list) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : 'chain3_epilogue) in
+     Obj.repr(
+ # 357 "src/dparser.mly"
+   ( let file,label,var,keep_do,append_all = _1 in
+     Dc.Chain3
+     {
+       Dc.c3_entry_condition = None;
+       Dc.c3_entry_weight = Dlg.Not_Specified;
+       Dc.c3_entry_file = file ;
+       Dc.c3_iffileexists = false;
+       Dc.c3_entry_label = label ;
+       Dc.c3_dialogue = _2 ;
+       Dc.c3_variable = Some(var) ;
+       Dc.c3_exit_trans = _3 ;
+       Dc.c3_keep_first_do_with_first_speaker = keep_do;
+       Dc.c3_append_all = append_all ;
+     }
+   )
+ # 1135 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * string * string * bool * bool)) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound_chain3_list) in
+     Obj.repr(
+ # 373 "src/dparser.mly"
+   ( let file,label,var,keep_do,append_all = _1 in
+     Dc.Chain3
+     {
+       Dc.c3_entry_condition = None;
+       Dc.c3_entry_weight = Dlg.Not_Specified;
+       Dc.c3_entry_file = file ;
+       Dc.c3_iffileexists = false;
+       Dc.c3_entry_label = label ;
+       Dc.c3_dialogue = _2 ;
+       Dc.c3_variable = Some(var) ;
+       Dc.c3_exit_trans = [| Dlg.make_trans_of_next (Dlg.Copy(file,label)) |] ;
+       Dc.c3_keep_first_do_with_first_speaker = keep_do;
+       Dc.c3_append_all = append_all ;
+     }
+   )
+ # 1157 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 389 "src/dparser.mly"
+   ( Dc.Replace_Trigger_Text(String.uppercase _2,_3,_4,false) )
+ # 1166 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 391 "src/dparser.mly"
+   ( Dc.Replace_Trigger_Text(String.uppercase _2,_3,_4,true) )
+ # 1175 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 393 "src/dparser.mly"
+   ( Dc.Replace_Action_Text(String.uppercase _2 :: _5,_3,_4,false) )
+ # 1185 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 395 "src/dparser.mly"
+   ( Dc.Replace_Action_Text(String.uppercase _2 :: _5,_3,verify_action_list _4,false) )
+ # 1195 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 397 "src/dparser.mly"
+   ( Dc.Replace_Action_Text(String.uppercase _2 :: _5,_3,_4,true) )
+ # 1205 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : string list) in
+     Obj.repr(
+ # 399 "src/dparser.mly"
+   ( Dc.Replace_Action_Text(String.uppercase _2 :: _5,_3,verify_action_list _4,true) )
+ # 1215 "src/dparser.ml"
+                : Dc.action))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : string option) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : Dlg.tlk_string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : 'optional_action) in
+     Obj.repr(
+ # 402 "src/dparser.mly"
+                                                          ( [(_1,_2,_3)] )
+ # 1224 "src/dparser.ml"
+                : ((string option) * Dlg.tlk_string * (string option)) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 4 : string option) in
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : Dlg.tlk_string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : 'optional_action) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : ((string option) * Dlg.tlk_string * (string option)) list) in
+     Obj.repr(
+ # 404 "src/dparser.mly"
+   ( (_1,_2,_3) :: (List.map (fun (a,b,c) -> 
+     match _1,a with
+     | _,None -> (_1,b,c)
+     | None,_ -> (a,b,c)
+     | Some(first),Some(second) -> (Some(first ^ "\n" ^ second),b,c)
+     ) _5) )
+ # 1239 "src/dparser.ml"
+                : ((string option) * Dlg.tlk_string * (string option)) list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 412 "src/dparser.mly"
+                         ( None )
+ # 1245 "src/dparser.ml"
+                : 'optional_action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 413 "src/dparser.mly"
+                         ( let verified_action = verify_action_list _2 in 
+                           Some(verified_action) )
+ # 1253 "src/dparser.ml"
+                : 'optional_action))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 419 "src/dparser.mly"
+     ( let next = Dlg.Symbolic(String.uppercase _2,_3,false) in
+       [| Dlg.make_trans_of_next next |] )
+ # 1262 "src/dparser.ml"
+                : 'chain3_epilogue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 422 "src/dparser.mly"
+     ( let next = Dlg.Symbolic(String.uppercase _2,_3,false) in
+       [| Dlg.make_trans_of_next next |] )
+ # 1271 "src/dparser.ml"
+                : 'chain3_epilogue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 425 "src/dparser.mly"
+     ( let next = Dlg.Copy(String.uppercase _2,_3) in
+       [| Dlg.make_trans_of_next next |] )
+ # 1280 "src/dparser.ml"
+                : 'chain3_epilogue))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 428 "src/dparser.mly"
+     ( let next = Dlg.Exit in 
+       [| Dlg.make_trans_of_next next |] )
+ # 1287 "src/dparser.ml"
+                : 'chain3_epilogue))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.transition list) in
+     Obj.repr(
+ # 430 "src/dparser.mly"
+                                      ( Array.of_list _2 )
+ # 1294 "src/dparser.ml"
+                : 'chain3_epilogue))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 433 "src/dparser.mly"
+                                  ( ((Dlg.Not_Specified),(None)) )
+ # 1300 "src/dparser.ml"
+                : 'optional_weighted_condition))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : Dlg.weight) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     Obj.repr(
+ # 434 "src/dparser.mly"
+                         ( (_2,(Some(verify_trigger_list _3))) )
+ # 1308 "src/dparser.ml"
+                : 'optional_weighted_condition))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : 'optional_then) in
+     Obj.repr(
+ # 438 "src/dparser.mly"
+                            ( Some(verify_trigger_list _2) )
+ # 1316 "src/dparser.ml"
+                : string option))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 439 "src/dparser.mly"
+   ( None )
+ # 1322 "src/dparser.ml"
+                : string option))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 442 "src/dparser.mly"
+                                         ( [] )
+ # 1328 "src/dparser.ml"
+                : 'compound_chain3_list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : ((string option) * Dlg.tlk_string * (string option)) list) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : 'compound_chain3_list) in
+     Obj.repr(
+ # 444 "src/dparser.mly"
+   ( let this_speaker = String.uppercase _2 in
+     let first_part = List.map (fun (cond,says,action) ->
+       { Dc.c3du_speaker = this_speaker ;
+         Dc.c3du_condition = cond ;
+         Dc.c3du_action = action ;
+         Dc.c3du_say = says ;
+         Dc.c3du_id = Dc.get_c3du_counter () ;
+         Dc.c3du_ifexists = false ;
+         }) _3 in
+     first_part @ _4
+   )
+ # 1347 "src/dparser.ml"
+                : 'compound_chain3_list))
+ ; (fun __caml_parser_env ->
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : ((string option) * Dlg.tlk_string * (string option)) list) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound_chain3_list) in
+     Obj.repr(
+ # 456 "src/dparser.mly"
+   ( let this_speaker = String.uppercase _3 in
+     let first_part = List.map (fun (cond,says,action) ->
+       { Dc.c3du_speaker = this_speaker ;
+         Dc.c3du_condition = cond ;
+         Dc.c3du_action = action ;
+         Dc.c3du_say = says ;
+         Dc.c3du_id = Dc.get_c3du_counter () ;
+         Dc.c3du_ifexists = true ;
+         }) _4 in
+     first_part @ _5
+   )
+ # 1366 "src/dparser.ml"
+                : 'compound_chain3_list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 4 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 2 : 'compound_chain3_list) in
+     let _6 = (Parsing.peek_val __caml_parser_env 0 : 'compound_chain3_list) in
+     Obj.repr(
+ # 468 "src/dparser.mly"
+   (
+     List.map (fun x ->
+       {
+         x with
+           Dc.c3du_condition = match x.Dc.c3du_condition with
+             | None -> Some (_2)
+             | Some(y) -> Some(_2 ^ " " ^ y)
+       }
+     ) _4 @ _6
+   )
+ # 1384 "src/dparser.ml"
+                : 'compound_chain3_list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 482 "src/dparser.mly"
+                         ( [] )
+ # 1390 "src/dparser.ml"
+                : Dlg.state list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : Dlg.state list) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.state list) in
+     Obj.repr(
+ # 483 "src/dparser.mly"
+                         ( _1 @ _2 )
+ # 1398 "src/dparser.ml"
+                : Dlg.state list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 486 "src/dparser.mly"
+                         ( Dlg.Not_Specified )
+ # 1404 "src/dparser.ml"
+                : Dlg.weight))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 487 "src/dparser.mly"
+                         ( Dlg.Offset(_2) )
+ # 1411 "src/dparser.ml"
+                : Dlg.weight))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 490 "src/dparser.mly"
+                ( () )
+ # 1417 "src/dparser.ml"
+                : 'optional_then))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 491 "src/dparser.mly"
+        ( () )
+ # 1423 "src/dparser.ml"
+                : 'optional_then))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 493 "src/dparser.mly"
+                 ( () )
+ # 1429 "src/dparser.ml"
+                : 'optional_begin))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 494 "src/dparser.mly"
+         ( () )
+ # 1435 "src/dparser.ml"
+                : 'optional_begin))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 498 "src/dparser.mly"
+        ( if _1 = "" then "" else verify_trigger_list _1 )
+ # 1442 "src/dparser.ml"
+                : 'state_trigger))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 8 : Dlg.weight) in
+     let _3 = (Parsing.peek_val __caml_parser_env 7 : 'state_trigger) in
+     let _4 = (Parsing.peek_val __caml_parser_env 6 : 'optional_then) in
+     let _5 = (Parsing.peek_val __caml_parser_env 5 : 'optional_begin) in
+     let _6 = (Parsing.peek_val __caml_parser_env 4 : string) in
+     let _8 = (Parsing.peek_val __caml_parser_env 2 : Dlg.tlk_string list) in
+     let _9 = (Parsing.peek_val __caml_parser_env 1 : Dlg.transition list) in
+     Obj.repr(
+ # 505 "src/dparser.mly"
+     (
+       let state_trigger = _3 in 
+       if List.length _8 = 1 then
+          [{ Dlg.resp_str = List.hd _8 ;
+            Dlg.trans = Array.of_list _9 ;
+            Dlg.state_trigger = state_trigger ;
+            Dlg.state_trigger_weight = _2 ; 
+            Dlg.symbolic_label = _6 ; }]
+       else begin
+         let rec process_say_list sl in_label in_trig in_weight = match sl with
+           s1 :: s2 :: tl -> 
+             let new_label = Dc.chain_label () in
+             let dest_file = get_current_unit () in 
+             let new_state = Dlg.make_state s1 in_label dest_file new_label in
+             new_state.Dlg.state_trigger_weight <- in_weight ; 
+             new_state.Dlg.state_trigger <- in_trig ;
+             new_state :: (process_say_list (s2::tl) new_label "" Dlg.Not_Specified)
+         | s1 :: [] -> [
+           let state = Dlg.make_state_trans s1 in_label (Array.of_list _9)
+           in state.Dlg.state_trigger_weight <- in_weight ;
+           state ] 
+         | [] -> [] 
+         in 
+         process_say_list _8 _6 _3 _2
+       end
+     )
+ # 1480 "src/dparser.ml"
+                : Dlg.state list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : string option * string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : Dlg.state list) in
+     Obj.repr(
+ # 533 "src/dparser.mly"
+   (
+     let old_unit, append_name = _1 in
+     extra_actions := (Dc.Append( append_name,false, _2 )) :: !extra_actions ;
+     current_unit := old_unit ;
+     [] 
+   )
+ # 1493 "src/dparser.ml"
+                : Dlg.state list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 5 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 4 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Dlg.tlk_string) list) in
+     let _6 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _7 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 541 "src/dparser.mly"
+   ( let rec convert cl extern_guy = match cl with
+       [] -> []
+     | (code,s) :: tl -> 
+         let file = if extern_guy then _2 else get_current_unit () in
+         let extern_guy = if code = "==" then not extern_guy else extern_guy in
+         (file,s) :: convert tl extern_guy
+     in 
+     extra_actions := (Dc.Chain(
+       { Dc.entry_file = String.uppercase _2 ;
+         Dc.entry_label = _3 ;
+         Dc.dialogue = convert _4 true;
+         Dc.exit_file = String.uppercase _6 ;
+         Dc.exit_label = _7 ;
+       } )) :: !extra_actions ;
+     []  
+   )
+ # 1519 "src/dparser.ml"
+                : Dlg.state list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 560 "src/dparser.mly"
+  ( let what = String.uppercase _2 in  
+   let old = !current_unit in current_unit := Some(what); (old, what) )
+ # 1527 "src/dparser.ml"
+                : string option * string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 564 "src/dparser.mly"
+                                 ( [("",_1)] )
+ # 1534 "src/dparser.ml"
+                : (string * Dlg.tlk_string) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : Dlg.tlk_string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Dlg.tlk_string) list) in
+     Obj.repr(
+ # 565 "src/dparser.mly"
+                                 ( ("",_1) :: _3 )
+ # 1542 "src/dparser.ml"
+                : (string * Dlg.tlk_string) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : Dlg.tlk_string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Dlg.tlk_string) list) in
+     Obj.repr(
+ # 566 "src/dparser.mly"
+                                 ( ("==",_1) :: _3 )
+ # 1550 "src/dparser.ml"
+                : (string * Dlg.tlk_string) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 569 "src/dparser.mly"
+                                 ( [_1] )
+ # 1557 "src/dparser.ml"
+                : Dlg.tlk_string list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : Dlg.tlk_string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string list) in
+     Obj.repr(
+ # 570 "src/dparser.mly"
+                                 ( _1 :: _3 )
+ # 1565 "src/dparser.ml"
+                : Dlg.tlk_string list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 573 "src/dparser.mly"
+                              ( [] )
+ # 1571 "src/dparser.ml"
+                : Dlg.transition list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : Dlg.transition) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.transition list) in
+     Obj.repr(
+ # 574 "src/dparser.mly"
+                              ( _1 :: _2 )
+ # 1579 "src/dparser.ml"
+                : Dlg.transition list))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 578 "src/dparser.mly"
+                  ( Trans_Reply(Some(_2)) )
+ # 1586 "src/dparser.ml"
+                : trans_opt_type))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 579 "src/dparser.mly"
+                  ( let verified_action = verify_action_list _2 in
+                     Trans_Do(Some(verified_action)) )
+ # 1594 "src/dparser.ml"
+                : trans_opt_type))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 581 "src/dparser.mly"
+                  ( Trans_Journal(Some(Dlg.Normal_Journal,_2)) )
+ # 1601 "src/dparser.ml"
+                : trans_opt_type))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 582 "src/dparser.mly"
+                         ( Trans_Journal(Some(Dlg.Solved_Journal,_2)) )
+ # 1608 "src/dparser.ml"
+                : trans_opt_type))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 583 "src/dparser.mly"
+                           ( Trans_Journal(Some(Dlg.Unsolved_Journal,_2)) )
+ # 1615 "src/dparser.ml"
+                : trans_opt_type))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 584 "src/dparser.mly"
+                  ( Trans_Flags(my_int_of_string _2))
+ # 1622 "src/dparser.ml"
+                : trans_opt_type))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 587 "src/dparser.mly"
+                                 ( [] )
+ # 1628 "src/dparser.ml"
+                : trans_opt_type list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : trans_opt_type) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : trans_opt_type list) in
+     Obj.repr(
+ # 588 "src/dparser.mly"
+                                 ( _1 :: _2 )
+ # 1636 "src/dparser.ml"
+                : trans_opt_type list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 591 "src/dparser.mly"
+                        ( if _1 = "" then None else
+   Some(verify_trigger_list _1) )
+ # 1644 "src/dparser.ml"
+                : 'trans_trigger))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 595 "src/dparser.mly"
+                          ( _1 )
+ # 1651 "src/dparser.ml"
+                : 'optional_string))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 596 "src/dparser.mly"
+   ( "" )
+ # 1657 "src/dparser.ml"
+                : 'optional_string))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : 'trans_trigger) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : 'optional_then) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : trans_opt_type list) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : Dlg.trans_next) in
+     Obj.repr(
+ # 601 "src/dparser.mly"
+   ( let result = {
+       Dlg.trans_trigger = _2 ;
+       Dlg.trans_str = None ;
+       Dlg.action = None ;
+       Dlg.journal_str = None;
+       Dlg.unknown_flags = 0 ;
+       Dlg.next = _5 ;
+     } in
+     List.iter (fun elt -> match elt with
+     | Trans_Reply(r) -> (if (result.Dlg.trans_str <> None) && !debug_modder then
+          try parse_error "You may only have one REPLY per transition.  Recovering."
+          with _ -> ()) ; result.Dlg.trans_str <- r ;
+     | Trans_Do(r) ->(if (result.Dlg.action <> None) && !debug_modder then
+          try
+            parse_error "You may only have one DO per transition.  Recovering."
+          with _ -> ()) ;
+          let r = try Some(
+            value_of_option r ^ value_of_option result.Dlg.action
+          ) with _ -> r in
+          result.Dlg.action <- r ;
+     | Trans_Journal(r) ->
+         (if (result.Dlg.journal_str <> None) && !debug_modder then
+          try parse_error "You may only have one JOURNAL per transition.  Recovering." with _ -> ()) ;
+         result.Dlg.journal_str <- r;
+     | Trans_Flags(r) -> result.Dlg.unknown_flags <- r;
+     ) _4 ;
+     result
+   )
+ # 1694 "src/dparser.ml"
+                : Dlg.transition))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 4 : 'optional_string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 2 : Dlg.tlk_string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 1 : trans_opt_type list) in
+     let _6 = (Parsing.peek_val __caml_parser_env 0 : Dlg.trans_next) in
+     Obj.repr(
+ # 630 "src/dparser.mly"
+   ( let result = {
+       Dlg.trans_trigger =
+         if _2 = "" then None
+         else Some(verify_trigger_list _2) ;
+       Dlg.trans_str = Some(_4) ;
+       Dlg.action = None ;
+       Dlg.journal_str = None;
+       Dlg.unknown_flags = 0 ;
+       Dlg.next = _6 ;
+     } in
+     List.iter (fun elt -> match elt with
+     | Trans_Reply(r) -> (if (result.Dlg.trans_str <> None) && !debug_modder then
+          try parse_error "You may only have one REPLY per transition.  Recovering."
+          with _ -> ()) ; result.Dlg.trans_str <- r ;
+     | Trans_Do(r) ->(if (result.Dlg.action <> None) && !debug_modder then
+          try
+            parse_error "You may only have one DO per transition.  Recovering."
+          with _ -> ()) ;
+          let r = try Some(
+            value_of_option r ^ value_of_option result.Dlg.action
+          ) with _ -> r in
+          result.Dlg.action <- r ;
+     | Trans_Journal(r) ->
+         (if (result.Dlg.journal_str <> None) && !debug_modder then
+          try parse_error "You may only have one JOURNAL per transition.  Recovering." with _ -> ()) ;
+         result.Dlg.journal_str <- r;
+     | Trans_Flags(r) -> result.Dlg.unknown_flags <- r;
+     ) _5 ;
+     result
+   )
+ # 1733 "src/dparser.ml"
+                : Dlg.transition))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 661 "src/dparser.mly"
+   ( {
+       Dlg.trans_trigger = None ;
+       Dlg.trans_str = None ;
+       Dlg.action = None ;
+       Dlg.journal_str = None;
+       Dlg.unknown_flags = 0 ;
+       Dlg.next = Dlg.Copy(_2,_3) ;
+     }
+   )
+ # 1749 "src/dparser.ml"
+                : Dlg.transition))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 672 "src/dparser.mly"
+                        ( Dlg.Symbolic(get_current_unit () ,_2,false) )
+ # 1756 "src/dparser.ml"
+                : Dlg.trans_next))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 673 "src/dparser.mly"
+                   ( Dlg.Symbolic(get_current_unit () ,_2,false) )
+ # 1763 "src/dparser.ml"
+                : Dlg.trans_next))
+ ; (fun __caml_parser_env ->
+     let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 674 "src/dparser.mly"
+                        ( Dlg.Symbolic(String.uppercase _2,_3,false) )
+ # 1771 "src/dparser.ml"
+                : Dlg.trans_next))
+ ; (fun __caml_parser_env ->
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 675 "src/dparser.mly"
+                                       ( Dlg.Symbolic(String.uppercase _3,_4,true) )
+ # 1779 "src/dparser.ml"
+                : Dlg.trans_next))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 676 "src/dparser.mly"
+                        ( Dlg.Exit )
+ # 1785 "src/dparser.ml"
+                : Dlg.trans_next))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 679 "src/dparser.mly"
+                        ( _1 )
+ # 1792 "src/dparser.ml"
+                : 'lse_string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lse_string) in
+     Obj.repr(
+ # 680 "src/dparser.mly"
+                                   ( _1 ^ _3 )
+ # 1800 "src/dparser.ml"
+                : 'lse_string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : 'lse_string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 684 "src/dparser.mly"
+   ( let result = Dlg.Local_String({ lse_male = _1 ; lse_male_sound = _2;
+                     lse_female = _1; lse_female_sound = _2;}) in
+     (match !Dlg.local_string_ht with
+       Some(l) -> if not (List.mem result l ) then begin
+           Dlg.local_string_ht := Some(result :: l )
+         end
+     | _ -> () ) ;
+     result
+   )
+ # 1816 "src/dparser.ml"
+                : Dlg.tlk_string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 3 : 'lse_string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : 'lse_string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 694 "src/dparser.mly"
+   ( let result = Dlg.Local_String({ lse_male = _1 ; lse_male_sound = _2;
+           lse_female = _3; lse_female_sound = _4; }) in
+     (match !Dlg.local_string_ht with
+       Some(l) -> if not (List.mem result l) then
+         Dlg.local_string_ht := Some(result :: l)
+     | _ -> () ) ;
+     result
+   )
+ # 1833 "src/dparser.ml"
+                : Dlg.tlk_string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 702 "src/dparser.mly"
+              ( Dlg.TLK_Index(_1) )
+ # 1840 "src/dparser.ml"
+                : Dlg.tlk_string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : int) in
+     Obj.repr(
+ # 703 "src/dparser.mly"
+              ( Dc.resolve_string_while_loading (Dlg.Trans_String(_1)) )
+ # 1847 "src/dparser.ml"
+                : Dlg.tlk_string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 1 : int) in
+     let _2 = (Parsing.peek_val __caml_parser_env 0 : Dlg.tlk_string) in
+     Obj.repr(
+ # 705 "src/dparser.mly"
+   ( let _ = Dc.set_string_while_loading _1 _2 in Dlg.TLK_Index(_1) )
+ # 1855 "src/dparser.ml"
+                : Dlg.tlk_string))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 708 "src/dparser.mly"
+                         ( "" )
+ # 1861 "src/dparser.ml"
+                : string))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
+     Obj.repr(
+ # 709 "src/dparser.mly"
+                         ( _1 )
+ # 1868 "src/dparser.ml"
+                : string))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 712 "src/dparser.mly"
+                         ( [] )
+ # 1874 "src/dparser.ml"
+                : (int * Dlg.tlk_string) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 3 : int) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : Dlg.tlk_string) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : (int * Dlg.tlk_string) list) in
+     Obj.repr(
+ # 713 "src/dparser.mly"
+                                 ( (_1,_3) :: _4 )
+ # 1883 "src/dparser.ml"
+                : (int * Dlg.tlk_string) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * int * int * (string option)) list) in
+     Obj.repr(
+ # 716 "src/dparser.mly"
+                               ( _1 )
+ # 1890 "src/dparser.ml"
+                : (string * int * int * (string option)) list))
+ ; (fun __caml_parser_env ->
+     Obj.repr(
+ # 719 "src/dparser.mly"
+                               ( [] )
+ # 1896 "src/dparser.ml"
+                : (string * int * int * (string option)) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 2 : int) in
+     let _3 = (Parsing.peek_val __caml_parser_env 1 : int) in
+     let _4 = (Parsing.peek_val __caml_parser_env 0 : (string * int * int * (string option)) list) in
+     Obj.repr(
+ # 721 "src/dparser.mly"
+   ( (_1,_2,_3,None) :: _4 )
+ # 1906 "src/dparser.ml"
+                : (string * int * int * (string option)) list))
+ ; (fun __caml_parser_env ->
+     let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
+     let _2 = (Parsing.peek_val __caml_parser_env 3 : int) in
+     let _3 = (Parsing.peek_val __caml_parser_env 2 : int) in
+     let _4 = (Parsing.peek_val __caml_parser_env 1 : string) in
+     let _5 = (Parsing.peek_val __caml_parser_env 0 : (string * int * int * (string option)) list) in
+     Obj.repr(
+ # 723 "src/dparser.mly"
+   ( (_1,_2,_3,Some(_4)) :: _5 )
+ # 1917 "src/dparser.ml"
+                : (string * int * int * (string option)) list))
+ (* Entry d_file *)
+ ; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
+ (* Entry tra_file *)
+ ; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
+ (* Entry log_file *)
+ ; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
+ |]
+ let yytables =
+   { Parsing.actions=yyact;
+     Parsing.transl_const=yytransl_const;
+     Parsing.transl_block=yytransl_block;
+     Parsing.lhs=yylhs;
+     Parsing.len=yylen;
+     Parsing.defred=yydefred;
+     Parsing.dgoto=yydgoto;
+     Parsing.sindex=yysindex;
+     Parsing.rindex=yyrindex;
+     Parsing.gindex=yygindex;
+     Parsing.tablesize=yytablesize;
+     Parsing.table=yytable;
+     Parsing.check=yycheck;
+     Parsing.error_function=parse_error;
+     Parsing.names_const=yynames_const;
+     Parsing.names_block=yynames_block }
+ let d_file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
+    (Parsing.yyparse yytables 1 lexfun lexbuf : Dc.action list)
+ let tra_file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
+    (Parsing.yyparse yytables 2 lexfun lexbuf : (int * Dlg.tlk_string) list)
+ let log_file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
+    (Parsing.yyparse yytables 3 lexfun lexbuf : (string * int * int * (string option)) list)
+ ;;
+ # 727 "src/dparser.mly"
+ 
+ 
+ 
+ # 1954 "src/dparser.ml"
