*** WeiDU-185/obj/x86_LINUX/dlexer.ml	1970-01-01 01:00:00.000000000 +0100
--- WeiDU/obj/x86_LINUX/dlexer.ml	2007-07-26 15:35:20.000000000 +0200
***************
*** 0 ****
--- 1,456 ----
+ # 1 "src/dlexer.mll"
+  
+ 
+ open Util
+ open Dparser
+ 
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.dlexer.mll.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
+ (*
+ ** Keyword hashtable
+ *)
+ 
+ let string_of lb = (Lexing.lexeme lb)
+ 
+ let lexicon = Hashtbl.create 211
+ let _ = List.iter
+     (fun (key, token) -> Hashtbl.add lexicon key token)
+     [
+       ("ADD_STATE_TRIGGER", ADD_STATE_TRIGGER) ;
+       ("ADD_TRANS_ACTION", ADD_TRANS_ACTION) ;
+       ("ADD_TRANS_TRIGGER", ADD_TRANS_TRIGGER) ;
+       ("APPEND", APPEND);
+       ("APPENDI", APPENDI);
+       ("APPEND_EARLY", APPEND_EARLY);
+       ("A_S_T", ADD_STATE_TRIGGER) ;
+       ("A_T_T", ADD_TRANS_TRIGGER) ;
+       ("BEGIN", BEGIN) ;
+       ("BRANCH", BRANCH) ;
+       ("CHAIN", CHAIN3);
+       ("CHAIN2", CHAIN2);
+       ("CHAIN3", CHAIN3);
+       ("COPY_TRANS", COPY_TRANS);
+       ("DO", DO) ;
+       ("END", END) ;
+       ("EXTEND",EXTEND_BOTTOM) ;
+       ("EXTEND_BOTTOM", EXTEND_BOTTOM) ;
+       ("EXTEND_BOTTOM_REGEXP", EXTEND_BOTTOM_REGEXP);
+       ("EXTEND_TOP", EXTEND_TOP) ;
+       ("EXTEND_TOP_REGEXP", EXTEND_TOP_REGEXP);
+       ("EXTERN", EXTERN) ;
+       ("EXIT", EXIT) ;
+       ("FLAGS", FLAGS);
+       ("GOTO", GOTO) ;
+       ("IF", IF) ;
+       ("IF_FILE_EXISTS", IF_FILE_EXISTS) ;
+       ("INTERJECT", INTERJECT);
+       ("INTERJECT_COPY_TRANS", INTERJECT_COPY_TRANS);
+       ("INTERJECT_COPY_TRANS2", INTERJECT_COPY_TRANS2);
+       ("INTERJECT_COPY_TRANS3", INTERJECT_COPY_TRANS3);
+       ("INTERJECT_COPY_TRANS4", INTERJECT_COPY_TRANS4);
+       ("I_C_T", INTERJECT_COPY_TRANS);
+       ("I_C_T2", INTERJECT_COPY_TRANS2);
+       ("I_C_T3", INTERJECT_COPY_TRANS3);
+       ("I_C_T4", INTERJECT_COPY_TRANS4);
+       ("JOURNAL", JOURNAL) ;
+       ("REPLACE", REPLACE) ;
+       ("REPLACE_ACTION_TEXT", REPLACE_ACTION_TEXT) ;
+       ("REPLACE_ACTION_TEXT_PROCESS", REPLACE_ACTION_TEXT_PROCESS) ;
+       ("REPLACE_ACTION_TEXT_PROCESS_REGEXP", REPLACE_ACTION_TEXT_PROCESS_REGEXP) ;
+       ("REPLACE_ACTION_TEXT_REGEXP", REPLACE_ACTION_TEXT_REGEXP) ;
+       ("REPLACE_SAY", REPLACE_SAY) ;
+       ("REPLACE_STATE_TRIGGER", REPLACE_STATE_TRIGGER) ;
+       ("REPLACE_TRIGGER_TEXT", REPLACE_TRIGGER_TEXT) ;
+       ("REPLACE_TRIGGER_TEXT_REGEXP", REPLACE_TRIGGER_TEXT_REGEXP) ;
+       ("REPLACE_TRANS_ACTION", REPLACE_TRANS_ACTION) ;
+       ("REPLY", REPLY) ;
+       ("R_A_T", REPLACE_ACTION_TEXT) ;
+       ("R_A_T_P_R", REPLACE_ACTION_TEXT_PROCESS_REGEXP) ;
+       ("R_S_T", REPLACE_STATE_TRIGGER) ;
+       ("R_T_T", REPLACE_TRIGGER_TEXT) ;
+       ("SAY", SAY) ;
+       ("SET_WEIGHT", SET_WEIGHT) ;
+       ("SOLVED_JOURNAL", SOLVED_JOURNAL) ;
+       ("THEN", THEN) ;
+       ("UNSOLVED_JOURNAL", UNSOLVED_JOURNAL) ;
+       ("WEIGHT", WEIGHT) ;
+     ]
+ 
+ (*
+ ** Buffer processor
+ *)
+  
+ 
+ 
+ 
+ 
+ # 94 "src/dlexer.ml"
+ let __ocaml_lex_tables = {
+   Lexing.lex_base = 
+    "\000\000\238\255\239\255\079\000\092\000\105\000\128\000\001\000\
+     \002\000\012\000\003\000\248\255\249\255\001\000\251\255\252\255\
+     \253\255\016\000\254\255\255\255\247\255\246\255\030\000\013\000\
+     \025\000\245\255\026\000\038\000\240\255\005\000\004\000\221\000\
+     \239\000\249\000\003\001\013\001\023\001\177\000\000\000\012\000\
+     \156\000\039\000\041\000\042\000\043\000\006\000";
+   Lexing.lex_backtrk = 
+    "\255\255\255\255\255\255\017\000\017\000\017\000\011\000\017\000\
+     \017\000\017\000\017\000\255\255\255\255\005\000\255\255\255\255\
+     \255\255\017\000\255\255\255\255\255\255\255\255\255\255\010\000\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\012\000\
+     \255\255\013\000\255\255\014\000\255\255\255\255\004\000\004\000\
+     \255\255\003\000\255\255\255\255\255\255\255\255";
+   Lexing.lex_default = 
+    "\001\000\000\000\000\000\255\255\255\255\255\255\255\255\030\000\
+     \029\000\024\000\022\000\000\000\000\000\255\255\000\000\000\000\
+     \000\000\255\255\000\000\000\000\000\000\000\000\022\000\255\255\
+     \024\000\000\000\255\255\255\255\000\000\029\000\030\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\014\000\255\255\255\255\
+     \015\000\255\255\255\255\255\255\255\255\018\000";
+   Lexing.lex_trans = 
+    "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\015\000\014\000\000\000\016\000\016\000\000\000\000\000\
+     \019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \016\000\004\000\008\000\005\000\025\000\007\000\025\000\025\000\
+     \000\000\025\000\016\000\012\000\000\000\000\000\000\000\017\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\019\000\019\000\000\000\013\000\020\000\018\000\
+     \003\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\010\000\000\000\000\000\011\000\006\000\
+     \021\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\021\000\036\000\000\000\009\000\035\000\
+     \035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
+     \035\000\034\000\023\000\026\000\033\000\033\000\033\000\033\000\
+     \033\000\033\000\033\000\033\000\033\000\033\000\032\000\025\000\
+     \027\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
+     \031\000\031\000\031\000\006\000\028\000\042\000\016\000\043\000\
+     \044\000\019\000\000\000\000\000\000\000\006\000\006\000\000\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\000\000\018\000\000\000\000\000\000\000\000\000\
+     \000\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\039\000\000\000\000\000\000\000\006\000\
+     \038\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\000\000\000\000\000\000\000\000\000\000\
+     \002\000\255\255\255\255\255\255\255\255\255\255\016\000\000\000\
+     \000\000\000\000\000\000\000\000\255\255\031\000\031\000\031\000\
+     \031\000\031\000\031\000\031\000\031\000\031\000\031\000\000\000\
+     \000\000\255\255\041\000\000\000\000\000\000\000\255\255\031\000\
+     \031\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
+     \031\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
+     \033\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
+     \033\000\033\000\033\000\033\000\033\000\035\000\035\000\035\000\
+     \035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
+     \035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
+     \035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\018\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\015\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     ";
+   Lexing.lex_check = 
+    "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\000\000\000\000\255\255\000\000\000\000\255\255\255\255\
+     \045\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \000\000\000\000\000\000\000\000\008\000\000\000\007\000\029\000\
+     \255\255\030\000\038\000\000\000\255\255\255\255\255\255\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\017\000\039\000\255\255\000\000\013\000\017\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\255\255\255\255\000\000\000\000\
+     \010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\022\000\003\000\255\255\000\000\003\000\
+     \003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
+     \003\000\004\000\009\000\023\000\004\000\004\000\004\000\004\000\
+     \004\000\004\000\004\000\004\000\004\000\004\000\005\000\024\000\
+     \026\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\006\000\027\000\041\000\040\000\042\000\
+     \043\000\044\000\255\255\255\255\255\255\006\000\006\000\255\255\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\255\255\037\000\255\255\255\255\255\255\255\255\
+     \255\255\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\037\000\255\255\255\255\255\255\006\000\
+     \037\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\006\000\006\000\006\000\006\000\006\000\
+     \006\000\006\000\006\000\255\255\255\255\255\255\255\255\255\255\
+     \000\000\007\000\008\000\010\000\030\000\029\000\045\000\255\255\
+     \255\255\255\255\255\255\255\255\009\000\031\000\031\000\031\000\
+     \031\000\031\000\031\000\031\000\031\000\031\000\031\000\255\255\
+     \255\255\024\000\040\000\255\255\255\255\255\255\022\000\032\000\
+     \032\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
+     \032\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
+     \033\000\033\000\033\000\034\000\034\000\034\000\034\000\034\000\
+     \034\000\034\000\034\000\034\000\034\000\035\000\035\000\035\000\
+     \035\000\035\000\035\000\035\000\035\000\035\000\035\000\036\000\
+     \036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
+     \036\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\040\000\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\037\000\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     ";
+   Lexing.lex_base_code = 
+    "";
+   Lexing.lex_backtrk_code = 
+    "";
+   Lexing.lex_default_code = 
+    "";
+   Lexing.lex_trans_code = 
+    "";
+   Lexing.lex_check_code = 
+    "";
+   Lexing.lex_code = 
+    "";
+ }
+ 
+ let rec initial lexbuf =
+     __ocaml_lex_initial_rec lexbuf 0
+ and __ocaml_lex_initial_rec lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 99 "src/dlexer.mll"
+         ( adj lexbuf ; let _ = comment lexbuf in initial lexbuf)
+ # 276 "src/dlexer.ml"
+ 
+   | 1 ->
+ # 100 "src/dlexer.mll"
+         ( adj lexbuf ; endline lexbuf )
+ # 281 "src/dlexer.ml"
+ 
+   | 2 ->
+ # 101 "src/dlexer.mll"
+         ( adj lexbuf ; initial lexbuf)
+ # 286 "src/dlexer.ml"
+ 
+   | 3 ->
+ # 102 "src/dlexer.mll"
+         ( tab (); initial lexbuf )
+ # 291 "src/dlexer.ml"
+ 
+   | 4 ->
+ # 103 "src/dlexer.mll"
+         ( newline (); initial lexbuf )
+ # 296 "src/dlexer.ml"
+ 
+   | 5 ->
+ # 104 "src/dlexer.mll"
+         ( adj lexbuf ; EQUALS )
+ # 301 "src/dlexer.ml"
+ 
+   | 6 ->
+ # 105 "src/dlexer.mll"
+         ( adj lexbuf ; PLUS )
+ # 306 "src/dlexer.ml"
+ 
+   | 7 ->
+ # 106 "src/dlexer.mll"
+         ( adj lexbuf ; STRING_CONCAT )
+ # 311 "src/dlexer.ml"
+ 
+   | 8 ->
+ # 108 "src/dlexer.mll"
+         ( adj lexbuf ; EQUALSEQUALS )
+ # 316 "src/dlexer.ml"
+ 
+   | 9 ->
+ # 109 "src/dlexer.mll"
+                 ( str_adj lexbuf ; SOUND(strip (string_of lexbuf)) )
+ # 321 "src/dlexer.ml"
+ 
+   | 10 ->
+ # 112 "src/dlexer.mll"
+                  ( str_adj lexbuf ; STRING(strip (string_of lexbuf)) )
+ # 326 "src/dlexer.ml"
+ 
+   | 11 ->
+ # 113 "src/dlexer.mll"
+                                                                  (
+     adj lexbuf ; try Hashtbl.find lexicon (string_of lexbuf)
+     with _ -> STRING(string_of lexbuf) )
+ # 333 "src/dlexer.ml"
+ 
+   | 12 ->
+ # 116 "src/dlexer.mll"
+                       ( adj lexbuf ;
+       let str = string_of lexbuf in
+       let str = String.sub str 1 ((String.length str) - 1) in
+       STRING_REF((int_of_string str)) )
+ # 341 "src/dlexer.ml"
+ 
+   | 13 ->
+ # 120 "src/dlexer.mll"
+                       ( adj lexbuf ;
+       let str = string_of lexbuf in
+       let str = String.sub str 1 ((String.length str) - 1) in
+       FORCED_STRING_REF((int_of_string str)) )
+ # 349 "src/dlexer.ml"
+ 
+   | 14 ->
+ # 124 "src/dlexer.mll"
+                       ( adj lexbuf ;
+       let str = string_of lexbuf in
+       let str = String.sub str 1 ((String.length str) - 1) in
+       TRANS_REF((int_of_string str)) )
+ # 357 "src/dlexer.ml"
+ 
+   | 15 ->
+ # 128 "src/dlexer.mll"
+           ( adj lexbuf ; let buf = Buffer.create 255 in widestring buf lexbuf )
+ # 362 "src/dlexer.ml"
+ 
+   | 16 ->
+ # 129 "src/dlexer.mll"
+         ( EOF )
+ # 367 "src/dlexer.ml"
+ 
+   | 17 ->
+ # 130 "src/dlexer.mll"
+     ( lex_error (Printf.sprintf "invalid character [%s]" (string_of
+ lexbuf)) )
+ # 373 "src/dlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_initial_rec lexbuf __ocaml_lex_state
+ 
+ and comment lexbuf =
+     __ocaml_lex_comment_rec lexbuf 37
+ and __ocaml_lex_comment_rec lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 133 "src/dlexer.mll"
+            ( adj lexbuf ; () )
+ # 384 "src/dlexer.ml"
+ 
+   | 1 ->
+ # 134 "src/dlexer.mll"
+                 ( newline (); comment lexbuf )
+ # 389 "src/dlexer.ml"
+ 
+   | 2 ->
+ # 135 "src/dlexer.mll"
+                 ( adj lexbuf ; let _ = comment lexbuf in comment lexbuf )
+ # 394 "src/dlexer.ml"
+ 
+   | 3 ->
+ # 136 "src/dlexer.mll"
+                 ( lex_error "unterminated comment" )
+ # 399 "src/dlexer.ml"
+ 
+   | 4 ->
+ # 137 "src/dlexer.mll"
+          ( adj lexbuf ; comment lexbuf )
+ # 404 "src/dlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_comment_rec lexbuf __ocaml_lex_state
+ 
+ and widestring buf lexbuf =
+     __ocaml_lex_widestring_rec buf lexbuf 40
+ and __ocaml_lex_widestring_rec buf lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 139 "src/dlexer.mll"
+                  ( adj lexbuf ; STRING(Buffer.contents buf) )
+ # 415 "src/dlexer.ml"
+ 
+   | 1 ->
+ # 140 "src/dlexer.mll"
+                  ( lex_error "unterminated ~~~~~ string" )
+ # 420 "src/dlexer.ml"
+ 
+   | 2 ->
+ # 141 "src/dlexer.mll"
+                  ( newline (); Buffer.add_char buf '\n';widestring buf lexbuf)
+ # 425 "src/dlexer.ml"
+ 
+   | 3 ->
+ # 142 "src/dlexer.mll"
+                  ( adj lexbuf ; let str = string_of lexbuf in
+                    Buffer.add_string buf str ; widestring buf lexbuf )
+ # 431 "src/dlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_widestring_rec buf lexbuf __ocaml_lex_state
+ 
+ and endline lexbuf =
+     __ocaml_lex_endline_rec lexbuf 45
+ and __ocaml_lex_endline_rec lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 145 "src/dlexer.mll"
+                 ( newline (); initial lexbuf)
+ # 442 "src/dlexer.ml"
+ 
+   | 1 ->
+ # 146 "src/dlexer.mll"
+       ( adj lexbuf ; endline lexbuf)
+ # 447 "src/dlexer.ml"
+ 
+   | 2 ->
+ # 147 "src/dlexer.mll"
+                                 ( EOF )
+ # 452 "src/dlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_endline_rec lexbuf __ocaml_lex_state
+ 
+ ;;
+ 
