*** WeiDU-185/obj/x86_LINUX/tlexer.ml	1970-01-01 01:00:00.000000000 +0100
--- WeiDU/obj/x86_LINUX/tlexer.ml	2007-07-26 15:35:19.000000000 +0200
***************
*** 0 ****
--- 1,1004 ----
+ # 1 "src/tlexer.mll"
+  
+ 
+ open Util
+ open Tparser
+ 
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.dlexer.mll.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
+ (*
+ ** Keyword hashtable
+ *)
+ 
+ let string_of lb = (Lexing.lexeme lb)
+ 
+ let lexicon = Hashtbl.create 211
+ let _ = List.iter
+     (fun (key, token) -> Hashtbl.add lexicon key token)
+     [
+       ("LOOKUP_IDS_SYMBOL_OF_INT", SET_IDS_SYMBOL_OF_INT) ;
+       ("ACTION_DEFINE_ARRAY", ACTION_DEFINE_ARRAY) ;
+ 	    ("ACTION_BASH_FOR", ACTION_BASH_FOR) ;
+ 	    ("ACTION_FOR_EACH", ACTION_FOR_EACH) ;
+ 	    ("ACTION_PHP_EACH", ACTION_PHP_EACH) ;
+       ("ACTION_IF", ACTION_IF) ;
+       ("ACTION_READLN", ACTION_READLN);
+       ("ADD_CRE_ITEM", ADD_CRE_ITEM) ;
+       ("ADD_GAME_NPC", PATCH_GAM) ;
+       ("ADD_KIT", ADD_KIT) ;
+       ("ADD_KNOWN_SPELL", ADD_KNOWN_SPELL) ;
+       ("ADD_MEMORIZED_SPELL", ADD_MEMORIZED_SPELL) ;
+       ("ADD_MAP_NOTE", ADD_MAP_NOTE);
+       ("ADD_MUSIC", ADD_MUSIC) ;
+       ("ADD_PROJECTILE", ADD_PROJECTILE) ;
+       ("ADD_SPELL", ADD_SPELL) ;
+       ("ADD_STORE_ITEM", ADD_STORE_ITEM) ;
+       ("AFTER", AFTER) ;
+       ("ALLOW_MISSING", ALLOW_MISSING) ;
+       ("ALWAYS", ALWAYS) ;
+       ("APPEND", APPEND);
+       ("APPEND_COL", APPEND_COL);
+       ("APPEND_FILE", APPEND_FILE);
+       ("APPEND_FILE_EVALUATE", APPEND_FILE_EVALUATE);
+       ("APPEND_OUTER", APPEND_OUTER);
+       ("APPLY_BCS_PATCH", APPLY_BCS_PATCH) ;
+       ("APPLY_BCS_PATCH_OR_COPY", APPLY_BCS_PATCH_OR_COPY) ;
+       ("AS", AS) ;
+       ("ASK_EVERY_COMPONENT", ASK_EVERY_COMPONENT);
+       ("AT_EXIT", AT_EXIT);
+       ("AT_INTERACTIVE_EXIT", AT_INTERACTIVE_EXIT) ;
+       ("AT_INTERACTIVE_NOW", AT_INTERACTIVE_NOW) ;
+       ("AT_INTERACTIVE_UNINSTALL", AT_INTERACTIVE_UNINSTALL) ;
+       ("AT_NOW", AT_NOW) ;
+       ("AT_UNINSTALL", AT_UNINSTALL) ;
+       ("AUTHOR", AUTHOR);
+       ("AUTO_TRA", AUTO_TRA);
+       ("A_B_P", APPLY_BCS_PATCH) ;
+       ("BACKUP", BACKUP) ;
+       ("BEFORE", BEFORE) ;
+       ("BEGIN", BEGIN) ;
+       ("MAKE_BIFF", BIFF) ;
+       ("BUT_ONLY_IF_IT_CHANGES", BUT_ONLY_IF_IT_CHANGES);
+       ("BUT_ONLY", BUT_ONLY_IF_IT_CHANGES) ;
+       ("CASE_INSENSITIVE", CASE_INSENSITIVE) ;
+       ("CASE_SENSITIVE", CASE_SENSITIVE) ;
+       ("CLEAR_IDS_MAP", CLEAR_IDS_MAP) ;
+       ("CLEAR_MEMORY", CLEAR_MEMORY);
+       ("CLEAR_ARRAY", PATCH_CLEAR_ARRAY) ;
+       ("COMPILE", COMPILE);
+       ("COMPILE_BAF_TO_BCS", COMPILE_BAF_TO_BCS);
+       ("COMPILE_D_TO_DLG", COMPILE_D_TO_DLG);
+       ("COPY", COPY);
+       ("COPY_KIT", COPY_KIT);
+       ("COPY_ALL_GAM_FILES", COPY_ALL_GAM_FILES);
+       ("COPY_EXISTING", COPY_EXISTING);
+       ("COPY_EXISTING_REGEXP", COPY_EXISTING_REGEXP);
+       ("COPY_LARGE", COPY_LARGE);
+       ("COPY_RANDOM", COPY_RANDOM);
+       ("COUNT_2DA_ROWS", COUNT_2DA_ROWS) ;
+       ("COUNT_2DA_COLS", COUNT_2DA_COLS) ;
+       ("COUNT_REGEXP_INSTANCES", COUNT_REGEXP_INSTANCES) ;
+       ("DECOMPILE_BCS_TO_BAF", DECOMPILE_BCS_TO_BAF);
+       ("DECOMPILE_DLG_TO_D", DECOMPILE_DLG_TO_D);
+       ("DEFINE_ACTION_MACRO", DEFINE_ACTION_MACRO) ;
+       ("DEFINE_ARRAY", PATCH_DEFINE_ARRAY) ;
+       ("DEFINE_MACRO_ACTION", DEFINE_ACTION_MACRO) ;
+       ("DEFINE_MACRO_PATCH", DEFINE_PATCH_MACRO) ;
+       ("DEFINE_PATCH_MACRO", DEFINE_PATCH_MACRO) ;
+       ("DELETE_BYTES", DELETE_BYTES);
+       ("DEPRECATED", DEPRECATED);
+       ("DESCRIBE_ITEM", DESCRIBE_ITEM) ;
+       ("DESIGNATED", DESIGNATED);
+       ("ELSE", ELSE) ;
+       ("END", END) ;
+       ("EQUIP", EQUIP);
+       ("EVALUATE_REGEXP", EVALUATE_REGEXP);
+       ("EXACT_MATCH", EXACT_MATCH);
+       ("EXTEND",EXTEND_BOTTOM) ;
+       ("EXTEND_BOTTOM", EXTEND_BOTTOM) ;
+       ("EXTEND_BOTTOM_REGEXP", EXTEND_BOTTOM_REGEXP) ;
+       ("EXTEND_TOP", EXTEND_TOP) ;
+       ("EXTEND_TOP_REGEXP", EXTEND_TOP_REGEXP) ;
+       ("EVALUATE_BUFFER", EVALUATE_BUFFER) ;
+       ("FAIL", FAIL);
+       ("FILE_IS_IN_COMPRESSED_BIF",FILE_IS_IN_COMPRESSED_BIF);
+       ("FIRST", FIRST) ;
+       ("FOR", FOR) ;
+       ("FORBID_COMPONENT", FORBID_COMPONENT) ;
+       ("FORBID_FILE", FORBID_FILE) ;
+       ("FORCED_SUBCOMPONENT", FORCED_SUBCOMPONENT) ;
+       ("FROM", FROM) ;
+       ("GAME_IS", GAME_IS) ;
+       ("GET_OFFSET_ARRAY", GET_OFFSET_ARRAY) ;
+       ("GET_OFFSET_ARRAY2", GET_OFFSET_ARRAY2) ;
+       ("GET_STRREF", GET_STRREF) ;
+       ("GLOB", GLOB);
+       ("GROUP", GROUP) ;
+       ("IDS_OF_SYMBOL", IDS_OF_SYMBOL) ;
+       ("IF", IF) ;
+       ("IF_EVAL", IF_EVAL) ;
+       ("IF_FILE_EXISTS", IF_FILE_EXISTS) ;
+       ("IF_SIZE_IS", IF_SIZE_IS) ;
+       ("IN", IN) ;
+       ("INCLUDE", INCLUDE) ;
+       ("ACTION_INCLUDE", INCLUDE) ;
+       ("PATCH_INCLUDE", PATCH_INCLUDE) ;
+       ("INNER_ACTION", INNER_ACTION) ;
+       ("INNER_PATCH", INNER_PATCH) ;
+       ("INNER_PATCH_FILE", INNER_PATCH_FILE) ;
+       ("INNER_PATCH_SAVE", INNER_PATCH_SAVE) ;
+       ("INSERT_2DA_ROW", INSERT_2DA_ROW) ;
+       ("INSERT_BYTES", INSERT_BYTES);
+       ("INSERT_FILE", INSERT_FILE);
+       ("INSTALL_BY_DEFAULT", INSTALL_BY_DEFAULT) ;
+       ("IS_AN_INT", IS_AN_INT);
+       ("I_S_I", IF_SIZE_IS) ;
+       ("LANGUAGE", LANGUAGE) ;
+       ("LAST", LAST) ;
+       ("LAUNCH_ACTION_MACRO", LAUNCH_ACTION_MACRO) ;
+       ("LAUNCH_PATCH_MACRO", LAUNCH_PATCH_MACRO) ;
+       ("LAUNCH_MACRO_PATCH", LAUNCH_PATCH_MACRO) ;
+       ("LAUNCH_MACRO_ACTION", LAUNCH_ACTION_MACRO) ;
+       ("LOAD", LOAD) ;
+       ("LOAD_TRA", LOAD_TRA) ;
+       ("LOCAL_SET", LOCAL_SET) ;
+       ("LOCAL_SPRINT", LOCAL_SPRINT) ;
+       ("LOCAL_TEXT_SPRINT", LOCAL_TEXT_SPRINT) ;
+       ("MENU_STYLE", MENU_STYLE) ;
+       ("MKDIR", MKDIR) ;
+       ("MOD_IS_INSTALLED", MOD_IS_INSTALLED) ;
+       ("MODDER", MODDER) ;
+       ("NO_IF_EVAL_BUG", NO_IF_EVAL_BUG);
+       ("NO_LOG_RECORD", NO_LOG_RECORD) ;
+       ("NULL", NULL) ;
+       ("OUTER_FOR", OUTER_FOR) ;
+       ("OUTER_INNER_PATCH", OUTER_PATCH) ;
+       ("OUTER_INNER_PATCH_SAVE", OUTER_PATCH_SAVE) ;
+       ("OUTER_PATCH", OUTER_PATCH) ;
+       ("OUTER_PATCH_SAVE", OUTER_PATCH_SAVE) ;
+       ("OUTER_SET", OUTER_SET) ;
+       ("OUTER_SPRINT", OUTER_SPRINT) ;
+       ("OUTER_TEXT_SPRINT", OUTER_TEXT_SPRINT) ;
+       ("OUTER_WHILE", OUTER_WHILE);
+ 	    ("PATCH_BASH_FOR", PATCH_BASH_FOR) ;
+ 	    ("PATCH_DEFINE_ARRAY", PATCH_DEFINE_ARRAY) ;
+ 	    ("PATCH_PHP_EACH", PATCH_PHP_EACH) ;
+ 	    ("PATCH_FOR_EACH", PATCH_FOR_EACH) ;
+       ("PATCH_GAM", PATCH_GAM) ;
+       ("PATCH_IF", PATCH_IF) ;
+       ("PATCH_SILENT", PATCH_SILENT) ;
+       ("PATCH_PRINT", PATCH_PRINT);
+       ("PATCH_VERBOSE", PATCH_VERBOSE);
+       ("PHP_EACH", PATCH_PHP_EACH) ;
+       ("SPRINT", SPRINT);
+       ("SNPRINT", SNPRINT);
+       ("PRINT", PRINT);
+       ("PRETTY_PRINT_2DA", PRETTY_PRINT_2DA);
+       ("QUOTE", QUOTE);
+       ("RANDOM", RANDOM);
+       ("RANDOM_SEED", RANDOM_SEED);
+       ("PATCH_RANDOM_SEED", PATCH_RANDOM_SEED);
+       ("PATCH_READLN", PATCH_READLN);
+       ("READ_2DA_ENTRIES_NOW", READ_2DA_ENTRIES_NOW) ;
+       ("READ_2DA_ENTRY", READ_2DA_ENTRY) ;
+       ("READ_2DA_ENTRY_FORMER", READ_2DA_ENTRY_FORMER) ;
+       ("READ_ASCII", READ_ASCII);
+       ("READ_STRREF", READ_STRREF);
+       ("READ_BYTE", READ_BYTE) ;
+       ("READ_SBYTE", READ_SBYTE) ;
+       ("READ_SSHORT", READ_SSHORT) ;
+       ("READ_LONG", READ_LONG) ;
+       ("READ_SHORT", READ_SHORT) ;
+       ("REINCLUDE", REINCLUDE) ;
+       ("ACTION_REINCLUDE", REINCLUDE) ;
+       ("PATCH_REINCLUDE", PATCH_REINCLUDE) ;
+       ("README", README) ;
+       ("REMOVE_CRE_ITEM", REMOVE_CRE_ITEM) ;
+       ("REMOVE_KNOWN_SPELL", REMOVE_KNOWN_SPELL) ;
+       ("REMOVE_MEMORIZED_SPELL", REMOVE_MEMORIZED_SPELL) ;
+       ("REMOVE_STORE_ITEM", REMOVE_STORE_ITEM) ;
+       ("REPLACE", REPLACE) ;
+       ("REPLACE_BCS_BLOCK", REPLACE_BCS_BLOCK) ;
+       ("REPLACE_BCS_BLOCK_REGEXP", REPLACE_BCS_BLOCK_REGEXP) ;
+       ("REPLACE_CRE_ITEM", REPLACE_CRE_ITEM);
+       ("REPLACE_EVALUATE", REPLACE_EVALUATE) ;
+       ("REPLACE_TEXTUALLY", REPLACE_TEXTUALLY) ;
+       ("REQUIRE_COMPONENT", REQUIRE_COMPONENT) ;
+       ("REQUIRE_FILE", REQUIRE_FILE) ;
+       ("REQUIRE_PREDICATE", REQUIRE_PREDICATE) ;
+       ("R_B_B", REPLACE_BCS_BLOCK) ;
+       ("R_B_B_RE", REPLACE_BCS_BLOCK_REGEXP) ;
+       ("SAY", SAY) ;
+       ("SAY_EVALUATED", SAY_EVALUATED) ;
+       ("SCRIPT_STYLE", SCRIPT_STYLE) ;
+       ("SET", SET);
+       ("SET_2DA_ENTRY", SET_2DA_ENTRY) ;
+       ("SET_2DA_ENTRY_LATER", SET_2DA_ENTRY_LATER) ;
+       ("SET_2DA_ENTRIES_NOW", SET_2DA_ENTRIES_NOW) ;
+       ("SILENT", SILENT) ;
+       ("SPACES", SPACES) ;
+       ("STATE_WHICH_SAYS", STATE_WHICH_SAYS) ;
+       ("STRING_COMPARE", STRING_COMPARE) ;
+       ("STRING_COMPARE_CASE", STRING_COMPARE_CASE) ;
+       ("STRING_EQUAL", STRING_EQUAL) ;
+       ("STRING_EQUAL_CASE", STRING_EQUAL_CASE) ;
+       ("STRING_COMPARE_REGEXP", STRING_MATCHES_REGEXP) ;
+       ("STRING_MATCHES_REGEXP", STRING_MATCHES_REGEXP) ;
+       ("STRING_CONTAINS_REGEXP", STRING_CONTAINS_REGEXP) ;
+       ("STRING_SET", STRING_SET) ;
+       ("STRING_SET_EVALUATE", STRING_SET_EVALUATE) ;
+       ("STRING_SET_RANGE", STRING_SET_RANGE) ;
+       ("STR_CMP", STRING_COMPARE) ;
+       ("SUBCOMPONENT", SUBCOMPONENT) ;
+       ("SUB_COMPONENT", SUBCOMPONENT) ;
+       ("TEXT_SPRINT", TEXT_SPRINT) ;
+       ("THEN", THEN) ;
+       ("TO_LOWER", TO_LOWER) ;
+       ("TO_UPPER", TO_UPPER) ;
+       ("TWOHANDED", TWOHANDED);
+       ("UNINSTALL", UNINSTALL) ;
+       ("UNLESS", UNLESS) ;
+       ("USING", USING) ;
+       ("VARIABLE_IS_SET", VARIABLE_IS_SET) ;
+       ("VERBOSE", VERBOSE) ;
+       ("WHILE", WHILE) ;
+       ("WRITE_ASCII", WRITE_ASCII) ;
+       ("WRITE_ASCII_TERMINATE", WRITE_ASCII_TERMINATED) ;
+       ("WRITE_ASCIIT", WRITE_ASCII_TERMINATED) ;
+       ("WRITE_BYTE", WRITE_BYTE) ;
+       ("WRITE_EVALUATED_ASCII", WRITE_EVALUATED_ASCII) ;
+       ("WRITE_ASCIIE", WRITE_EVALUATED_ASCII) ;
+       ("WRITE_FILE", WRITE_FILE) ;
+       ("WRITE_LONG", WRITE_LONG) ;
+       ("WRITE_SHORT", WRITE_SHORT) ;
+       
+       ("ITM_V10_HEADERS", ITM_V10_HEADERS) ;
+       ("ITM_V10_GEN_EFFECTS", ITM_V10_GEN_EFFECTS) ;
+       
+       ("ITM_V10_HEAD_EFFECTS", ITM_V10_HEAD_EFFECTS) ;
+ 
+       (* predicates *)
+       ("FILE_EXISTS", FILE_EXISTS ) ;
+       ("FILE_MD5", FILE_MD5 ) ;
+       ("FILE_EXISTS_IN_GAME", FILE_EXISTS_IN_GAME ) ;
+       ("FILE_SIZE", FILE_SIZE ) ;
+       ("FILE_CONTAINS", FILE_CONTAINS ) ;
+       ("FILE_CONTAINS_EVALUATED", FILE_CONTAINS_EVALUATED ) ;
+       ("AND", AND) ;
+       ("OR", OR) ;
+       ("NOT", NOT) ;
+ 
+       ("BAND", BAND) ;
+       ("BOR", BOR) ;
+       ("BNOT", BNOT) ;
+       ("BXOR", BXOR) ;
+       ("BLSL", BLSL) ;
+       ("BLSR", BLSR) ;
+       ("BASR", BASR) ;
+     ]
+ 
+ (*
+ ** Buffer processor
+ *)
+ 
+ 
+ 
+ 
+ 
+ # 295 "src/tlexer.ml"
+ let __ocaml_lex_tables = {
+   Lexing.lex_base = 
+    "\000\000\202\255\203\255\080\000\093\000\116\000\002\000\010\000\
+     \001\000\030\000\217\255\194\000\102\000\031\000\045\000\092\000\
+     \095\000\097\000\118\000\032\000\093\000\245\255\246\255\247\255\
+     \248\255\249\255\250\255\251\255\252\255\253\255\212\000\231\255\
+     \254\255\255\255\234\255\233\255\232\255\241\255\213\255\214\255\
+     \216\255\113\000\227\255\215\255\115\000\117\000\228\255\118\000\
+     \120\000\147\000\148\000\014\000\204\255\001\000\004\000\148\000\
+     \226\255\220\255\230\255\221\255\229\255\226\000\239\000\212\255\
+     \211\255\117\000\086\000\114\000\210\255\115\000\126\000\205\255\
+     \219\000\224\000\249\000\003\001\013\001\023\001\071\001\220\000\
+     \216\000\254\000\139\000\141\000\142\000\143\000\072\001\209\000\
+     \210\000\222\000\223\000\021\001\022\001\023\001\076\001";
+   Lexing.lex_backtrk = 
+    "\255\255\255\255\255\255\053\000\053\000\046\000\053\000\053\000\
+     \053\000\053\000\255\255\030\000\031\000\032\000\020\000\018\000\
+     \017\000\016\000\013\000\012\000\011\000\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\015\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\037\000\255\255\255\255\036\000\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\033\000\
+     \255\255\255\255\255\255\255\255\255\255\048\000\255\255\255\255\
+     \255\255\255\255\045\000\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\047\000\255\255\049\000\255\255\255\255\004\000\
+     \004\000\255\255\003\000\255\255\255\255\255\255\255\255\003\000\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255";
+   Lexing.lex_default = 
+    "\001\000\000\000\000\000\255\255\255\255\255\255\073\000\072\000\
+     \067\000\065\000\000\000\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\255\255\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\255\255\000\000\000\000\255\255\255\255\000\000\255\255\
+     \255\255\255\255\255\255\054\000\000\000\255\255\054\000\255\255\
+     \000\000\000\000\000\000\000\000\000\000\255\255\255\255\000\000\
+     \000\000\065\000\255\255\067\000\000\000\255\255\255\255\000\000\
+     \072\000\073\000\255\255\255\255\255\255\255\255\027\000\255\255\
+     \255\255\028\000\255\255\255\255\255\255\255\255\028\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\032\000";
+   Lexing.lex_trans = 
+    "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\028\000\027\000\052\000\029\000\029\000\052\000\000\000\
+     \000\000\053\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \052\000\000\000\000\000\053\000\000\000\000\000\000\000\000\000\
+     \029\000\011\000\007\000\004\000\023\000\006\000\012\000\068\000\
+     \026\000\025\000\018\000\020\000\068\000\019\000\051\000\030\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\022\000\021\000\015\000\017\000\016\000\024\000\
+     \003\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\009\000\058\000\035\000\014\000\005\000\
+     \010\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\064\000\013\000\077\000\008\000\066\000\
+     \076\000\076\000\076\000\076\000\076\000\076\000\076\000\076\000\
+     \076\000\076\000\075\000\055\000\059\000\074\000\074\000\074\000\
+     \074\000\074\000\074\000\074\000\074\000\074\000\074\000\005\000\
+     \044\000\043\000\034\000\057\000\040\000\041\000\038\000\039\000\
+     \037\000\005\000\005\000\060\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\042\000\045\000\
+     \046\000\047\000\048\000\036\000\049\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\050\000\
+     \051\000\056\000\064\000\005\000\069\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\062\000\
+     \068\000\070\000\061\000\061\000\061\000\061\000\061\000\061\000\
+     \061\000\061\000\061\000\061\000\071\000\068\000\033\000\063\000\
+     \002\000\255\255\255\255\032\000\255\255\068\000\029\000\033\000\
+     \029\000\083\000\255\255\084\000\085\000\033\000\255\255\088\000\
+     \089\000\031\000\061\000\061\000\061\000\061\000\061\000\061\000\
+     \061\000\061\000\061\000\061\000\090\000\091\000\255\255\061\000\
+     \061\000\061\000\061\000\061\000\061\000\061\000\061\000\061\000\
+     \061\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
+     \074\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
+     \074\000\074\000\074\000\074\000\074\000\076\000\076\000\076\000\
+     \076\000\076\000\076\000\076\000\076\000\076\000\076\000\076\000\
+     \076\000\076\000\076\000\076\000\076\000\076\000\076\000\076\000\
+     \076\000\032\000\029\000\092\000\093\000\033\000\033\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\080\000\255\255\000\000\000\000\255\255\079\000\000\000\
+     \000\000\000\000\000\000\000\000\082\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\087\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\255\255\000\000\000\000\000\000\000\000\
+     \255\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\032\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\000\
+     \032\000\000\000\000\000\000\000\029\000";
+   Lexing.lex_check = 
+    "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\000\000\000\000\053\000\000\000\000\000\054\000\255\255\
+     \255\255\054\000\255\255\255\255\255\255\255\255\255\255\255\255\
+     \051\000\255\255\255\255\051\000\255\255\255\255\255\255\255\255\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\
+     \000\000\000\000\000\000\000\000\007\000\000\000\051\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\013\000\019\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\009\000\000\000\003\000\000\000\008\000\
+     \003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
+     \003\000\003\000\004\000\014\000\012\000\004\000\004\000\004\000\
+     \004\000\004\000\004\000\004\000\004\000\004\000\004\000\005\000\
+     \015\000\015\000\020\000\013\000\016\000\016\000\017\000\017\000\
+     \018\000\005\000\005\000\012\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\041\000\044\000\
+     \044\000\045\000\047\000\018\000\048\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\049\000\
+     \050\000\055\000\065\000\005\000\066\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\005\000\
+     \005\000\005\000\005\000\005\000\005\000\005\000\005\000\011\000\
+     \067\000\069\000\011\000\011\000\011\000\011\000\011\000\011\000\
+     \011\000\011\000\011\000\011\000\070\000\072\000\030\000\011\000\
+     \000\000\008\000\006\000\030\000\054\000\073\000\079\000\080\000\
+     \081\000\082\000\007\000\083\000\084\000\085\000\051\000\087\000\
+     \088\000\030\000\061\000\061\000\061\000\061\000\061\000\061\000\
+     \061\000\061\000\061\000\061\000\089\000\090\000\009\000\062\000\
+     \062\000\062\000\062\000\062\000\062\000\062\000\062\000\062\000\
+     \062\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
+     \074\000\074\000\074\000\075\000\075\000\075\000\075\000\075\000\
+     \075\000\075\000\075\000\075\000\075\000\076\000\076\000\076\000\
+     \076\000\076\000\076\000\076\000\076\000\076\000\076\000\077\000\
+     \077\000\077\000\077\000\077\000\077\000\077\000\077\000\077\000\
+     \077\000\078\000\086\000\091\000\092\000\093\000\094\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\078\000\067\000\255\255\255\255\065\000\078\000\255\255\
+     \255\255\255\255\255\255\255\255\081\000\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\086\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\072\000\255\255\255\255\255\255\255\255\
+     \073\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\081\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\078\000\
+     \086\000\255\255\255\255\255\255\094\000";
+   Lexing.lex_base_code = 
+    "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\014\000\000\000\001\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000";
+   Lexing.lex_backtrk_code = 
+    "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000";
+   Lexing.lex_default_code = 
+    "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\006\000\000\000\000\000\006\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000";
+   Lexing.lex_trans_code = 
+    "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \009\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
+     \000\000\000\000";
+   Lexing.lex_check_code = 
+    "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\051\000\054\000\255\255\051\000\054\000\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \051\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\050\000\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
+     \051\000\054\000";
+   Lexing.lex_code = 
+    "\255\003\255\002\255\255\003\255\255\002\255\003\255\255\000\002\
+     \001\003\255";
+ }
+ 
+ let rec initial lexbuf =
+   lexbuf.Lexing.lex_mem <- Array.create 4 (-1) ;   __ocaml_lex_initial_rec lexbuf 0
+ and __ocaml_lex_initial_rec lexbuf __ocaml_lex_state =
+   match Lexing.new_engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 301 "src/tlexer.mll"
+         ( adj lexbuf ; let _ = comment lexbuf in initial lexbuf)
+ # 605 "src/tlexer.ml"
+ 
+   | 1 ->
+ # 302 "src/tlexer.mll"
+         ( adj lexbuf ; endline lexbuf )
+ # 610 "src/tlexer.ml"
+ 
+   | 2 ->
+ # 303 "src/tlexer.mll"
+         ( adj lexbuf ; initial lexbuf)
+ # 615 "src/tlexer.ml"
+ 
+   | 3 ->
+ # 304 "src/tlexer.mll"
+         ( tab (); initial lexbuf )
+ # 620 "src/tlexer.ml"
+ 
+   | 4 ->
+ # 305 "src/tlexer.mll"
+         ( newline (); initial lexbuf )
+ # 625 "src/tlexer.ml"
+ 
+   | 5 ->
+ # 306 "src/tlexer.mll"
+         ( adj lexbuf ; LPAREN )
+ # 630 "src/tlexer.ml"
+ 
+   | 6 ->
+ # 307 "src/tlexer.mll"
+         ( adj lexbuf ; RPAREN )
+ # 635 "src/tlexer.ml"
+ 
+   | 7 ->
+ # 308 "src/tlexer.mll"
+         ( adj lexbuf ; QUESTION )
+ # 640 "src/tlexer.ml"
+ 
+   | 8 ->
+ # 309 "src/tlexer.mll"
+         ( adj lexbuf ; DOLLARS )
+ # 645 "src/tlexer.ml"
+ 
+   | 9 ->
+ # 310 "src/tlexer.mll"
+         ( adj lexbuf ; COLON )
+ # 650 "src/tlexer.ml"
+ 
+   | 10 ->
+ # 311 "src/tlexer.mll"
+         ( adj lexbuf ; SEMICOLON )
+ # 655 "src/tlexer.ml"
+ 
+   | 11 ->
+ # 312 "src/tlexer.mll"
+         ( adj lexbuf ; PLUS )
+ # 660 "src/tlexer.ml"
+ 
+   | 12 ->
+ # 313 "src/tlexer.mll"
+         ( adj lexbuf ; MINUS )
+ # 665 "src/tlexer.ml"
+ 
+   | 13 ->
+ # 314 "src/tlexer.mll"
+         ( adj lexbuf ; TIMES )
+ # 670 "src/tlexer.ml"
+ 
+   | 14 ->
+ # 315 "src/tlexer.mll"
+          ( adj lexbuf ; TIMESTIMES )
+ # 675 "src/tlexer.ml"
+ 
+   | 15 ->
+ # 316 "src/tlexer.mll"
+         ( adj lexbuf ; DIVIDE )
+ # 680 "src/tlexer.ml"
+ 
+   | 16 ->
+ # 317 "src/tlexer.mll"
+         ( adj lexbuf ; EQUALS )
+ # 685 "src/tlexer.ml"
+ 
+   | 17 ->
+ # 318 "src/tlexer.mll"
+         ( adj lexbuf ; GT )
+ # 690 "src/tlexer.ml"
+ 
+   | 18 ->
+ # 319 "src/tlexer.mll"
+         ( adj lexbuf ; LT )
+ # 695 "src/tlexer.ml"
+ 
+   | 19 ->
+ # 320 "src/tlexer.mll"
+         ( adj lexbuf ; PLUS )
+ # 700 "src/tlexer.ml"
+ 
+   | 20 ->
+ # 321 "src/tlexer.mll"
+         ( adj lexbuf ; STRING_CONCAT )
+ # 705 "src/tlexer.ml"
+ 
+   | 21 ->
+ # 323 "src/tlexer.mll"
+         ( adj lexbuf ; PLUS_EQUALS )
+ # 710 "src/tlexer.ml"
+ 
+   | 22 ->
+ # 324 "src/tlexer.mll"
+         ( adj lexbuf ; MINUS_EQUALS )
+ # 715 "src/tlexer.ml"
+ 
+   | 23 ->
+ # 325 "src/tlexer.mll"
+         ( adj lexbuf ; TIMES_EQUALS )
+ # 720 "src/tlexer.ml"
+ 
+   | 24 ->
+ # 326 "src/tlexer.mll"
+         ( adj lexbuf ; DIVIDE_EQUALS )
+ # 725 "src/tlexer.ml"
+ 
+   | 25 ->
+ # 327 "src/tlexer.mll"
+         ( adj lexbuf ; OR_EQUALS )
+ # 730 "src/tlexer.ml"
+ 
+   | 26 ->
+ # 328 "src/tlexer.mll"
+         ( adj lexbuf ; AND_EQUALS )
+ # 735 "src/tlexer.ml"
+ 
+   | 27 ->
+ # 329 "src/tlexer.mll"
+         ( adj lexbuf ; BLSL_EQUALS )
+ # 740 "src/tlexer.ml"
+ 
+   | 28 ->
+ # 330 "src/tlexer.mll"
+         ( adj lexbuf ; BLSR_EQUALS )
+ # 745 "src/tlexer.ml"
+ 
+   | 29 ->
+ # 331 "src/tlexer.mll"
+         ( adj lexbuf ; BXOR_EQUALS )
+ # 750 "src/tlexer.ml"
+ 
+   | 30 ->
+ # 333 "src/tlexer.mll"
+         ( adj lexbuf ; NOT )
+ # 755 "src/tlexer.ml"
+ 
+   | 31 ->
+ # 334 "src/tlexer.mll"
+        ( adj lexbuf ; BAND )
+ # 760 "src/tlexer.ml"
+ 
+   | 32 ->
+ # 335 "src/tlexer.mll"
+        ( adj lexbuf ; BOR )
+ # 765 "src/tlexer.ml"
+ 
+   | 33 ->
+ # 336 "src/tlexer.mll"
+        ( adj lexbuf ; BXOR )
+ # 770 "src/tlexer.ml"
+ 
+   | 34 ->
+ # 337 "src/tlexer.mll"
+         ( adj lexbuf ; AND )
+ # 775 "src/tlexer.ml"
+ 
+   | 35 ->
+ # 338 "src/tlexer.mll"
+         ( adj lexbuf ; OR )
+ # 780 "src/tlexer.ml"
+ 
+   | 36 ->
+ # 339 "src/tlexer.mll"
+         ( adj lexbuf ; BLSL )
+ # 785 "src/tlexer.ml"
+ 
+   | 37 ->
+ # 340 "src/tlexer.mll"
+         ( adj lexbuf ; BLSR )
+ # 790 "src/tlexer.ml"
+ 
+   | 38 ->
+ # 341 "src/tlexer.mll"
+         ( adj lexbuf ; BNOT )
+ # 795 "src/tlexer.ml"
+ 
+   | 39 ->
+ # 343 "src/tlexer.mll"
+          ( adj lexbuf ; GTE )
+ # 800 "src/tlexer.ml"
+ 
+   | 40 ->
+ # 344 "src/tlexer.mll"
+          ( adj lexbuf ; LTE )
+ # 805 "src/tlexer.ml"
+ 
+   | 41 ->
+ # 345 "src/tlexer.mll"
+          ( adj lexbuf ; EQUALSGREATER )
+ # 810 "src/tlexer.ml"
+ 
+   | 42 ->
+ # 346 "src/tlexer.mll"
+         ( adj lexbuf ; EQUALSEQUALS )
+ # 815 "src/tlexer.ml"
+ 
+   | 43 ->
+ # 347 "src/tlexer.mll"
+         ( adj lexbuf ; NOTEQUALS )
+ # 820 "src/tlexer.ml"
+ 
+   | 44 ->
+ # 348 "src/tlexer.mll"
+                 ( str_adj lexbuf ; SOUND(strip (string_of lexbuf)) )
+ # 825 "src/tlexer.ml"
+ 
+   | 45 ->
+ # 351 "src/tlexer.mll"
+                  ( str_adj lexbuf ; STRING(strip (string_of lexbuf)) )
+ # 830 "src/tlexer.ml"
+ 
+   | 46 ->
+ # 352 "src/tlexer.mll"
+                                                                  (
+     adj lexbuf ; try Hashtbl.find lexicon (string_of lexbuf)
+     with _ -> STRING(string_of lexbuf) )
+ # 837 "src/tlexer.ml"
+ 
+   | 47 ->
+ # 355 "src/tlexer.mll"
+                       ( adj lexbuf ;
+       let str = string_of lexbuf in
+       let str = String.sub str 1 ((String.length str) - 1) in
+       STRING_REF((int_of_string str)) )
+ # 845 "src/tlexer.ml"
+ 
+   | 48 ->
+ # 359 "src/tlexer.mll"
+                       ( adj lexbuf ;
+       let str = string_of lexbuf in
+       let str = String.sub str 1 ((String.length str) - 1) in
+       FORCED_STRING_REF((int_of_string str)) )
+ # 853 "src/tlexer.ml"
+ 
+   | 49 ->
+ # 363 "src/tlexer.mll"
+                       ( adj lexbuf ;
+       let str = string_of lexbuf in
+       let str = String.sub str 1 ((String.length str) - 1) in
+       TRANS_REF((int_of_string str)) )
+ # 861 "src/tlexer.ml"
+ 
+   | 50 ->
+ # 367 "src/tlexer.mll"
+           ( adj lexbuf ; let buf = Buffer.create 255 in widestring buf lexbuf )
+ # 866 "src/tlexer.ml"
+ 
+   | 51 ->
+ let
+ # 368 "src/tlexer.mll"
+                                      name
+ # 872 "src/tlexer.ml"
+ = Lexing.sub_lexeme lexbuf lexbuf.Lexing.lex_mem.(0) lexbuf.Lexing.lex_mem.(1) in
+ # 368 "src/tlexer.mll"
+                                                        (
+   adj lexbuf ;
+   let buf = Buffer.create 10240 in
+   inlined name buf lexbuf )
+ # 879 "src/tlexer.ml"
+ 
+   | 52 ->
+ # 372 "src/tlexer.mll"
+         ( EOF )
+ # 884 "src/tlexer.ml"
+ 
+   | 53 ->
+ # 373 "src/tlexer.mll"
+     ( lex_error (Printf.sprintf "invalid character [%s]" (string_of
+ lexbuf)) )
+ # 890 "src/tlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_initial_rec lexbuf __ocaml_lex_state
+ 
+ and comment lexbuf =
+     __ocaml_lex_comment_rec lexbuf 78
+ and __ocaml_lex_comment_rec lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 376 "src/tlexer.mll"
+            ( adj lexbuf ; () )
+ # 901 "src/tlexer.ml"
+ 
+   | 1 ->
+ # 377 "src/tlexer.mll"
+                 ( newline (); comment lexbuf )
+ # 906 "src/tlexer.ml"
+ 
+   | 2 ->
+ # 378 "src/tlexer.mll"
+                 ( adj lexbuf ; let _ = comment lexbuf in comment lexbuf )
+ # 911 "src/tlexer.ml"
+ 
+   | 3 ->
+ # 379 "src/tlexer.mll"
+                 ( lex_error "unterminated comment" )
+ # 916 "src/tlexer.ml"
+ 
+   | 4 ->
+ # 380 "src/tlexer.mll"
+          ( adj lexbuf ; comment lexbuf )
+ # 921 "src/tlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_comment_rec lexbuf __ocaml_lex_state
+ 
+ and widestring buf lexbuf =
+     __ocaml_lex_widestring_rec buf lexbuf 81
+ and __ocaml_lex_widestring_rec buf lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 382 "src/tlexer.mll"
+                  ( adj lexbuf ; STRING(Buffer.contents buf) )
+ # 932 "src/tlexer.ml"
+ 
+   | 1 ->
+ # 383 "src/tlexer.mll"
+                  ( lex_error "unterminated ~~~~~ string" )
+ # 937 "src/tlexer.ml"
+ 
+   | 2 ->
+ # 384 "src/tlexer.mll"
+                  ( newline (); Buffer.add_char buf '\n';widestring buf lexbuf)
+ # 942 "src/tlexer.ml"
+ 
+   | 3 ->
+ # 385 "src/tlexer.mll"
+                  ( adj lexbuf ; let str = string_of lexbuf in
+                    Buffer.add_string buf str ; widestring buf lexbuf )
+ # 948 "src/tlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_widestring_rec buf lexbuf __ocaml_lex_state
+ 
+ and inlined name buf lexbuf =
+     __ocaml_lex_inlined_rec name buf lexbuf 86
+ and __ocaml_lex_inlined_rec name buf lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 388 "src/tlexer.mll"
+                 ( adj lexbuf ;
+                   INLINED_FILE(name,(Buffer.contents buf)) )
+ # 960 "src/tlexer.ml"
+ 
+   | 1 ->
+ # 390 "src/tlexer.mll"
+                 ( lex_error "unterminated inlined file" )
+ # 965 "src/tlexer.ml"
+ 
+   | 2 ->
+ # 391 "src/tlexer.mll"
+                 ( newline (); Buffer.add_char buf '\n' ;
+                   inlined name buf lexbuf )
+ # 971 "src/tlexer.ml"
+ 
+   | 3 ->
+ # 393 "src/tlexer.mll"
+                 ( adj lexbuf ;
+                   let str = string_of lexbuf in
+                   Buffer.add_string buf str ;
+                   inlined name buf lexbuf )
+ # 979 "src/tlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_inlined_rec name buf lexbuf __ocaml_lex_state
+ 
+ and endline lexbuf =
+     __ocaml_lex_endline_rec lexbuf 94
+ and __ocaml_lex_endline_rec lexbuf __ocaml_lex_state =
+   match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
+       | 0 ->
+ # 398 "src/tlexer.mll"
+                 ( newline (); initial lexbuf)
+ # 990 "src/tlexer.ml"
+ 
+   | 1 ->
+ # 399 "src/tlexer.mll"
+       ( adj lexbuf ; endline lexbuf)
+ # 995 "src/tlexer.ml"
+ 
+   | 2 ->
+ # 400 "src/tlexer.mll"
+                                 ( EOF )
+ # 1000 "src/tlexer.ml"
+ 
+   | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_endline_rec lexbuf __ocaml_lex_state
+ 
+ ;;
+ 
