*** WeiDU-185/src/arch_cygwin.ml	2005-05-18 22:14:05.000000000 +0200
--- WeiDU/src/arch_cygwin.ml	2007-06-21 16:10:46.000000000 +0200
***************
*** 1,3 ****
--- 1,11 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.arch_cygwin.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (* CygWin Arch-Specific Definitions *)
  
  (* Query the Windows Registry to find out about Infinity Engine games. *)
***************
*** 21,40 ****
  (* no slash removal: helps make shell scripts work better *)
  let slash_to_backslash s = s 
  
  (* how to view a text file *)
  let view_command = "less" 
  
  let do_auto_update = false 
  
  (* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
! let handle_view_command s =
!   let view_regexp = Str.regexp_case_fold "^VIEW" in
!   if Str.string_match view_regexp s 0 then begin
!     (* first, replace VIEW with my view command *) 
!     let result = Str.replace_first view_regexp view_command s in 
!     (* next, for unix, replace \ with / *)
!     Str.global_replace (Str.regexp (Str.quote "\\")) "/" result 
!   end else s 
  
  let glob str fn = failwith "no globbing support"
  
--- 29,55 ----
  (* no slash removal: helps make shell scripts work better *)
  let slash_to_backslash s = s 
  
+ let backslash_to_slash s =
+   let s = Str.global_replace (Str.regexp "\\\\") "/" s in
+   s
+ 
  (* how to view a text file *)
  let view_command = "less" 
  
  let do_auto_update = false 
  
  (* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
! let handle_view_command s skip =
!   let result = ref s in
!   List.iter (fun view_regexp ->
!     if Str.string_match view_regexp !result 0 then begin
!       result := Str.replace_first view_regexp view_command !result ;
!       result := Str.global_replace (Str.regexp (Str.quote "\\")) "/" !result;
!     end) [Str.regexp_case_fold "^VIEW" ; Str.regexp_case_fold "^NOTEPAD" ;
!           Str.regexp_case_fold "^EXPLORER"];
!   if skip && (s <> !result) then result := "";
!   let s = !result in
!   s
  
  let glob str fn = failwith "no globbing support"
  
