*** WeiDU-185/src/arch_unix.ml	2005-05-18 22:16:08.000000000 +0200
--- WeiDU/src/arch_unix.ml	2007-06-21 16:10:46.000000000 +0200
***************
*** 1,3 ****
--- 1,11 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.arch_unix.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (* Generic Unix Definitions *)
  
  let registry_paths = ref [ "\\BGII - SoA\\" ] 
***************
*** 5,24 ****
  (* no slash removal: helps make shell scripts work better *)
  let slash_to_backslash s = s 
  
! (* how to view a text file *)
! let view_command = "less" 
  
  let do_auto_update = false 
  
  (* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
! let handle_view_command s =
!   let view_regexp = Str.regexp_case_fold "^VIEW" in
!   if Str.string_match view_regexp s 0 then begin
!     (* first, replace VIEW with my view command *) 
!     let result = Str.replace_first view_regexp view_command s in 
!     (* next, for unix, replace \ with / *)
!     Str.global_replace (Str.regexp (Str.quote "\\")) "/" result 
!   end else s 
  
  let glob str fn = failwith "no globbing support"
  
--- 13,40 ----
  (* no slash removal: helps make shell scripts work better *)
  let slash_to_backslash s = s 
  
! let backslash_to_slash s =
!   let s = Str.global_replace (Str.regexp "\\\\") "/" s in
!   s
! 
! (* how to view a text (or HTML) file on 90% of linuxes *)
! let view_command = "firefox ./"
  
  let do_auto_update = false
  
  (* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
! let handle_view_command s skip =
!   let result = ref s in
!   List.iter (fun view_regexp ->
!     if Str.string_match view_regexp !result 0 then begin
!       result := Str.replace_first view_regexp view_command !result ;
!       result := Str.global_replace (Str.regexp (Str.quote "\\")) "/" !result ;
!     end) [Str.regexp_case_fold "^VIEW[ \t]*" ; Str.regexp_case_fold "^NOTEPAD[ \t]*" ;
!           Str.regexp_case_fold "^EXPLORER[ \t]*"];
!   if skip && (s <> !result) then result := "";
!   let s = String.lowercase !result in
! (*  Printf.printf "exec: %s\n" s; *)
!   s
  
  let glob str fn = failwith "no globbing support"
  
