*** WeiDU-185/src/biff.ml	2004-02-16 20:15:14.000000000 +0100
--- WeiDU/src/biff.ml	2007-06-21 16:11:09.000000000 +0200
***************
*** 1,6 ****
--- 1,15 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.biff.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (* Infinity Engine [BIF] *)
  open Util
  open Key
+ open Cbif
  
  type biff_file = {
    res_loc       : int ;
***************
*** 29,41 ****
   * save the biff to the disk
   * returns an updated KEY _that can only be saved, cannot be used_ 
   *)
! let save_biff key filename components = begin
    let all_components = List.flatten (List.map (fun file ->
      let size = file_size file in
      if size > 0 then begin
        let a,b = split (Filename.basename file) in
        try 
!         let tau = key_of_ext b in 
          [ (size,file,String.uppercase a,String.uppercase b,tau) ]
        with _ -> 
          log_only "WARNING: Not including [%s]: unknown resource type\n" 
--- 38,51 ----
   * save the biff to the disk
   * returns an updated KEY _that can only be saved, cannot be used_
   *)
! let save_biff key filename components = 
!   begin
    let all_components = List.flatten (List.map (fun file ->
      let size = file_size file in
      if size > 0 then begin
        let a,b = split (Filename.basename file) in
        try
!         let tau = key_of_ext false b in
          [ (size,file,String.uppercase a,String.uppercase b,tau) ]
        with _ ->
          log_only "WARNING: Not including [%s]: unknown resource type\n"
***************
*** 44,50 ****
    ) components) in
    let total_size = List.fold_left (fun acc (s,f,a,b,t) -> acc + s) 0
      all_components in
!   let tis_key = key_of_ext "TIS" in 
    let files,tiles = List.partition (fun (s,f,a,b,t) -> t <> tis_key)
     all_components in  
    let files = Array.of_list files in
--- 54,60 ----
    ) components) in
    let total_size = List.fold_left (fun acc (s,f,a,b,t) -> acc + s) 0
      all_components in
!   let tis_key = key_of_ext true "TIS" in
    let files,tiles = List.partition (fun (s,f,a,b,t) -> t <> tis_key)
     all_components in
    let files = Array.of_list files in
***************
*** 81,86 ****
--- 91,101 ----
      offset_data := !offset_data + s ;
    ) files ;
    Array.iteri (fun i (s,f,a,b,t) ->
+     let in_fd = Case_ins.unix_openfile f [Unix.O_RDONLY] 0 in
+     let istis = String.create 8 in
+       my_read 8 in_fd istis f ;
+     Unix.close in_fd ;
+     let s = (if istis = "TIS V1  " then s - 24 else s) in
      let off = offset_tiles + (i * 20) in
      let tis_loc = (i + 1) lsl 14 in
      write_int buff (off+0) tis_loc ; (* resource location *)
***************
*** 93,99 ****
      write_short buff (off+16) tis_type ;
      offset_data := !offset_data + s;
    ) tiles ; 
!   let out_fd = Unix.openfile filename [Unix.O_RDWR ; Unix.O_CREAT] 0 in 
    my_write buff_size out_fd buff filename ;
  
    let chunk_size = 10240 in
--- 108,114 ----
      write_short buff (off+16) tis_type ;
      offset_data := !offset_data + s;
    ) tiles ;
!   let out_fd = Unix.descr_of_out_channel (open_for_writing filename true) in
    my_write buff_size out_fd buff filename ;
  
    let chunk_size = 10240 in
***************
*** 110,127 ****
    in 
    Array.iteri (fun i (s,f,a,b,t) ->
      log_only "[%s] incorporating [%s]\n" filename f ;
!     let in_fd = Unix.openfile f [Unix.O_RDONLY] 0 in 
      copy_over in_fd f s ;
      Unix.close in_fd ;
    ) files ; 
    Array.iteri (fun i (s,f,a,b,t) ->
      log_only "[%s] incorporating [%s]\n" filename f ;
!     let in_fd = Unix.openfile f [Unix.O_RDONLY] 0 in 
      copy_over in_fd f s ;
      Unix.close in_fd ;
    ) tiles ; 
  
    Unix.close out_fd ;
  
    let total_size = file_size filename in 
  
--- 125,159 ----
    in
    Array.iteri (fun i (s,f,a,b,t) ->
      log_only "[%s] incorporating [%s]\n" filename f ;
!     let in_fd = Case_ins.unix_openfile f [Unix.O_RDONLY] 0 in
      copy_over in_fd f s ;
      Unix.close in_fd ;
    ) files ;
    Array.iteri (fun i (s,f,a,b,t) ->
      log_only "[%s] incorporating [%s]\n" filename f ;
!     let in_fd = Case_ins.unix_openfile f [Unix.O_RDONLY] 0 in
!     let istis = String.create 8 in
!       my_read 8 in_fd istis f ;
!     Unix.close in_fd ;
!     let in_fd = Case_ins.unix_openfile f [Unix.O_RDONLY] 0 in
!       if istis = "TIS V1  " then begin
!         let istis = String.create 24 in
!         (* have it skip the first 24 bytes *)
!         my_read 24 in_fd istis f ;
!         copy_over in_fd f (s - 24) ;
!       end else
          copy_over in_fd f s ;
+       ;
      Unix.close in_fd ;
    ) tiles ;
  
    Unix.close out_fd ;
+   if true then
+   begin
+     try
+       Case_ins.unix_chmod filename 511 ;
+     with e -> ()
+   end ;
  
    let total_size = file_size filename in
  
***************
*** 174,183 ****
    } 
  end 
  
- (* comment this out if you don't have zlib *)
- external uncompress : string -> pos:int -> clen:int -> ulen: int -> string
-   = "mlgz_uncompress"
- 
  (* reads 'size' bytes that would start at location 'start' in this BIFF
   * if it were not compressed! *)
  let read_compressed_biff_internal fd filename start size chunk_fun =
--- 206,211 ----
***************
*** 185,191 ****
    let unc_offset = ref 0 in 
  
    (* buffer holds the uncompressed bytes [start_unc,end_unc]  *)
!   let result = Buffer.create size in 
    let start_unc_offset = ref 0 in 
    let end_unc_offset = ref 0 in 
  
--- 213,219 ----
    let unc_offset = ref 0 in 
  
    (* buffer holds the uncompressed bytes [start_unc,end_unc]  *)
!   let (*result*) _ = Buffer.create size in
    let start_unc_offset = ref 0 in 
    let end_unc_offset = ref 0 in
  
***************
*** 218,224 ****
        let _ = Unix.lseek fd (!cmp_offset+8) Unix.SEEK_SET in 
        let cmp_buff = String.create cmplen in 
        my_read cmplen fd cmp_buff filename ;
!       let uncmp = uncompress cmp_buff 0 cmplen uncmplen in
        (*
        if (String.length uncmp <> uncmplen) then begin
          log_and_print "ERROR: [%s] chunk at offset %d was supposed to have %d bytes of compressed data that expanded to %d, but in reality they expanded to %d"
--- 246,252 ----
        let _ = Unix.lseek fd (!cmp_offset+8) Unix.SEEK_SET in 
        let cmp_buff = String.create cmplen in 
        my_read cmplen fd cmp_buff filename ;
!       let uncmp = Cbif.uncompress cmp_buff 0 cmplen uncmplen in
        (*
        if (String.length uncmp <> uncmplen) then begin
          log_and_print "ERROR: [%s] chunk at offset %d was supposed to have %d bytes of compressed data that expanded to %d, but in reality they expanded to %d"
***************
*** 342,350 ****
  
  let load_biff filename = 
    try 
!     let stats = Unix.stat filename in
      let size = stats.Unix.st_size in 
!     let fd = Unix.openfile filename [Unix.O_RDONLY] 0 in 
      let buff = String.create 20 in 
      let _ = Unix.read fd buff 0 20 in 
      if String.length buff < 8 then begin 
--- 370,378 ----
  
  let load_biff filename = 
    try 
!     let stats = Case_ins.unix_stat filename in
      let size = stats.Unix.st_size in 
!     let fd = Case_ins.unix_openfile filename [Unix.O_RDONLY] 0 in 
      let buff = String.create 20 in 
      let _ = Unix.read fd buff 0 20 in 
      if String.length buff < 8 then begin 
