*** WeiDU-185/src/dc.ml	2005-06-20 03:05:19.000000000 +0200
--- WeiDU/src/dc.ml	2007-07-16 21:51:33.000000000 +0200
***************
*** 1,9 ****
  open Util
  
  type action =
    Create of Dlg.dlg
! | Append of string * (Dlg.state list)
! | Append_Early of string * (Dlg.state list)
  | Extend_Bottom of string * (string list) * int * (Dlg.transition list)
  | Extend_Top of string * (string list) * int * (Dlg.transition list)
  | Replace of string * (Dlg.state list)
--- 1,17 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 9 March 06. All changes for this file are listed in
+ diffs/src.dc.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  open Util
  
  type action =
    Create of Dlg.dlg
! | Append of string * bool * (Dlg.state list)
! | Append_Early of string * bool * (Dlg.state list)
  | Extend_Bottom of string * (string list) * int * (Dlg.transition list)
  | Extend_Top of string * (string list) * int * (Dlg.transition list)
  | Replace of string * (Dlg.state list)
***************
*** 14,19 ****
--- 22,28 ----
      * (string list) (* state labels *)
      * (int list)    (* transition #s, empty = all *)
      * string        (* new action text *)
+ | Replace_Trans_Action of string * string list * int list * string * string
  | Replace_State_Trigger of string * (string list)* string
  | Add_State_Trigger of string * (string list)* string
  | Set_Weight of string * string * int
***************
*** 35,40 ****
--- 44,50 ----
    mutable c3_entry_condition : string option;
    mutable c3_entry_weight : Dlg.weight;
    c3_entry_file : string;
+   c3_iffileexists : bool;
    c3_entry_label : string;
    c3_dialogue : c3_dialogue_unit list ;
    mutable c3_exit_trans : Dlg.transition array ;
***************
*** 51,56 ****
--- 61,94 ----
    I propose an INTERJECT_COPY_TRANS2 command which would be identical to
    I_C_T in format, but would only carry over the GOTO/EXTERN/REPLYs in the
    original dialogue but not carry over the DOs. *)
+   c3_append_all : bool ;
+   (* If true,
+ INTERJECT_COPY_TRANS IMOEN2 0 TestInterject
+ == MINSCJ IF ~IsValidForPartyDialog("Minsc")~ THEN ~Hey Imoen!~
+ == JAHEIRAJ IF ~IsValidForPartyDialog("Jaheira")~ THEN ~Yo, Imoen, wassup?~
+ == KORGANJ IF ~IsValidForPartyDialog("Korgan")~ THEN ~Och, aye.~
+ == IMOEN2 IF ~~ THEN ~You're all nuts.~
+ END
+     is parsed as
+ INTERJECT_COPY_TRANS IMOEN2 0 TestInterject3
+ == KORGANJ IF ~IsValidForPartyDialog("Korgan")~ THEN ~Och, aye.~
+ == IMOEN2 IF ~~ THEN ~You're all nuts.~
+ END
+ 
+ INTERJECT_COPY_TRANS IMOEN2 0 TestInterject2
+ == JAHEIRAJ IF ~IsValidForPartyDialog("Jaheira")~ THEN ~Yo, Imoen, wassup?~
+ == KORGANJ IF ~IsValidForPartyDialog("Korgan")~ THEN ~Och, aye.~
+ == IMOEN2 IF ~~ THEN ~You're all nuts.~
+ END
+ 
+ INTERJECT_COPY_TRANS IMOEN2 0 TestInterject
+ == MINSCJ IF ~IsValidForPartyDialog("Minsc")~ THEN ~Hey Imoen!~
+ == JAHEIRAJ IF ~IsValidForPartyDialog("Jaheira")~ THEN ~Yo, Imoen, wassup?~
+ == KORGANJ IF ~IsValidForPartyDialog("Korgan")~ THEN ~Och, aye.~
+ == IMOEN2 IF ~~ THEN ~You're all nuts.~
+ END
+     for easier multiple-comments in the same ICT block.
+   *)
  }
  
  and c3_dialogue_unit = {
***************
*** 59,66 ****
--- 97,120 ----
    mutable c3du_action : string option;
    c3du_say : Dlg.tlk_string ;
    c3du_id : int ;
+   c3du_ifexists : bool ;
  }
  
+ let d_file_exists game file =
+   let f = file ^ ".DLG" in
+   let old_allow_missing = !Load.allow_missing in
+   Load.allow_missing := [] ;
+   let res =
+   (try
+     let a,b = split f in
+     Load.skip_next_load_error := true;
+     let buff,path = Load.load_resource "FILE_EXISTS_IN_GAME" game true a b in
+       (String.length buff > 0)
+   with _ -> false ) in
+   Load.allow_missing := old_allow_missing ;
+   res ;;
+ 
+ 
  let c3du_counter = ref 0
  
  let get_c3du_counter () =
***************
*** 102,108 ****
  let pop_trans () =
    trans_strings := List.tl !trans_strings 
  
! let rec resolve_tlk_string game ts =
    match ts with
      Dlg.Local_String(lse) ->
        let index = 
--- 156,162 ----
  let pop_trans () =
    trans_strings := List.tl !trans_strings 
  
! let rec resolve_tlk_string_internal can_create warn_mess game ts =
    match ts with
      Dlg.Local_String(lse) ->
        let index =
***************
*** 116,140 ****
              if Hashtbl.mem strings_to_add_ht lse then begin
                Hashtbl.find strings_to_add_ht lse 
              end else begin 
                let index = !cur_index in 
                Queue.add (lse) strings_to_add ; 
                Hashtbl.add strings_to_add_ht lse index ; 
                Hashtbl.add strings_added_ht index lse ; 
                incr cur_index ;
                index
              end ) () 
          ) () in 
          Dlg.TLK_Index(index) 
      | Dlg.Trans_String(idx) -> begin
          try
            let new_ts = Hashtbl.find (List.hd !trans_strings) idx in
!           resolve_tlk_string game new_ts
          with Not_found ->
!           log_and_print "ERROR: No translation provided for @%d\n" idx ;
            raise Not_found
          end
      | _ -> ts
  
  let ok_to_resolve_strings_while_loading = ref None 
  let doing_traify = ref false 
  let resolve_string_while_loading ts = 
--- 170,199 ----
              if Hashtbl.mem strings_to_add_ht lse then begin
                Hashtbl.find strings_to_add_ht lse
              end else begin
+               if not can_create then raise Not_found else begin
                  let index = !cur_index in
                  Queue.add (lse) strings_to_add ;
                  Hashtbl.add strings_to_add_ht lse index ;
                  Hashtbl.add strings_added_ht index lse ;
                  incr cur_index ;
                  index
+               end
              end ) ()
          ) () in
          Dlg.TLK_Index(index)
      | Dlg.Trans_String(idx) -> begin
          try
            let new_ts = Hashtbl.find (List.hd !trans_strings) idx in
!           resolve_tlk_string_internal can_create warn_mess game new_ts
          with Not_found ->
!           if warn_mess then log_and_print "ERROR: No translation provided for @%d\n" idx ;
            raise Not_found
          end
      | _ -> ts
      
+ let resolve_tlk_string = resolve_tlk_string_internal true (* will add the new string if absent from the tlk *)
+                                                      true (* warning message if @xx is missing from the tra *)
+ 
  let ok_to_resolve_strings_while_loading = ref None
  let doing_traify = ref false
  let resolve_string_while_loading ts = 
***************
*** 156,161 ****
--- 215,235 ----
    | Dlg.TLK_Index(idx) -> 
          Tlk.pretty_print game.Load.dialog idx 
  
+ let rec single_string_of_tlk_string_safe game ts =
+   match ts with
+     Dlg.Local_String(lse) -> lse.lse_male 
+   | Dlg.Trans_String(idx) -> begin
+       try
+         let new_ts = Hashtbl.find (List.hd !trans_strings) idx in
+         single_string_of_tlk_string game new_ts
+       with Not_found ->
+         log_and_print "ERROR: No translation provided for @%d\n" idx ;
+         log_and_print "Continuing despite error.\n";
+         "UNDEFINED STRING:   @" ^ string_of_int idx
+       end
+   | Dlg.TLK_Index(idx) -> 
+         Tlk.pretty_print game.Load.dialog idx 
+ 
  let pretty_print_no_quote tlk i = 
    let alt = Array.length tlk in 
    if i < alt then 
***************
*** 232,249 ****
      | _ -> 999999
      in 
      if (ref < max) then begin
!       Printf.fprintf out "@%d is #%d\n" id ref 
      end
    ) (List.hd !trans_strings)
  
  
  exception FoundState of int 
  
! let resolve_label (file,label) =
    try
      let dlg = 
        try Hashtbl.find available_dlgs file 
        with _ -> begin
          let index = 
          try 
            int_of_string label
--- 306,330 ----
      | _ -> 999999
      in 
      if (ref < max) then begin
!       out (Printf.sprintf  "@%d is #%d\n" id ref)
      end
    ) (List.hd !trans_strings)
  
  
  exception FoundState of int 
  
! let resolve_label (file,label) game =
    try
      let dlg = 
        try Hashtbl.find available_dlgs file 
        with _ -> begin
+ 				begin
+ 					try
+ 						Load.skip_next_load_error := true;
+ 						ignore(Load.load_resource "just_a_check" game true file "DLG")
+ 					with _ ->
+ 						if !debug_modder then log_and_print "WARNING: couldn't find the file %s.DLG for EXTERN\n" file;
+ 				end;
          let index = 
          try 
            int_of_string label
***************
*** 281,292 ****
    with FoundState(i) -> i
  
  
! let resolve_symbolic_labels d = 
    Array.iteri (fun i s ->
      Array.iteri (fun j t ->
        match t.Dlg.next with
!         Dlg.Symbolic(name,label) ->
!           let idx = resolve_label (name,label) in
            t.Dlg.next <- Dlg.Absolute(name,idx) 
        | _ -> ()
      ) s.Dlg.trans
--- 362,373 ----
    with FoundState(i) -> i
  
  
! let resolve_symbolic_labels d game =
    Array.iteri (fun i s ->
      Array.iteri (fun j t ->
        match t.Dlg.next with
!         Dlg.Symbolic(name,label,_) ->
!           let idx = resolve_label (name,label) game in
            t.Dlg.next <- Dlg.Absolute(name,idx) 
        | _ -> ()
      ) s.Dlg.trans
***************
*** 316,328 ****
      dlg 
    end
  
! let make_available for_what game name =
    if Hashtbl.mem available_dlgs name then
      ()
    else begin
      let buff, final_path = Load.load_resource for_what game true name "DLG" in
      let dlg = Dlg.load_dlg name buff in 
      Hashtbl.add available_dlgs name dlg 
    end
  
  let clear_state () =
--- 397,415 ----
      dlg 
    end
  
! let make_available for_what game name unsafe =
    if Hashtbl.mem available_dlgs name then
      ()
    else begin
+     try
+       if unsafe then Load.skip_next_load_error := true ;
        let buff, final_path = Load.load_resource for_what game true name "DLG" in
        let dlg = Dlg.load_dlg name buff in
        Hashtbl.add available_dlgs name dlg
+     with e -> begin 
+       if !debug_ocaml then log_and_print "File %s is missing.\n" name ;
+       if not unsafe then raise e;
+     end
    end
  
  let clear_state () =
***************
*** 330,337 ****
    Hashtbl.clear available_dlgs 
  
  let preprocess_append_early game a = match a with
!   | Append_Early(n,sl) -> 
!         make_available "APPEND_EARLY" game n ; 
          let dlg = Hashtbl.find available_dlgs n in
          dlg.Dlg.state <- Array.append dlg.Dlg.state 
           (Array.of_list sl) 
--- 417,424 ----
    Hashtbl.clear available_dlgs
  
  let preprocess_append_early game a = match a with
!   | Append_Early(n,unsafe,sl) ->
!         make_available "APPEND_EARLY" game n unsafe ;
          let dlg = Hashtbl.find available_dlgs n in
          dlg.Dlg.state <- Array.append dlg.Dlg.state 
           (Array.of_list sl)
***************
*** 358,363 ****
--- 445,451 ----
    | Replace_Say _ -> "REPLACE_SAY"
    | Add_Trans_Trigger _ -> "ADD_TRANS_TRIGGER"
    | Add_Trans_Action  _ -> "ADD_TRANS_ACTION"
+   | Replace_Trans_Action _ -> "REPLACE_TRANS_ACTION"
    | Replace_State_Trigger _ -> "REPLACE_STATE_TRIGGER"
    | Add_State_Trigger _ -> "ADD_STATE_TRIGGER"
    | Set_Weight _ -> "SET_WEIGHT"
***************
*** 369,376 ****
  let preprocess_action2 game a = match a with
    | Create(d) -> () 
  
!   | Append(n,_) 
!   | Append_Early(n,_) 
    | Extend_Top(n,_,_,_) 
    | Extend_Bottom(n,_,_,_) 
    | Replace(n,_) 
--- 457,465 ----
  let preprocess_action2 game a = match a with
    | Create(d) -> ()
  
!   | Append(n,unsafe,_)
!   | Append_Early(n,unsafe,_)
!       -> make_available (action_to_str a) game n unsafe
    | Extend_Top(n,_,_,_)
    | Extend_Bottom(n,_,_,_)
    | Replace(n,_)
***************
*** 379,400 ****
    | Replace_State_Trigger(n,_,_)
    | Add_Trans_Trigger(n,_,_,_)
    | Add_Trans_Action(n,_,_,_)
    | Set_Weight(n,_,_) 
    | Replace_Trigger_Text(n,_,_,false)
!       -> make_available (action_to_str a) game n
    | Replace_Action_Text(nl,_,_,false)
!       -> List.iter (fun n -> make_available (action_to_str a) game n) nl 
    | Replace_Action_Text(_,_,_,true)
    | Replace_Trigger_Text(_,_,_,true) -> () 
    | Chain(ci) ->
        let s = action_to_str a in 
!       make_available s game ci.entry_file ; 
!       List.iter (fun (speaker,says) -> make_available s game speaker)
          ci.dialogue 
    | Chain3(ci) ->
        let s = action_to_str a in 
!       make_available s game ci.c3_entry_file ; 
!       List.iter (fun c3du -> make_available s game c3du.c3du_speaker)
          ci.c3_dialogue 
  
  let append_state n state =
--- 468,490 ----
    | Replace_State_Trigger(n,_,_)
    | Add_Trans_Trigger(n,_,_,_)
    | Add_Trans_Action(n,_,_,_)
+   | Replace_Trans_Action(n,_,_,_,_)
    | Set_Weight(n,_,_)
    | Replace_Trigger_Text(n,_,_,false)
!       -> make_available (action_to_str a) game n false
    | Replace_Action_Text(nl,_,_,false)
!       -> List.iter (fun n -> make_available (action_to_str a) game n false) nl
    | Replace_Action_Text(_,_,_,true)
    | Replace_Trigger_Text(_,_,_,true) -> () 
    | Chain(ci) ->
        let s = action_to_str a in 
!       make_available s game ci.entry_file false ;
!       List.iter (fun (speaker,says) -> make_available s game speaker false )
          ci.dialogue
    | Chain3(ci) ->
        let s = action_to_str a in
!       make_available s game ci.c3_entry_file ci.c3_iffileexists ;
!       List.iter (fun c3du -> make_available s game c3du.c3du_speaker c3du.c3du_ifexists)
          ci.c3_dialogue 
  
  let append_state n state =
***************
*** 406,412 ****
  
    | Set_Weight(n,s,w) ->
      let dlg = Hashtbl.find available_dlgs n in
!     let num = resolve_label (n,s) in
      dlg.Dlg.state.(num).Dlg.state_trigger_weight <- Dlg.Offset(w)
  
    | Replace_Action_Text(nl,s_from,s_to,use_regexp) ->
--- 496,502 ----
  
    | Set_Weight(n,s,w) ->
      let dlg = Hashtbl.find available_dlgs n in
!     let num = resolve_label (n,s) game in
      dlg.Dlg.state.(num).Dlg.state_trigger_weight <- Dlg.Offset(w)
  
    | Replace_Action_Text(nl,s_from,s_to,use_regexp) ->
***************
*** 414,423 ****
      let process dlg = 
        Array.iter (fun state ->
          Array.iter (fun trans ->
!           match trans.Dlg.action with
!             Some(trans_str) -> trans.Dlg.action <- 
!               Some(Str.global_replace r s_to trans_str)
!           | None -> () 
          ) state.Dlg.trans
        ) dlg.Dlg.state
      in 
--- 504,513 ----
      let process dlg =
        Array.iter (fun state ->
          Array.iter (fun trans ->
!           (match trans.Dlg.action with
!             Some(trans_str) ->
!               trans.Dlg.action <- Some(Str.global_replace r s_to trans_str);
!           | None -> ());
          ) state.Dlg.trans
        ) dlg.Dlg.state
      in
***************
*** 430,436 ****
          if e = "DLG" && 
            (List.exists (fun regexp -> Str.string_match regexp b 0) 
                         regexp_list) then begin 
!           make_available (action_to_str a) game b ; 
            matches := b :: !matches
          end 
        ) files_in_chitin ;
--- 520,526 ----
          if e = "DLG" &&
            (List.exists (fun regexp -> Str.string_match regexp b 0) 
                         regexp_list) then begin 
!           make_available (action_to_str a) game b false ;
            matches := b :: !matches
          end 
        ) files_in_chitin ;
***************
*** 438,444 ****
      end else 
        List.iter (fun n -> 
          let dlg = Hashtbl.find available_dlgs n in
!         process dlg 
        ) nl 
  
    | Replace_Trigger_Text(n,s_from,s_to,use_regexp) ->
--- 528,534 ----
      end else
        List.iter (fun n ->
          let dlg = Hashtbl.find available_dlgs n in
!         process dlg;
        ) nl
  
    | Replace_Trigger_Text(n,s_from,s_to,use_regexp) ->
***************
*** 462,468 ****
        List.iter (fun poss ->
          let b,e = split (String.uppercase poss) in
          if e = "DLG" && Str.string_match regexp b 0 then begin 
!           make_available (action_to_str a) game b ; 
            matches := b :: !matches
          end 
        ) files_in_chitin ;
--- 552,558 ----
        List.iter (fun poss ->
          let b,e = split (String.uppercase poss) in
          if e = "DLG" && Str.string_match regexp b 0 then begin 
!           make_available (action_to_str a) game b false ;
            matches := b :: !matches
          end 
        ) files_in_chitin ;
***************
*** 470,485 ****
      end else process (Hashtbl.find available_dlgs n)
  
  
!   | Append(n,sl) -> 
          let dlg = Hashtbl.find available_dlgs n in
          dlg.Dlg.state <- Array.append dlg.Dlg.state 
           (Array.of_list sl) 
!   | Append_Early(n,sl) -> () (* done earlier! *) 
  
    | Extend_Top(n,sl,0,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s -> 
!         let num = resolve_label (n,s) in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then
          dlg.Dlg.state.(num).Dlg.trans <- Array.append
            (Array.of_list tl) dlg.Dlg.state.(num).Dlg.trans 
--- 560,575 ----
      end else process (Hashtbl.find available_dlgs n)
  
  
!   | Append(n,unsafe,sl) ->
          let dlg = Hashtbl.find available_dlgs n in
          dlg.Dlg.state <- Array.append dlg.Dlg.state 
           (Array.of_list sl) 
!   | Append_Early(n,unsafe,sl) -> () (* done earlier! *)
  
    | Extend_Top(n,sl,0,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s -> 
!         let num = resolve_label (n,s) game in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then
          dlg.Dlg.state.(num).Dlg.trans <- Array.append
            (Array.of_list tl) dlg.Dlg.state.(num).Dlg.trans 
***************
*** 492,498 ****
    | Extend_Top(n,sl,place,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s -> 
!         let num = resolve_label (n,s) in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then begin
            let s = dlg.Dlg.state.(num) in 
            let tlen = Array.length s.Dlg.trans in 
--- 582,588 ----
    | Extend_Top(n,sl,place,tl) ->
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s ->
!         let num = resolve_label (n,s) game in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then begin
            let s = dlg.Dlg.state.(num) in 
            let tlen = Array.length s.Dlg.trans in 
***************
*** 521,527 ****
    | Extend_Bottom(n,sl,0,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s -> 
!         let num = resolve_label (n,s) in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then
            dlg.Dlg.state.(num).Dlg.trans <- Array.append
              dlg.Dlg.state.(num).Dlg.trans (Array.of_list tl) 
--- 611,617 ----
    | Extend_Bottom(n,sl,0,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s -> 
!         let num = resolve_label (n,s) game in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then
            dlg.Dlg.state.(num).Dlg.trans <- Array.append
              dlg.Dlg.state.(num).Dlg.trans (Array.of_list tl) 
***************
*** 534,540 ****
    | Extend_Bottom(n,sl,place,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s-> 
!         let num = resolve_label (n,s) in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then begin
            let s = dlg.Dlg.state.(num) in 
            let tlen = Array.length s.Dlg.trans in 
--- 624,630 ----
    | Extend_Bottom(n,sl,place,tl) -> 
        let dlg = Hashtbl.find available_dlgs n in
        List.iter (fun s-> 
!         let num = resolve_label (n,s) game in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then begin
            let s = dlg.Dlg.state.(num) in 
            let tlen = Array.length s.Dlg.trans in 
***************
*** 563,569 ****
  
    | Replace_Say(n,l,s) -> 
      let dlg = Hashtbl.find available_dlgs n in
!     let num = resolve_label (n,l) in
      dlg.Dlg.state.(num).Dlg.resp_str <- s
  
    | Replace(n,new_s_list) -> 
--- 653,659 ----
  
    | Replace_Say(n,l,s) ->
      let dlg = Hashtbl.find available_dlgs n in
!     let num = resolve_label (n,l) game in
      dlg.Dlg.state.(num).Dlg.resp_str <- s
  
    | Replace(n,new_s_list) -> 
***************
*** 578,584 ****
            incr trigger_ord;
          end) dlg.Dlg.state ;      
        List.iter (fun new_s -> 
!           let num = resolve_label (n,new_s.Dlg.symbolic_label) in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then begin
            let old_wgt = dlg.Dlg.state.(num).Dlg.state_trigger_weight in
            let new_wgt = new_s.Dlg.state_trigger_weight in begin
--- 668,674 ----
            incr trigger_ord;
          end) dlg.Dlg.state ;      
        List.iter (fun new_s -> 
!           let num = resolve_label (n,new_s.Dlg.symbolic_label) game in
          if (num >= 0 && num < Array.length dlg.Dlg.state) then begin
            let old_wgt = dlg.Dlg.state.(num).Dlg.state_trigger_weight in
            let new_wgt = new_s.Dlg.state_trigger_weight in begin
***************
*** 599,611 ****
    | Replace_State_Trigger(n,sl,new_t) -> 
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun s -> 
!         let num = resolve_label (n,s) in
          dlg.Dlg.state.(num).Dlg.state_trigger <- new_t 
          ) sl 
    | Add_State_Trigger(n,sl,new_t) -> 
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun s -> 
!         let num = resolve_label (n,s) in
          dlg.Dlg.state.(num).Dlg.state_trigger <- new_t ^ "\r\n" ^ 
          dlg.Dlg.state.(num).Dlg.state_trigger 
          ) sl 
--- 689,701 ----
    | Replace_State_Trigger(n,sl,new_t) ->
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun s -> 
!         let num = resolve_label (n,s) game in
          dlg.Dlg.state.(num).Dlg.state_trigger <- new_t 
          ) sl
    | Add_State_Trigger(n,sl,new_t) -> 
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun s -> 
!         let num = resolve_label (n,s) game in
          dlg.Dlg.state.(num).Dlg.state_trigger <- new_t ^ "\r\n" ^ 
          dlg.Dlg.state.(num).Dlg.state_trigger
          ) sl 
***************
*** 613,623 ****
    | Add_Trans_Action(n,state_labels,transition_indices,action_text) ->
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun state_label -> 
!           let num = resolve_label (n,state_label) in
            let do_it trans = 
            match trans.Dlg.action with
              None -> trans.Dlg.action <- Some(action_text)
!           | Some(str) -> trans.Dlg.action <- Some(action_text ^ "\r\n" ^ str)
            in 
            match transition_indices with
            | [] -> (* do them all *) 
--- 703,736 ----
    | Add_Trans_Action(n,state_labels,transition_indices,action_text) ->
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun state_label ->
!           let num = resolve_label (n,state_label) game in
            let do_it trans =
            match trans.Dlg.action with
              None -> trans.Dlg.action <- Some(action_text)
!           | Some(str) -> trans.Dlg.action <- Some(action_text ^ "\r\n" ^ str);
!           in
!           match transition_indices with
!           | [] -> (* do them all *)
!             Array.iter do_it dlg.Dlg.state.(num).Dlg.trans
!           | lst ->
!             List.iter (fun i ->
!               if (i >= 0 &&
!                   i < Array.length dlg.Dlg.state.(num).Dlg.trans) then begin
!                 let trans = dlg.Dlg.state.(num).Dlg.trans.(i) in
!                 do_it trans
!               end
!             ) lst
!         ) state_labels;
! 
!   | Replace_Trans_Action(n,state_labels,transition_indices,oldt,newt) ->
!         let dlg = Hashtbl.find available_dlgs n in
!         List.iter (fun state_label ->
!           let num = resolve_label (n,state_label) game in
!           let do_it trans =
!           match trans.Dlg.action with
!             None -> ()
!           | Some(str) -> trans.Dlg.action <- Some(Str.global_replace
!                              (Str.regexp oldt) newt str);
            in
            match transition_indices with
            | [] -> (* do them all *)
***************
*** 630,641 ****
                  do_it trans 
                end 
              ) lst 
!         ) state_labels 
  
    | Add_Trans_Trigger(n,sl,new_t,t_list) -> 
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun s -> 
!         let num = resolve_label (n,s) in
          let do_it trans = 
          match trans.Dlg.trans_trigger with
            None -> trans.Dlg.trans_trigger <- Some(new_t )
--- 743,754 ----
                  do_it trans
                end
              ) lst
!         ) state_labels;
  
    | Add_Trans_Trigger(n,sl,new_t,t_list) ->
          let dlg = Hashtbl.find available_dlgs n in
          List.iter (fun s ->
!           let num = resolve_label (n,s) game in
            let do_it trans =
            match trans.Dlg.trans_trigger with
              None -> trans.Dlg.trans_trigger <- Some(new_t )
***************
*** 667,672 ****
--- 780,808 ----
      end
  
    | Chain3(ci) -> begin
+       if not ci.c3_append_all then begin
+         (* expunge the failing IF_FILE_EXISTS lines *)
+         let ci = {ci with c3_dialogue = (
+           let new_dialogue = ref [] in
+           List.iter (fun x -> if not x.c3du_ifexists then new_dialogue := x :: !new_dialogue
+           else begin
+             let f = x.c3du_speaker ^ ".DLG" in
+             let old_allow_missing = !Load.allow_missing in
+             Load.allow_missing := [] ;
+             let res =
+             (try
+               let a,b = split f in
+               Load.skip_next_load_error := true;
+               let buff,path = Load.load_resource "FILE_EXISTS_IN_GAME" game true a b in
+                 (String.length buff > 0)
+             with _ -> false ) in
+             Load.allow_missing := old_allow_missing ;
+             if res then new_dialogue := x :: !new_dialogue ;
+           end
+           ) ci.c3_dialogue ;
+           List.rev (!new_dialogue)
+         ) ;
+         } in
          let label_of_ci = Hashtbl.create 255 in
          List.iter (fun c3du ->
            Hashtbl.add label_of_ci c3du (c3du.c3du_speaker,(chain_label ()))
***************
*** 728,734 ****
                            Dlg.journal_str = None ;
                            Dlg.trans_trigger = ci.c3du_condition ;
                            Dlg.action = action ;
!                           Dlg.next = Dlg.Symbolic(a,b) } in
              trans :: (match ci.c3du_condition with 
                | None -> [] 
                | Some _ -> (possible_trans action tl))
--- 864,870 ----
                              Dlg.journal_str = None ;
                              Dlg.trans_trigger = ci.c3du_condition ;
                              Dlg.action = action ;
!                             Dlg.next = Dlg.Symbolic(a,b,false) } in
                trans :: (match ci.c3du_condition with
                  | None -> []
                  | Some _ -> (possible_trans action tl))
***************
*** 756,762 ****
            begin
            let fst = List.hd ci.c3_dialogue in
            let file,label = Hashtbl.find label_of_ci fst in  
!           let trans = Dlg.make_trans_of_next (Dlg.Symbolic(file,label)) in
            trans.Dlg.trans_trigger <- Some 
              (Printf.sprintf "Global(\"%s\",\"GLOBAL\",0)%s" var 
              (match fst.c3du_condition with Some(s) -> (" " ^ s) | None -> ""));
--- 892,898 ----
              begin
              let fst = List.hd ci.c3_dialogue in
              let file,label = Hashtbl.find label_of_ci fst in
!             let trans = Dlg.make_trans_of_next (Dlg.Symbolic(file,label,false)) in
              trans.Dlg.trans_trigger <- Some
                (Printf.sprintf "Global(\"%s\",\"GLOBAL\",0)%s" var
                (match fst.c3du_condition with Some(s) -> (" " ^ s) | None -> ""));
***************
*** 768,774 ****
            end 
        end  
      end
! 
  
  let pctta game tl = (* process_copy_trans__trans_array *)
    (* given a transition, return the list of transition it expands to *)
--- 904,926 ----
              end
          end
        end
!       else begin
!         let the_list = ref ci.c3_dialogue in
!         let list_to_process = ref [] in
!         while List.length !the_list > 0 do
!           list_to_process := !the_list :: !list_to_process ;
!           if !debug_ocaml then log_and_print "%d appended has have %d entries\n" (List.length ci.c3_dialogue - List.length !list_to_process) (List.length !the_list) ;
!           the_list := List.tl !the_list ;
!         done ;
!         List.iter (fun x ->
!           if !debug_ocaml then log_and_print "Processing the one long %d\n" (List.length x) ;
!           process_action game (Chain3({
!             ci with c3_dialogue = x ; c3_append_all = false;
!           }))
!         )
!           !list_to_process ;
!       end
!     end
  
  let pctta game tl = (* process_copy_trans__trans_array *)
    (* given a transition, return the list of transition it expands to *)
***************
*** 777,783 ****
      match t.Dlg.next with
        Dlg.Copy(f,s) -> 
          let d = locate_dlg game f in 
!         let i = resolve_label (f,s) in
          if i < 0 || i >= Array.length d.Dlg.state then begin
            log_and_print 
              "ERROR: COPY_TRANS %s state #%d out of range 0-%d, SKIPPED\n"
--- 929,935 ----
      match t.Dlg.next with
        Dlg.Copy(f,s) ->
          let d = locate_dlg game f in
!         let i = resolve_label (f,s) game in
          if i < 0 || i >= Array.length d.Dlg.state then begin
            log_and_print
              "ERROR: COPY_TRANS %s state #%d out of range 0-%d, SKIPPED\n"
***************
*** 803,811 ****
          s.Dlg.trans <- pctta game s.Dlg.trans
        ) d.Dlg.state ;
        Create(d) 
!   | Append(s,sl) -> 
        List.iter (fun s -> s.Dlg.trans <- pctta game s.Dlg.trans) sl ;
!       Append(s,sl)
    | Extend_Top(a,b,pos,tl) ->    Extend_Top(a,b,pos,
      Array.to_list (pctta game (Array.of_list tl)))
    | Extend_Bottom(a,b,pos,tl) -> Extend_Bottom(a,b,pos,
--- 955,963 ----
          s.Dlg.trans <- pctta game s.Dlg.trans
        ) d.Dlg.state ;
        Create(d)
!   | Append(s,unsafe,sl) ->
        List.iter (fun s -> s.Dlg.trans <- pctta game s.Dlg.trans) sl ;
!       Append(s,unsafe,sl)
    | Extend_Top(a,b,pos,tl) ->    Extend_Top(a,b,pos,
      Array.to_list (pctta game (Array.of_list tl)))
    | Extend_Bottom(a,b,pos,tl) -> Extend_Bottom(a,b,pos,
***************
*** 813,824 ****
    | Replace(n,sl) -> 
        List.iter (fun s -> s.Dlg.trans <- pctta game s.Dlg.trans) sl ;
        Replace(n,sl)
!   | Append_Early(_,_)
    | Replace_Say(_,_,_)
    | Add_State_Trigger(_,_,_) 
    | Replace_State_Trigger(_,_,_) 
    | Add_Trans_Trigger(_,_,_,_) 
    | Add_Trans_Action(_,_,_,_) 
    | Set_Weight(_,_,_) 
    | Replace_Action_Text(_,_,_,_)
    | Replace_Trigger_Text(_,_,_,_)
--- 965,977 ----
    | Replace(n,sl) ->
        List.iter (fun s -> s.Dlg.trans <- pctta game s.Dlg.trans) sl ;
        Replace(n,sl)
!   | Append_Early(_,_,_)
    | Replace_Say(_,_,_)
    | Add_State_Trigger(_,_,_)
    | Replace_State_Trigger(_,_,_)
    | Add_Trans_Trigger(_,_,_,_)
    | Add_Trans_Action(_,_,_,_)
+   | Replace_Trans_Action(_,_,_,_,_)
    | Set_Weight(_,_,_)
    | Replace_Action_Text(_,_,_,_)
    | Replace_Trigger_Text(_,_,_,_)
***************
*** 829,848 ****
  let postprocess_dlg game name d = 
              (*      try  *)
                    Stats.time "resolve strings" (resolve_strings game) d ;
!                   Stats.time "resolve labels" (resolve_symbolic_labels) d
                    (* with s ->
                      log_and_print "ERROR: Cannot postprocess %s\n" name ; 
                      raise s *)
  
  let dc game lst = 
    let what = ref "" in 
    let where = ref "" in 
    try 
      what := "preprocessing CREATE" ;
      List.iter (fun (w,a) -> where := w; preprocess_action1 game a) lst ;
      what := "preprocessing APPEND_EARLY" ;
      List.iter (fun (w,a) -> where := w; preprocess_append_early game a) lst ;
      List.iter (fun (w,a) -> where := w;  preprocess_action2 game a) lst ;
      what := "processing COPY_TRANS" ; 
      let lst =
        List.map (fun (w,a) -> where := w ; (w,process_copy_trans game a)) lst in 
--- 982,1100 ----
  let postprocess_dlg game name d =
              (*      try  *)
                    Stats.time "resolve strings" (resolve_strings game) d ;
!                   Stats.time "resolve labels" (resolve_symbolic_labels) d game
                    (* with s ->
                      log_and_print "ERROR: Cannot postprocess %s\n" name ;
                      raise s *)
  
+ let prife game tl = (* PRocess_If_File_Exists *)
+   (* given a transition, return the list of transition it expands to *)
+   try
+   let process t =
+     match t.Dlg.next with
+     | Dlg.Symbolic(a,b,true) ->
+       let f = a ^ ".DLG" in
+       let old_allow_missing = !Load.allow_missing in
+       Load.allow_missing := [] ;
+       let res =
+       (try
+         let a,b = split f in
+         Load.skip_next_load_error := true;
+         let buff,path = Load.load_resource "FILE_EXISTS_IN_GAME" game true a b in
+           (String.length buff > 0)
+       with _ -> false ) in
+       Load.allow_missing := old_allow_missing ;
+       if res then [t] else []
+     | _ -> [t]
+   in
+   let expanded_trans_a = Array.map process tl in
+   let expanded_trans_list = Array.to_list expanded_trans_a in
+   let expanded_trans_list = List.flatten expanded_trans_list in
+   let expanded_trans_a = Array.of_list expanded_trans_list in
+   expanded_trans_a
+   with s ->
+     log_and_print "ERROR: Cannot process IF_FILE_EXISTS\n" ;
+     raise s
+ 
+ let preprocess_ife game a =
+   match a with
+   | Create(d) ->
+       Array.iter (fun s ->
+         s.Dlg.trans <- prife game s.Dlg.trans
+       ) d.Dlg.state ;
+       Create(d)
+   | Append_Early(s,unsafe,sl) ->
+       List.iter (fun s -> s.Dlg.trans <- prife game s.Dlg.trans) sl ;
+       Append_Early(s,unsafe,sl)
+   | Append(s,unsafe,sl) ->
+       List.iter (fun s -> s.Dlg.trans <- prife game s.Dlg.trans) sl ;
+       Append(s,unsafe,sl)
+   | Extend_Top(a,b,pos,tl) ->    Extend_Top(a,b,pos,
+     Array.to_list (prife game (Array.of_list tl)))
+   | Extend_Bottom(a,b,pos,tl) -> Extend_Bottom(a,b,pos,
+     Array.to_list (prife game (Array.of_list tl)))
+   | Replace(n,sl) ->
+       List.iter (fun s -> s.Dlg.trans <- prife game s.Dlg.trans) sl ;
+       Replace(n,sl)
+   | Replace_Say(_,_,_)
+   | Add_State_Trigger(_,_,_)
+   | Replace_State_Trigger(_,_,_)
+   | Add_Trans_Trigger(_,_,_,_)
+   | Add_Trans_Action(_,_,_,_)
+   | Replace_Trans_Action(_,_,_,_,_)
+   | Set_Weight(_,_,_)
+   | Replace_Action_Text(_,_,_,_)
+   | Replace_Trigger_Text(_,_,_,_)
+   | Chain(_) -> a
+   | Chain3(c) -> c.c3_exit_trans <- prife game c.c3_exit_trans ; a
+ ;;
+ 
+ let preprocess_ife_state game a =
+   match a with
+     | Append_Early(s,unsafe,sl)
+     | Append(s,unsafe,sl) ->
+         if unsafe && not (d_file_exists game s) then None else Some(a)
+     | Chain3(c) -> if c.c3_iffileexists && not (d_file_exists game c.c3_entry_file) then None else Some(a)
+     | Extend_Top(_,_,_,_)
+     | Extend_Bottom(_,_,_,_)
+     | Replace(_,_)
+     | Create(_)
+     | Replace_Say(_,_,_)
+     | Add_State_Trigger(_,_,_)
+     | Replace_State_Trigger(_,_,_)
+     | Add_Trans_Trigger(_,_,_,_)
+     | Add_Trans_Action(_,_,_,_)
+     | Replace_Trans_Action(_,_,_,_,_)
+     | Set_Weight(_,_,_)
+     | Replace_Action_Text(_,_,_,_)
+     | Replace_Trigger_Text(_,_,_,_)
+     | Chain(_) -> Some(a)
+ ;;
+ 
  let dc game lst =
    let what = ref "" in
    let where = ref "" in
    try
+     what := "preprocess IF_FILE_EXISTS" ;
+     let result = ref [] in
+     List.iter (fun (w,a) ->
+       where := w;
+       let this_one = (preprocess_ife_state game a) in
+       match this_one with
+         | None -> ()
+         | Some(x) -> result := (w,x) :: !result ;
+     ) lst;
+     let lst = List.rev !result in
+     let lst = List.map (fun (w,a) -> where := w; (w,preprocess_ife game a)) lst in
+                                                  (* IF_FILE_EXISTS somewhere *)
      what := "preprocessing CREATE" ;
      List.iter (fun (w,a) -> where := w; preprocess_action1 game a) lst ;
+                                         (* BEGIN *)
      what := "preprocessing APPEND_EARLY" ;
      List.iter (fun (w,a) -> where := w; preprocess_append_early game a) lst ;
+                                         (* APPEND_EARLY *)
      List.iter (fun (w,a) -> where := w;  preprocess_action2 game a) lst ;
+                                          (* make_available *)
      what := "processing COPY_TRANS" ;
      let lst =
        List.map (fun (w,a) -> where := w ; (w,process_copy_trans game a)) lst in
***************
*** 850,855 ****
--- 1102,1108 ----
      List.iter (fun (w,a) -> where := w; process_action game a) lst ;
      what := "postprocessing" ;
      Hashtbl.iter (fun n d -> where := n; postprocess_dlg game n d)
+                                          (* resolve_string & resolve_label *)
        available_dlgs ;
      ()
    with e ->
