*** WeiDU-185/src/iwg2.ml	2005-05-18 06:06:31.000000000 +0200
--- WeiDU/src/iwg2.ml	2007-06-21 16:10:47.000000000 +0200
***************
*** 576,582 ****
      (* we must bring over the files for this animation *) 
      if Hashtbl.mem animate_ht r then begin
        let (r',lst) = Hashtbl.find animate_ht r in
!       let bam_ext = Key.key_of_ext "BAM" in 
        error "ANIMATE" "For Source [%s] we use Source BAMs to make [%s]\n" r r'; 
        List.iter (fun (bg2_prefix, iwd2_prefix) -> 
          Array.iter (fun res ->
--- 576,582 ----
      (* we must bring over the files for this animation *) 
      if Hashtbl.mem animate_ht r then begin
        let (r',lst) = Hashtbl.find animate_ht r in
!       let bam_ext = Key.key_of_ext true "BAM" in 
        error "ANIMATE" "For Source [%s] we use Source BAMs to make [%s]\n" r r'; 
        List.iter (fun (bg2_prefix, iwd2_prefix) -> 
          Array.iter (fun res ->
***************
*** 7405,7416 ****
  
    let files_in_chitin = Key.list_of_key_resources config.source.Load.key in 
    let files_in_override = 
!                   let dh = Unix.opendir "override" in
                    let lst = ref [] in 
                    (try 
                      while true do 
                        let next = Unix.readdir dh in
!                       if ((Unix.stat ("override/" ^ next)).Unix.st_kind = 
                           Unix.S_REG) then 
                          lst := (String.uppercase next) :: !lst
                      done 
--- 7405,7416 ----
  
    let files_in_chitin = Key.list_of_key_resources config.source.Load.key in 
    let files_in_override = 
!                   let dh = Case_ins.unix_opendir "override" in
                    let lst = ref [] in 
                    (try 
                      while true do 
                        let next = Unix.readdir dh in
!                       if ((Case_ins.unix_stat ("override/" ^ next)).Unix.st_kind = 
                           Unix.S_REG) then 
                          lst := (String.uppercase next) :: !lst
                      done 
***************
*** 7432,7438 ****
    in 
    let matches = uniqify sorted in 
  
!   let fout = open_out "Setup-RL.tp2" in 
  
    Printf.fprintf fout "BACKUP ~iwg2/backup~\n" ; 
    Printf.fprintf fout "AUTHOR ~weimer~\n" ; 
--- 7432,7438 ----
    in 
    let matches = uniqify sorted in 
  
!   let fout = Case_ins.perv_open_out "Setup-RL.tp2" in 
  
    Printf.fprintf fout "BACKUP ~iwg2/backup~\n" ; 
    Printf.fprintf fout "AUTHOR ~weimer~\n" ; 
***************
*** 7563,7595 ****
  
    let usageMsg = Printf.sprintf "\nusage: IWG2 [options] [specific-resource-files-to-convert]\n\nOptions:\n" in
    let argDescr = [
!     "--cfg", Arg.String (fun s -> cfg_file := s),"X\tread global configuration from file X"; 
!     "--bcs-debug", Arg.Set option_bcs_debug, "\tIncluding debugging information in BCS files (ON by default)" ; 
!     "--bcs-none", Arg.Set option_bcs_none, "\tConvert all BCSs to None.BCS" ; 
!     "--cre-keg", Arg.Set option_cre_keg, "\tConvert all CREs to 10KEG.CRE" ;
!     "--cre-fighter", Arg.Set option_cre_fighter, "\tConvert all CREs classes to fighter" ;
!     "--cre-no-feats", Arg.Set option_cre_no_feats, "\tDrop all feats when converting CREs" ;
!     "--cre-no-items", Arg.Set option_cre_no_items, "\tDrop all items when converting CREs" ;
!     "--cre-no-spells", Arg.Set option_cre_no_spells, "\tDrop all memorized spells when converting CREs" ;
!     "--no-cre-in-name", Arg.Clear option_cre_in_name, "\tPut CRE in creature name" ;
!     "--animate-keg", Arg.Set option_animate_keg, "\tConvert all animations to Keg 1" ;
!     "--damage-reduction", Arg.Set option_damage_reduction, "\tArmor reduces damage, not 'armor class'" ;
!     "--log", Arg.String (fun s -> init_log s),"X\tlog output and details to X" ;
!     "--rl", Arg.Set option_do_rl, "\t---" ; 
    ] in 
  
!   let give_help () = Arg.usage argDescr usageMsg ; exit 1 in 
    let handleArg str = 
      res_to_process := (split (String.uppercase str)) :: !res_to_process 
    in 
  
!   Arg.parse argDescr handleArg usageMsg  ;
  
    log_and_print "\n*** Reading Global Configuration ***\n" ; 
  
    let read_rule_file filename = 
      begin
!         let inchan = open_in filename in 
          let lexbuf : Lexing.lexbuf = lex_init filename inchan in
          try 
            let result = Stats.time "parsing rules"  
--- 7563,7595 ----
  
    let usageMsg = Printf.sprintf "\nusage: IWG2 [options] [specific-resource-files-to-convert]\n\nOptions:\n" in
    let argDescr = [
!     "--cfg", Myarg.String (fun s -> cfg_file := s),"X\tread global configuration from file X"; 
!     "--bcs-debug", Myarg.Set option_bcs_debug, "\tIncluding debugging information in BCS files (ON by default)" ; 
!     "--bcs-none", Myarg.Set option_bcs_none, "\tConvert all BCSs to None.BCS" ; 
!     "--cre-keg", Myarg.Set option_cre_keg, "\tConvert all CREs to 10KEG.CRE" ;
!     "--cre-fighter", Myarg.Set option_cre_fighter, "\tConvert all CREs classes to fighter" ;
!     "--cre-no-feats", Myarg.Set option_cre_no_feats, "\tDrop all feats when converting CREs" ;
!     "--cre-no-items", Myarg.Set option_cre_no_items, "\tDrop all items when converting CREs" ;
!     "--cre-no-spells", Myarg.Set option_cre_no_spells, "\tDrop all memorized spells when converting CREs" ;
!     "--no-cre-in-name", Myarg.Clear option_cre_in_name, "\tPut CRE in creature name" ;
!     "--animate-keg", Myarg.Set option_animate_keg, "\tConvert all animations to Keg 1" ;
!     "--damage-reduction", Myarg.Set option_damage_reduction, "\tArmor reduces damage, not 'armor class'" ;
!     "--log", Myarg.String (fun s -> init_log s),"X\tlog output and details to X" ;
!     "--rl", Myarg.Set option_do_rl, "\t---" ; 
    ] in 
  
!   let give_help () = Myarg.usage argDescr usageMsg ; exit 1 in 
    let handleArg str = 
      res_to_process := (split (String.uppercase str)) :: !res_to_process 
    in 
  
!   Myarg.parse argDescr handleArg usageMsg  ;
  
    log_and_print "\n*** Reading Global Configuration ***\n" ; 
  
    let read_rule_file filename = 
      begin
!         let inchan = Case_ins.perv_open_in filename in 
          let lexbuf : Lexing.lexbuf = lex_init filename inchan in
          try 
            let result = Stats.time "parsing rules"  
***************
*** 7646,7658 ****
          Util.error_chn_base := s 
  
    | Replace("delete.files.in",[s]) -> 
!         let s_d_h = try Unix.opendir s 
                      with _ -> failwith ("cannot open directory " ^ s) in 
          begin try 
            while true do
              let s' = Unix.readdir s_d_h in
              let filename = (s ^ "/" ^ s') in 
!             try Unix.unlink filename with _ -> () 
            done
          with e -> (Unix.closedir s_d_h ) end 
  
--- 7646,7658 ----
          Util.error_chn_base := s 
  
    | Replace("delete.files.in",[s]) -> 
!         let s_d_h = try Case_ins.unix_opendir s 
                      with _ -> failwith ("cannot open directory " ^ s) in 
          begin try 
            while true do
              let s' = Unix.readdir s_d_h in
              let filename = (s ^ "/" ^ s') in 
!             try Case_ins.unix_unlink filename with _ -> () 
            done
          with e -> (Unix.closedir s_d_h ) end 
  
***************
*** 7690,7696 ****
      rl () 
    end else begin 
  
!   let key_type = Key.key_of_ext "ARE" in 
    Array.iter (fun r ->
      if r.Key.res_type = key_type then 
        ignore (rename r.Key.res_name "ARE") 
--- 7690,7696 ----
      rl () 
    end else begin 
  
!   let key_type = Key.key_of_ext true "ARE" in 
    Array.iter (fun r ->
      if r.Key.res_type = key_type then 
        ignore (rename r.Key.res_name "ARE") 
***************
*** 7710,7716 ****
          convert_pdialog () ; 
          --> now handled in GAM conversion 
          *)
!         (try Unix.mkdir "Sounds/A_NPC" 511 with _ -> () ) 
        end 
    | BG1, BG2 -> 
        log_and_print "Japh (or whatnot) must do something here.\n" 
--- 7710,7716 ----
          convert_pdialog () ; 
          --> now handled in GAM conversion 
          *)
!         (try Case_ins.unix_mkdir "Sounds/A_NPC" 511 with _ -> () ) 
        end 
    | BG1, BG2 -> 
        log_and_print "Japh (or whatnot) must do something here.\n" 
***************
*** 7756,7762 ****
    Stats.time "CHITIN.KEY" (fun () -> 
    let new_key = process_add_to_key () in 
  
!   let oc = open_out_bin "chitin.key" in 
    Key.save_key new_key oc ;
    ) () 
    (* Load.saved_game := Some(game) ;  *)
--- 7756,7762 ----
    Stats.time "CHITIN.KEY" (fun () -> 
    let new_key = process_add_to_key () in 
  
!   let oc = Case_ins.perv_open_out_bin "chitin.key" in 
    Key.save_key new_key oc ;
    ) () 
    (* Load.saved_game := Some(game) ;  *)
