*** WeiDU-185/src/key.ml	2004-08-19 21:13:54.000000000 +0200
--- WeiDU/src/key.ml	2007-06-21 16:10:58.000000000 +0200
***************
*** 1,4 ****
--- 1,13 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.key.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (* Infinity Engine [KEY] *)
+ 
  open Util
  
  type key_biff = {
***************
*** 71,82 ****
    with e -> 
      Printf.sprintf "0x%X" key
  
! let key_of_ext ext = 
    let ext = String.uppercase ext in 
    try 
      Hashtbl.find key_ext_ht ext 
    with e -> 
!     log_and_print "ERROR: unknown resource extension [%s]\n" ext ;
      raise e
  
  let save_key key outchan = begin
--- 80,91 ----
    with e -> 
      Printf.sprintf "0x%X" key
  
! let key_of_ext warn ext = 
    let ext = String.uppercase ext in 
    try 
      Hashtbl.find key_ext_ht ext 
    with e -> 
!     if warn then log_and_print "ERROR: unknown resource extension [%s]\n" ext ;
      raise e
  
  let save_key key outchan = begin
***************
*** 95,104 ****
      let base_name_offset = 24 + (12 * num_biff) in
  
      Array.iter (fun b ->
!       let filename = Printf.sprintf "%s%c" b.filename (Char.chr 0) in 
        let filename_offset = base_name_offset + (Buffer.length biff_name_buff) in
        let filename_length = String.length filename in
!       Buffer.add_string biff_name_buff filename ; 
        Buffer.add_string biff_buff (str_of_int b.length) ;
        Buffer.add_string biff_buff (str_of_int filename_offset) ;
        Buffer.add_string biff_buff (str_of_short filename_length) ; 
--- 104,113 ----
      let base_name_offset = 24 + (12 * num_biff) in
  
      Array.iter (fun b ->
!       let filename = Printf.sprintf "%s%c" (String.lowercase b.filename) (Char.chr 0) in
        let filename_offset = base_name_offset + (Buffer.length biff_name_buff) in
        let filename_length = String.length filename in
!       Buffer.add_string biff_name_buff (String.lowercase filename) ;
        Buffer.add_string biff_buff (str_of_int b.length) ;
        Buffer.add_string biff_buff (str_of_int filename_offset) ;
        Buffer.add_string biff_buff (str_of_short filename_length) ;
***************
*** 110,116 ****
  
      Array.iter (fun r ->
        let res_name = str_to_exact_size r.res_name 8 in 
!       Buffer.add_string res_buff res_name ;
        Buffer.add_string res_buff (str_of_short r.res_type) ;
        let bitfield : Int32.t = Int32.logor
          (Int32.logor (Int32.of_int r.other_index)
--- 119,125 ----
  
      Array.iter (fun r ->
        let res_name = str_to_exact_size r.res_name 8 in
!       Buffer.add_string res_buff (String.lowercase res_name) ;
        Buffer.add_string res_buff (str_of_short r.res_type) ;
        let bitfield : Int32.t = Int32.logor
          (Int32.logor (Int32.of_int r.other_index)
***************
*** 152,158 ****
        let len_file = short_of_str_off buff (off + 8) in
        {
          length = int_of_str_off buff off ;
!         filename = get_string_of_size buff off_file len_file ; 
          locations = short_of_str_off buff (off + 10) ;
        } 
      ) ;
--- 161,167 ----
        let len_file = short_of_str_off buff (off + 8) in
        {
          length = int_of_str_off buff off ;
!         filename = String.uppercase (get_string_of_size buff off_file len_file) ;
          locations = short_of_str_off buff (off + 10) ;
        } 
      ) ;
***************
*** 161,167 ****
        let bitfield = int32_of_str_off buff (off + 10) in
        let res = 
        {
!         res_name = get_string_of_size buff off 8 ; 
          res_type = short_of_str_off buff (off + 8) ;
          other_index = Int32.to_int 
                      (Int32.logand bitfield (Int32.of_int 16383)) ;
--- 170,176 ----
        let bitfield = int32_of_str_off buff (off + 10) in
        let res = 
        {
!         res_name = String.uppercase (get_string_of_size buff off 8) ;
          res_type = short_of_str_off buff (off + 8) ;
          other_index = Int32.to_int
                      (Int32.logand bitfield (Int32.of_int 16383)) ;
***************
*** 190,196 ****
      end
  
  (*
!   let rtype = key_of_ext ext in 
    let name = String.uppercase name in 
    try 
      Array.iter (fun res ->
--- 199,205 ----
      end
  
  (*
!   let rtype = key_of_ext true ext in 
    let name = String.uppercase name in 
    try 
      Array.iter (fun res ->
***************
*** 212,221 ****
    (filename,res.other_index,res.tis_index)
  end
  
  let list_biff key o = begin
    Array.iter (fun b ->
!     Printf.fprintf o "[%s]\t%9d bytes, %3d locations\n" 
!       b.filename b.length b.locations
    ) key.biff
  end
  
--- 221,240 ----
    (filename,res.other_index,res.tis_index)
  end
  
+ let bif_exists_in_key key name = begin
+   let result = ref false in
+   let name = Str.global_replace (Str.regexp "[\\/:]") Arch.biff_path_separator name in
+   Array.iter (fun b ->
+     let b = String.uppercase b.filename in
+     if String.compare (String.uppercase name) b = 0 then result := true;
+   ) key.biff ;
+   !result;
+ end
+ 
  let list_biff key o = begin
    Array.iter (fun b ->
!     o (Printf.sprintf "[%s]\t%9d bytes, %3d locations\n" 
!       b.filename b.length b.locations)
    ) key.biff
  end
  
***************
*** 224,239 ****
      let biff = key.biff.(r.bif_index) in
      let up_name = String.uppercase biff.filename in 
      if List.mem up_name bl then 
!       Printf.fprintf o "[%s] contains %8s.%3s at index %d\n"
          biff.filename r.res_name ( ext_of_key r.res_type )
          (if ext_of_key r.res_type = "TIS" then 
!           r.tis_index else r.other_index)
    ) key.resource
  end
  
  let list_key key o = begin
    Array.iter (fun r ->
!     Printf.fprintf o "%s.%s\n" r.res_name (ext_of_key r.res_type)
    ) key.resource
  end
  
--- 243,258 ----
      let biff = key.biff.(r.bif_index) in
      let up_name = String.uppercase biff.filename in 
      if List.mem up_name bl then 
!       o (Printf.sprintf "[%s] contains %8s.%3s at index %d\n"
          biff.filename r.res_name ( ext_of_key r.res_type )
          (if ext_of_key r.res_type = "TIS" then 
!           r.tis_index else r.other_index))
    ) key.resource
  end
  
  let list_key key o = begin
    Array.iter (fun r ->
!     o (Printf.sprintf "%s.%s\n" r.res_name (ext_of_key r.res_type))
    ) key.resource
  end
  
