*** WeiDU-185/src/main.ml	2005-06-27 01:51:51.000000000 +0200
--- WeiDU/src/main.ml	2007-07-21 15:52:27.000000000 +0200
***************
*** 1,3 ****
--- 1,11 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.main.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  open Util
  open Xdiff
  open Version
***************
*** 11,17 ****
        let result = Stats.time sort_of_file 
          (fun () -> parse_lex_fun lexbuf) () in
        pop_context () ;
!       log_or_print "[%s] parsed\n" filename ; 
        result
      with e -> 
        (try input_error "" (Printexc.to_string e) with _ -> () ) ; 
--- 19,25 ----
        let result = Stats.time sort_of_file
          (fun () -> parse_lex_fun lexbuf) () in
        pop_context () ;
!       log_or_print_modder "[%s] parsed\n" filename ;
        result
      with e ->
        (try input_error "" (Printexc.to_string e) with _ -> () ) ;
***************
*** 91,107 ****
  
  let handle_tp2_filename filename =
    let res = parse_file filename "parsing .tp2 files" 
!       (Dparser.tp_file Dlexer.initial) 
    in
    res.Tp.tp_filename <- filename ;
    res 
  
  let handle_tra_filename filename =
!   if file_exists filename then begin
      let result = 
      (match split (String.uppercase filename) with
      | _, "TRB" -> 
!       let inchan = open_in_bin filename in 
        let result = Stats.time "parsing .trb files" 
          Marshal.from_channel inchan in
        close_in inchan ; 
--- 99,123 ----
  
  let handle_tp2_filename filename =
    let res = parse_file filename "parsing .tp2 files"
!       (Tparser.tp_file Tlexer.initial)
    in
    res.Tp.tp_filename <- filename ;
    res
  
+ let handle_tph_filename filename =
+   parse_file filename "parsing .tph files"
+     (Tparser.tph_file Tlexer.initial)
+ 
+ let handle_tpp_filename filename =
+   parse_file filename "parsing .tpp files"
+     (Tparser.tpp_file Tlexer.initial)
+ 
  let handle_tra_filename filename =
!   if file_exists filename || Hashtbl.mem inlined_files filename then begin
      let result =
      (match split (String.uppercase filename) with
      | _, "TRB" ->
!       let inchan = Case_ins.perv_open_in_bin filename in
        let result = Stats.time "parsing .trb files"
          Marshal.from_channel inchan in
        close_in inchan ;
***************
*** 116,121 ****
--- 132,157 ----
      Stats.time "adding translation strings" Dc.add_trans_strings result
    end
  
+ let get_tra_list_filename filename =
+   if file_exists filename || Hashtbl.mem inlined_files filename then begin
+     let result =
+     (match split (String.uppercase filename) with
+     | _, "TRB" ->
+       let inchan = Case_ins.perv_open_in_bin filename in
+       let result = Stats.time "parsing .trb files"
+         Marshal.from_channel inchan in
+       close_in inchan ;
+       result
+     | _, _ ->
+       let result = parse_file filename "parsing .tra files"
+         (Dparser.tra_file Dlexer.initial) in
+       result)
+     in
+     log_or_print "[%s] has %d translation strings\n" filename
+       (List.length result);
+     result
+   end else []
+ 
  let handle_d_filename filename =
    try
      let result = parse_file filename "parsing .d files"
***************
*** 174,192 ****
  type output_info = { 
    mutable dir : string ;
    mutable file : string ; 
!   mutable chan : out_channel ; 
    mutable append : bool ; 
  } 
  
  let main () = 
  
    let theout = {
      dir = ".";
      file = "";
!     chan = stdout ; 
      append = false ; 
    } in
  
    let set_theout app s = 
      theout.append <- app ; 
      if is_directory s then
--- 210,311 ----
  type output_info = {
    mutable dir : string ;
    mutable file : string ;
!   mutable chan : out_channel lazy_t ;
    mutable append : bool ;
  }
  
  let main () =
+   let could_overwrite_tlk =
+     (try ignore (Str.search_forward (Str.regexp_case_fold "setup-")
+         Sys.argv.(0) 0);
+       true with _ -> false) ||
+     Array.fold_left (fun acc elt -> acc || elt = "--tlkout") false Sys.argv
+   in
+   if could_overwrite_tlk then (try
+     if file_exists "weidu.lock" then begin
+       let which = load_file "weidu.lock" in
+       let my_check in_lock current_tp2 =
+         let is_in patt buff =
+           try
+             ignore (Str.search_forward (Str.regexp_case_fold patt) buff 0);
+             true
+           with _ -> false
+         in
+         let is_in_a patt arr =
+           Array.fold_left (fun acc elt ->
+             acc || is_in patt elt
+           ) false arr
+         in
+         (is_in in_lock which) && (is_in_a current_tp2 Sys.argv)
+       in
+       if not (my_check "NEJ2" "NEJGUI") then begin
+         print_endline
+ "You cannot install more than one mod at a time or you will have bugs.
+ 
+ Try to install the mod once again, after the following:";
+         print_endline which;
+         print_endline "has finished.
+ 
+ Press ENTER to exit.";
+         ignore (read_line() );
+         exit 1;
+       end;
+     end;
+     let x = open_out "weidu.lock" in
+     for i = 0 to Array.length Sys.argv - 1 do
+       output_string x (Sys.argv.(i) ^ " ");
+     done;
+     flush x;
+     close_out x;
+     at_exit (fun () -> my_unlink "weidu.lock");
+   with e -> print_endline (Printexc.to_string e));
  
    let theout = {
      dir = ".";
      file = "";
!     chan = lazy(stdout) ;
      append = false ;
    } in
  
+   let print_theout fmt = Printf.fprintf (Lazy.force theout.chan) fmt in
+   let output_theout s = print_theout "%s" s in
+   let output_buffer_theout b = print_theout "%s" (Buffer.contents b) in
+   let flush_theout () = flush (Lazy.force theout.chan) in
+ 
+   let handle_out_boringness file ext_chop =
+     try
+       if !debug_ocaml then log_and_print "\n\nhandle_out_boringness received %s as a file name.\n" file ;
+       if true then begin match theout.dir, theout.file with
+         | ".", "" -> if !debug_ocaml then log_and_print "no --out\n"
+         | _, "" -> if !debug_ocaml then log_and_print "--out a_dir: %s\n"  theout.dir
+         | ".", _ -> if !debug_ocaml then log_and_print "--out a_file: %s\n"  theout.file
+         | _ -> if !debug_ocaml then log_and_print "You're a pervert, decide where to put your stuff!\n"
+       end ;
+       let ext_chop = List.map String.uppercase ext_chop in
+       let directory,(name,ext) = (Filename.dirname file,split(Filename.basename file)) in
+       let fullname = match theout.dir, theout.file with
+         | ".", "" -> file
+         | _, "" -> theout.dir ^
+           (match (String.get theout.dir (String.length theout.dir - 1)) with
+             | '/'
+             | '\\' -> ""
+             | _ -> "/"
+           ) ^ name ^ "." ^ ext
+         | ".", _ -> theout.file
+         | _ -> file
+       in
+       let base,ext = split fullname in
+       let result =
+         if List.mem (String.uppercase ext) ext_chop then
+           Filename.chop_extension fullname
+         else
+           fullname
+       in
+       if !debug_ocaml then log_and_print "handle_out_boringness returns %s\n" result ;
+       result
+     with _ -> if !debug_ocaml then log_and_print "something happened...\nDefaulting to %s\n"  file ; file
+   in
+ 
    let set_theout app s =
      theout.append <- app ;
      if is_directory s then
***************
*** 194,202 ****
      else begin
        theout.file <- s ;
        if app then 
!         theout.chan <- open_out_gen [Open_append ; Open_wronly ; Open_creat ; Open_text ] 511 s 
        else
!         theout.chan <- open_out s 
      end 
    in 
  
--- 313,321 ----
      else begin
        theout.file <- s ;
        if app then
!         theout.chan <- lazy (Case_ins.perv_open_out_gen [Open_append ; Open_wronly ; Open_creat ; Open_text ] 511 s)
        else
!         theout.chan <- lazy (Case_ins.perv_open_out s)
      end
    in
  
***************
*** 251,256 ****
--- 370,380 ----
    let self_update_message = ref true in 
    let auto_update_all = ref false in 
  
+   let force_install_these_main   = ref [] in
+   let force_uninstall_these_main = ref [] in
+   
+   let process_script = ref "" in
+ 
    let automate_list = ref [] in
    let automate_min = ref 62169 in 
  
***************
*** 283,291 ****
--- 407,420 ----
    let output_dialogf = ref None in 
  
    let traify = ref None in
+   let traify_old_tra = ref None in
+   let traify_comment = ref false in
    let trbify = ref None in
    let traify_num = ref 0 in
    
+   let untraify_d = ref None in
+   let untraify_tra = ref None in
+ 
    let forceify = ref None in 
  
    let use_trans = ref false in 
***************
*** 313,319 ****
      (if not (Str.string_match (Str.regexp_case_fold "setup-.*exe") my_real_name 0) then weidu_list := (my_real_name,int_of_string version) :: !weidu_list) ;
  
      (try begin
!       let d_h = Unix.opendir "." in
        try
          while true do 
          let f = Unix.readdir d_h in
--- 442,448 ----
      (if not (Str.string_match (Str.regexp_case_fold "setup-.*exe") my_real_name 0) then weidu_list := (my_real_name,int_of_string version) :: !weidu_list) ;
  
      (try begin
!       let d_h = Case_ins.unix_opendir "." in
        try
          while true do 
          let f = Unix.readdir d_h in
***************
*** 376,382 ****
        List.iter (fun (target,target_t) ->
          if (target <> this) && (target_t <> newest_t) then begin 
          (* log_and_print "\tUnlinking [%s]: " target ;  *)
!         let unlink_worked = (try Unix.unlink target ; true with _ -> false) in
          (* log_and_print "%b\n" unlink_worked ; *)
          log_and_print "\tCopying [%s] -> [%s]: " newest target ; 
          let copy_worked = try 
--- 505,511 ----
        List.iter (fun (target,target_t) ->
          if (target <> this) && (target_t <> newest_t) then begin 
          (* log_and_print "\tUnlinking [%s]: " target ;  *)
!         let unlink_worked = (try Case_ins.unix_unlink target ; true with _ -> false) in
          (* log_and_print "%b\n" unlink_worked ; *)
          log_and_print "\tCopying [%s] -> [%s]: " newest target ;
          let copy_worked = try 
***************
*** 462,599 ****
      end 
    end in 
  
!   let forced_script_style = ref Load.BG in 
  
    let usageMsg = Printf.sprintf "\t\tWeiDU (version %s: \"%s\")\n\nusage: WeiDU [options] BAF,BCS,D,DLG,TRA,TP,TP2-files\n\nGeneral Input Options:\n" version comment in
    let argDescr = [
!     "--game", Arg.String Load.add_game_path, "X\tset main game directory to X" ;
!     "--nogame", Arg.Set no_game,"\tdo not load any default game files" ; 
!     "--search", Arg.String Load.add_override_path, "X\tlook in X for input files (cumulative)" ;
!     "--tlkin", Arg.String Load.set_dialog_tlk_path,"X\tuse X as DIALOG.TLK" ;
!     "--ftlkin", Arg.String Load.set_dialogf_tlk_path,"X\tuse X as DIALOGF.TLK";
!     "--tlkmerge", Arg.String (fun s -> tlk_merge := !tlk_merge @ [s]),
        "X\tmerge X into loaded DIALOG.TLK" ;
!     "--yes", Arg.Set Tp.always_yes,"\tanswer all TP2 questions with 'Yes'"
      ;
!     "--uninstall", Arg.Set Tp.always_uninstall,"\tanswer all TP2 questions with 'Uninstall'" ;
!     "--reinstall", Arg.Set Tp.sometimes_reinstall,"\treinstall all installed TP2 components" ;
!     "--ask-every", Arg.Set Tp.ask_all, "\task about every TP2 component" ; 
!     "--noautoupdate", Arg.Set no_auto_update,"\tdo not auto-update WeiDU setup files" ;
!     "--noselfupdatemsg", Arg.Clear self_update_message,"\tdo not print any self-updating messages" ; 
!     "--update-all", Arg.Set auto_update_all,"\tauto-update all WeiDU setup files"; 
!     "--script-style", Arg.String (fun s -> 
        let n = match String.uppercase s with
!         | "PST" -> Load.PST
!         | "BG" -> Load.BG
          | "BG2" -> Load.BG
!         | "IWD" -> Load.BG
          | "IWD2" -> Load.IWD2
!         | _ -> failwith "unknown script-style" 
!       in forced_script_style := n),"X\tuse BCS/BAF style X (BG, PST, IWD2)"
  
      ^ "\n\nGeneral Output Options:\n" ;
  
!     "--backup", Arg.String (fun s -> backup_dir := Some(s)), "X\tbackup files to directory X before overwriting" ;
!     "--tlkout", Arg.String (fun s -> output_dialog := Some(s)), "X\temit X as new DIALOG.TLK" ;
!     "--ftlkout", Arg.String (fun s -> output_dialogf := Some(s)), "X\temit X as new DIALOGF.TLK\n\nD Options:\n" ; 
! 
!     "--transin", Arg.String (fun s -> trans_list := !trans_list @ [s]), "X\tuse translation file X (cumulative)" ;
!     "--testtrans", Arg.Set test_trans, "\ttest all translations files" ;
!     "--noheader", Arg.Clear d_headers, "\tdo not emit .D header comments" ;
!     "--nofrom", Arg.Clear Dlg.emit_from, "\tdo not emit .D \"// from:\" comments" ;
!     "--full-from", Arg.Set two_pass, "\tGenerate complete \"// from:\" comments"; 
!     "--nocom", Arg.Clear Dlg.comments, "\tdo not emit ANY .D / .BAF comments" ;
!     "--transitive", Arg.Set transitive, "\tFollow EXTERN links when making D files" ;
!     "--toplevel", Arg.Set d_toplevel, "\tEmit top-level DLG states only" ; 
!     "--text", Arg.Set Dlg.emit_text, "\temit string text with refs in comments" ; 
  
!     "--out", Arg.String (set_theout false), "X\temit to file or directory X" ;
!     "--append", Arg.String (set_theout true), "X\tappend to file or directory X" ;
  
      (*
!     "--out", Arg.String (fun s -> output_dir := s), "X\temit all output files in directory X" ;
!     "--dout", Arg.String (fun s -> dout_list := !dout_list @ [s]), "X\tname of output .D file to emit (cumulative)" ;
!     "--textout", Arg.String (fun s -> textout := open_out s), "X\tput text output in file X"; 
!     "--textapp", Arg.String (fun s -> 
!         textout := open_out_gen [Open_append ; Open_wronly ; Open_creat ; Open_text ] 511 s ) ,
          "X\tappend text output to end of file X"; 
      *)
!     "--traify", Arg.String (fun s -> traify := Some(s)), "X\tconvert .D file X to use TRAs (use with --out)" ;
!     "--traify#", Arg.Int (fun d -> traify_num := d), "X\tstart --traify .TRA file at @X" ;
!     "--trbify", Arg.String (fun s -> trbify := Some(s)), "X\tconvert .TRA file X to a TRB (use with --out)" ;
!     "--extract-kits", Arg.Int (fun d -> extract_kits := d), "X\textract all kits starting with kit #X"; 
!     "--forceify", Arg.String (fun s -> forceify := Some(s)), "X\tconvert .D file X to use forced strrefs (use with --dout)" ;
!     "--transref", Arg.Set Dlg.use_trans_ref, "\temit string reference numbers in TRA files" ;
!     "--trans", Arg.Set use_trans, "\temit coupled .D and .TRA files\n\nTLK String Options:\n" ;
! 
!     "--traify-tlk", Arg.Set extract_tlk, "\temit a .TRA file for the given .TLK file (see --textout, --min, --traify#)" ;
!     "--make-tlk", Arg.String (fun s -> make_tlk := s :: !make_tlk), "X\tmake a .TLK file from .TRA file X (cumulative, see --tlkout)" ; 
!     "--string", Arg.Int (fun i -> ds_list := i :: !ds_list), "X\tdisplay string reference #X (cumulative)" ;
!     "--strfind", Arg.String (fun s -> strfind_list := s :: !strfind_list), "X\tdisplay strings that contain X (cumulative, regexp allowed)" ;
!     "--strapp", Arg.String (fun s -> strapp_list := s :: !strapp_list), "X\tappend string X to DIALOG.TLK (cumulative)\n\nBIFF Options:\n" ;
! 
!     "--list-biffs", Arg.Set list_biff, "\tenumerate all BIFF files in CHITIN.KEY" ;
!     "--list-files", Arg.Set list_files, "\tenumerate all resource files in CHITIN.KEY"; 
!     "--biff", Arg.String (fun s -> bc_list := (String.uppercase s) :: !bc_list), "X\tenumerate contents of BIFF file X (cumulative)" ;
!     "--biff-type", Arg.String (fun s -> bs_type_list := s :: !bs_type_list), "X\texamine all BIFF resources of extension X ... (cumulative)" ;
!     "--biff-str", Arg.String (fun s -> bs_str_list := s :: !bs_str_list), "X\t... and list those containing X (cumulative, regexp allowed)" ;
!     "--biff-name", Arg.Int (fun i -> Load.content_name_offset := Some(i)),
        "X\tassume matching items have a strref name at offset X" ;
!     "--biff-value", Arg.Int (fun i -> biff_short := i), "X\t... or list those containing value X ..." ;
!     "--biff-value-at", Arg.Int (fun i -> biff_short_at := i), "X\t... at offset X" ;
!     "--biff-get", Arg.String (fun s -> bg_list := s :: !bg_list), "X\textract resource X from game BIFFs (cumulative, regexp allowed)" ;
!     "--biff-get-rest", Arg.Rest (fun s -> bg_list := s :: !bg_list), "X, Y, ...\textract resources X, Y, ... from game BIFFs (regexp allowed)" ;
!     "--make-biff", Arg.String (fun s -> make_biff := Some(s)), "X\tmake data\\X.bif from all files in folder X, update CHITIN.KEY" ;
!     "--remove-biff", Arg.String (fun s -> remove_biff := Some(s)), "X\tremove references to biff X and its resources, update CHITIN.KEY" ;
  
  (* 
!     "--itemlist", Arg.Set make_an_itemlist, "\tmake an item listing (IWD2)" ; 
!     "--xplist", Arg.Set make_an_xplist, "\tmake an XP listing (IWD2)" ; 
!     "--cre_analysis", Arg.Set do_cre_analysis, "\tdo CRE analysis (IWD2)" ;
!     "--itemsort", Arg.Set do_itmsort, "\tdo ITM sort (IWD2)" ;
       *)
  
!     "", Arg.Unit (fun a -> a),  "\nARE/ITM/SPL/CRE Options:\n" ;
!     "--automate", Arg.String (fun s -> automate_list := s ::
!     !automate_list), "X\tautomatically make a TP2 file for ARE/ITM/SPL/CRE files in X" ;
!     "--automate-min", Arg.Int (fun i -> automate_min := i),
        "X\tminimum strref # for --automate (default is SoA)";
  
!     "--list-eff", Arg.String (fun s -> list_eff_list := s :: !list_eff_list), "X\tlist effects in resource X" ;
  
!     "", Arg.Unit (fun a -> a),  "\nComparison Options:\n" ;
!     "--cmp-from", Arg.String (fun s -> cmp_src := Some(s)), "X\temit WRITE_BYTEs to turn this file ..." ;
!     "--cmp-to", Arg.String (fun s -> cmp_dest := Some(s)), "X\t... into this one";
!     "--dcmp-from", Arg.String (fun s -> dcmp_src := Some(s)), "X\temit REPLACEs to turn this DLG file ..." ;
!     "--dcmp-to", Arg.String (fun s -> dcmp_dest := Some(s)), "X\t... into this one";
! 
!     "--tcmp-from", Arg.String (fun s -> tcmp_src := Some(s)), "X\tcompare this TRA file (or directory of TRA files)..." ;
!     "--tcmp-to", Arg.String (fun s -> tcmp_dest := Some(s)), "X\t... with this one (or this directory)";
!     "--bcmp-from", Arg.String (fun s -> bcmp_src := Some(s)), "X\temit APPLY_BCS_PATCH to turn this BCS file..." ;
!     "--bcmp-to", Arg.String (fun s -> bcmp_dest := Some(s)), "X\t... into this one" ;
      (* For debugging patch/diff: *)
!     "--bcmp-orig", Arg.String (fun s -> bcmp_orig := Some(s)), "X\toriginal file to apply ..." ;
!     "--bcmp-patch", Arg.String (fun s -> bcmp_patch := Some(s)), "X\t... this patch to" ;
!     "--tlkcmp-from", Arg.String (fun s -> tlkcmp_src := Some(s)), "X\temit STRING_SETs to convert this TLK file ..." ;
!     "--tlkcmp-to", Arg.String (fun s -> tlkcmp_dest := Some(s)), "X\t... into this one";
!     "--tlkcmp-use-strings", Arg.Set tlkcmp_strings, "\tmodifies --tlkcmp behavior"; 
!     "--min", Arg.Int (fun i -> user_min := Some(i)), "X\tlower range for some commands (like --tlkcmp)" ;
!     "--max", Arg.Int (fun i -> user_max := Some(i)), "X\tupper range for some commands (like --string)" ;
! 
!     "", Arg.Unit (fun a -> a),  "\nLog Options:\n" ;
! 
!     "--log", Arg.String (fun s -> init_log s),"X\tlog output and details to X" ;
!     "--autolog", Arg.Unit (fun () -> init_log "WSETUP.DEBUG"), "\tlog output and details to WSETUP.DEBUG" ;
!     "--logapp", Arg.Set append_to_log,"\tappend to log instead of overwriting" ; 
!     "--debug-assign", Arg.Set Var.debug_assign,"\tPrint out all values assigned to TP2 variables" ;
!     "--debug-value", Arg.Set Tp.debug_pe,"\tPrint out all value expressions" ;
!     "--continue", Arg.Set Tp.continue_on_error,"\tcontinue despite TP2 action errors" ;
  
!     "", Arg.Unit (fun a -> a),  "\nHelp Options:\n"; 
  
    ] in 
    let give_help () = 
!     Arg.usage argDescr usageMsg ;
      exit return_value_error_argument
    in 
    let handleArg str = begin 
--- 591,762 ----
      end
    end in
  
!   let forced_script_style = ref Load.NONE in
!   let counter = ref 0 in
  
    let usageMsg = Printf.sprintf "\t\tWeiDU (version %s: \"%s\")\n\nusage: WeiDU [options] BAF,BCS,D,DLG,TRA,TP,TP2-files\n\nGeneral Input Options:\n" version comment in
    let argDescr = [
!     "--game", Myarg.String Load.add_game_path, "X\tset main game directory to X" ;
!     "--nogame", Myarg.Set no_game,"\tdo not load any default game files" ;
!     "--search", Myarg.String Load.add_override_path, "X\tlook in X for input files (cumulative)" ;
!     "--tlkin", Myarg.String Load.set_dialog_tlk_path,"X\tuse X as DIALOG.TLK" ;
!     "--ftlkin", Myarg.String Load.set_dialogf_tlk_path,"X\tuse X as DIALOGF.TLK";
!     "--tlkmerge", Myarg.String (fun s -> tlk_merge := !tlk_merge @ [s]),
        "X\tmerge X into loaded DIALOG.TLK" ;
!     "--yes", Myarg.Set Tp.always_yes,"\tanswer all TP2 questions with 'Yes'"
      ;
!     "--uninstall", Myarg.Set Tp.always_uninstall,"\tanswer all TP2 questions with 'Uninstall'" ;
!     "--reinstall", Myarg.Set Tp.sometimes_reinstall,"\treinstall all installed TP2 components" ;
!     "--language", Myarg.Int (fun d -> Tp.forced_language := d), "X\tSet the language to X" ;
!     "--force-install",   Myarg.Int (fun d -> force_install_these_main   := d :: !force_install_these_main;
! 	  Tp.specified_specific_components := true),     "\tX installs component X number (cumulative)" ;
!     "--force-uninstall", Myarg.Int (fun d -> force_uninstall_these_main := d :: !force_uninstall_these_main;
! 	  Tp.specified_specific_components := true), "\tX uninstalls component X number (cumulative)" ;
!     "--force-install-rest",   Myarg.Rest (fun d -> force_install_these_main   := (int_of_string d) :: !force_install_these_main;
! 	  Tp.specified_specific_components := true),     "\tX Y... installs component number X, Y... (cumulative)" ;
!     "--force-install-list",   Myarg.List (fun d -> force_install_these_main   := (int_of_string d) :: !force_install_these_main;
! 	  Tp.specified_specific_components := true),     "\tX Y... installs component number X, Y... (cumulative)" ;
!     "--force-uninstall-rest", Myarg.Rest (fun d -> force_uninstall_these_main := (int_of_string d) :: !force_uninstall_these_main;
! 	  Tp.specified_specific_components := true), "\tX Y... uninstalls component number X, Y... (cumulative)" ;
!     "--force-uninstall-list", Myarg.List (fun d -> force_uninstall_these_main := (int_of_string d) :: !force_uninstall_these_main;
! 	  Tp.specified_specific_components := true), "\tX Y... uninstalls component number X, Y... (cumulative)" ;
!     "--process-script", Myarg.String (fun s -> process_script := s), "\tX process installation script X";
! 	  "--skip-at-view", Myarg.Set Tp.skip_at_view, "kills AT_* ~VIEW this~";
! 	  "--quick-log", Myarg.Set Tp.quick_log, "Doesn't print the name of components in weidu.log (much faster)";
!     "--ask-every", Myarg.Set Tp.ask_all, "\task about every TP2 component" ;
!     "--noautoupdate", Myarg.Set no_auto_update,"\tdo not auto-update WeiDU setup files" ;
!     "--noselfupdatemsg", Myarg.Clear self_update_message,"\tdo not print any self-updating messages" ;
!     "--update-all", Myarg.Set auto_update_all,"\tauto-update all WeiDU setup files";
!     "--args", Myarg.String (fun s -> Var.set_string ("argv[" ^ (string_of_int !counter) ^ "]") s; incr counter), 
!       "\tX X will be stored in the %argv[x]% variable (cumulative)";
!     "--args-rest", Myarg.Rest (fun s -> Var.set_string ("argv[" ^ (string_of_int !counter) ^ "]") s; incr counter),
!       "\tX Y... X, Y... will be stored in the %argvx% variables (cumulative)";
!     "--args-list", Myarg.List (fun s -> Var.set_string ("argv[" ^ (string_of_int !counter) ^ "]") s; incr counter),
!       "\tX Y... X, Y... will be stored in the %argvx% variables (cumulative)";
!     "--debug-presence", Myarg.Set Bcs.debug_presence,"\twhen compiling .BAF files check that files referenced do exist" ;
!     "--debug-ocaml", Myarg.Set Util.debug_ocaml,"\tenables random debugging information for the OcaML source (rarely of interest to end-users" ;
!     "--debug-boiic", Myarg.Set Tp.debug_boiic,"\tprints out which files have been changed by BUT_ONLY_IF_IT_CHANGES" ;
!     "--debug-change", Myarg.Set Tp.debug_change,"\tprints a warning if a file is being COPY_EXISTED without receiving a change." ;
!     "--script-style", Myarg.String (fun s ->
        let n = match String.uppercase s with
!         | "BG"
!         | "BG1"
          | "BG2" -> Load.BG
!         | "PST" -> Load.PST
!         | "IWD"
!         | "IWD1" -> Load.IWD1
          | "IWD2" -> Load.IWD2
!         | _ -> parse_error "unknown SCRIPT_STYLE"
!       in forced_script_style := n),"X\tuse BCS/BAF style X (BG, PST, IWD1, IWD2)"
  
      ^ "\n\nGeneral Output Options:\n" ;
  
!     "--backup", Myarg.String (fun s -> backup_dir := Some(s)), "X\tbackup files to directory X before overwriting" ;
!     "--tlkout", Myarg.String (fun s -> output_dialog := Some(s)), "X\temit X as new DIALOG.TLK" ;
!     "--ftlkout", Myarg.String (fun s -> output_dialogf := Some(s)), "X\temit X as new DIALOGF.TLK\n\nD Options:\n" ; 
! 
!     "--transin", Myarg.String (fun s -> trans_list := !trans_list @ [s]), "X\tuse translation file X (cumulative)" ;
!     "--testtrans", Myarg.Set test_trans, "\ttest all translations files" ;
!     "--noheader", Myarg.Clear d_headers, "\tdo not emit .D header comments" ;
!     "--nofrom", Myarg.Clear Dlg.emit_from, "\tdo not emit .D \"// from:\" comments" ;
!     "--full-from", Myarg.Set two_pass, "\tGenerate complete \"// from:\" comments"; 
!     "--nocom", Myarg.Clear Dlg.comments, "\tdo not emit ANY .D / .BAF comments" ;
!     "--transitive", Myarg.Set transitive, "\tFollow EXTERN links when making D files" ;
!     "--toplevel", Myarg.Set d_toplevel, "\tEmit top-level DLG states only" ; 
!     "--text", Myarg.Set Dlg.emit_text, "\temit string text with refs in comments" ; 
  
!     "--out", Myarg.String (set_theout false), "X\temit to file or directory X" ;
!     "--append", Myarg.String (set_theout true), "X\tappend to file or directory X" ;
  
      (*
!     "--out", Myarg.String (fun s -> output_dir := s), "X\temit all output files in directory X" ;
!     "--dout", Myarg.String (fun s -> dout_list := !dout_list @ [s]), "X\tname of output .D file to emit (cumulative)" ;
!     "--textout", Myarg.String (fun s -> textout := Case_ins.perv_open_out s), "X\tput text output in file X"; 
!     "--textapp", Myarg.String (fun s -> 
!         textout := Case_ins.perv_open_out_gen [Open_append ; Open_wronly ; Open_creat ; Open_text ] 511 s ) ,
          "X\tappend text output to end of file X"; 
      *)
!     "--traify", Myarg.String (fun s -> traify := Some(s)), "X\tconvert .D file X to use TRAs (use with --out)" ;
!     "--traify-old-tra", Myarg.String (fun s -> traify_old_tra := Some(s)), "X\tthe given .TRA file contains the initial strings to traify" ;
!     "--traify#", Myarg.Int (fun d -> traify_num := d), "X\tstart --traify .TRA file at @X" ;
!     "--traify-comment", Myarg.Set traify_comment, "\toutput @1 /* ~Hello~ */ rather than @1 when traifying" ;
!     "--trbify", Myarg.String (fun s -> trbify := Some(s)), "X\tconvert .TRA file X to a TRB (use with --out)" ;
!     "--untraify-d", Myarg.String (fun s -> untraify_d := Some(s)), "X\tconvert .D file X to use hardcoded strings...";
!     "--untraify-tra", Myarg.String (fun s -> untraify_tra := Some(s)), "X\t...from TRA file X";
!     "--extract-kits", Myarg.Int (fun d -> extract_kits := d), "X\textract all kits starting with kit #X";
!     "--forceify", Myarg.String (fun s -> forceify := Some(s)), "X\tconvert .D file X to use forced strrefs (use with --dout)" ;
!     "--transref", Myarg.Set Dlg.use_trans_ref, "\temit string reference numbers in TRA files" ;
!     "--trans", Myarg.Set use_trans, "\temit coupled .D and .TRA files\n\nTLK String Options:\n" ;
! 
!     "--traify-tlk", Myarg.Set extract_tlk, "\temit a .TRA file for the given .TLK file (see --textout, --min, --traify#)" ;
!     "--make-tlk", Myarg.String (fun s -> make_tlk := s :: !make_tlk), "X\tmake a .TLK file from .TRA file X (cumulative, see --tlkout)" ;
!     "--string", Myarg.Int (fun i -> ds_list := i :: !ds_list), "X\tdisplay string reference #X (cumulative)" ;
!     "--strfind", Myarg.String (fun s -> strfind_list := s :: !strfind_list), "X\tdisplay strings that contain X (cumulative, regexp allowed)" ;
!     "--strapp", Myarg.String (fun s -> strapp_list := s :: !strapp_list), "X\tappend string X to DIALOG.TLK (cumulative)\n\nBIFF Options:\n" ;
! 
!     "--list-biffs", Myarg.Set list_biff, "\tenumerate all BIFF files in CHITIN.KEY" ;
!     "--list-files", Myarg.Set list_files, "\tenumerate all resource files in CHITIN.KEY"; 
!     "--biff", Myarg.String (fun s -> bc_list := (String.uppercase s) :: !bc_list), "X\tenumerate contents of BIFF file X (cumulative)" ;
!     "--biff-type", Myarg.String (fun s -> bs_type_list := s :: !bs_type_list), "X\texamine all BIFF resources of extension X ... (cumulative)" ;
!     "--biff-str", Myarg.String (fun s -> bs_str_list := s :: !bs_str_list), "X\t... and list those containing X (cumulative, regexp allowed)" ;
!     "--biff-name", Myarg.Int (fun i -> Load.content_name_offset := Some(i)),
        "X\tassume matching items have a strref name at offset X" ;
!     "--biff-value", Myarg.Int (fun i -> biff_short := i), "X\t... or list those containing value X ..." ;
!     "--biff-value-at", Myarg.Int (fun i -> biff_short_at := i), "X\t... at offset X" ;
!     "--biff-get", Myarg.String (fun s -> bg_list := s :: !bg_list), "X\textract resource X from game BIFFs (cumulative, regexp allowed)" ;
!     "--biff-get-rest", Myarg.Rest (fun s -> bg_list := s :: !bg_list), "X, Y, ...\textract resources X, Y, ... from game BIFFs (regexp allowed)" ;
!     "--biff-get-list", Myarg.List (fun s -> bg_list := s :: !bg_list), "X, Y, ...\textract resources X, Y, ... from game BIFFs (regexp allowed)" ;
!     "--make-biff", Myarg.String (fun s -> make_biff := Some(s)), "X\tmake data\\X.bif from all files in folder X, update CHITIN.KEY" ;
!     "--remove-biff", Myarg.String (fun s -> remove_biff := Some(s)), "X\tremove references to biff X and its resources, update CHITIN.KEY" ;
  
  (* 
!     "--itemlist", Myarg.Set make_an_itemlist, "\tmake an item listing (IWD2)" ; 
!     "--xplist", Myarg.Set make_an_xplist, "\tmake an XP listing (IWD2)" ; 
!     "--cre_analysis", Myarg.Set do_cre_analysis, "\tdo CRE analysis (IWD2)" ;
!     "--itemsort", Myarg.Set do_itmsort, "\tdo ITM sort (IWD2)" ;
       *)
  
!     "", Myarg.Unit (fun a -> a),  "\nARE/ITM/SPL/CRE Options:\n" ;
!     "--automate", Myarg.String (fun s -> automate_list := s ::
!     !automate_list), "X\tautomatically make a TP2 file for ARE/ITM/SPL/CRE/EFF/STO files in X" ;
!     "--automate-min", Myarg.Int (fun i -> automate_min := i),
        "X\tminimum strref # for --automate (default is SoA)";
  
!     "--list-eff", Myarg.String (fun s -> list_eff_list := s :: !list_eff_list), "X\tlist effects in resource X" ;
  
!     "", Myarg.Unit (fun a -> a),  "\nComparison Options:\n" ;
!     "--cmp-from", Myarg.String (fun s -> cmp_src := Some(s)), "X\temit WRITE_BYTEs to turn this file ..." ;
!     "--cmp-to", Myarg.String (fun s -> cmp_dest := Some(s)), "X\t... into this one";
!     "--dcmp-from", Myarg.String (fun s -> dcmp_src := Some(s)), "X\temit REPLACEs to turn this DLG file ..." ;
!     "--dcmp-to", Myarg.String (fun s -> dcmp_dest := Some(s)), "X\t... into this one";
! 
!     "--tcmp-from", Myarg.String (fun s -> tcmp_src := Some(s)), "X\tcompare this TRA file (or directory of TRA files)..." ;
!     "--tcmp-to", Myarg.String (fun s -> tcmp_dest := Some(s)), "X\t... with this one (or this directory)";
!     "--bcmp-from", Myarg.String (fun s -> bcmp_src := Some(s)), "X\temit APPLY_BCS_PATCH to turn this BCS file..." ;
!     "--bcmp-to", Myarg.String (fun s -> bcmp_dest := Some(s)), "X\t... into this one" ;
      (* For debugging patch/diff: *)
!     "--bcmp-orig", Myarg.String (fun s -> bcmp_orig := Some(s)), "X\toriginal file to apply ..." ;
!     "--bcmp-patch", Myarg.String (fun s -> bcmp_patch := Some(s)), "X\t... this patch to" ;
!     "--tlkcmp-from", Myarg.String (fun s -> tlkcmp_src := Some(s)), "X\temit STRING_SETs to convert this TLK file ..." ;
!     "--tlkcmp-to", Myarg.String (fun s -> tlkcmp_dest := Some(s)), "X\t... into this one";
!     "--tlkcmp-use-strings", Myarg.Set tlkcmp_strings, "\tmodifies --tlkcmp behavior"; 
!     "--min", Myarg.Int (fun i -> user_min := Some(i)), "X\tlower range for some commands (like --tlkcmp)" ;
!     "--max", Myarg.Int (fun i -> user_max := Some(i)), "X\tupper range for some commands (like --string)" ;
! 
!     "", Myarg.Unit (fun a -> a),  "\nLog Options:\n" ;
! 
!     "--log", Myarg.String (fun s -> init_log s),"X\tlog output and details to X" ;
!     "--autolog", Myarg.Unit (fun () -> init_log "WSETUP.DEBUG"), "\tlog output and details to WSETUP.DEBUG" ;
!     "--logapp", Myarg.Set append_to_log,"\tappend to log instead of overwriting" ; 
!     "--debug-assign", Myarg.Set Var.debug_assign,"\tPrint out all values assigned to TP2 variables" ;
!     "--debug-value", Myarg.Set Tp.debug_pe,"\tPrint out all value expressions" ;
!     "--continue", Myarg.Set Tp.continue_on_error,"\tcontinue despite TP2 action errors" ;
  
!     "", Myarg.Unit (fun a -> a),  "\nHelp Options:\n";
  
    ] in
    let give_help () =
!     Myarg.usage argDescr usageMsg ;
      exit return_value_error_argument
    in
    let handleArg str = begin
***************
*** 638,650 ****
      let target = Unix.getenv "weiduautoupdate" in 
      let silent = 
        try 
!         if Unix.getenv "weiduautoupdatesilent" = "0" then false else true
!       with _ -> false
      in 
      log_and_print "Auto-Updating on behalf of [%s]\n" target ; 
      let this_buff = load_file Sys.argv.(0) in 
      (* in this case we can always just copy ourselves over the target *) 
!         let unlink_worked = (try Unix.unlink target ; true with _ -> false) in
          (* log_and_print "%b\n" unlink_worked ; *)
          log_and_print "\tCopying [%s] -> [%s]: " Sys.argv.(0) target ; 
          let copy_worked = try 
--- 801,817 ----
      let target = Unix.getenv "weiduautoupdate" in 
      let silent =
        try
!         if !debug_ocaml then log_and_print "weiduautoupdatesilent = %s\n"
!             (Unix.getenv "weiduautoupdatesilent") ;
!         if Unix.getenv "weiduautoupdatesilent" = "0" then false else true ;
!       with _ -> (
!         if !debug_ocaml then log_and_print "weiduautoupdatesilent is not set\n" ;
!         false)
      in
      log_and_print "Auto-Updating on behalf of [%s]\n" target ;
      let this_buff = load_file Sys.argv.(0) in 
      (* in this case we can always just copy ourselves over the target *)
!         let unlink_worked = (try Case_ins.unix_unlink target ; true with _ -> false) in
          (* log_and_print "%b\n" unlink_worked ; *)
          log_and_print "\tCopying [%s] -> [%s]: " Sys.argv.(0) target ;
          let copy_worked = try 
***************
*** 659,665 ****
      if not silent then begin 
        log_and_print
      "\n\n\t***********************************************************\n\tWeiDU has finished auto-updating all copies of itself\n\tin this directory. Please RE-RUN %s\n\tto actually install the mod.\n\t(sorry, I can't do it for you, Windows won't let me)\n" target ; 
!       (if Arg.term <> "xterm" then (try ignore (read_line () ) with _ -> ()))
      end 
      ;
      exit return_value_retry_autoupdate ;
--- 826,832 ----
      if not silent then begin
        log_and_print
      "\n\n\t***********************************************************\n\tWeiDU has finished auto-updating all copies of itself\n\tin this directory. Please RE-RUN %s\n\tto actually install the mod.\n\t(sorry, I can't do it for you, Windows won't let me)\n" target ;
!       (if Myarg.term <> "xterm" then (try ignore (read_line () ) with _ -> ()))
      end
      ;
      exit return_value_retry_autoupdate ;
***************
*** 667,673 ****
  
    Load.game_paths := Load.registry_game_paths () ; 
  
!   Arg.parse argDescr handleArg usageMsg  ;
  
    if (!auto_update_all) then begin
      (if (Arch.do_auto_update) then 
--- 834,840 ----
  
    Load.game_paths := Load.registry_game_paths () ;
  
!   Myarg.parse argDescr handleArg usageMsg  ;
  
    if (!auto_update_all) then begin
      (if (Arch.do_auto_update) then
***************
*** 683,689 ****
      auto () ;
    with _ -> 
      if Array.length Sys.argv <= 1 then begin 
!       Arg.usage argDescr usageMsg ;
        flush_all () ; 
        log_and_print "\nEnter arguments: " ;
        let mystr = read_line () in
--- 850,856 ----
      auto () ;
    with _ ->
      if Array.length Sys.argv <= 1 then begin
!       Myarg.usage argDescr usageMsg ;
        flush_all () ;
        log_and_print "\nEnter arguments: " ;
        let mystr = read_line () in
***************
*** 699,723 ****
        Load.load_game () 
    in 
  
    game.Load.script_style <- !forced_script_style ; 
    Dc.cur_index := Array.length game.Load.dialog ;
    Load.saved_game := Some(game) ; 
  
  
  (* 
!   (  if (!make_an_itemlist) then Itemlist.make_item_list game theout.chan );
!   (  if (!make_an_xplist) then Itemlist.make_xplist game theout.chan );
!   ( if (!do_cre_analysis) then Itemlist.cre_analysis game theout.chan ) ; 
!   ( if (!do_itmsort) then Itemlist.itm_randomizer game theout.chan ) ; 
      *)
  
!   Automate.automate game !automate_list !automate_min theout.chan ;
  
    (match !forceify with
      Some(file) -> begin
        try 
          let name,ext = split (String.uppercase file) in 
!         let inchan = open_in file in 
          let lexbuf = lex_init file inchan in 
          Dlg.local_string_ht := Some([]) ; 
          begin 
--- 865,900 ----
  			Load.load_game ()
    in
  
+   if (!forced_script_style <> Load.NONE) then
      game.Load.script_style <- !forced_script_style ;
+   let s = match game.Load.script_style with
+   | Load.PST -> "PST"
+   | Load.BG -> "BG"
+   | Load.IWD1 -> "IWD1"
+   | Load.IWD2 -> "IWD2"
+   | Load.NONE -> "NONE (ERROR!!!)"
+   in log_and_print "[%s] Using scripting style \"%s\"\n" Sys.argv.(0) s;
+ 
    Dc.cur_index := Array.length game.Load.dialog ;
    Load.saved_game := Some(game) ;
  
  
  (*
!   (  if (!make_an_itemlist) then Itemlist.make_item_list game print_theout );
!   (  if (!make_an_xplist) then Itemlist.make_xplist game print_theout );
!   ( if (!do_cre_analysis) then Itemlist.cre_analysis game print_theout ) ; 
!   ( if (!do_itmsort) then Itemlist.itm_randomizer game print_theout ) ; 
      *)
  
!   if !automate_list <> [] then begin
!   	Automate.automate game !automate_list !automate_min (output_string (Lazy.force theout.chan)) ;
!   end;
  
    (match !forceify with
      Some(file) -> begin
        try 
          let name,ext = split (String.uppercase file) in 
!         let inchan = Case_ins.perv_open_in file in 
          let lexbuf = lex_init file inchan in 
          Dlg.local_string_ht := Some([]) ;
          begin 
***************
*** 726,732 ****
                    (fun () -> Dparser.d_file Dlexer.initial lexbuf) ()  )
            | "TP2" -> ignore
                     (Stats.time "parsing .TP2 files"
!                   (fun () -> Dparser.tp_file Dlexer.initial lexbuf) () )
            | _ -> log_and_print "ERROR: don't know how to --forceify files with extension [%s]\n" ext ; failwith ext 
          end ;
          pop_context (); 
--- 903,909 ----
                    (fun () -> Dparser.d_file Dlexer.initial lexbuf) ()  )
            | "TP2" -> ignore
                     (Stats.time "parsing .TP2 files"
!                   (fun () -> Tparser.tp_file Tlexer.initial lexbuf) () )
            | _ -> log_and_print "ERROR: don't know how to --forceify files with extension [%s]\n" ext ; failwith ext 
          end ;
          pop_context (); 
***************
*** 735,741 ****
  
          let buf = ref (load_file file) in 
  
!         let dout = theout.chan in 
  
          let replace lse str = 
            let my_regexp = Str.regexp (Str.quote str) in
--- 912,918 ----
  
          let buf = ref (load_file file) in
  
!         let dout = output_theout in 
  
          let replace lse str =
            let my_regexp = Str.regexp (Str.quote str) in
***************
*** 764,770 ****
          ); 
  
          Dlg.local_string_ht := None ;
!         output_string dout !buf ; 
          () 
  
        with e -> 
--- 941,947 ----
          ); 
  
          Dlg.local_string_ht := None ;
!         dout !buf ; 
          ()
  
        with e -> 
***************
*** 828,838 ****
            ) false reg_list 
          in 
          if matches then begin 
!           Printf.fprintf theout.chan "@%-5d =" (i + !traify_num);
            let display ts = begin
!             Printf.fprintf theout.chan " %s" (Tlk.weidu_quotify ts.Tlk.text) ;
              if ts.Tlk.sound_name <> "" then 
!              Printf.fprintf theout.chan " [%s]" ts.Tlk.sound_name ;
            end  in
            display tlk.(i) ;
            (match ftlk with 
--- 1005,1015 ----
            ) false reg_list 
          in 
          if matches then begin 
!           print_theout "@%-5d =" (i + !traify_num);
            let display ts = begin
!             print_theout " %s" (Tlk.weidu_quotify ts.Tlk.text) ;
              if ts.Tlk.sound_name <> "" then 
!              print_theout " [%s]" ts.Tlk.sound_name ;
            end  in
            display tlk.(i) ;
            (match ftlk with 
***************
*** 841,852 ****
              if a.(i).Tlk.text <> tlk.(i).Tlk.text ||
                 a.(i).Tlk.sound_name <> tlk.(i).Tlk.sound_name then 
                  display a.(i) )  ;
!           Printf.fprintf theout.chan "\n" ; 
          end 
        done 
    end) ;
  
!   (if !extract_kits > 0 then Kit.extract game theout.chan theout.dir
    !extract_kits) ;
  
    (match !cmp_src,!cmp_dest with
--- 1018,1029 ----
              if a.(i).Tlk.text <> tlk.(i).Tlk.text ||
                 a.(i).Tlk.sound_name <> tlk.(i).Tlk.sound_name then 
                  display a.(i) )  ;
!           print_theout "\n" ; 
          end 
        done 
    end) ;
  
!   (if !extract_kits > 0 then Kit.extract game (output_string (Lazy.force theout.chan)) theout.dir
    !extract_kits) ;
  
    (match !cmp_src,!cmp_dest with
***************
*** 855,871 ****
        let b2 = load_file d in
        let l1 = String.length b1 in
        let l2 = String.length b2 in 
        if (l1 <> l2) then begin 
!         log_and_print "[%s] is %d bytes while [%s] is %d bytes\n"
            s l1 d l2 
        end else begin
!         Printf.fprintf theout.chan "\t// patches to turn [%s] into [%s]\n" s d ;
!         for i = 0 to l1 - 1 do 
!           if b1.[i] <> b2.[i] then
!             Printf.fprintf theout.chan "\tWRITE_BYTE %d %d // 0x%x == '%c'\n" 
!               i (Char.code b2.[i]) (Char.code b2.[i]) b2.[i]
!         done 
        end
    | _, _ -> ()) ; 
  
  
--- 1032,1062 ----
        let b2 = load_file d in
        let l1 = String.length b1 in
        let l2 = String.length b2 in
+ 			print_theout "// patches to turn [%s] into [%s]\n" s d ;
        if (l1 <> l2) then begin
!         print_theout "\t//[%s] is %d bytes while [%s] is %d bytes\n"
            s l1 d l2
+       end;
+ 			let (b1,b2) = 
+ 				if (l1 < l2) then begin
+ 					print_theout "\tINSERT_BYTES 0x%x 0x%x\n" l1 (l2 - l1);
+ 					b1 ^ String.make (l2 - l1) '\000',b2
+ 				end else if (l1 > l2) then begin
+ 					print_theout "\tDELETE_BYTES 0x%x 0x%x\n" l1 (l1 - l2);
+ 					(String.sub b1 0 l2), b2
  				end else begin
! 					b1,b2
! 				end
! 			in
! 			for i = 0 to l2 - 1 do
! 				if b1.[i] <> b2.[i] then begin
! 					print_theout "\tWRITE_BYTE 0x%x %d // 0x%02x"
! 						i (Char.code b2.[i]) (Char.code b2.[i]);
! 					if Char.code b2.[i] > 0x20 && Char.code b2.[i] < 0x80 then
! 						print_theout " == %c" b2.[i];
! 					print_theout "\n";
  				end
+ 			done
    | _, _ -> ()) ;
  
  
***************
*** 883,889 ****
  
          let new_buffer = Buffer.create (1024 * 32) in 
          Dlg.dlg_compare new_buffer s_dlg d_dlg game.Load.dialog game.Load.dialogf reprint_d_action ;
!         Buffer.output_buffer theout.chan new_buffer 
  
    | _,_ -> ()) ; 
  
--- 1074,1080 ----
  
          let new_buffer = Buffer.create (1024 * 32) in 
          Dlg.dlg_compare new_buffer s_dlg d_dlg game.Load.dialog game.Load.dialogf reprint_d_action ;
!         output_buffer_theout new_buffer 
  
    | _,_ -> ()) ; 
  
***************
*** 896,904 ****
        let dest_buff, final_path = Load.load_resource "BCS patch command" game true b e in begin
          try begin
            let _ = Diff.create_patch src_buff dest_buff out_name 20 in
!           Printf.fprintf theout.chan "// TP2 patch to turn %s into %s.  For example using:\n" s d;
!           Printf.fprintf theout.chan "COPY_EXISTING ~%s~ ~override/%s~\n" s s;
!           Printf.fprintf theout.chan "\tAPPLY_BCS_PATCH ~%s~\n" out_name
          end
          with e -> 
            Printf.printf "Failed to create patch for [%s] to [%s] : %s\n" s d
--- 1087,1095 ----
        let dest_buff, final_path = Load.load_resource "BCS patch command" game true b e in begin
          try begin
            let _ = Diff.create_patch src_buff dest_buff out_name 20 in
!           print_theout "// TP2 patch to turn %s into %s.  For example using:\n" s d;
!           print_theout "COPY_EXISTING ~%s~ ~override/%s~\n" s s;
!           print_theout "\tAPPLY_BCS_PATCH ~%s~\n" out_name
          end
          with e -> 
            Printf.printf "Failed to create patch for [%s] to [%s] : %s\n" s d
***************
*** 927,933 ****
                  log_and_print "File %s unchanged by patch %s.\n" s d
                else
                  let out_name = s ^ ".new" in
!                 let out = open_out_bin out_name in begin
                    log_and_print "Saving new file to %s\n" out_name ;
                    output_string out new_buff ;
                    close_out out
--- 1118,1124 ----
                  log_and_print "File %s unchanged by patch %s.\n" s d
                else
                  let out_name = s ^ ".new" in
!                 let out = Case_ins.perv_open_out_bin out_name in begin
                    log_and_print "Saving new file to %s\n" out_name ;
                    output_string out new_buff ;
                    close_out out
***************
*** 956,977 ****
          Some(i) -> i
        | None -> (min (Array.length stlk) (Array.length dtlk)) - 1
        in 
!       Printf.fprintf theout.chan "// TP2 File\n" ;
        for i = my_min to my_max do 
          if (stlk.(i).Tlk.text <> dtlk.(i).Tlk.text) || 
             (stlk.(i).Tlk.sound_name <> dtlk.(i).Tlk.sound_name) then begin
            if !tlkcmp_strings then 
!             Printf.fprintf theout.chan "\tSTRING_SET %s @%d\n" 
                (Tlk.weidu_quotify stlk.(i).Tlk.text) (1000000 + i) 
            else 
!             Printf.fprintf theout.chan "\tSTRING_SET %d @%d\n" i (1000000 + i) 
          end 
        done ;
!       flush theout.chan ; 
!       Printf.fprintf theout.chan "\n// TRA File\n" ;
        for i = my_min to my_max do 
          if stlk.(i).Tlk.text <> dtlk.(i).Tlk.text then
!           Printf.fprintf theout.chan "@%d = ~%s~ [%s]\n"
              (1000000 + i) dtlk.(i).Tlk.text dtlk.(i).Tlk.sound_name 
        done
    | _,_ -> ()
--- 1147,1168 ----
          Some(i) -> i
        | None -> (min (Array.length stlk) (Array.length dtlk)) - 1
        in 
!       print_theout "// TP2 File\n" ;
        for i = my_min to my_max do
          if (stlk.(i).Tlk.text <> dtlk.(i).Tlk.text) || 
             (stlk.(i).Tlk.sound_name <> dtlk.(i).Tlk.sound_name) then begin
            if !tlkcmp_strings then 
!             print_theout "\tSTRING_SET %s @%d\n"
                (Tlk.weidu_quotify stlk.(i).Tlk.text) (1000000 + i) 
            else 
!             print_theout "\tSTRING_SET %d @%d\n" i (1000000 + i) 
          end
        done ;
!       flush_theout (); 
!       print_theout "\n// TRA File\n" ;
        for i = my_min to my_max do 
          if stlk.(i).Tlk.text <> dtlk.(i).Tlk.text then
!           print_theout "@%d = ~%s~ [%s]\n"
              (1000000 + i) dtlk.(i).Tlk.text dtlk.(i).Tlk.sound_name 
        done
    | _,_ -> ()
***************
*** 981,994 ****
      Some(s),Some(d) ->
        let tracompare s d = 
          try 
!         let schan = open_in s in
          let lexbuf = lex_init s schan in 
          let sresult = Stats.time "parsing .TRA files" (fun () -> Dparser.tra_file Dlexer.initial lexbuf) () in
          log_or_print "[%s] parsed (%d translation strings)\n" s (List.length sresult); 
          close_in schan ; 
          pop_context (); 
  
!         let dchan = open_in d in
          let lexbuf = lex_init d dchan in 
          let dresult = Stats.time "parsing .TRA files" (fun () -> Dparser.tra_file Dlexer.initial lexbuf) () in
          log_or_print "[%s] parsed (%d translation strings)\n" d (List.length dresult); 
--- 1172,1185 ----
      Some(s),Some(d) ->
        let tracompare s d = 
          try
!         let schan = Case_ins.perv_open_in s in
          let lexbuf = lex_init s schan in 
          let sresult = Stats.time "parsing .TRA files" (fun () -> Dparser.tra_file Dlexer.initial lexbuf) () in
          log_or_print "[%s] parsed (%d translation strings)\n" s (List.length sresult);
          close_in schan ; 
          pop_context (); 
  
!         let dchan = Case_ins.perv_open_in d in
          let lexbuf = lex_init d dchan in
          let dresult = Stats.time "parsing .TRA files" (fun () -> Dparser.tra_file Dlexer.initial lexbuf) () in
          log_or_print "[%s] parsed (%d translation strings)\n" d (List.length dresult); 
***************
*** 997,1035 ****
  
          (* int * dlg.string list *)
          let left_out = ref [] in 
!         List.iter (fun (si,_) ->
            let found = List.fold_left (fun acc (di,_) -> acc || si = di)
              false dresult in
            if not found then
!             left_out := si :: !left_out 
          ) sresult ; 
          let left_out = List.sort compare !left_out in 
          if left_out = [] then begin
!           Printf.fprintf theout.chan "\nAll Strings in [%s] are also in [%s]\n" s d ;
          end else begin 
!           Printf.fprintf theout.chan 
!             "\nStrings in [%s] that are not in [%s]:\n" s d ;
!           List.iter (fun i ->
!             Printf.fprintf theout.chan " %7d" i
            ) left_out ; 
!           Printf.fprintf theout.chan "\n\n"
          end 
          with e -> 
            begin 
!           Printf.fprintf theout.chan "\nThe ENTIRE FILE [%s] is missing:\n\t%s\n" 
              d (Printexc.to_string e) ; 
            Printf.printf "Skipping [%s] and [%s] : %s\n" s d
              (Printexc.to_string e)
            end 
        in 
!       if (Unix.stat s).Unix.st_kind <> Unix.S_REG then begin
!         let s_d_h = Unix.opendir s in
          try
            while true do 
              let s' = Unix.readdir s_d_h in
              let one = (s ^ "/" ^ s') in 
              let two = (d ^ "/" ^ s') in 
!             if (Unix.stat one).Unix.st_kind = Unix.S_REG then 
                tracompare one two 
            done 
          with e -> (Unix.closedir s_d_h ) 
--- 1188,1226 ----
  
          (* int * dlg.string list *)
          let left_out = ref [] in 
!         List.iter (fun (si,sv) ->
            let found = List.fold_left (fun acc (di,_) -> acc || si = di)
              false dresult in
            if not found then
!             left_out := (si, sv) :: !left_out 
          ) sresult ; 
          let left_out = List.sort compare !left_out in 
          if left_out = [] then begin
!           print_theout "\n// All Strings in [%s] are also in [%s]\n" s d ;
          end else begin 
!           print_theout
!             "\n// Strings in [%s] that are not in [%s]:\n" s d ;
!           List.iter (fun (i,v) ->
!             print_theout "@%-7d = ~%s~\n" i (Dc.single_string_of_tlk_string_safe game v)
            ) left_out ; 
!           print_theout "\n\n"
          end 
          with e -> 
            begin 
!           print_theout "\nThe ENTIRE FILE [%s] is missing:\n\t%s\n" 
              d (Printexc.to_string e) ; 
            Printf.printf "Skipping [%s] and [%s] : %s\n" s d
              (Printexc.to_string e)
            end 
        in
!       if (Case_ins.unix_stat s).Unix.st_kind <> Unix.S_REG then begin
!         let s_d_h = Case_ins.unix_opendir s in
          try
            while true do
              let s' = Unix.readdir s_d_h in
              let one = (s ^ "/" ^ s') in 
              let two = (d ^ "/" ^ s') in 
!             if (Case_ins.unix_stat one).Unix.st_kind = Unix.S_REG then
                tracompare one two 
            done 
          with e -> (Unix.closedir s_d_h ) 
***************
*** 1081,1108 ****
  
    (* List all BIFFs *)
    if (!list_biff) then begin
!     Key.list_biff game.Load.key theout.chan 
    end ;
  
    (* List all files *)
    if (!list_files) then begin
!     Key.list_key game.Load.key theout.chan 
    end ;
  
    (* List BIFF contents *)
    if (!bc_list <> []) then begin
!     Key.list_biff_contents game.Load.key theout.chan !bc_list
    end ; 
  
    (* Regex on BIFF contents *)
    if (!bs_type_list <> [] && !bs_str_list <> []) then begin
!     Load.search_biff_contents game theout.chan !bs_type_list !bs_str_list
    end else if (!bs_type_list <> [] && !biff_short_at <> 0) then begin
      let size = if !biff_short > 65535 then 4
                 else if !biff_short > 255 then 2
                 else 1
      in 
!     Load.search_biff_contents_fun game theout.chan !bs_type_list
        (fun buff -> 
          (String.length buff) >= (!biff_short_at + size) &&
          let i = (match size with 
--- 1272,1299 ----
  
    (* List all BIFFs *)
    if (!list_biff) then begin
!     Key.list_biff game.Load.key output_theout 
    end ;
  
    (* List all files *)
    if (!list_files) then begin
!     Key.list_key game.Load.key output_theout 
    end ;
  
    (* List BIFF contents *)
    if (!bc_list <> []) then begin
!     Key.list_biff_contents game.Load.key output_theout !bc_list
    end ; 
  
    (* Regex on BIFF contents *)
    if (!bs_type_list <> [] && !bs_str_list <> []) then begin
!     Load.search_biff_contents game output_theout !bs_type_list !bs_str_list
    end else if (!bs_type_list <> [] && !biff_short_at <> 0) then begin
      let size = if !biff_short > 65535 then 4
                 else if !biff_short > 255 then 2
                 else 1
      in 
!     Load.search_biff_contents_fun game output_theout !bs_type_list
        (fun buff ->
          (String.length buff) >= (!biff_short_at + size) &&
          let i = (match size with 
***************
*** 1149,1155 ****
            end 
          ) files_in_chitin ;
          if not !any_matches then
!           try_to_load str 
        with e ->
          log_and_print "\nERROR: %s\n" (Printexc.to_string e)  
      ) !bg_list 
--- 1340,1346 ----
            end 
          ) files_in_chitin ;
          if not !any_matches then
!           log_and_print "\nNo matches for: %s\n" str
        with e ->
          log_and_print "\nERROR: %s\n" (Printexc.to_string e)  
      ) !bg_list
***************
*** 1159,1177 ****
    | None -> () 
    | Some(s) -> begin
      let file_list = ref [] in 
!     let s_d_h = Unix.opendir s in
      (try
        while true do 
          let s' = Unix.readdir s_d_h in
!         file_list := (s ^ "/" ^ s') :: !file_list 
        done
      with _ -> () ) ;
      if !file_list <> [] then begin 
        let filename = "data/" ^ s ^ ".bif" in 
        let new_key = Biff.save_biff game.Load.key filename !file_list in
        let oc = open_for_writing "CHITIN.KEY" true in 
        Key.save_key new_key oc ;
!       close_out oc 
      end 
      end 
    ) ; 
--- 1350,1370 ----
    | None -> () 
    | Some(s) -> begin
      let file_list = ref [] in
!     let s_d_h = Case_ins.unix_opendir s in
      (try
        while true do 
          let s' = Unix.readdir s_d_h in
!         if ((Case_ins.unix_stat (s ^ "/" ^ s')).Unix.st_kind =
!            Unix.S_REG) then file_list := (s ^ "/" ^ s') :: !file_list 
        done
      with _ -> () ) ;
      if !file_list <> [] then begin
+       game.Load.key_mod <- true ;
        let filename = "data/" ^ s ^ ".bif" in
        let new_key = Biff.save_biff game.Load.key filename !file_list in
        let oc = open_for_writing "CHITIN.KEY" true in 
        Key.save_key new_key oc ;
!       close_out oc ;
      end 
      end 
    ) ; 
***************
*** 1179,1184 ****
--- 1372,1378 ----
    (match !remove_biff with
    | None -> ()
    | Some(f) -> 
+     game.Load.key_mod <- true ;
      let new_key = Key.remove_biff game.Load.key f in 
      let oc = open_for_writing "CHITIN.KEY" true in 
      Key.save_key new_key oc ;
***************
*** 1222,1228 ****
    List.iter (fun (dlg,out_name,transout_name,b,e,final_path) -> 
      try 
        let out_chan = 
!         if theout.append then theout.chan
          else open_for_writing out_name false 
        in
        let out_trans_chan = match !use_trans with
--- 1416,1422 ----
    List.iter (fun (dlg,out_name,transout_name,b,e,final_path) -> 
      try 
        let out_chan = 
!         if theout.append then Lazy.force theout.chan
          else open_for_writing out_name false 
        in
        let out_trans_chan = match !use_trans with
***************
*** 1255,1261 ****
    List.iter handle_tra_filename !trans_list ; 
  
    if !test_trans then begin
!     Dc.test_trans theout.chan game
    end ; 
  
    (match !trbify with
--- 1449,1455 ----
    List.iter handle_tra_filename !trans_list ;
  
    if !test_trans then begin
!     Dc.test_trans output_theout game
    end ;
  
    (match !trbify with
***************
*** 1264,1286 ****
          (Dparser.tra_file Dlexer.initial) in 
        log_or_print "[%s] has %d translation strings\n" filename 
          (List.length result); 
!       let name,ext = split filename in 
!       let out = open_out_bin (name ^ ".trb") in 
        Marshal.to_channel out result [] ; 
        close_out out 
      end 
    | _ -> ()
    ) ; 
  
  
    (match !traify with
      Some(file) -> begin
        try 
          let name,ext = split (String.uppercase file) in 
!         let inchan = open_in_bin file in 
          let lexbuf = lex_init file inchan in 
!         Dlg.local_string_ht := Some([]) ; 
  
          let old_ok = !Dc.ok_to_resolve_strings_while_loading in
          Dc.ok_to_resolve_strings_while_loading := None ; 
          Dc.doing_traify := true ; 
--- 1458,1603 ----
          (Dparser.tra_file Dlexer.initial) in
        log_or_print "[%s] has %d translation strings\n" filename
          (List.length result);
!       let base = handle_out_boringness filename ["tra"; "trb"] in
!       if !debug_ocaml then log_and_print "I'm trying to save to %s.trb\n\n" base ;
!       let out = Case_ins.perv_open_out_bin (base ^ ".trb") in
        Marshal.to_channel out result [] ;
        close_out out
      end
    | _ -> ()
    ) ;
  
+   ( match (!untraify_d,!untraify_tra) with
+     | (Some(d),Some(tra)) ->
+       let result = parse_file tra "parsing .tra files" (Dparser.tra_file Dlexer.initial) in
+         log_or_print "[%s] has %d translation strings\n" tra
+           (List.length result);
+       let base,ext = split d in
+       let base = handle_out_boringness base [ext] in
+       if !debug_ocaml then log_and_print "I'm trying to save to %s.%s\n\n" base ext ;
+       let filebuff = load_file d in
+       let filebuff = List.fold_left (fun acc (i,ls) ->
+         match ls with
+         | Dlg.Local_String(lse) ->
+             let buff =
+               (if lse.lse_male <> "" then begin
+                 "~" ^ lse.lse_male ^ "~" ^ (
+                 if lse.lse_male_sound <> "" then begin
+                    " [ " ^ lse.lse_male_sound ^ " ] ";
+                 end else "" )
+               end else "") ^
+               (if (lse.lse_female <> "") &&
+                  (lse.lse_female <> lse.lse_male) then begin
+                   " ~" ^ lse.lse_female ^ "~ " ^
+                 (if lse.lse_female_sound <> "" then begin
+                   " [ " ^ lse.lse_female_sound ^ " ] ";
+                 end else "")
+               end else "" )
+             in
+             Str.global_replace (Str.regexp (Printf.sprintf "@%d\\([^0-9]\\)" i)) (Printf.sprintf "%s\\1" buff) acc;
+         | _ -> failwith "traify1"
+       ) filebuff result
+       in
+     let out = open_out (base ^ "." ^ ext) in
+     output_string out filebuff;
+     close_out out;
+   | _ -> ()
+   ) ;
  
    (match !traify with
      Some(file) -> begin
        try
          let name,ext = split (String.uppercase file) in
! 
!         let buf = ref (load_file file) in
! 
!         let base = handle_out_boringness file [ "d"; "tra"; "tp2"; "baf"] in
!         if !debug_ocaml then log_and_print "I'm trying to save to %s.%s and %s.tra\n\n" base (String.lowercase ext) base ;
!         let transout_name = base ^ ".tra" in
!         let dout_name = base ^ "." ^ ext in 
! 
!         let dout = open_for_writing dout_name true in 
! 
!         let traout = open_for_writing transout_name true in 
! 
!         let counter = traify_num in
! 
!         (* replace the given string with the tra-value of the counter *) 
!         let replace str comment =
!           let my_regexp = Str.regexp (Str.quote str) in
!           let replace_with = (Printf.sprintf "@%d" !counter) ^ comment in
!           buf := Str.global_replace my_regexp replace_with !buf ;
!         in
!         let remove str =
!           let my_regexp = Str.regexp (Str.quote str) in
!           buf := Str.global_replace my_regexp "" !buf ;
!         in
!         let fix_suckage comment =
!           let my_regexp = Str.regexp (Str.quote (
!                   Printf.sprintf " /* @%d%s */" !counter comment)) in
!           let replace_with = Printf.sprintf "%s" comment in
!           buf := Str.global_replace my_regexp replace_with !buf ;
!         in
!         let add_refer comment =
!         	let my_regexp = Str.regexp (Printf.sprintf "@%d\\([^0-9]\\)" !counter) in
!         	let replace_with = Printf.sprintf "@%d%s\\1" !counter comment in
!         	buf := Str.global_replace my_regexp replace_with !buf;
!         	let my_regexp = Str.regexp (Str.quote (comment ^ comment)) in
!         	let replace_with = comment in
!         	buf := Str.global_replace my_regexp replace_with !buf;
!         in
! 
!         begin match !traify_old_tra with
!           | None -> ()
!           | Some(x) ->
!             let max = ref !counter in
!             let inchan = Case_ins.perv_open_in_bin x in
              let lexbuf = lex_init file inchan in
!             let tra_file = Stats.time "parsing.TRA files" (fun () -> Dparser.tra_file
!               Dlexer.initial lexbuf) () in
!             List.iter (fun (reference,ls) ->
!               counter := reference;
!               if !max <= reference then max := reference + 1;
! 							match ls with
! 							| Dlg.Local_String(lse) -> 
! 									if lse.lse_male <> "" (* ||
! 											lse.lse_male_sound <> "" *) then begin
! 										let comment_string = (if !traify_comment then
! 											(Printf.sprintf " /* ~" ^ lse.lse_male ^ "~ */") else "")
! 										in
! 										Printf.fprintf traout "@%-4d = ~%s~" !counter lse.lse_male ;
! 										replace ("~" ^ lse.lse_male ^ "~" ) comment_string;
! 										replace ("%" ^ lse.lse_male ^ "%" ) comment_string;
! 										replace ("\"" ^ lse.lse_male ^ "\"" ) comment_string;
! 										fix_suckage comment_string;
! 										if !traify_comment then add_refer comment_string;
! 										if lse.lse_male_sound <> "" then begin
! 											Printf.fprintf traout " [%s]" lse.lse_male_sound ;
! 											remove ("[" ^ lse.lse_male_sound ^ "]")
! 										end ;
! 									end ;
! 									if (lse.lse_female <> "" (* || lse.lse_male_sound <> ""*)) && 
! 											(lse.lse_female <> lse.lse_male (* || 
! 											lse.lse_female_sound <> lse.lse_male_sound *)) then begin
! 										Printf.fprintf traout " ~%s~" lse.lse_female ; 
! 										remove ("~" ^ lse.lse_female ^ "~" ); 
! 										remove ("%" ^ lse.lse_female ^ "%" ); 
! 										remove ("\"" ^ lse.lse_female ^ "\"" ); 
! 										if lse.lse_female_sound <> "" then begin
! 											Printf.fprintf traout " [%s]" lse.lse_female_sound ; 
! 											remove ("[" ^ lse.lse_female_sound ^ "]")
! 										end 
! 									end ; 
! 									Printf.fprintf traout "\n" ; 
! 									() 
! 							| _ -> failwith "traify1" 
!             ) tra_file;
!             counter := !max;
!             close_in inchan
!         end ;
  
+         let lexbuf = lex_init_from_string file !buf in
+         Dlg.local_string_ht := Some([]) ;
          let old_ok = !Dc.ok_to_resolve_strings_while_loading in
          Dc.ok_to_resolve_strings_while_loading := None ;
          Dc.doing_traify := true ;
***************
*** 1291,1297 ****
                    (fun () -> Dparser.d_file Dlexer.initial lexbuf) ()  )
            | "TP2" -> ignore
                     (Stats.time "parsing .TP2 files"
!                   (fun () -> Dparser.tp_file Dlexer.initial lexbuf) () ) 
            | "BAF" -> 
              (if (!Dlg.local_string_ht = None) then
                Dlg.local_string_ht := Some([]) ) ;
--- 1608,1614 ----
                    (fun () -> Dparser.d_file Dlexer.initial lexbuf) ()  )
            | "TP2" -> ignore
                     (Stats.time "parsing .TP2 files"
!                   (fun () -> Tparser.tp_file Tlexer.initial lexbuf) () )
            | "BAF" ->
              (if (!Dlg.local_string_ht = None) then
                Dlg.local_string_ht := Some([]) ) ;
***************
*** 1301,1340 ****
          end ;
          log_or_print "[%s] parsed for --traify\n" file ; 
          pop_context (); 
-         close_in inchan ; 
  
          Dc.ok_to_resolve_strings_while_loading := old_ok ; 
          Dc.doing_traify := false; 
  
-         let buf = ref (load_file file) in 
- 
-         let base = 
-           theout.dir ^ "/" ^ 
-           (if theout.file = "" then 
-             try (Filename.chop_extension file) with _ -> theout.file else
-             theout.file)
-         in 
- 
-         let transout_name = base ^ ".tra" in 
-         let dout_name = base ^ "." ^ ext in 
- 
-         let dout = open_for_writing dout_name true in 
- 
-         let traout = open_for_writing transout_name true in 
- 
-         let counter = traify_num in 
- 
-         (* replace the given string with the tra-value of the counter *) 
-         let replace str = 
-           let my_regexp = Str.regexp (Str.quote str) in
-           let replace_with = Printf.sprintf "@%d" !counter in 
-           buf := Str.global_replace my_regexp replace_with !buf ;
-         in 
-         let remove str = 
-           let my_regexp = Str.regexp (Str.quote str) in
-           buf := Str.global_replace my_regexp "" !buf ;
-         in 
- 
          (match !Dlg.local_string_ht with 
            Some(lst) -> 
          List.iter (fun  ls  -> 
--- 1618,1627 ----
***************
*** 1342,1351 ****
            | Dlg.Local_String(lse) -> 
                if lse.lse_male <> "" (* || 
                   lse.lse_male_sound <> "" *) then begin 
                  Printf.fprintf traout "@%-4d = ~%s~" !counter lse.lse_male ;
!                 replace ("~" ^ lse.lse_male ^ "~" ); 
!                 replace ("%" ^ lse.lse_male ^ "%" ); 
!                 replace ("\"" ^ lse.lse_male ^ "\"" ); 
                  if lse.lse_male_sound <> "" then begin
                    Printf.fprintf traout " [%s]" lse.lse_male_sound ; 
                    remove ("[" ^ lse.lse_male_sound ^ "]")
--- 1629,1641 ----
            | Dlg.Local_String(lse) -> 
                if lse.lse_male <> "" (* ||
                   lse.lse_male_sound <> "" *) then begin
+                 let comment_string = (if !traify_comment then
+                   (Printf.sprintf " /* ~" ^ lse.lse_male ^ "~ */") else "")
+                 in
                  Printf.fprintf traout "@%-4d = ~%s~" !counter lse.lse_male ;
!                 replace ("~" ^ lse.lse_male ^ "~" ) comment_string;
!                 replace ("%" ^ lse.lse_male ^ "%" ) comment_string;
!                 replace ("\"" ^ lse.lse_male ^ "\"" ) comment_string;
                  if lse.lse_male_sound <> "" then begin
                    Printf.fprintf traout " [%s]" lse.lse_male_sound ;
                    remove ("[" ^ lse.lse_male_sound ^ "]")
***************
*** 1393,1399 ****
      try 
        let script = handle_baf_filename str in
        let name,ext = split (Filename.basename str) in 
!       let out = open_out_bin (theout.dir ^ "/" ^ name ^ ".bcs") in
        Bcs.save_bcs game (Bcs.Save_BCS_OC(out)) script ;
        close_out out 
      with e -> log_and_print "ERROR: problem loading [%s]: %s\n" str
--- 1683,1689 ----
      try 
        let script = handle_baf_filename str in
        let name,ext = split (Filename.basename str) in
!       let out = Case_ins.perv_open_out_bin (theout.dir ^ "/" ^ name ^ ".bcs") in
        Bcs.save_bcs game (Bcs.Save_BCS_OC(out)) script ;
        close_out out 
      with e -> log_and_print "ERROR: problem loading [%s]: %s\n" str
***************
*** 1413,1419 ****
      Some(path) when file_exists path -> begin
          try Unix.access path [Unix.W_OK] ;
              log_or_print "[%s] claims to be writeable.\n" path ; 
!             if (Unix.stat path).Unix.st_kind <> Unix.S_REG then
                failwith (path ^ " is a not a regular file") ;
              log_or_print "[%s] claims to be a regular file.\n" path ; 
              ()
--- 1703,1709 ----
      Some(path) when file_exists path -> begin
          try Unix.access path [Unix.W_OK] ;
              log_or_print "[%s] claims to be writeable.\n" path ; 
!             if (Case_ins.unix_stat path).Unix.st_kind <> Unix.S_REG then
                failwith (path ^ " is a not a regular file") ;
              log_or_print "[%s] claims to be a regular file.\n" path ; 
              ()
***************
*** 1435,1440 ****
--- 1725,1734 ----
      if !Tp.always_uninstall then pause_at_end := false ;
      if !Tp.always_yes then pause_at_end := false ;
      if !Tp.sometimes_reinstall then pause_at_end := false ;
+     Tp.force_install_these   := !force_install_these_main   ;
+     Tp.force_uninstall_these := !force_uninstall_these_main ;
+     if !Tp.force_install_these <> [] then pause_at_end := false ;
+     if !Tp.force_uninstall_these <> [] then pause_at_end := false ;
      load_log () ;
      let q = Queue.create () in
      List.iter (fun tp_file -> Queue.add tp_file q) !tp_list ;
***************
*** 1443,1459 ****
--- 1737,1834 ----
        try
        if file_exists tp_file then begin
          let result = handle_tp2_filename tp_file in
+         let old_debug_modder = !debug_modder in
+         debug_modder := false;
          Tp.handle_tp game handle_tp2_filename handle_tra_filename
            (handle_d_filename)
+           (handle_tph_filename)
+           (handle_tpp_filename)
            (compile_baf_filename game)
            (handle_script_buffer)
            (handle_dlg_buffer)
            (handle_d_buffer)
+           (get_tra_list_filename)
            (fun filename ->
              log_only "Enqueuing [%s] for TP2 processing.\n" filename ;
              Queue.add filename q)
            emit_dlg_files
+           tp_file result;
+         debug_modder := old_debug_modder;
+       end
+       with e ->
+         log_and_print "ERROR: problem parsing TP file [%s]: %s\n" tp_file
+           (Printexc.to_string e) ;
+         raise e
+       done
+   end ;
+ 
+   if !process_script <> "" then begin
+     pause_at_end := false ;
+     load_log () ;
+     let q = Queue.create () in
+     let buff = try load_file !process_script with _ -> "" in
+     let lines = Str.split many_newline_or_cr_regexp buff in
+     List.iter (fun x -> Queue.add x q) lines;
+     while not (Queue.is_empty q) do
+       let this = Queue.take q in
+       let parts = Array.of_list (Str.split many_whitespace_regexp this) in
+       let tp_file = parts.(0) in
+       let action = ref "" in
+       Tp.always_yes := false;
+       Tp.always_uninstall := false;
+       Tp.sometimes_reinstall := false;
+       Tp.forced_language := int_of_string parts.(1);
+       Tp.force_install_these := [];
+       Tp.force_uninstall_these := [];
+       Tp.specified_specific_components := true;
+       let toproc = ref [] in
+       Array.iteri (fun i s -> if i > 1 then begin
+         match String.uppercase s with
+           | "U"
+           | "I" -> action := String.uppercase s
+           | _ -> begin
+               let num = int_of_string s in
+               match !action with
+               | "U"
+               | "I" -> toproc := (num, !action) :: !toproc ;
+               | _ -> failwith "wrong installation script"
+             end
+       end) parts ;
+       List.iter (fun (a,b) -> log_and_print "%s %d\n" b a) !toproc;
+       try
+       if file_exists tp_file then begin
+         let result = handle_tp2_filename tp_file in
+         List.iter (fun (a,b) ->
+           begin
+             match b with
+             | "U" ->
+               Tp.force_install_these := [];
+               Tp.force_uninstall_these := [a];
+             | "I" ->
+               Tp.force_uninstall_these := [];
+               Tp.force_install_these := [a];
+             | _ -> ()
+           end ;
+           Tp.handle_tp game handle_tp2_filename handle_tra_filename
+             (handle_d_filename)
+             (handle_tph_filename)
+             (handle_tpp_filename)
+             (compile_baf_filename game)
+             (handle_script_buffer)
+             (handle_dlg_buffer)
+             (handle_d_buffer)
+             (get_tra_list_filename)
+             (fun filename ->
+               log_only "Enqueuing [%s] for TP2 processing.\n" filename ;
+               Queue.add (filename ^ " 0") q)
+             emit_dlg_files
              tp_file result
+           ) (List.rev !toproc);
+           List.iter (fun s ->
+             log_or_print "Executing: [%s]\n" s ;
+             ignore (Unix.system (Arch.slash_to_backslash s)))
+           !execute_at_exit;
+           execute_at_exit := [];
        end
        with e ->
          log_and_print "ERROR: problem parsing TP file [%s]: %s\n" tp_file
***************
*** 1465,1471 ****
    List.iter (fun str ->
      let name,ext = split (String.uppercase str) in 
      let buff,path = Load.load_resource "list effects command" game true name ext in
!     Printf.fprintf theout.chan "[%s] has effects:\n" str ;
      let eff_arr = match ext with
      | "EFF" -> Load.eff_of_eff buff
      | _ -> Load.eff_of_spl_itm buff 
--- 1840,1846 ----
    List.iter (fun str ->
      let name,ext = split (String.uppercase str) in 
      let buff,path = Load.load_resource "list effects command" game true name ext in
!     print_theout "[%s] has effects:\n" str ;
      let eff_arr = match ext with
      | "EFF" -> Load.eff_of_eff buff
      | _ -> Load.eff_of_spl_itm buff 
***************
*** 1474,1487 ****
        let op = eff.Load.opcode in 
        let eff_name = Eff_table.name_of_opcode op in
        if op = 139 then begin (* display string *)
!         Printf.fprintf theout.chan "\t%s %s #%d\n" eff_name 
            (Tlk.pretty_print game.Load.dialog eff.Load.arg1)
            eff.Load.arg1
        end else if op = 101 then begin
!         Printf.fprintf theout.chan "\t%s (%s)\n" eff_name 
            (Eff_table.name_of_opcode eff.Load.arg2)
        end else begin
!         Printf.fprintf theout.chan "\t%s\n" eff_name 
        end
      ) eff_arr
    ) !list_eff_list ;
--- 1849,1862 ----
        let op = eff.Load.opcode in 
        let eff_name = Eff_table.name_of_opcode op in
        if op = 139 then begin (* display string *)
!         print_theout "\t%s %s #%d\n" eff_name 
            (Tlk.pretty_print game.Load.dialog eff.Load.arg1)
            eff.Load.arg1
        end else if op = 101 then begin
!         print_theout "\t%s (%s)\n" eff_name 
            (Eff_table.name_of_opcode eff.Load.arg2)
        end else begin
!         print_theout "\t%s\n" eff_name 
        end
      ) eff_arr
    ) !list_eff_list ;
***************
*** 1497,1503 ****
        let script =  handle_script_buffer str buff in
        let base = Filename.basename b in 
        let out_name = theout.dir ^ "/" ^ base ^ ".baf" in 
!       let out = open_out out_name in 
        (try 
          Bcs.print_script_text game (Bcs.Save_BCS_OC(out)) 
            (Bcs.BCS_Print_Script(script)) (!Dlg.comments) None ;
--- 1872,1878 ----
        let script =  handle_script_buffer str buff in
        let base = Filename.basename b in 
        let out_name = theout.dir ^ "/" ^ base ^ ".baf" in 
!       let out = Case_ins.perv_open_out out_name in
        (try 
          Bcs.print_script_text game (Bcs.Save_BCS_OC(out))
            (Bcs.BCS_Print_Script(script)) (!Dlg.comments) None ;
***************
*** 1558,1571 ****
        Tlk.save_tlk path t outchan 
    | _, _, _ -> () ) ;
  
!   List.iter (fun str -> log_and_print "%s" str) !Tp.strings_to_print_at_exit ;
  
    ()
  ;;
  
  
  (try 
!   main () 
  with e -> 
    log_and_print "\nFATAL ERROR: %s\n" (Printexc.to_string e) ) 
  
--- 1933,1948 ----
        Tlk.save_tlk path t outchan
    | _, _, _ -> () ) ;
  
!   Hashtbl.iter (fun a x -> Unix.close x.Biff.fd) game.Load.loaded_biffs;
!   Queue.iter my_unlink Load.cbifs_to_rem;
  
+   List.iter (fun str -> log_and_print "%s" str) !Tp.strings_to_print_at_exit ;
    ()
  ;;
  
  
  (try
!   Stats.time "stuff not covered elsewhere" main ();
  with e ->
    log_and_print "\nFATAL ERROR: %s\n" (Printexc.to_string e) )
  
***************
*** 1577,1589 ****
  
  ;; 
  
- if !pause_at_end then begin
-   Printf.printf "\nPress ENTER to exit.\n" ;
-   try ignore (read_line () ) with _ -> () 
- end 
- 
- ;;
- 
  List.iter (fun s -> 
    log_or_print "Executing: [%s]\n" s ; 
    ignore (Unix.system (Arch.slash_to_backslash s))) 
--- 1954,1959 ----
***************
*** 1598,1605 ****
  ;;
  
  Util.log_channel := None 
- 
  ;;
  
  exit !return_value 
  ;;
--- 1968,1981 ----
  ;;
  
  Util.log_channel := None
  ;;
  
+ if !pause_at_end || (!return_value <> return_value_success && Var.get_string "%WEIDU_OS%" =
+     "x86_WIN32") then begin
+   Printf.printf "\nPress ENTER to exit.\n" ;
+   try ignore (read_line () ) with _ -> ()
+ end
+ 
+ ;;
  exit !return_value
  ;;
