(* Note added due to LGPL terms.

This file was edited by Valerio Bigiani, AKA The Bigg, starting from
6 November 2005. All changes for this file are listed in
diffs/src.arch_osx.ml.diff file, as the output of a diff -Bw -c -N command.

It was originally taken from Westley Weimer's WeiDU 185. *)

(* Mac OSX Arch-Specific Definitions *)

let registry_paths = ref [ "\\BGII - SoA\\" ] 

(* no slash removal: helps make shell scripts work better *)
let slash_to_backslash s = 
  s

let backslash_to_slash s =
  let s = Str.global_replace (Str.regexp "\\\\") "/" s in
  s


(* how to view a text file *)
(* let view_command = "open -a /Applications/TextEdit.app/"  *)
let view_command = "open"

let do_auto_update = false 

(* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
let handle_view_command s skip =
  let result = ref s in
  List.iter (fun view_regexp ->
    if Str.string_match view_regexp !result 0 then begin
      result := Str.replace_first view_regexp view_command !result ;
    end) [Str.regexp_case_fold "^VIEW" ; Str.regexp_case_fold "^NOTEPAD" ;
          Str.regexp_case_fold "^EXPLORER"];
  if skip && (s <> !result) then result := "";
  let s = !result in
  s
external glob : string -> (string -> unit) -> unit = "myglob"

let create_process_env = Unix.create_process_env

let biff_path_separator = ":"

(* On OSX, TOB baldur.ini has: 
[Alias]
CD5:=:CD5:
HD0:=:
CD1:=:CD1:
CD2:=:CD2:
CD3:=:CD3:
CD4:=:CD4:
*) 
let cd_regexp = Str.regexp "\\(CD[0-9]\\)"
(* doesn't work: 
let cd_regexp = Str.regexp "^[CH]D[0-9]+.*=\\([^\r\n]*\\)"  *)
