*** WeiDU-185/src/tp.ml	2005-07-04 23:07:06.000000000 +0200
--- WeiDU/src/tp.ml	2007-07-26 15:43:49.000000000 +0200
***************
*** 1,3 ****
--- 1,15 ----
+ (* TODO:
+  *)
+ 
+ 
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.tp.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (* Talk-Patcher / Installer *)
  open Util
  open Diff
***************
*** 5,22 ****
  let always_yes = ref false 
  let always_uninstall = ref false 
  let sometimes_reinstall = ref false 
- let continue_on_error = ref false 
  let ask_all = ref false
  
  let debug_pe = ref false 
  
  type tp_flag =
!   Auto_Tra of string
  | Menu_Style of string
  | Ask_Every_Component 
  | Always of tp_action list 
  | Allow_Missing of string list
  | Script_Style of Load.script_style 
  
  and tp_file = {
    mutable tp_filename  : string ;
--- 17,48 ----
  let always_yes = ref false
  let always_uninstall = ref false
  let sometimes_reinstall = ref false
  let ask_all = ref false
+ let forced_language = ref ( 0-1 )
+ let force_install_these = ref []
+ let force_uninstall_these = ref []
+ let specified_specific_components = ref false
+ let skip_at_view = ref false
+ let quick_log = ref false
+ let debug_boiic = ref false
+ let debug_change = ref false
  
+ let has_if_eval_bug = ref true
+ let continue_on_error = ref false
  let debug_pe = ref false
  
  type tp_flag =
! | Auto_Tra of string
! | TP_No_If_Eval of unit
  | Menu_Style of string
  | Ask_Every_Component
  | Always of tp_action list
+ | Define_Action_Macro of string * tp_local_declaration list * tp_action list
+ | Define_Patch_Macro of string * tp_local_declaration list * tp_patch list
  | Allow_Missing of string list
  | Script_Style of Load.script_style
+ | Load_Macro of string list
+ | Readme of string
  
  and tp_file = {
    mutable tp_filename  : string ;
***************
*** 40,53 ****
  } 
  
  and tp_mod_flag = 
!   TPM_Deprecated of Dlg.tlk_string (* should be uninstalled when encountered *) 
  | TPM_RequireComponent of string * int * Dlg.tlk_string  
  | TPM_ForbidComponent of string * int * Dlg.tlk_string  
  | TPM_RequirePredicate of tp_patchexp * Dlg.tlk_string
! | TPM_SubComponents of Dlg.tlk_string * tp_patchexp
  | TPM_Designated of int
  | TPM_NotInLog
  | TPM_InstallByDefault
  
  and tp_copy_args = {
    copy_get_existing   : bool ;  (* get from biffs? *)
--- 66,80 ----
  }
  
  and tp_mod_flag =
! | TPM_Deprecated of Dlg.tlk_string (* should be uninstalled when encountered *)
  | TPM_RequireComponent of string * int * Dlg.tlk_string
  | TPM_ForbidComponent of string * int * Dlg.tlk_string
  | TPM_RequirePredicate of tp_patchexp * Dlg.tlk_string
! | TPM_SubComponents of Dlg.tlk_string * tp_patchexp * bool (* is forced? *)
  | TPM_Designated of int
  | TPM_NotInLog
  | TPM_InstallByDefault
+ | TPM_Group of Dlg.tlk_string
  
  and tp_copy_args = {
    copy_get_existing    : bool ;  (* get from biffs? *)
***************
*** 60,65 ****
--- 87,99 ----
    copy_at_end          : bool ;
      (* write all of the output *after* doing all of the processing for
       * all souce files *)
+   copy_save_inlined    : bool ; (* the result is not saved to the HD, but stored in the inlined Hashtable *)
+ }
+ 
+ and tp_copy_large_args = {
+   copy_large_use_glob       : bool ;
+   copy_large_file_list      : ( string * string ) list ; (* (source,dest) list *)
+   copy_large_backup         : bool ; (* normally TRUE *)
  }
  
  and store_args = {
***************
*** 67,82 ****
  }
  
  and tp_action =
    | TP_Copy   of tp_copy_args 
    | TP_CopyRandom of (string list list) * (tp_patch list) * (tp_constraint list)
!   | TP_RandomSeed of int 
    | TP_Compile of bool * (string list) * (string list) (* eval, DLG, TRA *)
    | TP_Inlined_File of (string * string)
    | TP_Mkdir of string list 
    | TP_Require_File of string * (Dlg.tlk_string)
    | TP_Forbid_File of string * (Dlg.tlk_string)
!   | TP_Append of string * string * (tp_constraint list)
!   | TP_Append_Col of string * (string list) * (tp_constraint list)
    | TP_Set_Col of string * (string list) * int 
    | TP_Extend_Top of bool * string * string * (tp_patch list) * (string list)
    | TP_Extend_Bottom of bool * string * string * (tp_patch list) * (string list) 
--- 101,143 ----
  }
  
  and tp_action =
+   | TP_ActionBashFor of ((string * (bool option) * string) list) * (tp_action list)
+   | TP_ActionDefineArray of tp_pe_string * string list
+   | TP_ActionPHPEach of tp_pe_string * tp_pe_string * tp_pe_string * tp_action list
+   | TP_Action_For_Each of tp_pe_string * string list * tp_action list
+   | TP_Action_ReadLN of tp_pe_string
+   | TP_ClearMemory
+   | TP_Clear_Ids_Map
+   | TP_CopyAllGamFiles of tp_patch list * tp_constraint list
    | TP_Copy   of tp_copy_args
+   | TP_CopyLarge of tp_copy_large_args
    | TP_CopyRandom of (string list list) * (tp_patch list) * (tp_constraint list)
!   | TP_RandomSeed of tp_patchexp
    | TP_Compile of bool * (string list) * (string list) (* eval, DLG, TRA *)
+   | TP_Launch_Action_Macro of string
+   | TP_Reinclude of string list
+   | TP_Include of string list
+   | TP_Load_Tra of string list
    | TP_Inlined_File of (string * string)
+   | TP_Define_Action_Macro of string * tp_local_declaration list * tp_action list
+   | TP_Define_Patch_Macro of string * tp_local_declaration list * tp_patch list
+   | TP_Biff of string * ((string * (bool option) * string) list)
    | TP_Mkdir of string list
+   | TP_Outer_For of (tp_patch list) * tp_patchexp * (tp_patch list) * (tp_action list)
+   | TP_Outer_Inner_Buff of string * (tp_patch list)
+   | TP_Outer_Inner_Buff_Save of string * string * (tp_patch list)
+   | TP_Outer_Set of tp_pe_string * tp_patchexp
+   | TP_Outer_Sprint of tp_pe_string * tp_pe_tlk_string
+   | TP_Outer_Text_Sprint of tp_pe_string * tp_pe_string
+   | TP_Outer_While of tp_patchexp * (tp_action list)
    | TP_Require_File of string * (Dlg.tlk_string)
    | TP_Forbid_File of string * (Dlg.tlk_string)
!   | TP_Append of string * string * (tp_constraint list) * bool
!         (* When bool is true, load the file as bif or override; otherwise, it's loaded
!          * as a normal file.
!          *)
!   | TP_Append_Col of string * string * int * (tp_constraint list)
!         (* prepend to the string int blank entries (EG for ADD_KIT) *)
    | TP_Set_Col of string * (string list) * int
    | TP_Extend_Top of bool * string * string * (tp_patch list) * (string list)
    | TP_Extend_Bottom of bool * string * string * (tp_patch list) * (string list)
***************
*** 84,98 ****
    | TP_At_Interactive_Exit of string 
    | TP_At_Uninstall of string 
    | TP_At_Interactive_Uninstall of string 
    | TP_Add_Kit of tp_add_kit
    | TP_Add_Music of tp_add_music 
    | TP_Add_Projectile of tp_add_projectile 
    | TP_String_Set of ((string * Dlg.tlk_string) list) * (string option)
!   | TP_String_Set_Range of int * int * string
    | TP_Fail of Dlg.tlk_string 
    | TP_Print of Dlg.tlk_string 
    | TP_If of tp_patchexp * (tp_action list) * (tp_action list)  
!   | TP_Uninstall_Now of string * int 
  
  (*
  and predicate = 
--- 145,167 ----
    | TP_At_Interactive_Exit of string
    | TP_At_Uninstall of string
    | TP_At_Interactive_Uninstall of string
+   | TP_At_Now of string
+   | TP_At_Interactive_Now of string
    | TP_Add_Kit of tp_add_kit
+   | TP_CopyKit of string * string * (string* string) list
+       (* old kit, new kit, changes *)
    | TP_Add_Music of tp_add_music
    | TP_Add_Projectile of tp_add_projectile
+   | TP_Add_Spell of string * tp_patchexp * tp_patchexp * string * (tp_patch list) * (tp_constraint list)
+   | TP_Silent
+   | TP_Verbose
    | TP_String_Set of ((string * Dlg.tlk_string) list) * (string option)
!   | TP_String_Set_Evaluate of ((tp_patchexp * Dlg.tlk_string) list) * (string option)
!   | TP_String_Set_Range of tp_patchexp * tp_patchexp * string
    | TP_Fail of Dlg.tlk_string
    | TP_Print of Dlg.tlk_string
    | TP_If of tp_patchexp * (tp_action list) * (tp_action list)
!   | TP_Uninstall_Now of string * tp_patchexp
  
  (*
  and predicate =
***************
*** 124,140 ****
  } 
  
  and tp_add_map_note = {
!   xcoord : int ;
!   ycoord : int ;
    mstring : Dlg.tlk_string ;
    colour : string ;
  }
  
  and tp_add_cre_item = {
    item_name : string ;
!   i_charge1 : int ;
!   i_charge2 : int ;
!   i_charge3 : int ;
    i_flags : string ;
    item_slot : string ;
    equip : bool ; (* Normally FALSE *)
--- 193,209 ----
  } 
  
  and tp_add_map_note = {
!   xcoord : tp_patchexp ;
!   ycoord : tp_patchexp ;
    mstring : Dlg.tlk_string ;
    colour : string ;
  }
  
  and tp_add_cre_item = {
    item_name : string ;
!   i_charge1 : tp_patchexp ;
!   i_charge2 : tp_patchexp ;
!   i_charge3 : tp_patchexp ;
    i_flags : string ;
    item_slot : string ;
    equip : bool ; (* Normally FALSE *)
***************
*** 150,168 ****
    pro_file : string ;
  }
  
  and tp_patch = 
    | TP_PatchStrRef of tp_patchexp * Dlg.tlk_string (* offset + text *)
    | TP_PatchStrRefEvaluated of tp_patchexp * string 
!   | TP_PatchString of string * Dlg.tlk_string (* regexp + text *) 
!   | TP_PatchStringTextually of string * string (* regexp + text *) 
!   | TP_PatchStringEvaluate of string * (tp_patch list) * string (* see below *)
    | TP_PatchReplaceBCSBlock of string * string (* old + new *) 
    | TP_PatchReplaceBCSBlockRE of string * string (* old + new *) 
    | TP_PatchApplyBCSPatch of string (* patch *) * (string option) (* copyover *)
    | TP_PatchByte of tp_patchexp * tp_patchexp
    | TP_PatchShort of tp_patchexp * tp_patchexp
    | TP_PatchLong of tp_patchexp * tp_patchexp
!   | TP_PatchReadAscii of tp_patchexp * string * (string option) * (tp_patchexp option)
    | TP_PatchReadStrRef of tp_patchexp * string * (string option) 
    | TP_PatchReadByte of tp_patchexp * string * (tp_patchexp option)
    | TP_PatchReadSByte of tp_patchexp * string * (tp_patchexp option)
--- 219,248 ----
    pro_file : string ;
  }
  
+ and tp_local_declaration =
+   | TP_LocalSet of tp_pe_string * tp_patchexp
+   | TP_LocalSprint of tp_pe_string * tp_pe_tlk_string
+   | TP_LocalTextSprint of tp_pe_string * tp_pe_string
+ 
  and tp_patch =
+   | TP_PatchBashFor of ((string * (bool option) * string) list) * (tp_patch list)
+   | TP_PatchClearArray of tp_pe_string
+   | TP_PatchDefineArray of tp_pe_string * string list
+   | TP_PatchPHPEach of tp_pe_string * tp_pe_string * tp_pe_string * tp_patch list
+   | TP_PatchForEach of tp_pe_string * string list * tp_patch list
    | TP_PatchStrRef of tp_patchexp * Dlg.tlk_string (* offset + text *)
    | TP_PatchStrRefEvaluated of tp_patchexp * string
!   | TP_PatchString of (bool option) * (bool option) * string * Dlg.tlk_string (* regexp + text *)
!   | TP_PatchStringTextually of (bool option) * (bool option) * string * string * (tp_patchexp option) (* regexp + text *)
!   | TP_PatchStringEvaluate of (bool option) * string * (tp_patch list) * string (* see below *)
    | TP_PatchReplaceBCSBlock of string * string (* old + new *)
    | TP_PatchReplaceBCSBlockRE of string * string (* old + new *)
    | TP_PatchApplyBCSPatch of string (* patch *) * (string option) (* copyover *)
    | TP_PatchByte of tp_patchexp * tp_patchexp
    | TP_PatchShort of tp_patchexp * tp_patchexp
    | TP_PatchLong of tp_patchexp * tp_patchexp
!   | TP_PatchGetStrRef of tp_patchexp * string
!   | TP_PatchReadAscii of tp_patchexp * string * (string option) * tp_patchexp * bool
    | TP_PatchReadStrRef of tp_patchexp * string * (string option)
    | TP_PatchReadByte of tp_patchexp * string * (tp_patchexp option)
    | TP_PatchReadSByte of tp_patchexp * string * (tp_patchexp option)
***************
*** 170,187 ****
    | TP_PatchReadShort of tp_patchexp * string * (tp_patchexp option)
    | TP_PatchReadLong of tp_patchexp * string * (tp_patchexp option)
    | TP_PatchReadSLong of tp_patchexp * string * (tp_patchexp option)
!   | TP_Add_Known_Spell of string * int * string 
    | TP_Read2DA of tp_patchexp * tp_patchexp * tp_patchexp * string 
    | TP_Get2DARows of tp_patchexp * string 
    | TP_DescribeItem of string 
    | TP_PatchPrint of Dlg.tlk_string 
    | TP_PatchSprint of tp_pe_string * tp_pe_tlk_string
    | TP_PatchSnprint of tp_patchexp * tp_pe_string * tp_pe_tlk_string
    | TP_PatchASCII of 
        tp_patchexp (* where? *)
      * string (* what? *)
      * bool (* evaluate? *) 
!     * (int option) (* minimum size? *) 
    | TP_PatchInsertBytes of tp_patchexp * tp_patchexp 
    | TP_PatchDeleteBytes of tp_patchexp * tp_patchexp 
    | TP_PatchSet of tp_pe_string * tp_patchexp 
--- 250,286 ----
    | TP_PatchReadShort of tp_patchexp * string * (tp_patchexp option)
    | TP_PatchReadLong of tp_patchexp * string * (tp_patchexp option)
    | TP_PatchReadSLong of tp_patchexp * string * (tp_patchexp option)
!   | TP_PatchReadLN of tp_pe_string
!   | TP_PatchGetOffsetArray of tp_pe_string * (tp_patchexp * tp_patchexp * tp_patchexp *
!                           tp_patchexp * tp_patchexp * tp_patchexp * tp_patchexp)
!   | TP_PatchGetOffsetArray2 of tp_pe_string * (tp_patchexp * tp_patchexp * tp_patchexp
!           * tp_patchexp * tp_patchexp * tp_patchexp * tp_patchexp * tp_patchexp)
!   | TP_Launch_Patch_Macro of string
!   | TP_Add_Known_Spell of string * tp_patchexp * string
!   | TP_Add_Memorized_Spell of string * tp_patchexp * string * tp_patchexp
    | TP_Read2DA of tp_patchexp * tp_patchexp * tp_patchexp * string
+   | TP_Read2DANow of string * tp_patchexp
+   | TP_Read2DAFormer of string * tp_patchexp * tp_patchexp * string
    | TP_Get2DARows of tp_patchexp * string
+   | TP_Get2DACols of string
+   | TP_CountRegexpInstances of (bool option) * (bool option) * string * string
    | TP_DescribeItem of string
    | TP_PatchPrint of Dlg.tlk_string
    | TP_PatchSprint of tp_pe_string * tp_pe_tlk_string
+   | TP_PatchTextSprint of tp_pe_string * tp_pe_string
+   | TP_PatchSpaces of tp_pe_string * tp_pe_string
+   | TP_PatchQuote of tp_pe_string * tp_pe_string
+   | TP_PatchToLower of tp_pe_string
+   | TP_PatchToUpper of tp_pe_string
    | TP_PatchSnprint of tp_patchexp * tp_pe_string * tp_pe_tlk_string
    | TP_PatchASCII of
        tp_patchexp (* where? *)
      * string (* what? *)
      * bool (* evaluate? *)
!     * (tp_patchexp option) (* minimum size? *)
!   | TP_PatchASCIITerminated of
!       tp_patchexp (* where? *)
!     * string (* what? *)
    | TP_PatchInsertBytes of tp_patchexp * tp_patchexp
    | TP_PatchDeleteBytes of tp_patchexp * tp_patchexp
    | TP_PatchSet of tp_pe_string * tp_patchexp
***************
*** 190,211 ****
    | TP_PatchFor of 
      (tp_patch list) * tp_patchexp * (tp_patch list) * (tp_patch list)
    | TP_PatchIf of tp_patchexp * (tp_patch list) * (tp_patch list)
    | TP_PatchRandomSeed of tp_patchexp 
    | TP_PatchInnerAction of tp_action list 
    | TP_PatchInnerBuff of string * (tp_patch list)
    | TP_PatchInnerBuffFile of string * (tp_patch list)
    | TP_Patch2DA of tp_patchexp * tp_patchexp * tp_patchexp * tp_patchexp
- 
    | TP_Patch2DALater of string * tp_patchexp * tp_patchexp * tp_patchexp 
    | TP_Patch2DANow of string * tp_patchexp 
  
    | TP_Add_Map_Note of tp_add_map_note
!   | TP_Patch_Gam of string * string * int * int
    | TP_Add_Cre_Item of tp_add_cre_item
!   | TP_Add_S_Item of store_args * string * int * int * int * string * int * (string option)
    | TP_Remove_Known_Spell of string list
    | TP_PatchWriteFile of tp_patchexp * string * bool (* where, what, insert? *)
!   | TP_PatchAppendFile of string 
    | TP_CompileBAFtoBCS
    | TP_CompileBCStoBAF
    | TP_CompileDtoDLG
--- 289,321 ----
    | TP_PatchFor of
      (tp_patch list) * tp_patchexp * (tp_patch list) * (tp_patch list)
    | TP_PatchIf of tp_patchexp * (tp_patch list) * (tp_patch list)
+   | TP_PatchReinclude of string list
+   | TP_PatchInclude of string list
    | TP_PatchRandomSeed of tp_patchexp
    | TP_PatchInnerAction of tp_action list
    | TP_PatchInnerBuff of string * (tp_patch list)
    | TP_PatchInnerBuffFile of string * (tp_patch list)
+   | TP_PatchInnerBuffSave of string * string * (tp_patch list)
+   | TP_PatchInsert2DARow of tp_patchexp * tp_patchexp * tp_patchexp
    | TP_Patch2DA of tp_patchexp * tp_patchexp * tp_patchexp * tp_patchexp
    | TP_Patch2DALater of string * tp_patchexp * tp_patchexp * tp_patchexp
    | TP_Patch2DANow of string * tp_patchexp
+   | TP_PrettyPrint2DA of tp_patchexp
+   | TP_PatchSilent
+   | TP_PatchVerbose
+ 
  
    | TP_Add_Map_Note of tp_add_map_note
!   | TP_Patch_Gam of string * string * tp_patchexp * tp_patchexp
    | TP_Add_Cre_Item of tp_add_cre_item
!   | TP_Replace_Cre_Item of tp_add_cre_item
!   | TP_Add_S_Item of store_args * string * ((string * int) list) * tp_patchexp * tp_patchexp * tp_patchexp * string * tp_patchexp * (string option)
!   | TP_Remove_Cre_Item of string list
    | TP_Remove_Known_Spell of string list
+   | TP_Remove_Memorized_Spell of string list
+   | TP_Remove_Store_Item of string list
    | TP_PatchWriteFile of tp_patchexp * string * bool (* where, what, insert? *)
!   | TP_PatchAppendFile of string * bool (* evaluate the file to be appended? *)
    | TP_CompileBAFtoBCS
    | TP_CompileBCStoBAF
    | TP_CompileDtoDLG
***************
*** 223,228 ****
--- 333,341 ----
  and tp_pe_string =
    | PE_LiteralString of string
    | PE_Evaluate of tp_pe_string
+   | PE_Lowercase of tp_pe_string
+   | PE_Uppercase of tp_pe_string
+   | PE_Dollars of tp_pe_string * (tp_pe_string list) * bool
  
  and tp_pe_tlk_string =
    | PE_Tlk of Dlg.tlk_string
***************
*** 231,237 ****
  and tp_patchexp =
    | Pred_True 
    | PE_String of tp_pe_string
!   | PE_StringEqual of tp_pe_string * tp_pe_string * bool (* ignore-case? *)
    | PE_StringRegexp of tp_pe_string * tp_pe_string * bool (* match exactly?  *)
    | PE_Not of tp_patchexp
    | PE_Add of tp_patchexp * tp_patchexp 
--- 344,350 ----
  and tp_patchexp =
    | Pred_True
    | PE_String of tp_pe_string
!   | PE_StringEqual of tp_pe_string * tp_pe_string * bool * bool (* ignore-case? * returns bool vs. 1,-1,0 *)
    | PE_StringRegexp of tp_pe_string * tp_pe_string * bool (* match exactly?  *)
    | PE_Not of tp_patchexp
    | PE_Add of tp_patchexp * tp_patchexp
***************
*** 259,267 ****
--- 372,387 ----
    | PE_FileContainsEvaluated of tp_pe_string * tp_pe_string
  
    | PE_If of tp_patchexp * tp_patchexp * tp_patchexp
+   | PE_ModIsInstalled of string * int
+   | PE_GameIs of string
+   | PE_VariableIsSet of tp_pe_string
+   | PE_IdsOfSymbol of string * string
+   | PE_StateWhichSays of (Dlg.tlk_string option) * ((tp_patchexp * string) option) * string
+   | PE_IsAnInt of tp_pe_string
  
    | Pred_File_MD5 of tp_pe_string * tp_pe_string
    | Pred_File_Exists of tp_pe_string
+   | Pred_File_Is_In_Compressed_Bif of tp_pe_string
    | Pred_File_Exists_In_Game of tp_pe_string
    | Pred_File_Size of tp_pe_string * int
    | Pred_File_Contains of tp_pe_string * tp_pe_string
***************
*** 281,289 ****
    | Pred_File_Size(s,i) -> Printf.sprintf "FILE_SIZE %s %d" (pe_str_str s) i
    | Pred_File_Contains(s,i) -> Printf.sprintf "FILE_CONTAINS %s %s" 
      (pe_str_str s) (pe_str_str i)
    | PE_String(s) -> (pe_str_str s)
!   | PE_StringEqual(s1,s2,b) -> Printf.sprintf "%s %s %s" 
!       (pe_str_str s1) (if b then "STRING_COMPARE_CASE" else "STRING_COMPARE") 
        (pe_str_str s2)
    | PE_StringRegexp(s1,s2,b) -> Printf.sprintf "%s %s %s" 
        (pe_str_str s1) (if b then "STRING_MATCHES_REGEXP" 
--- 401,410 ----
    | Pred_File_Size(s,i) -> Printf.sprintf "FILE_SIZE %s %d" (pe_str_str s) i
    | Pred_File_Contains(s,i) -> Printf.sprintf "FILE_CONTAINS %s %s"
      (pe_str_str s) (pe_str_str i)
+   | Pred_File_Is_In_Compressed_Bif(a) -> Printf.sprintf "FILE_IS_IN_COMPRESSED_BIF %s" (pe_str_str a)
    | PE_String(s) -> (pe_str_str s)
!   | PE_StringEqual(s1,s2,b,c) -> Printf.sprintf "%s %s%s %s"
!       (pe_str_str s1) (if c then "STRING_EQUAL" else "STRING_COMPARE") (if b then "_CASE" else "")
        (pe_str_str s2)
    | PE_StringRegexp(s1,s2,b) -> Printf.sprintf "%s %s %s"
        (pe_str_str s1) (if b then "STRING_MATCHES_REGEXP"
***************
*** 311,316 ****
--- 432,439 ----
    | PE_BLSR(e1,e2) -> Printf.sprintf "(%s) BLSR (%s)" (pe_to_str e1) (pe_to_str e2)
    | PE_BASR(e1,e2) -> Printf.sprintf "(%s) BASR (%s)" (pe_to_str e1) (pe_to_str e2)
    | PE_BNOT(e1) -> Printf.sprintf "BNOT (%s)" (pe_to_str e1)
+   | PE_GameIs(e1) -> Printf.sprintf "GAME_IS ~%s~" e1
+   | PE_ModIsInstalled(e1,e2) -> Printf.sprintf "MOD_IS_INSTALLED ~%s~ #%d" e1 e2
    | Pred_True -> Printf.sprintf "1"
  
    | PE_Random(e1,e2) -> Printf.sprintf "RANDOM((%s) (%s))" (pe_to_str e1) (pe_to_str e2)
***************
*** 320,335 ****
--- 443,476 ----
    | PE_If(e1,e2,e3) -> Printf.sprintf "(%s) ? (%s) : (%s)"
      (pe_to_str e1) (pe_to_str e2) (pe_to_str e3)
    
+   | PE_VariableIsSet(s) -> Printf.sprintf "VARIABLE_IS_SET %s" (pe_str_str s)
+   | PE_IdsOfSymbol(a,b) -> Printf.sprintf "IDS_OF_SYMBOL (%s %s)" a b
+   | PE_StateWhichSays(Some(x),None,y) -> Printf.sprintf "STATE_WHICH_SAYS __ FROM %s"  y
+   | PE_StateWhichSays(None,Some(a,b),y) -> Printf.sprintf "STATE_WHICH_SAYS (%s) IN %s FROM %s" (pe_to_str a) b y
+   | PE_StateWhichSays(None,None,_)
+   | PE_StateWhichSays(Some(_),Some(_),_) -> Printf.sprintf "INTERNAL ERROR"
+   | PE_IsAnInt(x) -> Printf.sprintf "IS_AN_INT %s" (pe_str_str x)
+ 
  and pe_str_str s = match s with
    | PE_LiteralString(s) -> s
    | PE_Evaluate(s) -> Printf.sprintf "EVALUATE_BUFFER %s" (pe_str_str s)
+   | PE_Lowercase(s) -> Printf.sprintf "LOWERCASE %s" (pe_str_str s)
+   | PE_Uppercase(s) -> Printf.sprintf "UPPERCASE %s" (pe_str_str s)
+   | PE_Dollars(s,a,r) -> let result = List.fold_left (fun acc this -> acc ^ " " ^ (pe_str_str this)) ("$" ^ (pe_str_str s) ^ "(") a in
+       Printf.sprintf "%s)" result
+ 
  
  let action_to_str a = match a with
    | TP_Copy _ -> "COPY"
+   | TP_ClearMemory -> "CLEAR_MEMORY"
+   | TP_Clear_Ids_Map -> "CLEAR_IDS_MAP"
+   | TP_CopyLarge _ -> "COPY_LARGE"
+   | TP_CopyAllGamFiles _ -> "COPY_ALL_GAM_FILES"
    | TP_CopyRandom _ -> "COPY_RANDOM"
    | TP_RandomSeed _ -> "RANDOM_SEED"
    | TP_Compile _ -> "COMPILE"
    | TP_Inlined_File _ -> "<<<<<<<<"
+   | TP_Load_Tra _-> "LOAD_TRA"
    | TP_Mkdir _ -> "MKDIR"
    | TP_Forbid_File _ -> "FORBID_FILE"
    | TP_Require_File _ -> "REQUIRE_FILE"
***************
*** 341,357 ****
    | TP_At_Exit _ 
    | TP_At_Interactive_Exit _ 
    | TP_At_Uninstall _ 
!   | TP_At_Interactive_Uninstall _ -> "AT_*" 
    | TP_Add_Kit _ -> "ADD_KIT" 
    | TP_Add_Music _ -> "ADD_MUSIC"
    | TP_Add_Projectile _ -> "ADD_PROJECTILE" 
    | TP_String_Set _ -> "STRING_SET" 
    | TP_String_Set_Range _ -> "STRING_SET_RANGE" 
    | TP_Fail _ -> "FAIL" 
    | TP_Print _ -> "PATCH_PRINT" 
    | TP_If _ -> "PATCH_IF" 
    | TP_Uninstall_Now _ -> "UNINSTALL" 
  
  (************************************************************************
   * For handling lists of modules.
   ************************************************************************)
--- 482,570 ----
    | TP_At_Exit _
    | TP_At_Interactive_Exit _
    | TP_At_Uninstall _
!   | TP_At_Interactive_Uninstall _
!   | TP_At_Now _
!   | TP_At_Interactive_Now _ -> "AT_*"
    | TP_Add_Kit _ -> "ADD_KIT"
+   | TP_CopyKit _ -> "COPY_KIT"
    | TP_Add_Music _ -> "ADD_MUSIC"
    | TP_Add_Projectile _ -> "ADD_PROJECTILE"
+   | TP_Add_Spell _ -> "ADD_SPELL"
    | TP_String_Set _ -> "STRING_SET"
+   | TP_String_Set_Evaluate _ -> "STRING_SET_EVALUATE"
    | TP_String_Set_Range _ -> "STRING_SET_RANGE"
    | TP_Fail _ -> "FAIL"
    | TP_Print _ -> "PATCH_PRINT"
    | TP_If _ -> "PATCH_IF"
    | TP_Uninstall_Now _ -> "UNINSTALL"
+   | TP_ActionBashFor _ -> "ACTION_BASH_FOR"
+   | TP_ActionDefineArray _ -> "ACTION_DEFINE_ARRAY"
+   | TP_ActionPHPEach _ -> "ACTION_PHP_EACH"
+   | TP_Action_For_Each _ -> "ACTION_FOR_EACH"
+   | TP_Biff _ -> "BIFF"
+   | TP_Outer_For _ -> "OUTER_FOR"
+   | TP_Outer_Inner_Buff _ -> "OUTER_INNER_PATCH"
+   | TP_Outer_Inner_Buff_Save _ -> "OUTER_INNER_PATCH_SAVE"
+   | TP_Outer_Set _ -> "OUTER_SET"
+   | TP_Outer_Sprint _ -> "OUTER_SPRINT"
+   | TP_Outer_Text_Sprint _ -> "OUTER_TEXT_SPRINT"
+   | TP_Outer_While _ -> "OUTER_WHILE"
+   | TP_Launch_Action_Macro _ -> "LAUNCH_ACTION_MACRO"
+   | TP_Include _ -> "INCLUDE"
+   | TP_Reinclude _ -> "REINCLUDE"
+   | TP_Define_Action_Macro _ -> "DEFINE_ACTION_MACRO"
+   | TP_Define_Patch_Macro _ -> "DEFINE_PATCH_MACRO"
+   | TP_Silent -> "SILENT"
+   | TP_Verbose -> "VERBOSE"
+   | TP_Action_ReadLN _ -> "ACTION_READLN"
+ 
+ (************************************************************************
+  * For handling the problem w/ REQUIRE_FILE & akin on bif
+  * w/ multiple installs.
+  ************************************************************************)
+ let bigg_file_exists file key =
+   let test = ref false in
+   if Str.string_match (Str.regexp_case_fold "data.25.*\\.bif") file 0 then
+   begin
+ (*    log_and_print "\nbigg_file_exist special case\n" ; *)
+     test := Key.bif_exists_in_key key (Str.global_replace (Str.regexp "[\\/:]")
+             Arch.biff_path_separator file)
+   end
+   else begin
+ (*    log_and_print "\nbigg_file_exist special case not triggered: %s\n" file ; *)
+     test := file_size file >= 0
+   end ;
+   !test
+ 
+ (************************************************************************
+  * Common hashtables.
+  ************************************************************************)
+ let handle_tph_filename_global = ref (fun x -> ([]) )
+ let handle_tra_filename_global = ref (fun x -> ignore(x) )
+ let loaded_tph = Hashtbl.create 5
+ let loaded_tpp = Hashtbl.create 5
+ let action_macros = Hashtbl.create 10
+ let patch_macros = Hashtbl.create 10
+ let readln_strings = ref []
+ 
+ (************************************************************************
+  * Some shorthand for writing macroes.
+  ************************************************************************)
+ let make_lse_internal male_string male_sound female_string female_sound =
+   Dlg.Local_String ({ lse_male = male_string ; lse_male_sound = male_sound ;
+                     lse_female = female_string ; lse_female_sound = female_sound; })
+ 
+ let get_lse the_string =
+   make_lse_internal the_string "" the_string ""
+ 
+ let get_pe_int a_string =
+   PE_String(PE_LiteralString(a_string))
  
+ let get_pe_string a_string =
+   PE_LiteralString(a_string)
+ 
+ let get_pe_tlk_string a_string =
+   PE_Pe(get_pe_string a_string)
  (************************************************************************
   * For handling lists of modules.
   ************************************************************************)
***************
*** 401,407 ****
        lse_female_sound = s;
      }))]
    in 
!   add (-1000) "This mod has" ;
    add (-1001) "distinct optional components.\nTo save time, you can choose what to do with them at a high level rather\nthan being asked about each one.\n" ;
    add (-1002) "What should be done with all components that are NOT YET installed?\n[I]nstall them, [S]kip them, [A]sk about each one? " ;
    add (-1003) "What should be done with all components that are ALREADY installed?\n[R]e-install them, [U]ninstall them, [S]kip them, [A]sk about each one? " ;
--- 614,620 ----
        lse_female_sound = s;
      }))]
    in
!   add (-1000) "The %TP2_FILE_NAME% mod has" ;
    add (-1001) "distinct optional components.\nTo save time, you can choose what to do with them at a high level rather\nthan being asked about each one.\n" ;
    add (-1002) "What should be done with all components that are NOT YET installed?\n[I]nstall them, [S]kip them, [A]sk about each one? " ;
    add (-1003) "What should be done with all components that are ALREADY installed?\n[R]e-install them, [U]ninstall them, [S]kip them, [A]sk about each one? " ;
***************
*** 410,417 ****
    add (-1005) "to" ;
  
    add (-1006) "Install Component [" ;
!   add (-1007) "]\n[R]e-Install, [N]o Change or [U]ninstall or [Q]uit? " ;
!   add (-1008) "]\n[Y]es or [N]o or [Q]uit? " ;
  
    add (-1009) "Enter part of a module name: " ; 
  
--- 623,630 ----
    add (-1005) "to" ;
  
    add (-1006) "Install Component [" ;
!   add (-1007) "]?\n[R]e-Install, [N]o Change or [U]ninstall or [Q]uit? " ;
!   add (-1008) "]?\n[I]nstall, or [N]ot Install or [Q]uit? " ;
  
    add (-1009) "Enter part of a module name: " ;
  
***************
*** 433,447 ****
    add (-1023) ")" ;
    add (-1024) "SUCCESSFULLY REMOVED [" ;
  
!   add (-1025) "]\n[R]e-install, [N]o Change, [U]ninstall, [Q]uit or choose one:" ;
!   add (-1026) "]\n[N]o, [Q]uit or choose one:" ;
    add (-1027) " (currently installed)";
    ()
  
  
  (************************************************************************
   * Evaluate a TP2 Patch Expression
   ************************************************************************)
  let is_true i = i <> 0l 
  (* (Int32.compare i 0l) <> 0 *)
  let if_true p = if p then 1l else 0l 
--- 646,697 ----
    add (-1023) ")" ;
    add (-1024) "SUCCESSFULLY REMOVED [" ;
  
!   add (-1025) "]?\n[R]e-install, [N]o Change, [U]ninstall, [Q]uit or choose one:" ;
!   add (-1026) "]?\n[N]o, [Q]uit or choose one:" ;
    add (-1027) " (currently installed)";
+ 
+   add (-1028) "Would you like to display the components from [";
+   add (-1029) "]?\n[Y]es, [N]o? " ;
+ 
+   add (-1030) "]?\nchoose one:" ;
+   add (-1031) "]?\n[R]e-install, [N]o Change, [Q]uit or choose one:" ;
    ()
  
  
  (************************************************************************
   * Evaluate a TP2 Patch Expression
   ************************************************************************)
+ let log_match a b =
+   Filename.basename (String.uppercase a) = Filename.basename (String.uppercase b)
+ 
+ type status = Installed | Temporarily_Uninstalled | Permanently_Uninstalled
+ 
+ let the_log = ref []
+ 
+ let already_installed tp2 i =
+   let rec is_installed lst = match lst with
+   | [] -> false
+   | (a,b,c,sopt,d) :: tl when log_match a tp2 
+         && c = i && d <> Permanently_Uninstalled -> true
+   | hd :: tl -> is_installed tl 
+   in is_installed !the_log 
+ 
+ let installed_lang_index tp2 =
+   let rec is_installed lst = match lst with
+   | [] -> None
+   | (a,b,c,sopt,d) :: tl when log_match a tp2
+         && d <> Permanently_Uninstalled -> Some(b)
+   | hd :: tl -> is_installed tl
+   in is_installed !the_log
+ 
+ let temporarily_uninstalled tp2 i =
+   let rec is_installed lst = match lst with
+   | [] -> false
+   | (a,b,c,sopt,d) :: tl when log_match a tp2
+         && c = i && d = Temporarily_Uninstalled -> true
+   | hd :: tl -> is_installed tl
+   in is_installed !the_log
+ 
  let is_true i = i <> 0l
  (* (Int32.compare i 0l) <> 0 *)
  let if_true p = if p then 1l else 0l 
***************
*** 451,461 ****
--- 701,731 ----
  let rec eval_pe_str s = match s with
    | PE_LiteralString(s) -> s
    | PE_Evaluate(p) -> Var.get_string (eval_pe_str p)
+   | PE_Uppercase(s) -> String.uppercase (eval_pe_str s)
+   | PE_Lowercase(s) -> String.lowercase (eval_pe_str s)
+   | PE_Dollars(s,a,r) ->
+ 	  let a = List.map (fun x -> Var.get_string (eval_pe_str x)) a in
+ 		let s = eval_pe_str s in
+ 		let result = List.fold_left (fun acc this -> acc ^ "_" ^ this) s a in
+ 		if r then
+ 			( try
+ 			  ignore (int_of_string result); result
+ 			with _ ->
+ 			  try
+ 				  Var.get_string_exact ("%" ^ result ^ "%")
+ 				with _ -> result)
+ 		else (
+ 			let old = try Hashtbl.find Var.arrays s with Not_found -> [] in
+ 			if not (List.mem a old) then Hashtbl.add Var.arrays s (a :: old);
+ 			result
+ 		)
  
  let eval_pe_tlk_str game s = match s with
    | PE_Tlk(d) -> Dc.single_string_of_tlk_string game d
    | PE_Pe(p) -> eval_pe_str p
  
+ exception FoundInt of int
+ 
  let rec eval_pe game p =
    match p with
    | Pred_True -> 1l 
***************
*** 481,486 ****
--- 751,770 ----
          end
        end 
      end
+   | PE_VariableIsSet(s) ->
+       let s = eval_pe_str s in
+       if Hashtbl.mem Var.variables s then 1l
+       else if Hashtbl.mem Var.variables ("%" ^ s ^ "%") then 1l
+       else 0l
+   
+   | PE_IdsOfSymbol(file,entry) ->
+       begin try
+           let file = Var.get_string file in
+           let entry = Var.get_string entry in
+           Bcs.int_of_sym game file entry
+         with _ -> -1l
+       end
+ 
  
    | PE_Random(lb,ub) ->
      let lb = eval_pe game lb in
***************
*** 536,546 ****
    | Pred_File_Exists(f) -> if_true (
        let f = eval_pe_str f in 
        let filename = (Var.get_string f) in
!       file_size filename > 0  )
  
    | Pred_File_Exists_In_Game(f) -> if_true  (
        let f = eval_pe_str f in 
        let old_allow_missing = !Load.allow_missing in 
        Load.allow_missing := [] ; 
        let res = 
        (try 
--- 820,840 ----
    | Pred_File_Exists(f) -> if_true (
        let f = eval_pe_str f in
        let filename = (Var.get_string f) in
!       bigg_file_exists filename game.Load.key  )
! 
!   | Pred_File_Is_In_Compressed_Bif(f) -> if_true (
!       let f = eval_pe_str f in
!       let filename = (Var.get_string f) in
!       let (a,b) = split filename in
!       try
!         let (a,b,c,this_biff) = Load.find_in_key game a b in
!         this_biff.Biff.compressed
!       with _ -> failwith (Printf.sprintf "couldn't find file %s in a biff" f) )
  
    | Pred_File_Exists_In_Game(f) -> if_true  (
        let f = eval_pe_str f in
        let old_allow_missing = !Load.allow_missing in
+       let f = Var.get_string f in
        Load.allow_missing := [] ;
        let res =
        (try
***************
*** 580,586 ****
        in 
        if b then 0l else 1l 
  
!   | PE_StringEqual(s1,s2,ignore_case) ->
        let s1 = eval_pe_str s1 in 
        let s2 = eval_pe_str s2 in 
        let s1 = Var.get_string s1 in 
--- 874,880 ----
        in
        if b then 0l else 1l
  
!   | PE_StringEqual(s1,s2,ignore_case,isbool) ->
        let s1 = eval_pe_str s1 in
        let s2 = eval_pe_str s2 in
        let s1 = Var.get_string s1 in
***************
*** 589,595 ****
          (fun s1 s2 -> String.compare (String.uppercase s1)
          (String.uppercase s2)) else String.compare 
        in 
!       Int32.of_int (comparison s1 s2) 
    | PE_Add(a,b) -> let a = eval_pe game a in let b = eval_pe game b in Int32.add a b 
    | PE_Sub(a,b) -> let a = eval_pe game a in let b = eval_pe game b in Int32.sub a b 
    | PE_Mul(a,b) -> let a = eval_pe game a in let b = eval_pe game b in Int32.mul a b 
--- 883,896 ----
          (fun s1 s2 -> String.compare (String.uppercase s1)
          (String.uppercase s2)) else String.compare
        in
!       let result = Int32.of_int (comparison s1 s2) in
!       let bigg_make_bool () =
!         (if isbool then
!           if result = Int32.of_int 0 then Int32.of_int 1 else Int32.of_int 0
!         else
!           result )
!       in
!       bigg_make_bool ()
    | PE_Add(a,b) -> let a = eval_pe game a in let b = eval_pe game b in Int32.add a b
    | PE_Sub(a,b) -> let a = eval_pe game a in let b = eval_pe game b in Int32.sub a b
    | PE_Mul(a,b) -> let a = eval_pe game a in let b = eval_pe game b in Int32.mul a b
***************
*** 631,636 ****
--- 932,1070 ----
    | PE_BASR(a,b) -> Int32.shift_right (eval_pe game a) (Int32.to_int (eval_pe game b) )
  
    | PE_If(p,t,e) -> if is_true (eval_pe game p) then eval_pe game t else eval_pe game e
+   | PE_ModIsInstalled(filename,number) -> if_true (already_installed filename number &&
+              not (temporarily_uninstalled filename number))
+   | PE_GameIs(game_list) -> begin
+       let game_list = Str.split many_whitespace_regexp game_list in
+       List.fold_left (fun acc this -> if acc = 1l then 1l else eval_pe game begin
+           match String.uppercase this with
+           | "BG2"
+           | "SOA"    -> PE_And(PE_And(Pred_File_Exists_In_Game(get_pe_string "flythr01.mve"),
+                       PE_Not(Pred_File_Exists_In_Game(get_pe_string "saradush.mve"))),
+                       PE_Not(Pred_File_Exists_In_Game(get_pe_string "_eregost.mve")))
+           | "TOB"    -> PE_And(Pred_File_Exists_In_Game(get_pe_string "saradush.mve"),
+                       PE_Not(Pred_File_Exists_In_Game(get_pe_string "_eregost.mve")))
+           | "IWD2"   -> Pred_File_Exists_In_Game(get_pe_string "subrace.ids")
+           | "PST"    -> Pred_File_Exists_In_Game(get_pe_string "faction.ids")
+           | "BG1"    -> PE_And(Pred_File_Exists_In_Game(get_pe_string "beregost.mve"),
+                         PE_Not(Pred_File_Exists_In_Game(get_pe_string "durlag.mve")))
+           | "TOTSC"  -> Pred_File_Exists_In_Game(get_pe_string "durlag.mve")
+           | "IWD"
+           | "IWD1"   -> PE_And(Pred_File_Exists_In_Game(get_pe_string "avalanch.mve"),
+                         PE_Not(Pred_File_Exists_In_Game(get_pe_string "howdrag.mve")))
+           | "HOW"    -> Pred_File_Exists_In_Game(get_pe_string "howdrag.mve")
+           | "TUTU"   -> PE_And(Pred_File_Exists_In_Game(get_pe_string "_eregost.mve"),
+                         PE_Not(Pred_File_Exists_In_Game(get_pe_string "_durlag.mve")))
+           | "TUTU_TOTSC"
+           | "TUTU+TOTSC"  -> Pred_File_Exists_In_Game(get_pe_string "_durlag.mve")
+           | _ -> failwith (Printf.sprintf "No rule to identify %s" (String.uppercase this))
+         end
+       ) 0l game_list
+     end
+   | PE_IsAnInt(x) -> (eval_pe_warn := false ;
+     try
+       let _ = (eval_pe game (PE_String(x))) in
+       1l
+     with _ ->
+       0l
+     )
+   | PE_StateWhichSays(lse,traref,file) -> begin
+       let rec lookforit game lse lst =
+         if !debug_ocaml then log_and_print "in lookforit \n";
+         try (match lst with
+           | [] -> []
+           | hd :: tl -> looksingle game lse hd; lookforit game lse tl
+         ) with 
+         | FoundInt(i) -> i :: lookforit game lse (List.tl lst)
+         | e -> raise e
+       and looksingle game lse this =
+         if !debug_ocaml then log_and_print "looking in %s\n" this;
+         Dc.push_copy_trans () ;
+         !handle_tra_filename_global this ;
+         try
+             ( match Dc.resolve_tlk_string_internal false false game lse
+               with
+                 | Dlg.TLK_Index(i) -> Dc.pop_trans (); if !debug_ocaml then begin
+                   let str = Dc.single_string_of_tlk_string game (Dlg.TLK_Index(i)) in
+                   let str = Var.get_string str in
+                   log_and_print "\n%d - %s\n" i str
+                 end ; raise(FoundInt i)
+                 | _ -> Dc.pop_trans ();
+             )
+           with
+             FoundInt(i) -> raise (FoundInt i)
+             | a -> if !debug_ocaml then log_and_print "%s\n" (Printexc.to_string a)
+       in
+       let theref = match traref with
+         | None (*going by tra + @ref*) ->
+           begin try
+               ( match Dc.resolve_tlk_string_internal false true game (value_of_option lse)
+                 with
+                   | Dlg.TLK_Index(i) -> [i]
+                   | _ -> log_and_print "ERROR: cannot resolve SAY patch\n" ; failwith "resolve"
+               )
+             with Not_found -> [0 - 3]
+               | e -> raise e
+           end
+         | Some(num,file) (* going by hard string *) ->
+           begin
+             let lst = try
+                 let regexp = Str.regexp "%s" in
+                 let addr = Str.search_forward regexp file 0 in
+                 let parts = Str.split regexp file in
+                 if List.length parts > 2 then begin
+                   log_and_print "Can't use more than one %%s in STATE_WHICH_SAYS ... IN\n" ;
+                   failwith "STATE_WHICH_SAYS %s/%s"
+                 end ;
+                 let dh = Case_ins.unix_opendir (List.nth parts 0) in
+                 let rec readdir dh =
+                   try
+                     let x = Unix.readdir dh in
+                     if !debug_ocaml then log_and_print "%s-\n" x;
+                     if (Case_ins.unix_stat ((List.nth parts 0) ^ x)).Unix.st_kind = Unix.S_DIR &&
+                         (List.nth parts 0) <> "." && (List.nth parts 0) <> ".." then
+                       ((List.nth parts 0) ^ x ^ (List.nth parts 1)) :: readdir dh
+                     else readdir dh
+                   with End_of_file -> Unix.closedir dh ;[]
+                 in
+                 readdir dh
+               with
+               | Not_found -> [file]
+               | e -> raise e
+             in
+             if !debug_ocaml then List.iter (fun x -> log_and_print "%s\n" x) lst;
+             let x = begin try
+               lookforit game (Dlg.Trans_String(Int32.to_int(eval_pe game num))) lst
+               with
+                 | Not_found -> [0 - 3]
+                 | e -> Dc.pop_trans ();  raise e
+             end
+             in
+             x
+           end
+       in
+       if !debug_ocaml then log_and_print "Looking for these: \n" ;
+       if !debug_ocaml then List.iter (fun x -> log_and_print "%d\n" x) theref ;
+       if theref = [] then log_and_print "Couldn't find any suitable string in STATE_WHICH_SAYS\n";
+       if theref = [] then failwith "resolve" ;
+       if theref = [0 - 3] then Int32.of_int (0 - 3) else begin
+         let (a,b) = split file in
+         let buff,path = Load.load_resource "STATE_WHICH_SAYS" game true a b in
+         if !debug_ocaml then log_and_print "%s \n" path ;
+         let numstates = int_of_str_off buff 8  in
+         let stateoff  = int_of_str_off buff 12 in
+         let whichstate = ref (0 - 1) in
+         let howmany = ref 0 in
+         for i = 0 to numstates - 1 do
+           let this_say = int_of_str_off buff ((16 * i) + stateoff) in
+           if List.mem this_say theref then whichstate := i ;
+           if List.mem this_say theref && !debug_ocaml then log_and_print "Found number %d at state %d\n" this_say i;
+           if List.mem this_say theref then incr howmany ;
+         done ;
+         if !howmany = 0 then Int32.of_int (0 - 1) else if !howmany > 1 then Int32.of_int (0 - 2) else
+           Int32.of_int !whichstate
+       end
+     end
  
  let eval_pe game pe =
    let res = Stats.time "eval_pe" (fun () -> eval_pe game pe) () in
***************
*** 644,653 ****
  let uninstall_strset game filename = 
    if (file_exists filename) then begin
      (try
!       let buff = load_file filename in 
        let record : Load.str_set_record list = 
!         Marshal.from_string buff 0 
        in 
        List.iter (fun (i,m,f) -> 
          if (i < 0 || i > Array.length game.Load.dialog) then begin
            log_only "WARNING: Cannot uninstall STRING_SET #%d, out of range 0 -- %d\n" i (Array.length game.Load.dialog) 
--- 1078,1088 ----
  let uninstall_strset game filename = 
    if (file_exists filename) then begin
      (try
!       let infile = Case_ins.perv_open_in_bin filename in
        let record : Load.str_set_record list =
!         Marshal.from_channel infile
        in
+       close_in infile ;
        List.iter (fun (i,m,f) ->
          if (i < 0 || i > Array.length game.Load.dialog) then begin
            log_only "WARNING: Cannot uninstall STRING_SET #%d, out of range 0 -- %d\n" i (Array.length game.Load.dialog) 
***************
*** 667,673 ****
        ) record
      with e -> 
        log_and_print "WARNING: Unable to uninstall STRING_SET references from [%s]: %s\n" filename (Printexc.to_string e));
!     Unix.unlink filename ;
    end else log_only "[%s] SET_STRING uninstall info not found\n" filename 
  
  let record_strset_uninstall_info game filename = 
--- 1102,1108 ----
        ) record
      with e ->
        log_and_print "WARNING: Unable to uninstall STRING_SET references from [%s]: %s\n" filename (Printexc.to_string e));
!     my_unlink filename;
    end else log_only "[%s] SET_STRING uninstall info not found\n" filename
  
  let record_strset_uninstall_info game filename =
***************
*** 675,681 ****
      ()
    else begin 
      try 
!       let outchan = open_out_bin filename in 
        Marshal.to_channel outchan game.Load.str_sets [];
        close_out outchan ;
        game.Load.str_sets <- [] 
--- 1110,1116 ----
      ()
    else begin
      try 
!       let outchan = Case_ins.perv_open_out_bin filename in
        Marshal.to_channel outchan game.Load.str_sets [];
        close_out outchan ;
        game.Load.str_sets <- []
***************
*** 689,702 ****
  (************************************************************************
   * Uninstall a TP2 component
   ************************************************************************)
! let handle_at_uninstall m do_uninstall do_interactive_uninstall = 
      List.iter (fun a -> match a with
        | TP_At_Uninstall(str) -> 
          if do_uninstall then begin
          let str = Var.get_string str in 
          match (split (String.uppercase str)) with
          | _,"TP2" -> (!handle_recursive_tp2) str
!         | _,_ -> let str = Arch.handle_view_command str in 
                 ignore (Unix.system(Arch.slash_to_backslash str))
          end
        | TP_At_Interactive_Uninstall(str) -> 
--- 1124,1138 ----
  (************************************************************************
   * Uninstall a TP2 component
   ************************************************************************)
! let handle_at_uninstall tp2 m do_uninstall do_interactive_uninstall game =
!     let rec handle_al al =
        List.iter (fun a -> match a with
          | TP_At_Uninstall(str) ->
            if do_uninstall then begin
            let str = Var.get_string str in
            match (split (String.uppercase str)) with
            | _,"TP2" -> (!handle_recursive_tp2) str
!           | _,_ -> let str = Arch.handle_view_command str !skip_at_view in
                   ignore (Unix.system(Arch.slash_to_backslash str))
            end
          | TP_At_Interactive_Uninstall(str) ->
***************
*** 704,720 ****
            let str = Var.get_string str in 
            match (split (String.uppercase str)) with
            | _,"TP2" -> (!handle_recursive_tp2) str
!           | _,_ -> let str = Arch.handle_view_command str in 
                   ignore(Unix.system(Arch.slash_to_backslash str))
          end 
        | _ -> () 
!     ) m.mod_parts  
! 
! let one_newline_regexp = Str.regexp "[\n]" 
! let one_newline_or_cr_regexp = Str.regexp "[\r\n]" 
! let many_newline_or_cr_regexp = Str.regexp "[\r\n]+" 
! let many_whitespace_regexp = Str.regexp "[ \t]+" 
! let many_not_whitespace_regexp = Str.regexp "[^ \t\n\r]+"
  
  let uninstall_tp2_component game tp2 tp_file i interactive =
    Stats.time "tp2 uninstall" (fun () -> 
--- 1140,1219 ----
              let str = Var.get_string str in
              match (split (String.uppercase str)) with
              | _,"TP2" -> (!handle_recursive_tp2) str
!             | _,_ -> let str = Arch.handle_view_command str !skip_at_view in
                     ignore(Unix.system(Arch.slash_to_backslash str))
            end
+         | TP_If(p,al1,al2) ->
+           begin try
+               eval_pe_warn := false ;
+               let res = is_true (eval_pe game p) in
+               (* log_or_print "IF evaluates to %b\n" res ; *)
+               if res then begin
+                 handle_al al1
+               end else begin
+                 handle_al al2
+               end
+             with _ -> () ;
+             eval_pe_warn := true ;
+           end
+         | TP_Biff _ ->
+             (* re-load the chitin *)
+             let keyname = Load.find_file_in_path "." "^chitin.key$" in
+             let keybuff = load_file keyname in
+             game.Load.key <- Key.load_key keyname keybuff ;
+             game.Load.loaded_biffs <- Hashtbl.create 5 ;
+         | TP_Include(string_list) ->
+           List.iter (fun file ->
+             let incl_al = if Hashtbl.mem loaded_tph file
+               then begin
+                 if !debug_ocaml then log_and_print "%s is already loaded, restoring the image...\n" file ;
+                 Hashtbl.find loaded_tph file
+               end
+               else begin
+                 if !debug_ocaml then log_and_print "Loading %s...\n" file ;
+                 let x = !handle_tph_filename_global file in
+                 Hashtbl.replace loaded_tph file x ;
+                 x
+               end
+             in
+             handle_al incl_al ;
+           ) string_list ;
+         | TP_Reinclude(string_list) ->
+           List.iter (fun file ->
+             let incl_al =
+               if !debug_ocaml then log_and_print "Loading %s...\n" file ;
+               let x = !handle_tph_filename_global file in
+               Hashtbl.replace loaded_tph file x ;
+               x
+             in
+             handle_al incl_al ;
+           ) string_list ;
+ (* for now, no AT_* in macroes. Too shifty.
+         | TP_Launch_Action_Macro(str) ->
+           begin try
+               let (decl, actions) =
+                 Hashtbl.find action_macros str
+               in
+               handle_al actions ;
+             with _ ->
+               log_and_print "WARNING: can't find AT_*UNINSTALL in macro\n"
+           end
+         | TP_Define_Action_Macro(str,decl,al) ->
+             Hashtbl.replace action_macros str (decl, al)
+         | TP_Define_Patch_Macro(str,decl,al) ->
+             Hashtbl.replace patch_macros str (decl, al) *)
          | _ -> ()
!       ) al
!     in
!     let handle_flag fl =
!       List.iter (fun flag ->
!         match flag with
!         | Always(al) -> handle_al al ;
!         | _ -> ()
!       ) fl
!     in
!     handle_flag tp2.flags ;
!     handle_al m.mod_parts
  
  let uninstall_tp2_component game tp2 tp_file i interactive =
    Stats.time "tp2 uninstall" (fun () ->
***************
*** 722,761 ****
      let result = tp2 in
      let d = result.backup ^ "/" ^ (string_of_int i) in 
      let u_filename = (Printf.sprintf "%s/UNINSTALL.%d" d i) in 
      let u_strset_filename = (Printf.sprintf "%s/UNSETSTR.%d" d i) in 
      uninstall_strset game u_strset_filename ; 
!     let buff = load_file u_filename in 
!     let file_list = Str.split one_newline_regexp buff in
      log_and_print "Will uninstall %3d files for [%s] component %d.\n" 
!       (List.length file_list) tp_file i; 
      List.iter (fun override_filename -> 
        let base = Filename.basename override_filename in 
        let backup_filename = d ^ "/" ^ base in 
!       (* did we save a backup copy? *) 
!       if file_exists backup_filename then begin
!         (* copy it from Backup to Override *) 
!         log_or_print "  Restoring backed-up [%s]\n" backup_filename ; 
!         let buff = load_file backup_filename in
!         let restore_chn = open_out_bin override_filename in
!         output_string restore_chn buff ;
!         close_out restore_chn ;
!         Unix.unlink backup_filename 
!       end else begin
!         (* no backup copy, so just delete it from override *) 
!         log_or_print "  Deleting [%s] (to restore original game condition)\n" 
!           override_filename ; 
!         try 
!           Unix.unlink override_filename  
!         with e ->
!           log_or_print "Unable to Unlink [%s]: %s"
!             override_filename (Printexc.to_string e)
        end 
!     ) (List.rev file_list)  ;
!     Unix.unlink u_filename ;
      let m = get_nth_module result i true in 
!     handle_at_uninstall m true interactive ;
      log_and_print "Uninstalled    %3d files for [%s] component %d.\n" 
!       (List.length file_list) tp_file i; 
    with e ->
      log_and_print "Error Uninstalling [%s] component %d:\n%s\n"
        tp_file i (Printexc.to_string e)
--- 1221,1283 ----
      let result = tp2 in
      let d = result.backup ^ "/" ^ (string_of_int i) in
      let u_filename = (Printf.sprintf "%s/UNINSTALL.%d" d i) in
+     let m_filename = (Printf.sprintf "%s/MAPPINGS.%d" d i) in
      let u_strset_filename = (Printf.sprintf "%s/UNSETSTR.%d" d i) in
      uninstall_strset game u_strset_filename ;
!     let file_list = ref [] in
!     let mappings_list = Hashtbl.create 300 in
! 		let restore backup_filename override_filename =
! 			log_or_print "  Restoring backed-up [%s]\n" backup_filename ;
! 			copy_large_file backup_filename override_filename "restoring a backup" ;
! 			my_unlink backup_filename
! 		in
! 		let inchan = Case_ins.perv_open_in_bin u_filename in
! 		try
! 			while true do
! 				file_list := (input_line inchan) :: !file_list ;
! 			done
! 		with End_of_file -> () ;
! 		close_in inchan;
! 		let has_mappings = ref true in
! 		(
! 		try
! 		let inchan = Case_ins.perv_open_in_bin m_filename in
! 			while true do
! 				let line = input_line inchan in
! 				let pieces = Str.split (Str.regexp " ") line in
! 				match pieces with
! 				a :: b :: [] -> Hashtbl.add mappings_list a b
! 				| _ -> ()
! 			done
! 		with End_of_file -> (close_in inchan)
! 		| Sys_error _ -> has_mappings := false;
! 		);
! 		file_list := List.rev (!file_list);
  		log_and_print "Will uninstall %3d files for [%s] component %d.\n"
! 			(List.length !file_list) tp_file i; 
  		List.iter (fun override_filename -> 
+       my_unlink override_filename;
+       try
+ 			if !has_mappings then
+ 				restore (Hashtbl.find mappings_list override_filename) override_filename
+ 			else begin
  				let base = Filename.basename override_filename in
  				let backup_filename = d ^ "/" ^ base in
! 				let backup_filename1 = d ^ "/" ^ (Str.global_replace (Str.regexp "[\\/]") "." override_filename) in
! 				if file_exists backup_filename then
! 					restore backup_filename override_filename
! 				else if file_exists backup_filename1 then
! 					restore backup_filename1 override_filename
  			end
! 			with _ -> ()
! 			;
! 		) (!file_list)  ;
! 		my_unlink u_filename;
! 		my_unlink m_filename;
      let m = get_nth_module result i true in
!     handle_at_uninstall tp2 m true interactive game ;
      log_and_print "Uninstalled    %3d files for [%s] component %d.\n" 
!       (List.length !file_list) tp_file i; 
    with e ->
      log_and_print "Error Uninstalling [%s] component %d:\n%s\n"
        tp_file i (Printexc.to_string e)
***************
*** 764,774 ****
  (************************************************************************
   * Determine what has been installed. 
   ************************************************************************)
- type status = Installed | Temporarily_Uninstalled | Permanently_Uninstalled
  type installed_mods = (string * int * int * (string option) * status) list
    (* module : language : component : status *) 
  let log_name = "WeiDU.log"
- let the_log = ref [] 
  
  let str_of_str_opt sopt = match sopt with
      Some(str) -> "~" ^ str ^ "~"
--- 1286,1294 ----
***************
*** 783,807 ****
      (str_of_str_opt sopt) 
    ) !the_log
  
! let save_log game handle_tp2_filename handle_tra_filename =
!   let out = open_out log_name in
    log_or_print "Saving This Log:\n" ; print_log () ; 
    Printf.fprintf out "// Log of Currently Installed WeiDU Mods\n" ;
    Printf.fprintf out "// The top of the file is the 'oldest' mod\n" ; 
!   Printf.fprintf out "// ~TP2_File~ #language_number #component_number // Component Name\n" ;
    let newline_regexp = one_newline_or_cr_regexp in 
!   let my_ht = Hashtbl.create 511 in 
    List.iter (fun (a,b,c,sopt,d) -> 
      let str = 
!       let component_name = 
          try
            (* log_or_print "*** Looking Up %s.\n" a; *)
            let tp2 = 
!             try Hashtbl.find my_ht a 
              with _ -> 
                (* log_or_print "*** Parsing %s.\n" a; *)
                let res = handle_tp2_filename a in
!               Hashtbl.add my_ht a res ; res
            in 
            Dc.clear_state () ;
            Dc.push_trans ();
--- 1303,1330 ----
      (str_of_str_opt sopt)
    ) !the_log
  
! let save_log game handle_tp2_filename handle_tra_filename get_tra_list_filename =
!   let out = Case_ins.perv_open_out log_name in
    log_or_print "Saving This Log:\n" ; print_log () ;
    Printf.fprintf out "// Log of Currently Installed WeiDU Mods\n" ;
    Printf.fprintf out "// The top of the file is the 'oldest' mod\n" ;
!   Printf.fprintf out "// ~TP2_File~ #language_number #component_number%s"
!     (if !quick_log then "\n" else " // [Subcomponent Name -> ] Component Name\n") ;
    let newline_regexp = one_newline_or_cr_regexp in
!   let tp2_ht = Hashtbl.create 511 in
!   let tra_ht = Hashtbl.create 511 in
    List.iter (fun (a,b,c,sopt,d) ->
      let str =
!       if not !quick_log then begin
!         let component_name, subcomponent_name =
            try
              (* log_or_print "*** Looking Up %s.\n" a; *)
              let tp2 =
!               try Hashtbl.find tp2_ht a
                with _ ->
                  (* log_or_print "*** Parsing %s.\n" a; *)
                  let res = handle_tp2_filename a in
!                 Hashtbl.add tp2_ht a res ; res
              in
              Dc.clear_state () ;
              Dc.push_trans ();
***************
*** 809,829 ****
            (try
              let l = List.nth tp2.languages b in
              List.iter (fun s -> 
                (* log_or_print "*** Loading %s for %s.\n" s a; *)
!               handle_tra_filename s
              ) l.lang_tra_files ;
            with _ -> ()) ;
            let m = get_nth_module tp2 c true in 
!           let str = Dc.single_string_of_tlk_string game m.mod_name in 
            Dc.clear_state () ;
            Dc.pop_trans ();
!           str 
          with _ -> 
!           "???" 
        in 
        let component_name = Str.global_replace newline_regexp " " component_name in 
!       Printf.sprintf "~%s~ #%d #%d // %s\n" 
!         (String.uppercase a) b c component_name 
      in 
    match d with
      Installed -> output_string out str 
--- 1332,1376 ----
              (try
                let l = List.nth tp2.languages b in
                List.iter (fun s ->
+                 let x =
                  (* log_or_print "*** Loading %s for %s.\n" s a; *)
!                   try Hashtbl.find tra_ht s
!                   with _ ->
!                     (let x = get_tra_list_filename (Arch.backslash_to_slash s) in
!                     Hashtbl.add tra_ht s x; x
!                     )
!                 in
!                 Stats.time "adding translation strings" Dc.add_trans_strings x
                ) l.lang_tra_files ;
              with _ -> ()) ;
              let m = get_nth_module tp2 c true in
!             let comp_str = Dc.single_string_of_tlk_string_safe game m.mod_name in
!             let subcomp_group the_comp =
!               let rec walk lst = match lst with
!               | TPM_SubComponents(ts,a,b) :: tl -> Some(ts)
!               | hd :: tl -> walk tl
!               | [] -> None
!               in walk the_comp.mod_flags
!             in
!             let subcomp_str = (
!               match subcomp_group m with
!               | None    -> ""
!               | Some(x) -> "" ^ (Dc.single_string_of_tlk_string_safe game x) ^ " -> ") in
              Dc.clear_state () ;
              Dc.pop_trans ();
!             (comp_str, subcomp_str)
            with _ ->
!             ( "??? -> ", "???" )
          in
          let    component_name = Str.global_replace newline_regexp " "    component_name in
!         let subcomponent_name = Str.global_replace newline_regexp " " subcomponent_name in
!         Printf.sprintf "~%s~ #%d #%d // %s%s\n"
!           (String.uppercase a) b c subcomponent_name component_name
!       end
!       else begin
!         Printf.sprintf "~%s~ #%d #%d\n"
!           (String.uppercase a) b c
!       end
      in
    match d with
      Installed -> output_string out str
***************
*** 834,867 ****
    ) !the_log ; 
    close_out out 
  
! let log_match a b = 
!   Filename.basename (String.uppercase a) = Filename.basename (String.uppercase b) 
! 
! let already_installed tp2 i =
!   let rec is_installed lst = match lst with
!   | [] -> false
!   | (a,b,c,sopt,d) :: tl when log_match a tp2 
!         && c = i && d <> Permanently_Uninstalled -> true
!   | hd :: tl -> is_installed tl 
!   in is_installed !the_log 
! 
! let installed_lang_index tp2 =
!   let rec is_installed lst = match lst with
!   | [] -> None
!   | (a,b,c,sopt,d) :: tl when log_match a tp2 
!         && d <> Permanently_Uninstalled -> Some(b)
!   | hd :: tl -> is_installed tl 
!   in is_installed !the_log 
! 
! let temporarily_uninstalled tp2 i =
!   let rec is_installed lst = match lst with
!   | [] -> false
!   | (a,b,c,sopt,d) :: tl when log_match a tp2
!         && c = i && d = Temporarily_Uninstalled -> true
!   | hd :: tl -> is_installed tl 
!   in is_installed !the_log 
! 
! let temp_to_perm_uninstalled tp2 i handle_tp2_filename = 
    let rec is_installed lst = match lst with
    | [] -> []
    | (a,b,c,sopt,d) :: tl when log_match a tp2 
--- 1381,1387 ----
    ) !the_log ;
    close_out out
  
! let temp_to_perm_uninstalled tp2 i handle_tp2_filename game =
    let rec is_installed lst = match lst with
    | [] -> []
    | (a,b,c,sopt,d) :: tl when log_match a tp2
***************
*** 876,888 ****
          with _ -> "" ) in 
          Var.set_string "TP2_AUTHOR" tp2.author ; 
          Var.set_string "LANGUAGE" lang_name ;
          let m = get_nth_module tp2 c true in 
          log_only "Running AT_INTERACTIVE_EXITs in ~%s~ %d %d %s\n" 
            (String.uppercase a) b c
            (str_of_str_opt sopt) ;
!         handle_at_uninstall m 
            false (* "AT_UNINSTALL" was already done! *)
!           true (* but the user just asked for this to be explicit *) ;
          (* Var.remove_var "LANGUAGE" ; *) 
          (a,b,c,sopt,Permanently_Uninstalled) :: tl 
    | hd :: tl -> hd :: (is_installed tl)
--- 1396,1409 ----
          with _ -> "" ) in 
          Var.set_string "TP2_AUTHOR" tp2.author ;
          Var.set_string "LANGUAGE" lang_name ;
+         Var.set_string "TP2_FILE_NAME" tp2.tp_filename ;
          let m = get_nth_module tp2 c true in
          log_only "Running AT_INTERACTIVE_EXITs in ~%s~ %d %d %s\n"
            (String.uppercase a) b c
            (str_of_str_opt sopt) ;
!         handle_at_uninstall tp2 m
            false (* "AT_UNINSTALL" was already done! *)
!           true (* but the user just asked for this to be explicit *) game ;
          (* Var.remove_var "LANGUAGE" ; *) 
          (a,b,c,sopt,Permanently_Uninstalled) :: tl
    | hd :: tl -> hd :: (is_installed tl)
***************
*** 909,915 ****
      false 
    end else if (temporarily_uninstalled tp2 i) then begin
      log_or_print "uninstall: %s %d already temporarily uninstalled\n" tp2 i ;
!     temp_to_perm_uninstalled tp2 i handle_tp2_filename ; 
      true 
    end else begin
      let rec prepare lst = match lst with
--- 1430,1436 ----
      false
    end else if (temporarily_uninstalled tp2 i) then begin
      log_or_print "uninstall: %s %d already temporarily uninstalled\n" tp2 i ;
!     temp_to_perm_uninstalled tp2 i handle_tp2_filename game ;
      true
    end else begin
      let rec prepare lst = match lst with
***************
*** 1026,1031 ****
--- 1547,1556 ----
          (fun () -> int32_of_str_off buff where) eo 
          (fun v -> (eval_pe game v)) in
        Var.set_int32 name value
+   | TP_PatchGetStrRef(which,name) ->
+       let which = Int32.to_int (eval_pe game which) in
+       let value = Dc.pretty_print_no_quote game.Load.dialog which in
+       Var.set_string name value
    | TP_PatchReadStrRef(where,name,eo) ->
        let where = Int32.to_int (eval_pe game where) in
        let value = bounds_check where 4
***************
*** 1034,1051 ****
            Dc.pretty_print_no_quote game.Load.dialog i) eo 
          (fun v -> v) in
        Var.set_string name value  
!   | TP_PatchReadAscii(where,name,eo,size_opt) ->
        let where = Int32.to_int (eval_pe game where) in
!       let size, forced = match size_opt with
!       | None -> 8, false
!       | Some(pe) -> 
!           let size = Int32.to_int (eval_pe game pe) in
!           size, true
!       in 
        let value = bounds_check where size
          (fun () -> 
!           if forced then String.sub buff where size 
!           else get_string_of_size buff where size) eo
          (fun v ->  Var.get_string v)
        in 
        Var.set_string name value
--- 1559,1571 ----
            Dc.pretty_print_no_quote game.Load.dialog i) eo
          (fun v -> v) in
        Var.set_string name value
!   | TP_PatchReadAscii(where,name,eo,size,null_terminated) ->
        let where = Int32.to_int (eval_pe game where) in
!       let size = Int32.to_int (eval_pe game size) in
        let value = bounds_check where size
          (fun () -> 
!           if null_terminated then get_string_of_size buff where size
!           else String.sub buff where size) eo
          (fun v ->  Var.get_string v)
        in 
        Var.set_string name value
***************
*** 1061,1066 ****
--- 1581,1616 ----
        ) 0 entries in
        Var.set_int32 var_name (Int32.of_int num_rows)
  
+   | TP_Get2DACols(var_name) ->
+       let lines = Str.split many_newline_or_cr_regexp buff in
+       let rec num_cols lines current =
+         match lines with
+         | [] -> current
+         | line :: rest -> num_cols rest
+         	(max (List.length (Str.split many_whitespace_regexp line)) current)
+       in
+       Var.set_int32 var_name (Int32.of_int (num_cols lines 0))
+ 
+   | TP_CountRegexpInstances(case_sens,match_exact,find, var_name) ->
+       let find = Var.get_string find in
+       let case_sens = match case_sens with
+           None -> false
+         | Some(x) -> x
+       in
+       let match_exact = match match_exact with
+           None -> false
+         | Some(x) -> x
+       in
+       let my_regexp = match case_sens, match_exact with
+           false, false -> Str.regexp_case_fold        find
+         | true , false -> Str.regexp                  find
+         | false, true  -> Str.regexp_string_case_fold find
+         | true , true  -> Str.regexp_string           find
+       in
+       let split = Str.split_delim my_regexp buff in
+       let length = List.length split in
+       Var.set_int32 var_name (Int32.of_int (length - 1))
+ 
    | TP_Read2DA(row, col, req_col, var_name) ->
        let row = Int32.to_int (eval_pe game row) in
        let col = Int32.to_int (eval_pe game col) in
***************
*** 1097,1111 ****
--- 1647,1667 ----
        handle_tp2_filename
        handle_tra_filename
        handle_d_filename
+       handle_tph_filename
+       handle_tpp_filename
        compile_baf_filename
        handle_script_buffer
        handle_dlg_buffer
        handle_d_buffer
+       get_tra_list_filename
        enqueue_tp2_filename
        emit_dlg_files
        this_tp2_filename
        tp
  = begin
+       (* allow me to use this stuff before *)
+       handle_tph_filename_global := handle_tph_filename ;
+       handle_tra_filename_global := handle_tra_filename ;
  
  (*************************************************************************
                             2da helper functions
***************
*** 1171,1182 ****
      | _ -> 
        let arr = Array.of_list tp.languages in
        let answer, answer_index = 
!         match !always_uninstall || !always_yes || !sometimes_reinstall, (installed_lang_index this_tp2_filename) with
          | true, Some(i) when i >= 0 && (i < Array.length arr) -> 
              Some(arr.(i)), i 
          | _, _ -> None, 0
        in
        let answer, answer_index = ref answer, ref answer_index in 
        while !answer = None do  
          log_and_print "\nChoose your language:\n" ;
          Array.iteri (fun i l -> 
--- 1727,1743 ----
      | _ ->
        let arr = Array.of_list tp.languages in
        let answer, answer_index =
!         match !always_uninstall || !always_yes || !sometimes_reinstall || (!force_uninstall_these <> [] && !force_install_these = [])
!                   , (installed_lang_index this_tp2_filename) with
          | true, Some(i) when i >= 0 && (i < Array.length arr) ->
              Some(arr.(i)), i
          | _, _ -> None, 0
        in
        let answer, answer_index = ref answer, ref answer_index in
+       if !forced_language >= 0 && (!forced_language < Array.length arr) then begin
+         answer := Some(arr.(!forced_language)) ;
+         answer_index := !forced_language ;
+       end ;
        while !answer = None do
          log_and_print "\nChoose your language:\n" ;
          Array.iteri (fun i l ->
***************
*** 1190,1196 ****
          with _ -> () 
        done ;
        our_lang := !answer ;
!       our_lang_index := !answer_index 
    end ;
    let lang_init () = 
      init_default_strings () ; 
--- 1751,1757 ----
          with _ -> ()
          done ;
        our_lang := !answer ;
!       our_lang_index := !answer_index ;
    end ;
    let lang_init () =
      init_default_strings () ;
***************
*** 1199,1213 ****
          None -> () 
        | Some(l) -> 
            Var.set_string "LANGUAGE" l.lang_dir_name ; 
            log_or_print "[%s] has %d top-level TRA files\n"
              l.lang_name (List.length l.lang_tra_files) ;
!           List.iter handle_tra_filename l.lang_tra_files
      end 
    in 
    Var.set_string "TP2_AUTHOR" tp.author ; 
  
    lang_init () ; 
  
  (*************************************************************************
                             process_patch2
   *************************************************************************)
--- 1760,1788 ----
          None -> ()
        | Some(l) ->
            Var.set_string "LANGUAGE" l.lang_dir_name ;
+           log_and_print "Using Language [%s]\n" l.lang_name ;
+           Var.set_string "TP2_FILE_NAME" tp.tp_filename;
            log_or_print "[%s] has %d top-level TRA files\n"
              l.lang_name (List.length l.lang_tra_files) ;
!           List.iter handle_tra_filename (List.map Arch.backslash_to_slash l.lang_tra_files)
      end
    in
    Var.set_string "TP2_AUTHOR" tp.author ;
+   Var.set_string "TP2_FILE_NAME" tp.tp_filename;
  
    lang_init () ;
  
+ 	List.iter (fun flag ->
+ 		match flag with
+ 		| Readme(str) ->
+ 			let str = Var.get_string str in
+ 			let str = "VIEW " ^ str in
+ 			let str = Arch.handle_view_command str !skip_at_view in
+ 			ignore (Unix.system (Arch.slash_to_backslash str))
+ 		| _ -> ()
+ 	)  tp.flags
+ 	;
+ 
  (*************************************************************************
                             process_patch2
   *************************************************************************)
***************
*** 1261,1266 ****
--- 1837,1844 ----
        buff
  
    | TP_PatchReplaceBCSBlock(old_file, new_file) -> begin
+       let old_file = Arch.backslash_to_slash old_file in
+       let new_file = Arch.backslash_to_slash new_file in
        let bcs_buff_of_baf_or_bcs file =
          let a,b = split (String.uppercase file) in
          if b = "BAF" then begin
***************
*** 1293,1298 ****
--- 1871,1878 ----
        end 
  
    | TP_PatchReplaceBCSBlockRE(old_file, new_file) -> begin
+       let old_file = Arch.backslash_to_slash old_file in
+       let new_file = Arch.backslash_to_slash new_file in
        let string_to_find = load_file old_file in
        let string_to_sub_in = load_file new_file in
        let my_regexp = Str.regexp string_to_find in
***************
*** 1306,1311 ****
--- 1886,1892 ----
        end 
  
    | TP_PatchApplyBCSPatch(patch_file,opt_overwrite) -> begin
+       let patch_file = Arch.backslash_to_slash patch_file in
        let patch_buff = load_file patch_file in
        try
          let new_buff, bad_chunks, app_chunks = 
***************
*** 1315,1321 ****
                "ERROR: Cannot apply patch %s (%d bad chunks).\n" 
                patch_file bad_chunks ;
              match opt_overwrite with
!             | Some(newfile) -> load_file newfile 
              | None -> failwith "Cannot Apply Patch"
            end else begin 
            if ( app_chunks > 0 ) then begin
--- 1896,1902 ----
                "ERROR: Cannot apply patch %s (%d bad chunks).\n" 
                patch_file bad_chunks ;
              match opt_overwrite with
!             | Some(newfile) -> load_file (Arch.backslash_to_slash newfile)
              | None -> failwith "Cannot Apply Patch"
            end else begin 
            if ( app_chunks > 0 ) then begin
***************
*** 1334,1340 ****
        let blanks = String.make how_many ('\000') in
        let where = Int32.to_int (eval_pe game where) in 
        let before = Str.string_before buff where in
!       let after = Str.string_after buff where in
        before ^ blanks ^ after
  
    | TP_PatchDeleteBytes(where,how_many) ->
--- 1915,1924 ----
        let blanks = String.make how_many ('\000') in
        let where = Int32.to_int (eval_pe game where) in
        let before = Str.string_before buff where in
!       let after = (* try  *)
!         Str.string_after buff where
! (*         with _ -> "" *)
!       in
        before ^ blanks ^ after
  
    | TP_PatchDeleteBytes(where,how_many) ->
***************
*** 1371,1376 ****
--- 1955,1961 ----
        buff
  
    | TP_PatchInnerBuffFile(buff_var,pl) ->
+       let buff_var = Arch.backslash_to_slash buff_var in
        let filename = Var.get_string buff_var in
        if is_true (eval_pe game (Pred_File_Exists_In_Game(PE_LiteralString filename))) then begin
          let a,b = split filename in
***************
*** 1384,1391 ****
        end ;
        buff 
  
    | TP_PatchRandomSeed(i) -> 
!       Random.init (Int32.to_int (eval_pe game i)) ;
        buff 
  
    | TP_PatchIf(pred,tb,eb) -> 
--- 1969,1994 ----
        end ;
        buff
  
+   | TP_PatchInnerBuffSave(store_var,buff_var,pl) ->
+       let new_buff = Var.get_string buff_var in
+       let filename = Printf.sprintf "INNER_PATCH_SAVE %S" buff_var in
+       let result = List.fold_left (fun acc elt ->
+           process_patch2 filename game acc elt) new_buff pl
+       in
+       Var.set_string store_var (Var.get_string result);
+       buff
+ 
    | TP_PatchRandomSeed(i) ->
!       eval_pe_warn := false ;
!       let _ = try
!           let x = (eval_pe game i) in
!           Random.init (Int32.to_int x) ;
!         with _ ->
!           begin
!             Random.self_init () ;
!           end
!       in
!       eval_pe_warn := true ;
        buff
  
    | TP_PatchIf(pred,tb,eb) ->
***************
*** 1395,1400 ****
--- 1998,2040 ----
            (if is_true (eval_pe game pred) then tb else eb) ;
        !b
  
+   | TP_Launch_Patch_Macro(str) ->
+       let (decl, actions) =
+         try
+           Hashtbl.find patch_macros (Var.get_string str)
+         with _ ->
+           failwith (Printf.sprintf "Unknown macro: -%s-" str)
+ (*           ( [] , [] ) *)
+       in
+       List.iter (fun x ->
+         match x with
+           TP_LocalSet(var,pe) ->
+             let pe = (eval_pe game pe) in
+             let var = eval_pe_str var in
+             Var.add_local_int32 var pe
+         | TP_LocalSprint (var,str) ->
+             let var = eval_pe_str var in
+             let (str : string) = eval_pe_tlk_str game str in
+             let str = Var.get_string str in
+             Var.add_local_string var str
+         | TP_LocalTextSprint (var,str) ->
+             let var = eval_pe_str var in
+             let str = Var.get_string (eval_pe_str str) in
+             Var.add_local_string var str
+       ) decl ;
+       let b = ref buff in
+       b := List.fold_left (fun acc elt ->
+         process_patch2 patch_filename game acc elt) !b actions ;
+       List.iter (fun x ->
+         match x with
+           TP_LocalSet(var,_)
+         | TP_LocalSprint(var,_) 
+         | TP_LocalTextSprint(var,_)->
+           let var = eval_pe_str var in
+           Var.remove_local var
+       ) decl ;
+     !b
+ 
    | TP_PatchWhile(pred,pl) ->
        let b = ref buff in
        while is_true (eval_pe game pred) do
***************
*** 1402,1407 ****
--- 2042,2133 ----
              process_patch2 patch_filename game acc elt) !b pl
        done ;
        !b
+ 
+   | TP_PatchBashFor(where,pl) ->
+       let find_list = ref [] in
+       List.iter ( fun (directory,exact_match,regexp_string) ->
+         try
+           let dh = Case_ins.unix_opendir directory in
+           let reg = begin match exact_match with
+               | Some(true) ->
+                 Str.regexp_string_case_fold
+               | _ ->
+                 Str.regexp_case_fold
+             end regexp_string
+           in
+           (try
+             while true do
+               let next = Unix.readdir dh in
+               if ((Case_ins.unix_stat (directory ^ "/" ^ next)).Unix.st_kind =
+                  Unix.S_REG) && (Str.string_match reg next 0) then
+                 find_list := (String.uppercase (directory ^ "/" ^ next)) :: !find_list
+             done
+           with End_of_file -> () );
+           Unix.closedir dh ;
+         with _ -> ()
+       ) where ;
+       let the_buff = ref buff in
+       List.iter (fun file ->
+         let directory = Filename.dirname file in
+         let filespec = Filename.basename file in
+         Var.set_string "BASH_FOR_DIRECTORY" directory ;
+         Var.set_string "BASH_FOR_FILESPEC" file ;
+         Var.set_string "BASH_FOR_FILE" filespec ;
+         Var.set_string "BASH_FOR_RES"
+           (let a,b = split filespec in a) ;
+         the_buff := List.fold_left (fun acc elt ->
+               process_patch2 patch_filename game acc elt) !the_buff pl
+       ) !find_list ;
+       !the_buff
+ 
+ 	| TP_PatchClearArray(arr) ->
+ 		let arr = eval_pe_str arr in
+ 		while Hashtbl.mem Var.arrays arr do
+ 			Hashtbl.remove Var.arrays arr
+ 		done;
+ 		buff
+ 
+ 	| TP_PatchDefineArray(arr,vals) ->
+ 			let i = ref 0 in
+ 			List.iter (fun x ->
+ 				Var.set_string
+ 					(eval_pe_str (PE_Dollars(arr,[get_pe_string (string_of_int !i)],
+ 						false))) x;
+ 				incr i
+ 			) vals;
+ 			buff
+ 
+ 	| TP_PatchForEach(var,sl,pl) ->
+       let var = eval_pe_str var in
+       let sl = List.map Var.get_string sl in
+       let the_buff = ref buff in
+       List.iter (fun x ->
+         Var.set_string var x ;
+         the_buff := List.fold_left (fun acc elt ->
+               process_patch2 patch_filename game acc elt) !the_buff pl
+       ) sl ;
+       !the_buff
+ 
+ 	| TP_PatchPHPEach(var,invar,outvar,pl) ->
+ 		let var_s = eval_pe_str var in
+ 		let values = Hashtbl.find Var.arrays var_s in
+ 		let outvar = eval_pe_str outvar in
+ 		let  invar = eval_pe_str  invar in
+ 		let the_buff = ref buff in
+ 		List.iter ( fun x ->
+ 			let i = ref 0 in
+ 			List.iter ( fun y ->
+ 				Var.set_string (invar ^ "_" ^ string_of_int !i) y;
+ 				incr i
+ 			) x;
+ 			let x = List.map get_pe_string x in
+ 			let this_value = eval_pe_str (PE_Dollars(var,x,true)) in
+ 			Var.set_string outvar this_value;
+         the_buff := List.fold_left (fun acc elt ->
+               process_patch2 patch_filename game acc elt) !the_buff pl
+ 		) (List.rev values);
+ 		!the_buff
+ 
    | TP_PatchFor(init,guard,inc,body) ->
        let cmd_list = init @ [ TP_PatchWhile(guard,body @ inc) ] in
        let b = ref buff in
***************
*** 1409,1428 ****
            process_patch2 patch_filename game acc elt) !b cmd_list  ;
        !b
  
!   | TP_Patch2DALater(str,r,c,value) -> 
!       let row = (eval_pe game r) in
!       let col = (eval_pe game c) in
!       eval_pe_warn := false ; 
!       let value = 
!         try 
!           let x = (eval_pe game value) in
!           Int32.to_string x 
!         with _ -> 
!           begin
!             match value with
!             | PE_String(x) -> Var.get_string (eval_pe_str x)
!             | _ -> (eval_pe_warn := true ; ignore (eval_pe game value) ; "")
!           end 
        in 
        let iidx = try Var.get_int32 ("%" ^ str ^ "%") with _ -> 0l in 
        let idx = Int32.to_string iidx in 
--- 2135,2194 ----
            process_patch2 patch_filename game acc elt) !b cmd_list  ;
        !b
  
! 	| TP_PatchReinclude(string_list) ->
! 		let string_list = List.map Var.get_string string_list in
! 		let b = ref buff in
! 		List.iter (fun file ->
! 			let tpp_parsed =
! 				if !debug_ocaml then log_and_print "Loading %s...\n" file ;
! 				let x = handle_tpp_filename file in
! 				Hashtbl.replace loaded_tpp file x ;
! 				x
! 			in
! 			b := List.fold_left (fun acc elt ->
! 			    process_patch2 patch_filename game acc elt) !b tpp_parsed ;
! 		) string_list ;
! 		!b
! 
! 	| TP_PatchInclude(string_list) ->
! 		let string_list = List.map Var.get_string string_list in
! 		let b = ref buff in
! 		List.iter (fun file ->
! 			let tpp_parsed = if Hashtbl.mem loaded_tpp file
! 				then begin
! 					if !debug_ocaml then log_and_print "%s is already loaded, restoring the image...\n" file ;
! 					Hashtbl.find loaded_tpp file
! 				end
! 				else begin
! 					if !debug_ocaml then log_and_print "Loading %s...\n" file ;
! 					let x = handle_tpp_filename file in
! 					Hashtbl.replace loaded_tpp file x ;
! 					x
! 				end
! 			in
! 			b := List.fold_left (fun acc elt ->
! 			    process_patch2 patch_filename game acc elt) !b tpp_parsed ;
! 		) string_list ;
! 		!b
! 
!   | TP_PatchSilent -> be_silent := true ; buff
!   | TP_PatchVerbose -> be_silent := false ; buff
! 
!   | TP_Patch2DALater(str,r,c,value) ->
!       let row = (eval_pe game r) in
!       let col = (eval_pe game c) in
!       let str = Var.get_string str in
!       eval_pe_warn := false ;
!       let value =
!         try
!           let x = (eval_pe game value) in
!           Int32.to_string x
!         with _ ->
!           begin
!             match value with
!             | PE_String(x) -> Var.get_string (eval_pe_str x)
!             | _ -> (eval_pe_warn := true ; ignore (eval_pe game value) ; "")
!           end
        in
        let iidx = try Var.get_int32 ("%" ^ str ^ "%") with _ -> 0l in
        let idx = Int32.to_string iidx in
***************
*** 1435,1440 ****
--- 2201,2207 ----
  
    | TP_Patch2DANow(str, req_col) ->
        let req_col = Int32.to_int (eval_pe game req_col) in
+       let str = Var.get_string str in
        let lines = Str.split many_newline_or_cr_regexp buff in
        let max = ref 4 in
        let entries = List.map (fun line ->
***************
*** 1468,1474 ****
                   Hashtbl.find updates (!this_line,this_col)
                else orig_elt 
              in 
!             Printf.bprintf buf "%-.*s\t" !max elt
            ) entry_array ;
            Buffer.add_char buf '\n' ;
            if this_col_size >= req_col then incr this_line ; 
--- 2235,2241 ----
                   Hashtbl.find updates (!this_line,this_col)
                else orig_elt 
              in
!             Printf.bprintf buf "%-.*s " !max elt
            ) entry_array ;
            Buffer.add_char buf '\n' ;
            if this_col_size >= req_col then incr this_line ;
***************
*** 1477,1482 ****
--- 2244,2330 ----
        with _ -> buff
        end
  
+   | TP_PrettyPrint2DA(indent) ->
+     List.fold_left (fun acc elt ->
+             process_patch2 patch_filename game acc elt) buff
+       [TP_PatchSet(get_pe_string "tb#pretty_print_indent", indent);
+        TP_PatchInclude ["tb#pretty_print.tpp"]]
+ 
+   | TP_Read2DANow(str, req_col) ->
+       let req_col = Int32.to_int (eval_pe game req_col) in
+       let lines = Str.split many_newline_or_cr_regexp buff in
+       let str = Var.get_string str in
+       let i = ref 0 in
+       let j = ref 0 in (* line and column counters *)
+       List.iter (fun this_line ->
+         let this_line = Str.split many_whitespace_regexp this_line in
+         if (List.length this_line) >= req_col then begin
+           j := 0;
+           List.iter ( fun item ->
+             let name = Printf.sprintf "%s_%d_%d" str !i !j in
+             Var.set_string name item;
+             j := !j + 1;
+           ) this_line;
+           i := !i + 1;
+         end
+       ) lines;
+       let name = Printf.sprintf "%s" str in
+       Var.set_int32 name (Int32.of_int !i);
+       buff
+ 
+   | TP_Read2DAFormer(str, row, col, var) ->
+     let row = Int32.to_int (eval_pe game row) in
+     let col = Int32.to_int (eval_pe game col) in
+     let str = Var.get_string str in
+     let str = Printf.sprintf "%%%s_%d_%d%%" str row col in
+     if !debug_ocaml then log_and_print "%s reports to %s\n" str (Var.get_string str) ;
+     Var.set_string var (Var.get_string_exact str);
+     buff
+ 
+   | TP_PatchInsert2DARow(row,req_col,value) ->
+       let row = Int32.to_int (eval_pe game row) in
+       let req_col = Int32.to_int (eval_pe game req_col) in
+       let lines = Str.split many_newline_or_cr_regexp buff in
+       eval_pe_warn := false ;
+       let value =
+         try
+           let x = (eval_pe game value) in
+           Int32.to_string x
+         with _ ->
+           begin
+             match value with
+             | PE_String(x) -> Var.get_string (eval_pe_str x)
+             | _ -> (eval_pe_warn := true ; ignore (eval_pe game value) ; "")
+           end
+       in
+       let before = ref "" in
+       let num_rows = ref 0 in
+       let found = ref false in
+       let avoid_first_nl = ref true in
+       List.iter ( fun the_row ->
+         before := !before ^ (if !avoid_first_nl then "" else "\r\n") ;
+         if !avoid_first_nl then avoid_first_nl := false ;
+         if !num_rows < row then begin
+           let long_enough = ((List.length (Str.split many_whitespace_regexp the_row)) >= req_col) in
+           if long_enough then num_rows := !num_rows + 1 ;
+         end else
+         if !num_rows = row then begin
+           let long_enough = ((List.length (Str.split many_whitespace_regexp the_row)) >= req_col) in
+           if long_enough then begin
+             num_rows := !num_rows + 1 ;
+             before := !before ^ value ^ "\r\n" ;
+             found := true ;
+           end ;
+         end ;
+         before := !before ^ the_row
+       ) lines ;
+       if !num_rows = row then begin
+         before := !before ^ "\r\n" ^ value ;
+         found := true ;
+       end ;
+       if not (!found) then failwith "Failed to find enough lines to perform an INSERT_2DA_ROW" ;
+       !before ^ "\r\n" ;
+ 
    | TP_Patch2DA(row,col,req_col,value) ->
        let row = Int32.to_int (eval_pe game row) in
        let col = Int32.to_int (eval_pe game col) in
***************
*** 1559,1576 ****
          "" entries
          *)
  
!   | TP_PatchStringTextually(find,what) -> 
        let find = Var.get_string find in 
-       let my_regexp = Str.regexp_case_fold find in
        let what = Var.get_string what in 
        Str.global_replace my_regexp what buff 
  
!   | TP_PatchStringEvaluate(find, pl, replace) -> 
        (* REPLACE_EVALUATE ~Give(\([0-9]+\))~ 
                            SET "RESULT" = "%MATCH1%" 
                            ~Give(%RESULT%)~ 
           ( "%MATCH%" / 2 ) *)
!       let my_regexp = Str.regexp find in
        let i = ref 0 in 
        let work_buff = ref buff in 
        (try 
--- 2407,2465 ----
          "" entries
          *)
  
!   | TP_PatchStringTextually(case_sens,match_exact,find,what,length) ->
        let find = Var.get_string find in
        let what = Var.get_string what in
+       let find_ref = ref find in
+       let what_ref = ref what in
+       let case_sens = match case_sens with
+           None -> false
+         | Some(x) -> x
+       in
+       let match_exact = match match_exact with
+           None -> false
+         | Some(x) -> x
+       in
+       begin match length with
+           None -> ()
+         | Some(x) -> begin
+           let y = Int32.to_int (eval_pe game x) in
+           while String.length !what_ref < y do
+             what_ref := !what_ref ^ (String.make 1 (Char.chr 0)) ;
+           done ;
+           while String.length !find_ref < y do
+             find_ref := !find_ref ^ (String.make 1 (Char.chr 0)) ;
+           done ;
+           if !debug_ocaml then begin
+             for i = 0 to ( String.length !what_ref) - 1 do
+               let from_c = String.get !find_ref i in
+               let what_c = String.get !what_ref i in
+               log_and_print "%c[%d] -> %c[%d] \n" from_c (Char.code from_c) what_c (Char.code what_c) ;
+             done
+           end ;
+         end ;
+       end ;
+       let find = !find_ref in
+       let my_regexp = match case_sens, match_exact with
+           false, false -> Str.regexp_case_fold        find
+         | true , false -> Str.regexp                  find
+         | false, true  -> Str.regexp_string_case_fold find
+         | true , true  -> Str.regexp_string           find
+       in
+       let what = !what_ref in
        Str.global_replace my_regexp what buff
  
!   | TP_PatchStringEvaluate(case_sens,find, pl, replace) ->
        (* REPLACE_EVALUATE ~Give(\([0-9]+\))~ 
                            SET "RESULT" = "%MATCH1%"
                            ~Give(%RESULT%)~
           ( "%MATCH%" / 2 ) *)
!       let find = Var.get_string find in
!       let my_regexp = match case_sens with
!           None -> Str.regexp find
!         | Some(true) -> Str.regexp find
!         | Some(false) -> Str.regexp_case_fold find
!       in
        let i = ref 0 in
        let work_buff = ref buff in
        (try
***************
*** 1601,1608 ****
        with _ -> () ) ;
        !work_buff
  
!   | TP_PatchString(find,what) -> 
!       let my_regexp = Str.regexp_case_fold find in
        let new_index = match Dc.resolve_tlk_string game what with
          Dlg.TLK_Index(i) -> i
        | _ -> log_and_print "ERROR: cannot resolve REPLACE patch\n" ; failwith "resolve" 
--- 2490,2521 ----
        with _ -> () ) ;
        !work_buff
  
!   | TP_PatchString(case_sens,match_exact,find,what) ->
!       let find = Var.get_string find in
!       let case_sens = match case_sens with
!           None -> false
!         | Some(x) -> x
!       in
!       let match_exact = match match_exact with
!           None -> false
!         | Some(x) -> x
!       in
!       let my_regexp = match case_sens, match_exact with
!           false, false -> Str.regexp_case_fold        find
!         | true , false -> Str.regexp                  find
!         | false, true  -> Str.regexp_string_case_fold find
!         | true , true  -> Str.regexp_string           find
!       in
!       let what = begin match what with
!       | Dlg.Trans_String(a) -> what
!       | Dlg.Local_String(lse) ->
!           Dlg.Local_String ({ lse_male = Var.get_string lse.lse_male ;
!                                lse_male_sound = Var.get_string lse.lse_male_sound ;
!                                    lse_female = Var.get_string lse.lse_female ;
!                              lse_female_sound = Var.get_string lse.lse_female_sound ; })
!       | _ -> what
!       end
!       in
        let new_index = match Dc.resolve_tlk_string game what with
          Dlg.TLK_Index(i) -> i
        | _ -> log_and_print "ERROR: cannot resolve REPLACE patch\n" ; failwith "resolve"
***************
*** 1632,1642 ****
        bounds_check_write where 4 str ; 
        String.blit str 0 buff where 4 ;
        buff
!   | TP_PatchAppendFile(filename) ->  
        let file_buff = load_file filename in 
!       buff ^ file_buff
  
    | TP_PatchWriteFile(where,filename,insert) ->  
        let where = Int32.to_int (eval_pe game where) in 
        let filename = Var.get_string filename in 
        let file_buff = load_file filename in 
--- 2545,2558 ----
        bounds_check_write where 4 str ;
        String.blit str 0 buff where 4 ;
        buff
!   | TP_PatchAppendFile(filename, eval) ->
!       let filename = Arch.backslash_to_slash filename in
!       let filename = Var.get_string filename in
        let file_buff = load_file filename in
!       buff ^ (if eval then Var.get_string file_buff else file_buff)
  
    | TP_PatchWriteFile(where,filename,insert) ->
+       let filename = Arch.backslash_to_slash filename in
        let where = Int32.to_int (eval_pe game where) in 
        let filename = Var.get_string filename in 
        let file_buff = load_file filename in
***************
*** 1662,1667 ****
--- 2578,2584 ----
        let what = match reqdSize with
        | None -> what
        | Some(i) -> 
+         let i = (Int32.to_int (eval_pe game i)) in
          let res = String.make i '\000' in
          String.blit what 0 res 0 (min i (String.length what)) ;
          res
***************
*** 1670,1675 ****
--- 2587,2600 ----
        String.blit what 0 buff where (String.length what) ;
        buff
  
+   | TP_PatchASCIITerminated(where,what) ->
+       let where = Int32.to_int (eval_pe game where) in
+       let what = Var.get_string what in
+       let what = what ^ "\000" in
+       bounds_check_write where (String.length what) what ;
+       String.blit what 0 buff where (String.length what) ;
+       buff
+ 
    | TP_Patch_Gam(cre_name,area,x,y) ->
  
          (* Patch baldur.gam in save directories *)
***************
*** 1697,1702 ****
--- 2622,2629 ----
          write_int npc_entry_buff 0x4 (variable_off + 352);
          write_int npc_entry_buff 0x8 (String.length buff);
          String.blit area 0 npc_entry_buff 0x18 (String.length area);
+         let x = (Int32.to_int (eval_pe game x)) in
+         let y = (Int32.to_int (eval_pe game y)) in
          write_short npc_entry_buff 0x20 x;
          write_short npc_entry_buff 0x22 y;
  
***************
*** 1718,1726 ****
          let cre_chunk = String.sub baldur_buff last_npc_off (variable_off - last_npc_off) in
          let new_buff = before ^ npc_entry_buff ^ cre_chunk ^ buff ^ after in
  
!         let oc = open_out_bin (filename ^ "/baldur.gam") in
          output_string oc new_buff;
          close_out oc;
          end) dlist;
  
          (* Patch baldur.gam in mpsave directories *)
--- 2645,2660 ----
          let cre_chunk = String.sub baldur_buff last_npc_off (variable_off - last_npc_off) in
          let new_buff = before ^ npc_entry_buff ^ cre_chunk ^ buff ^ after in
  
!         let oc = Case_ins.perv_open_out_bin (filename ^ "/baldur.gam") in
          output_string oc new_buff;
          close_out oc;
+     begin (* handle read-only files! *)
+       try
+         Case_ins.unix_chmod (filename ^ "/baldur.gam") 511 ; (* 511 = octal 0777 = a+rwx *)
+       with e -> ()
+         (* log_or_print "WARNING: chmod %s : %s\n" filename 
+           (Printexc.to_string e) *)
+     end ;
          end) dlist;
  
          (* Patch baldur.gam in mpsave directories *)
***************
*** 1748,1753 ****
--- 2682,2689 ----
          write_int npc_entry_buff 0x4 (variable_off + 352);
          write_int npc_entry_buff 0x8 (String.length buff);
          String.blit area 0 npc_entry_buff 0x18 (String.length area);
+         let x = (Int32.to_int (eval_pe game x)) in
+         let y = (Int32.to_int (eval_pe game y)) in
          write_short npc_entry_buff 0x20 x;
          write_short npc_entry_buff 0x22 y;
  
***************
*** 1769,1777 ****
          let cre_chunk = String.sub baldur_buff last_npc_off (variable_off - last_npc_off) in
          let new_buff = before ^ npc_entry_buff ^ cre_chunk ^ buff ^ after in
  
!         let oc = open_out_bin (filename ^ "/baldur.gam") in
          output_string oc new_buff;
          close_out oc;
          end) mpdlist;
  
          (* Patch the baldur.gam in the biff *)
--- 2705,2720 ----
          let cre_chunk = String.sub baldur_buff last_npc_off (variable_off - last_npc_off) in
          let new_buff = before ^ npc_entry_buff ^ cre_chunk ^ buff ^ after in
  
!         let oc = Case_ins.perv_open_out_bin (filename ^ "/baldur.gam") in
          output_string oc new_buff;
          close_out oc;
+         begin (* handle read-only files! *)
+           try
+             Case_ins.unix_chmod (filename ^ "/baldur.gam") 511 ; (* 511 = octal 0777 = a+rwx *)
+           with e -> ()
+             (* log_or_print "WARNING: chmod %s : %s\n" filename
+               (Printexc.to_string e) *)
+         end ;
          end) mpdlist;
  
          (* Patch the baldur.gam in the biff *)
***************
*** 1791,1796 ****
--- 2734,2741 ----
          let npc_entry_buff = String.make 352 '\000' in
          String.blit (String.uppercase cre_name) 0 npc_entry_buff 0xc (String.length cre_name);
          String.blit area 0 npc_entry_buff 0x18 (String.length area);
+         let x = (Int32.to_int (eval_pe game x)) in
+         let y = (Int32.to_int (eval_pe game y)) in
          write_short npc_entry_buff 0x20 x;
          write_short npc_entry_buff 0x22 y;
          for i = 140 to 147 do
***************
*** 1813,1827 ****
          let after = Str.string_after nbaldur_buff party_npc_off in
          let new_buff = before ^ npc_entry_buff ^ after in
  
!         let oc = open_out_bin "override/baldur.gam" in
          output_string oc new_buff;
          close_out oc;
          buff
  
    | TP_Remove_Known_Spell(sp_list) ->
  
        (* Check for version *)
! 
        let cre_v = String.sub buff 0 8 in
        (match cre_v with
        | "CRE V1.0" ->
--- 2758,2779 ----
          let after = Str.string_after nbaldur_buff party_npc_off in
          let new_buff = before ^ npc_entry_buff ^ after in
  
!         let oc = Case_ins.perv_open_out_bin "override/baldur.gam" in
          output_string oc new_buff;
          close_out oc;
+         begin (* handle read-only files! *)
+           try
+             Case_ins.unix_chmod "override/baldur.gam" 511 ; (* 511 = octal 0777 = a+rwx *)
+           with e -> ()
+             (* log_or_print "WARNING: chmod %s : %s\n" filename
+               (Printexc.to_string e) *)
+         end ;
          buff
  
    | TP_Remove_Known_Spell(sp_list) ->
  
        (* Check for version *)
!       let sp_list = List.map Var.get_string sp_list in
        let cre_v = String.sub buff 0 8 in
        (match cre_v with
        | "CRE V1.0" ->
***************
*** 1914,1939 ****
  
          !work_buff
  
!      | _ -> failwith "ERROR: REMOVE_KNOWN_SPELL: Unknown cre version %s" cre_v);
! 
!   | TP_Add_Known_Spell(spell,level,sp_type) ->
!       
!       (* Create the new known spell *)
  
!       let spell_buff = String.make 12 '\000' in
!       String.blit spell 0 spell_buff 0 (String.length spell);
!       write_short spell_buff 8 level;
! 
!       let new_type =
!       (match (String.uppercase sp_type) with
!       | "PRIEST" -> 0
!       | "INNATE" -> 2
!       | "WIZARD" -> 1
!       | _ -> log_and_print "WARNING: ADD_NEW_SPELL: Unknown flag %s.  Defaulting to INNATE for spell type.\n" (String.uppercase sp_type);
!              2)
!       in
! 
!       write_short spell_buff 10 new_type ;
  
        (* Check for version *)
        
--- 2866,2877 ----
  
          !work_buff
  
!      | _ -> failwith (Printf.sprintf "ERROR: REMOVE_KNOWN_SPELL: Unknown cre version %s" cre_v));
  
!   | TP_Remove_Memorized_Spell(sp_list) ->
!     if !debug_ocaml then List.iter (fun x -> log_and_print "Trying to remove %s\n" x) sp_list ;
!     let sp_list = List.map (fun x -> String.uppercase(Var.get_string x)) sp_list in
!     if !debug_ocaml then List.iter (fun x -> log_and_print "Trying to remove %s\n" x) sp_list ;
  
        (* Check for version *)
  
***************
*** 1941,1983 ****
        (match cre_v with
        | "CRE V1.0" ->
  
!         let spellmemoff = int_of_str_off buff 0x2a8 in
!         let memspelloff = int_of_str_off buff 0x2b0 in
!         let itemsslotoff = int_of_str_off buff 0x2b8 in
!         let itemsoff = int_of_str_off buff 0x2bc in
!         let effoff = int_of_str_off buff 0x2c4 in
!         write_int buff 0x2a8 (spellmemoff + 12);
!         write_int buff 0x2b0 (memspelloff + 12);
!         write_int buff 0x2b8 (itemsslotoff + 12);
!         write_int buff 0x2bc (itemsoff + 12);
!         write_int buff 0x2c4 (effoff + 12);
!         let knownspelloff = int_of_str_off buff 0x2a0 in
!         let numknownspells = int_of_str_off buff 0x2a4 in
!         write_int buff 0x2a4 (numknownspells + 1);
!         let before_buff = Str.string_before buff knownspelloff in
!         let after_buff = Str.string_after buff knownspelloff in
!         before_buff ^ spell_buff ^ after_buff
  
       | "CRE V9.0" ->
  
!         let spellmemoff = int_of_str_off buff 0x310 in
!         let memspelloff = int_of_str_off buff 0x318 in
!         let itemsslotoff = int_of_str_off buff 0x320 in
!         let itemsoff = int_of_str_off buff 0x324 in
!         let effoff = int_of_str_off buff 0x32c in
!         write_int buff 0x310 (spellmemoff + 12);
!         write_int buff 0x318 (memspelloff + 12);
!         write_int buff 0x320 (itemsslotoff + 12);
!         write_int buff 0x324 (itemsoff + 12);
!         write_int buff 0x32c (effoff + 12);
!         let knownspelloff = int_of_str_off buff 0x308 in
!         let numknownspells = int_of_str_off buff 0x30c in
!         write_int buff 0x30c (numknownspells + 1);
!         let before_buff = Str.string_before buff knownspelloff in
!         let after_buff = Str.string_after buff knownspelloff in
!         before_buff ^ spell_buff ^ after_buff
  
!      | _ -> failwith "ERROR: ADD_NEW_SPELL: Unknown cre version %s" cre_v);
  
    | TP_Add_Map_Note(m) ->
  
--- 2879,3034 ----
        (match cre_v with
        | "CRE V1.0" ->
  
!         let spellmemoff = int_of_str_off buff 0x2b0 in
!         let nummempells = int_of_str_off buff 0x2b4 in
!         let effectsoff  = int_of_str_off buff 0x2c4 in
! 
!         (* Grab all spells *)
! 
!         let spell_list = ref [] in
!         let spell_string = String.sub buff spellmemoff (effectsoff - spellmemoff) in
!         for i = 0 to nummempells - 1 do
!           let spell_check = String.sub spell_string (i * 12) 8 in
!           let spell_check = get_string_of_size spell_check 0 8 in
!           spell_list := (String.uppercase spell_check) :: !spell_list
!         done;
! 
!         spell_list := List.rev !spell_list;
! 
!         let i = ref 0 in
!         let match_count = ref 0 in
!         let work_buff = ref buff in
!         List.iter (fun spell_name ->
!           if !debug_ocaml then log_and_print "I'm doing %s\n" spell_name ;
!           if List.mem spell_name sp_list then begin
!           let itemsslotoff = int_of_str_off !work_buff 0x2b8 in
!           let itemsoff = int_of_str_off !work_buff 0x2bc in
!           let effoff = int_of_str_off !work_buff 0x2c4 in
!           let nummemspells = int_of_str_off !work_buff 0x2b4 in
!           let memoroff = int_of_str_off buff 0x2a8 in
!           let memornum = int_of_str_off buff 0x2ac in
!           write_int !work_buff 0x2b8 (itemsslotoff - 12);
!           write_int !work_buff 0x2bc (itemsoff - 12);
!           write_int !work_buff 0x2c4 (effoff - 12);
!           write_int !work_buff 0x2b4 (nummemspells - 1);
!           let before_buff = Str.string_before !work_buff (spellmemoff + ((!i - !match_count) * 12)) in
!           let after_buff = Str.string_after !work_buff (spellmemoff + ((!i - !match_count) * 12) + 12) in
!           work_buff := before_buff ^ after_buff ;
!           for j = 0 to memornum - 1 do
!             let leveloff = int_of_str_off !work_buff (memoroff + 16 * j + 8) in
!             let levelnum = int_of_str_off !work_buff (memoroff + 16 * j + 12) in
!             if leveloff > !i - !match_count then write_int !work_buff (memoroff + 16 * j + 8) (leveloff - 1)
!               else if leveloff + levelnum > !i - !match_count then
!                   write_int !work_buff (memoroff + 16 * j + 12) (levelnum - 1) ;
!           done ;
!           incr i ;
!           incr match_count
!         end else
!         incr i) !spell_list ;
! 
!         !work_buff
  
        | "CRE V9.0" ->
  
!         let spellmemoff = int_of_str_off buff 0x318 in
!         let nummempells = int_of_str_off buff 0x31c in
!         let effectsoff  = int_of_str_off buff 0x32c in
! 
!         (* Grab all spells *)
! 
!         let spell_list = ref [] in
!         let spell_string = String.sub buff spellmemoff (effectsoff - spellmemoff) in
!         for i = 0 to nummempells - 1 do
!           let spell_check = String.sub spell_string (i * 12) 8 in
!           let spell_check = get_string_of_size spell_check 0 8 in
!           spell_list := (String.uppercase spell_check) :: !spell_list
!         done;
! 
!         spell_list := List.rev !spell_list;
! 
!         let i = ref 0 in
!         let match_count = ref 0 in
!         let work_buff = ref buff in
!         List.iter (fun spell_name ->
!           if !debug_ocaml then log_and_print "I'm doing %s\n" spell_name ;
!           if List.mem spell_name sp_list then begin
!           let itemsslotoff = int_of_str_off !work_buff 0x320 in
!           let itemsoff = int_of_str_off !work_buff 0x324 in
!           let effoff = int_of_str_off !work_buff 0x32c in
!           let nummemspells = int_of_str_off !work_buff 0x31c in
!           let memoroff = int_of_str_off buff 0x310 in
!           let memornum = int_of_str_off buff 0x314 in
!           write_int !work_buff 0x320 (itemsslotoff - 12);
!           write_int !work_buff 0x324 (itemsoff - 12);
!           write_int !work_buff 0x32c (effoff - 12);
!           write_int !work_buff 0x31c (nummemspells - 1);
!           let before_buff = Str.string_before !work_buff (spellmemoff + ((!i - !match_count) * 12)) in
!           let after_buff = Str.string_after !work_buff (spellmemoff + ((!i - !match_count) * 12) + 12) in
!           work_buff := before_buff ^ after_buff ;
!           for j = 0 to memornum - 1 do
!             let leveloff = int_of_str_off !work_buff (memoroff + 16 * j + 8) in
!             let levelnum = int_of_str_off !work_buff (memoroff + 16 * j + 12) in
!             if leveloff > !i - !match_count then write_int !work_buff (memoroff + 16 * j + 8) (leveloff - 1)
!               else if leveloff + levelnum > !i - !match_count then
!                   write_int !work_buff (memoroff + 16 * j + 12) (levelnum - 1) ;
!           done ;
!           incr i ;
!           incr match_count
!         end else
!         incr i) !spell_list ;
! 
!         !work_buff
  
!      | _ -> failwith (Printf.sprintf "ERROR: REMOVE_KNOWN_SPELL: Unknown cre version %s" cre_v));
! 
!   | TP_Add_Known_Spell(spell,level,sp_type) ->
! 		let cre = Cre.cre_of_string buff in
! 		let level = (Int32.to_int (eval_pe game level)) in
! 		let known_spells = cre.Cre.known_spells in
! 		let new_type =
! 			(match (String.uppercase sp_type) with
! 			| "PRIEST" -> 0
! 			| "INNATE" -> 2
! 			| "WIZARD" -> 1
! 			| _ -> log_and_print "WARNING: ADD_NEW_SPELL: Unknown flag %s.  Defaulting to INNATE for spell type.\n" (String.uppercase sp_type);
! 			2)
! 		in
! 		let this = (spell, level, new_type) in
! 		let known_spells = if not (List.exists (fun cur ->
! 			let (ospell, olevel, otype) = cur in
! 			(String.uppercase ospell = String.uppercase spell) && olevel = level
! 			  && otype = new_type
! 		) known_spells) then
! 			this :: known_spells else known_spells
! 		in
! 		Cre.string_of_cre { cre with Cre.known_spells = known_spells }
! 
! 	| TP_Add_Memorized_Spell(spell,level,stype,spcount) ->
! 		let cre = Cre.cre_of_string buff in
! 		let nlevel = (Int32.to_int (eval_pe game level)) in
! 		let memorized_info = ref cre.Cre.memorized_info in
! 		let spcount = Int32.to_int (eval_pe game spcount) in
! 		let new_type =
! 			(match (String.uppercase stype) with
! 			| "PRIEST" -> 0
! 			| "INNATE" -> 2
! 			| "WIZARD" -> 1
! 			| _ -> log_and_print "WARNING: ADD_NEW_SPELL: Unknown flag %s.  Defaulting to INNATE for spell type.\n" (String.uppercase stype);
! 			2)
! 		in
! 		for j = 1 to spcount do
!  			memorized_info := List.map (fun (level,count,count2, spell_type, mlist)->
! 				if (new_type = spell_type && level = nlevel) then begin
! 					let length = List.length mlist in
! 					let mlist = (spell,true) :: mlist in
! 					let i n = if n <= length then length + 1 else n in
! 					(level, i count, i count2, spell_type, mlist)
! 				end else
! 					(level,count,count2,spell_type,mlist)
! 			) !memorized_info
! 		done;
! 		process_patch2 patch_filename game (Cre.string_of_cre { cre with Cre.memorized_info = !memorized_info })
! 		  (TP_Add_Known_Spell(spell,level,stype))
  
    | TP_Add_Map_Note(m) ->
  
***************
*** 1999,2006 ****
  	  (* Create the new automap *)
  
        let auto_buff = String.make 52 '\000' in
!       write_short auto_buff 0 m.xcoord;
!       write_short auto_buff 2 m.ycoord;
        write_byte auto_buff 8 1;
        write_byte auto_buff 10 colour_flags;
  
--- 3050,3059 ----
        (* Create the new automap *)
  
        let auto_buff = String.make 52 '\000' in
!       let xcoord = (Int32.to_int (eval_pe game m.xcoord)) in
!       let ycoord = (Int32.to_int (eval_pe game m.ycoord)) in
!       write_short auto_buff 0 xcoord;
!       write_short auto_buff 2 ycoord;
        write_byte auto_buff 8 1;
        write_byte auto_buff 10 colour_flags;
  
***************
*** 2033,2039 ****
           write_int buff 0xd8 (auto_num + 1)
  		 end else
           write_int buff 0xd8 (auto_num + 1)
! 	   | _ -> failwith "ADD_MAP_NOTE: Unknown area version %s" area_v);
  
  	  (* Splice it all together *)
  
--- 3086,3092 ----
           write_int buff 0xd8 (auto_num + 1)
           end else
           write_int buff 0xd8 (auto_num + 1)
!        | _ -> failwith (Printf.sprintf "ADD_MAP_NOTE: Unknown area version %s" area_v));
  
        (* Splice it all together *)
  
***************
*** 2041,2046 ****
--- 3094,3100 ----
  
    | TP_PatchPrint(msg) ->
          let str = Dc.single_string_of_tlk_string game msg in
+         be_silent := false ;
          let str = Var.get_string str in
          log_and_print "\n%s\n" str ;
          buff
***************
*** 2052,2057 ****
--- 3106,3141 ----
          Var.set_string name value  ;
          buff
  
+   | TP_PatchTextSprint (var,str) ->
+       let var = eval_pe_str var in
+       let str = Var.get_string (eval_pe_str str) in
+       Var.add_local_string var str ;
+       buff
+ 
+   | TP_PatchSpaces (var,str) ->
+       let var = eval_pe_str var in
+       let str = Var.get_string (eval_pe_str str) in
+       Var.add_local_string var (String.make (String.length str) ' ') ;
+       buff
+ 
+   | TP_PatchQuote (var,str) ->
+       let var = eval_pe_str var in
+       let str = Var.get_string (eval_pe_str str) in
+       Var.add_local_string var (Str.quote str) ;
+       buff
+ 
+   | TP_PatchToLower(name) ->
+         let name = eval_pe_str name in
+         let value = Var.get_string_exact ("%" ^ name ^ "%") in
+         Var.set_string name (String.lowercase value) ;
+         buff
+ 
+   | TP_PatchToUpper(name) ->
+         let name = eval_pe_str name in
+         let value = Var.get_string_exact ("%" ^ name ^ "%") in
+         Var.set_string name (String.uppercase value) ;
+         buff
+ 
    | TP_PatchSnprint(size,name,msg) ->
          let name = eval_pe_str name in
          let str = eval_pe_tlk_str game msg in
***************
*** 2076,2088 ****
  
        let item_buff = String.make 20 '\000' in
        String.blit i.item_name 0 item_buff 0 (String.length i.item_name);
!       write_short item_buff 0xa i.i_charge1;
!       write_short item_buff 0xc i.i_charge2;
!       write_short item_buff 0xe i.i_charge3;
  
        (* Make the item type into something usable *)
        let type_word_list = Str.split many_whitespace_regexp i.item_slot in
!       let possible_slots = List.map (fun str -> match str with
        | "HELMET" -> 0
        | "ARMOR" -> 2
        | "SHIELD" -> 4
--- 3160,3187 ----
  
        let item_buff = String.make 20 '\000' in
        String.blit i.item_name 0 item_buff 0 (String.length i.item_name);
!       let i_charge1 = (Int32.to_int (eval_pe game i.i_charge1)) in
!       let i_charge2 = (Int32.to_int (eval_pe game i.i_charge2)) in
!       let i_charge3 = (Int32.to_int (eval_pe game i.i_charge3)) in
!       write_short item_buff 0xa i_charge1;
!       write_short item_buff 0xc i_charge2;
!       write_short item_buff 0xe i_charge3;
  
        (* Make the item type into something usable *)
+       let i = { i with item_slot = List.fold_left (
+           fun acc (from, into) ->
+             Str.global_replace (Str.regexp_case_fold from) into acc)
+             (" " ^ i.item_slot ^ " ")
+               [("[ \t]QITEM[ \t]"," QITEM1 QITEM2 QITEM3 ");
+                ("[ \t]QUIVER[ \t]"," QUIVER1 QUIVER2 QUIVER3 ");
+                ("[ \t]RING[ \t]"," LRING RRING ");
+                ("[ \t]INV[ \t]",
+                   " INV1 INV2 INV3 INV4 INV5 INV6 INV7 INV8 INV9 INV10 INV11 INV12 INV13 INV14 INV15 INV16 ")]
+                ;
+         }
+       in
        let type_word_list = Str.split many_whitespace_regexp i.item_slot in
!       let possible_slots = List.map (fun str -> match String.uppercase str with
        | "HELMET" -> 0
        | "ARMOR" -> 2
        | "SHIELD" -> 4
***************
*** 2217,2225 ****
          end;
  
          (* Check if it's a weapon and select the appropriate slot *)
!         let real_slot = find_empty_slot islot_off possible_slots in 
          if i.equip && real_slot >= 18 && real_slot <= 24 then begin 
!           let i_num = (real_slot - 18) / 2 in 
            write_short buff (islot_off + 76) (i_num - 1)
          end;
          (* Splice it all together *)
--- 3316,3385 ----
          end;
  
          (* Check if it's a weapon and select the appropriate slot *)
!         (* let real_slot = find_empty_slot islot_off possible_slots in *)
!         let real_slot = itype in
!         if i.equip && real_slot >= 18 && real_slot <= 24 then begin
!           let i_num = (real_slot - 16) / 2 in
!           write_short buff (islot_off + 76) (i_num - 1)
!         end ;
!         (* Splice it all together *)
!         let splice_off = items_off + (num_items * 20) in
!         let before_buff = Str.string_before buff splice_off in
!         let after_buff = Str.string_after buff splice_off in
!         before_buff ^ item_buff ^ after_buff
! 
!       | "CRE V2.2" ->
! 
!         (* Read in the offsets we need to update and grab the plus state *)
! 
!         let islot_off = int_of_str_off buff 0x612 in
!         let itype = find_empty_slot islot_off possible_slots in
!         let items_off = int_of_str_off buff 0x616 in
!         let num_items = int_of_str_off buff 0x61a in
!         let possible_plus = i.twohanded_weapon in
!         write_int buff 0x612 (islot_off + 20);
!         write_int buff 0x61a (num_items + 1);
! 
!         (* Check and see if we want to equip the item *)
!         if i.equip then begin
!           (* If it's a two-handed weapon, empty the shield slot. *)
!           if not possible_plus then begin
!             let shield_slot = short_of_str_off buff (islot_off + 4) in
!             write_empty_inv_slot buff (islot_off + 42) shield_slot ;
!             write_short buff (islot_off + 4) 65535 ;
!             let slot = short_of_str_off buff (islot_off + itype) in
!             if slot <> 65535 then begin
!               write_empty_inv_slot buff (islot_off + 42) slot;
!               write_short buff (islot_off + itype) num_items;
!             end else
!               write_short buff (islot_off + itype) num_items;
!           end else (* possible_plus *) begin
!             (* Not a two-handed weapon, just empty the slot and move any item
!                in the slot to the inventory *)
!             let slot = short_of_str_off buff (islot_off + itype) in
!             if slot = 65535 then
!               write_short buff (islot_off + itype) num_items
!             else begin
!               write_empty_inv_slot buff (islot_off + 42) slot ;
!               write_short buff (islot_off + itype) num_items;
!             end;
!           end;
!         end (* end of: if equip *) else begin
!           (* We're not equipping anything here, so just move any
!              item that may be in the slot to inventory *)
!           let slot = short_of_str_off buff (islot_off + itype) in
!           if slot <> 65535 then begin
!             write_empty_inv_slot buff (islot_off + 42) slot;
!             write_short buff (islot_off + itype) num_items
!           end else
!             write_short buff (islot_off + itype) num_items
!         end;
! 
!         (* Check if it's a weapon and select the appropriate slot *)
!         (* let real_slot = find_empty_slot islot_off possible_slots in *)
!         let real_slot = itype in
          if i.equip && real_slot >= 18 && real_slot <= 24 then begin
!           let i_num = (real_slot - 16) / 2 in
            write_short buff (islot_off + 76) (i_num - 1)
          end ;
          (* Splice it all together *)
***************
*** 2287,2296 ****
          end;
  
          (* Check if it's a weapon and select the appropriate slot *)
! 
!         let real_slot = find_empty_slot islot_off possible_slots in 
          if i.equip && real_slot >= 18 && real_slot <= 24 then begin 
!           let i_num = (real_slot - 18) / 2 in 
            write_short buff (islot_off + 76) (i_num - 1)
          end;
  
--- 3447,3456 ----
          end;
  
          (* Check if it's a weapon and select the appropriate slot *)
!         (* let real_slot = find_empty_slot islot_off possible_slots in *)
!         let real_slot = itype in
          if i.equip && real_slot >= 18 && real_slot <= 24 then begin
!           let i_num = (real_slot - 16) / 2 in
            write_short buff (islot_off + 76) (i_num - 1)
          end ;
  
***************
*** 2305,2310 ****
--- 3465,3652 ----
  
  
  
+   | TP_Replace_Cre_Item(i) ->
+ 
+       (* Create the new item *)
+       let i = { i with item_name =
+         Var.get_string i.item_name ;
+       } in
+ 
+       let item_buff = String.make 20 '\000' in
+       String.blit i.item_name 0 item_buff 0 (String.length i.item_name);
+       let i_charge1 = (Int32.to_int (eval_pe game i.i_charge1)) in
+       let i_charge2 = (Int32.to_int (eval_pe game i.i_charge2)) in
+       let i_charge3 = (Int32.to_int (eval_pe game i.i_charge3)) in
+       write_short item_buff 0xa i_charge1;
+       write_short item_buff 0xc i_charge2;
+       write_short item_buff 0xe i_charge3;
+ 
+       (* Make the item type into something usable *)
+       let i = { i with item_slot = List.fold_left (
+           fun acc (from, into) ->
+             Str.global_replace (Str.regexp_case_fold from) into acc)
+             (" " ^ i.item_slot ^ " ")
+               [("[ \t]QITEM[ \t]"," QITEM1 QITEM2 QITEM3 ");
+                ("[ \t]QUIVER[ \t]"," QUIVER1 QUIVER2 QUIVER3 ");
+                ("[ \t]RING[ \t]"," LRING RRING ");
+                ("[ \t]INV[ \t]",
+                   " INV1 INV2 INV3 INV4 INV5 INV6 INV7 INV8 INV9 INV10 INV11 INV12 INV13 INV14 INV15 INV16 ")]
+                ;
+         }
+       in
+       let type_word_list = Str.split many_whitespace_regexp i.item_slot in
+       let possible_slots = List.map (fun str -> match String.uppercase str with
+       | "HELMET" -> 0
+       | "ARMOR" -> 2
+       | "SHIELD" -> 4
+       | "GLOVES" -> 6
+       | "LRING" -> 8
+       | "RRING" -> 10
+       | "AMULET" -> 12
+       | "BELT" -> 14
+       | "BOOTS" -> 16
+       | "WEAPON1" -> 18
+       | "WEAPON2" -> 20
+       | "WEAPON3" -> 22
+       | "WEAPON4" -> 24
+       | "QUIVER1" -> 26
+       | "QUIVER2" -> 28
+       | "QUIVER3" -> 30
+       | "QUIVER4" -> 32
+       | "CLOAK" -> 34
+       | "QITEM1" -> 36
+       | "QITEM2" -> 38
+       | "QITEM3" -> 40
+       | "INV1" -> 42
+       | "INV2" -> 44
+       | "INV3" -> 46
+       | "INV4" -> 48
+       | "INV5" -> 50
+       | "INV6" -> 52
+       | "INV7" -> 54
+       | "INV8" -> 56
+       | "INV9" -> 58
+       | "INV10" -> 60
+       | "INV11" -> 62
+       | "INV12" -> 64
+       | "INV13" -> 66
+       | "INV14" -> 68
+       | "INV15" -> 70
+       | "INV16" -> 72
+       | _ -> log_and_print "WARNING: ADD_CRE_ITEM: Unknown slot %s.  Default to INV15 for placement.\n" (String.uppercase str) ; 70) type_word_list
+       in
+ 
+         let rec find_empty_slot islot_off lst = match lst with
+         | [] -> List.hd possible_slots
+         | hd :: tl ->
+           let in_slot = short_of_str_off buff (islot_off + hd) in
+           if in_slot = 65535 then hd
+           else find_empty_slot islot_off tl
+         in
+ 
+       (* Make the flags into something useable *)
+ 
+       let new_flags =
+       (match (String.uppercase i.i_flags) with
+       | "NONE" -> 0
+       | "IDENTIFIED" -> 1
+       | "UNSTEALABLE" -> 2
+       | "STOLEN" -> 4
+       | "UNDROPPABLE" -> 8
+       | "IDENTIFIED&STOLEN" -> 5
+       | "IDENTIFIED&UNSTEALABLE" -> 3
+       | "IDENTIFIED&UNDROPPABLE" -> 9
+       | "UNSTEALABLE&UNDROPPABLE" -> 10
+       | "STOLEN&UNDROPPABLE" -> 12
+       | "IDENTIFIED&STOLEN&UNDROPPABLE" -> 13
+       | "IDENTIFIED&UNSTEALABLE&UNDROPPABLE" -> 11
+       | _ -> log_and_print "WARNING: ADD_CRE_ITEM: Unknown flag %s.  Defaulting to NONE for flags.\n" (String.uppercase i.i_flags);
+              0)
+       in
+ 
+       write_int item_buff 0x10 new_flags;
+ 
+       let write_empty_inv_slot buff off itm =
+         let i = ref 0 in
+         while !i < 16 do
+           let slot = short_of_str_off buff (off + (!i * 2)) in
+           if slot = 65535 then begin
+             write_short buff (off + (!i * 2)) itm;
+             i := 16 ;
+           end else
+             incr i
+         done
+       in
+ 
+       (* Check for version *)
+ 
+       let cre_v = String.sub buff 0 8 in
+       (match cre_v with
+       | "CRE V1.0" ->
+         let islot_off = int_of_str_off buff 0x2b8 in
+         let items_off = int_of_str_off buff 0x2bc in
+         let num_items = int_of_str_off buff 0x2c0 in
+         let onefilled = ref false in
+         (* straight-replace the current item *)
+         List.iter (fun this ->
+           if not !onefilled then begin
+             let this_slot = short_of_str_off buff (islot_off + this) in
+             if this_slot <> 65535 then begin
+               onefilled := true;
+               (* put item_buff in the cre *)
+               for i = 0 to 4 do
+                 let part = int_of_str_off item_buff (i * 4) in
+                 write_int buff (items_off + 20 * this_slot + i*4) part;
+               done ;
+               if i.equip then begin
+                 (* If it's a two-handed weapon, empty the shield slot. *)
+                 if not i.twohanded_weapon then begin
+                   write_short buff (islot_off + 4) 65535 ;
+                   write_short buff (islot_off + 76) ((this/2 - 9));
+                 end else (* possible_plus *) begin
+                   (* Not a two-handed weapon, just empty the slot and move any item
+                      in the slot to the inventory *)
+                   write_short buff (islot_off + 76) ((this/2 - 9));
+                 end;
+               end
+             end
+           end ;
+         ) possible_slots ;
+         if !onefilled then buff else process_patch2 patch_filename game buff (TP_Add_Cre_Item(i));
+       | "CRE V9.0" ->
+         let islot_off = int_of_str_off buff 0x320 in
+         let items_off = int_of_str_off buff 0x324 in
+         let num_items = int_of_str_off buff 0x328 in
+         let onefilled = ref false in
+         List.iter (fun this ->
+           if not !onefilled then begin
+             let this_slot = short_of_str_off buff (islot_off + this) in
+             if this_slot <> 65535 then begin
+               onefilled := true;
+               for i = 0 to 4 do
+                 let part = int_of_str_off item_buff (i * 4) in
+                 write_int buff (items_off + 20 * this_slot + i*4) part;
+               done ;
+               if i.equip then begin
+                 (* If it's a two-handed weapon, empty the shield slot. *)
+                 if not i.twohanded_weapon then begin
+                   write_short buff (islot_off + 4) 65535 ;
+                   write_short buff (islot_off + 76) ((this/2 - 9));
+                 end else (* possible_plus *) begin
+                   (* Not a two-handed weapon, just empty the slot and move any item
+                      in the slot to the inventory *)
+                   write_short buff (islot_off + 76) ((this/2 - 9));
+                 end;
+               end
+             end
+           end
+         ) possible_slots ;
+         if !onefilled then buff else process_patch2 patch_filename game buff (TP_Add_Cre_Item(i));
+ 
+      | _ -> failwith ("ERROR: ADD_CRE_ITEM: Unknown cre version: " ^ cre_v)) ;
+ 
+ 
+ 
    | TP_CompileBAFtoBCS ->
          (try
          let bcs = handle_script_buffer (patch_filename ^ ".BAF") buff in
***************
*** 2330,2350 ****
  
    | TP_EvaluateBuffer -> Var.get_string buff
    
  
!   | TP_Add_S_Item(store_args,item,charge1,charge2,charge3,flags,stock,supply) ->
  
        (* Create the new item *)
        let item = Var.get_string item in 
        let item = String.uppercase item in
  
        let item_buff = String.make 28 '\000' in
        String.blit item 0 item_buff 0 (String.length item);
        write_short item_buff 0xa charge1;
        write_short item_buff 0xc charge2;
        write_short item_buff 0xe charge3;
  
        let new_flags =
        (match (String.uppercase flags) with
        | "IDENTIFIED" -> 1
        | "UNSTEALABLE" -> 2
        | "STOLEN" -> 4
--- 3672,3769 ----
  
    | TP_EvaluateBuffer -> Var.get_string buff
  
+   | TP_PatchReadLN(x) ->
+       if !interactive then begin
+         let y = read_line ()in
+         Var.set_string (eval_pe_str x) y;
+         readln_strings:= (x,y) :: !readln_strings;
+       end else begin
+         match !readln_strings with
+         | (a,b) :: tl ->
+             Var.set_string (eval_pe_str x) b;
+             readln_strings := tl
+         | [] ->
+             log_and_print "Not enough backed up entries in your replies";
+             failwith "Missing READLN strings"
+       end ;
+       buff
  
! 	| TP_PatchGetOffsetArray2 (arr, args) ->
!   	let (indoff,offsetO,offsetBL,countO,countBL,indexO,indexBL,length) = args in
!   	let countO = PE_Add(countO,indoff) in
!   	let indexO = PE_Add(indexO,indoff) in
!   	let args = (offsetO,offsetBL,countO,countBL,indexO,indexBL,length) in
!   	process_patch2 patch_filename game buff (TP_PatchGetOffsetArray(arr,args))
! 
!   | TP_PatchGetOffsetArray (arr, args) ->
!   	let (offsetO,offsetBL,countO,countBL,indexO,indexBL,length) = args in
! 		let bounds_check idx size retfun =
! 			let len = String.length buff in
! 			let out_of_bounds = (idx < 0 || (idx + size) > len) in
! 			match out_of_bounds with
! 			| false -> (retfun ())
! 			| true -> 
! 			begin 
! 				log_and_print "ERROR: illegal %d-byte read from offset %d of %d-byte file %s\n" size idx len patch_filename ;
! 				failwith (patch_filename ^ ": read out of bounds (GET_OFFSET_ARRAY)")
! 			end 
! 		in 
!   	let read4 where =
! 			let value = bounds_check where 4 
! 				(fun () -> int32_of_str_off buff where) in
! 			Int32.to_int value
! 		in
! 		let read2 where =
!       let value = bounds_check where 2
!         (fun () -> Int32.of_int (short_of_str_off buff where)) in
!       Int32.to_int value
!     in
! 		let read where howMany =
! 			let where = Int32.to_int (eval_pe game where) in
! 			let howMany = Int32.to_int (eval_pe game howMany) in
! 			match howMany with
! 			| 2 -> read2 where
! 			| 4 -> read4 where
! 			| 0 -> 0
! 			| _ -> failwith "TP_PatchGetOffsetArray internal"
! 		in
! 		let offset = read offsetO offsetBL in
! 		let count  = read  countO  countBL in
! 		let index  = read  indexO  indexBL in
! 		let length = Int32.to_int (eval_pe game length) in
! 		if !debug_ocaml then log_and_print "offset %d count %d index %d length %d\n"
! 			offset count index length;
! 		let arrS = eval_pe_str arr in
! 		if not (Hashtbl.mem Var.arrays arrS) then Hashtbl.add Var.arrays arrS [];
! 		for i = index to index + count - 1 do
! 			Var.set_string
! 				(eval_pe_str (PE_Dollars(arr,[get_pe_string (string_of_int (i - index))],
! 				  false))) (string_of_int (i * length + offset));
! 		done;
! 		buff
! 
!   | TP_Add_S_Item(store_args,item,where,charge1,charge2,charge3,flags,stock,supply) ->
  
        (* Create the new item *)
        let item = Var.get_string item in
        let item = String.uppercase item in
+       let before_what = ref "" in
+       let before_or_after = ref 0 in
+       List.iter ( fun (name, pos) -> before_what := Var.get_string name ; before_or_after := pos ) where ;
+       let before_what_list = Str.split (Str.regexp "[\t ]") !before_what in
  
        let item_buff = String.make 28 '\000' in
        String.blit item 0 item_buff 0 (String.length item);
+       let charge1 = Int32.to_int (eval_pe game charge1) in
+       let charge2 = Int32.to_int (eval_pe game charge2) in
+       let charge3 = Int32.to_int (eval_pe game charge3) in
        write_short item_buff 0xa charge1;
        write_short item_buff 0xc charge2;
        write_short item_buff 0xe charge3;
  
        let new_flags =
        (match (String.uppercase flags) with
+       | "NONE" -> 0
        | "IDENTIFIED" -> 1
        | "UNSTEALABLE" -> 2
        | "STOLEN" -> 4
***************
*** 2363,2369 ****
                   (String.uppercase str) ; 0
        in
  
!       let stock = if supply_tog = 1 then 1 else stock in
  
        write_int item_buff 0x10 new_flags;
        write_int item_buff 0x14 stock;
--- 3782,3788 ----
                   (String.uppercase str) ; 0
        in
  
!       let stock = if supply_tog = 1 then 1 else (Int32.to_int (eval_pe game stock)) in
  
        write_int item_buff 0x10 new_flags;
        write_int item_buff 0x14 stock;
***************
*** 2388,2394 ****
        (* Grab all items *)
  
        let items_list = ref [] in
!       let items_string = String.sub buff isaleoffset (ipurchasedoffset - isaleoffset) in
        for i = 0 to numisale - 1 do
        let item_check = String.sub items_string (i * 28) 8 in
        let item_check = get_string_of_size item_check 0 8 in
--- 3807,3815 ----
        (* Grab all items *)
  
        let items_list = ref [] in
!       if !debug_ocaml then log_and_print "Trying to String.sub buff %d %d\n" isaleoffset (ipurchasedoffset - isaleoffset);
!       let items_string = String.sub buff isaleoffset (numisale * 28) in
!       if !debug_ocaml then log_and_print "Done String.sub\n" ;
        for i = 0 to numisale - 1 do
        let item_check = String.sub items_string (i * 28) 8 in
        let item_check = get_string_of_size item_check 0 8 in
***************
*** 2430,2453 ****
        (* No + sign and the item doesn't exist *)
  
        else begin
- 
        log_and_print "Patching %s.ITM into store...\n" (String.uppercase item);
- 
        (* Update the offsets by 28 bytes *)
! 
!       write_int buff 0x2c (ipurchasedoffset + 28);
!       write_int buff 0x70 (cureoffset + 28);
! 
        (* Add 1 to the #items for sale *)
- 
        write_int buff 0x38 (numisale + 1);
! 
!       (* Splice in the new item *)
! 
!       let before = Str.string_before buff isaleoffset in
!       let after = Str.string_after buff isaleoffset in
!       let buff = before ^ item_buff ^ after in
!       buff
        end
  
    | _ -> buff 
--- 3851,3913 ----
        (* No + sign and the item doesn't exist *)
  
        else begin
          log_and_print "Patching %s.ITM into store...\n" (String.uppercase item);
          (* Update the offsets by 28 bytes *)
!         if ipurchasedoffset >= isaleoffset then write_int buff 0x2c (ipurchasedoffset + 28);
!         if cureoffset >= isaleoffset then write_int buff 0x70 (cureoffset + 28);
!         if drinksoffset >= isaleoffset then write_int buff 0x4c (drinksoffset + 28);
          (* Add 1 to the #items for sale *)
          write_int buff 0x38 (numisale + 1);
!         let added = ref false in
!         let buff_ref = ref (Str.string_before buff (isaleoffset)) in
!         if (!before_or_after = 1) or (!before_or_after = 2) then begin
!           let item_reg = List.map (fun x ->
!             let y = if String.length x > 8 then Str.string_before x 8 else x in
!             (y ^ String.make (8 - (String.length y)) '.')
!           ) before_what_list in
! (*           if !debug_ocaml then begin
!             log_and_print "item_reg is -%s-\n" item_reg ;
!           end ; *)
!           let item_reg = List.map Str.regexp_case_fold item_reg in
!           let item_string = Str.string_after (Str.string_before buff (isaleoffset + 28 * numisale)) isaleoffset in
!           let length = (String.length item_string) / 28 in
! (*           if !debug_ocaml then log_and_print "item_string:\"%s\", with %d items\n" item_string length ; *)
!           List.iter (fun this_test ->
!             if not !added then
!               for i = 0 to length - 1 do
!                 let this_one_long = Str.string_before (Str.string_after item_string (i * 28)) 28 in
!                 if not !added then begin
!                   let this_one = Str.string_before (this_one_long) 8 in
!                   if !debug_ocaml then log_and_print "Item %d is \"%s\"\n" i this_one ;
!                   if Str.string_match this_test this_one 0 then begin
!                     buff_ref := Printf.sprintf "%s%s%s" !buff_ref
!                     (* t_i_l i_b
!                        i_b t_i_l *)
!                       (if !before_or_after = 1 then this_one_long else item_buff)
!                       (if !before_or_after = 1 then item_buff else this_one_long) ;
!                     added := true
!                   end
!                   else buff_ref := !buff_ref ^ this_one_long
!                 end else buff_ref := !buff_ref ^ this_one_long ;
!               done ;
!           ) item_reg ;
!           if not !added then log_and_print "Not found space for %s %s %s.\n" item (if !before_or_after = 1
!               then "after" else "before") !before_what ;
!         end ;
!         let after = Str.string_after buff (match !added, !before_or_after with
!           | (true,_)
!           | (false,3) -> isaleoffset + 28 *numisale
!           | _     -> isaleoffset
!         ) in
!         if not !added then begin
!           let before = Str.string_before buff (match !before_or_after with
!             | 3 -> isaleoffset + 28 *numisale
!             | _ -> isaleoffset
!           ) in
!           buff_ref := before ^ item_buff
!         end ;
!         buff_ref := !buff_ref ^ after ;
!         !buff_ref
        end
  
    | _ -> buff
***************
*** 2464,2489 ****
      (match a with
      | TP_Require_File(file,error_msg) ->
          log_and_print "Checking for required files ...\n" ;
          let size = file_size file in 
!         if size >= 0 then begin
!           log_or_print "[%s] %d bytes\n" file size 
!         end else begin
            log_and_print "[%s] not found\n" file ;
!           log_and_print "\n%s\n" (Dc.single_string_of_tlk_string game
!           error_msg) ;
!           failwith file
          end
  
      | TP_Inlined_File(name,contents) ->
!         let name = Var.get_string name in 
!         log_only "Defined Inlined File [%s] (length %d)\n" 
            name (String.length contents) ;
!         Hashtbl.add inlined_files name contents 
  
      | TP_Forbid_File(file,error_msg) ->
          log_and_print "Checking for forbidden files ...\n" ;
          let size = file_size file in 
!         if size >= 0 then begin
            log_and_print "[%s] found: %d bytes\n" file size ;
            log_and_print "\n%s\n" (Dc.single_string_of_tlk_string game
            error_msg) ;
--- 3924,4112 ----
      (match a with
      | TP_Require_File(file,error_msg) ->
          log_and_print "Checking for required files ...\n" ;
+         let file = Arch.backslash_to_slash file in
          let size = file_size file in
!         let test = ref false in
!         test := bigg_file_exists file game.Load.key ;
!         if !test then begin
!           log_or_print "[%s] found: %d bytes\n" file size;
!         end
!         else begin
            log_and_print "[%s] not found\n" file ;
!           log_and_print "\n%s\n" (Dc.single_string_of_tlk_string game error_msg) ;
!           failwith file ;
          end
  
      | TP_Inlined_File(name,contents) ->
!         let name = Var.get_string (Arch.backslash_to_slash name) in
!         log_only_modder "Defined Inlined File [%s] (length %d)\n"
            name (String.length contents) ;
!         Hashtbl.add inlined_files (Arch.backslash_to_slash name) contents
! 
!     | TP_Biff(dest,what) ->
!         let find_list = ref [] in
!         game.Load.key_mod <- true ;
!         List.iter ( fun (directory,exact_match,regexp_string) ->
!           try
!             let dh = Case_ins.unix_opendir directory in
!             let reg = begin match exact_match with
!                 | Some(true) ->
!                   Str.regexp_string_case_fold
!                 | _ ->
!                   Str.regexp_case_fold
!               end regexp_string
!             in
!             (try
!               while true do
!                 let next = Unix.readdir dh in
!                 if ((Case_ins.unix_stat (directory ^ "/" ^ next)).Unix.st_kind =
!                    Unix.S_REG) && (Str.string_match reg next 0) then
!                   find_list := (String.uppercase (directory ^ "/" ^ next)) :: !find_list
!               done
!             with End_of_file -> () );
!             Unix.closedir dh ;
!           with _ -> ()
!         ) what ;
!         if !debug_ocaml then log_and_print "MAKE_BIFF: got file list\n";
!         if !find_list <> [] then begin
!           let filename = "data/" ^ dest ^ ".bif" in
!           let new_key = Biff.save_biff game.Load.key filename !find_list in
!           if !debug_ocaml then log_and_print "MAKE_BIFF: Calculated new key\n";
!           let oc = open_for_writing "CHITIN.KEY" true in
!           Key.save_key new_key oc ;
!           close_out oc ;
!           if !debug_ocaml then log_and_print "MAKE_BIFF: Saved the key\n";
!           (* re-load the chitin *)
!           let keybuff = load_file "chitin.key" in
!           if !debug_ocaml then log_and_print "MAKE_BIFF: Loaded the key file\n";
!           game.Load.key <- Key.load_key "chitin.key" keybuff ;
!           game.Load.loaded_biffs <- Hashtbl.create 5 ;
!           if !debug_ocaml then log_and_print "Unmarshaled the key\n";
!         end
! 
!     | TP_ActionBashFor(where,al) ->
!         let find_list = ref [] in
!         List.iter ( fun (directory,exact_match,regexp_string) ->
!           try
!             let dh = Case_ins.unix_opendir directory in
!             let reg = begin match exact_match with
!                 | Some(true) ->
!                   Str.regexp_string_case_fold
!                 | _ ->
!                   Str.regexp_case_fold
!               end regexp_string
!             in
!             (try
!               while true do
!                 let next = Unix.readdir dh in
!                 if ((Case_ins.unix_stat (directory ^ "/" ^ next)).Unix.st_kind =
!                    Unix.S_REG) && (Str.string_match reg next 0) then
!                   find_list := (String.uppercase (directory ^ "/" ^ next)) :: !find_list
!               done
!             with End_of_file -> () );
!             Unix.closedir dh ;
!           with _ -> ()
!         ) where ;
!         List.iter (fun file ->
!           let directory = Filename.dirname file in
!           let filespec = Filename.basename file in
!           Var.set_string "BASH_FOR_DIRECTORY" directory ;
!           Var.set_string "BASH_FOR_FILESPEC" file ;
!           Var.set_string "BASH_FOR_FILE" filespec ;
!           Var.set_string "BASH_FOR_RES"
!             (let a,b = split filespec in a) ;
!           List.iter (process_action tp) al ;
!         ) !find_list ;
! 
! 		| TP_ActionDefineArray(arr,vals) ->
! 				let i = ref 0 in
! 				List.iter (fun x ->
! 					Var.set_string
! 					  (eval_pe_str (PE_Dollars(arr,[get_pe_string (string_of_int !i)],
! 					    false))) x;
! 					incr i
! 				) vals;
! 
!     | TP_Action_For_Each(var,sl,al) ->
!         let var = eval_pe_str var in
!         let sl = List.map Var.get_string sl in
!         List.iter (fun x ->
!           Var.set_string var x ;
!           List.iter (process_action tp) al ;
!         ) sl ;
! 
! 
! 		| TP_ActionPHPEach(var,invar,outvar,al) ->
! 			let var_s = eval_pe_str var in
! 			let values = Hashtbl.find Var.arrays var_s in
! 			let outvar = eval_pe_str outvar in
! 			let  invar = eval_pe_str  invar in
! 			List.iter ( fun x ->
! 				let i = ref 0 in
! 				List.iter ( fun y ->
! 					Var.set_string (invar ^ "_" ^ string_of_int !i) y;
! 					incr i
! 				) x;
! 				let x = List.map get_pe_string x in
! 				let this_value = eval_pe_str (PE_Dollars(var,x,true)) in
! 				Var.set_string outvar this_value;
! 				List.iter (process_action tp) al ;
! 			) (List.rev values);
!     
! 	| TP_Outer_For(init,guard,inc,body) ->
!         let cmd_list = init @ [ TP_PatchWhile(guard,[(TP_PatchInnerAction body)] @ inc) ] in
!         let b = ref "" in
!         let patch_filename = "" in
!         b := List.fold_left (fun acc elt ->
!             process_patch2 patch_filename game acc elt) !b cmd_list  ;
!        ()
! 
!     | TP_Outer_While(guard,body) ->
!         let cmd_list = [ TP_PatchWhile(guard,[TP_PatchInnerAction body])] in
!         let b = ref "" in
!         let patch_filename = "" in
!         b := List.fold_left (fun acc elt ->
!             process_patch2 patch_filename game acc elt) !b cmd_list  ;
!        ()
! 
!     | TP_Outer_Inner_Buff(buff_var,pl) ->
!         let new_buff = Var.get_string buff_var in
!         let filename = Printf.sprintf "INNER_PATCH %S" buff_var in
!         let dummy = List.fold_left (fun acc elt ->
!             process_patch2 filename game acc elt) new_buff pl in
!         ()
! 
!       | TP_Outer_Inner_Buff_Save(store_var,buff_var,pl) ->
!         let new_buff = Var.get_string buff_var in
!         let filename = Printf.sprintf "INNER_PATCH_SAVE %S" buff_var in
!         let result = List.fold_left (fun acc elt ->
!             process_patch2 filename game acc elt) new_buff pl
!         in
!         Var.set_string store_var (Var.get_string result)
! 
!       | TP_Outer_Set(name,value) ->
!         let value = (eval_pe game value) in
!         let name = eval_pe_str name in
!         Var.set_int32 name value ;
! 
!     | TP_Outer_Sprint(name,msg) ->
!         let name = eval_pe_str name in
!         let (str : string) = eval_pe_tlk_str game msg in
!         let value = Var.get_string str in
!         Var.set_string name value  ;
! 
!     | TP_Outer_Text_Sprint (var,str) ->
!         let var = eval_pe_str var in
!         let str = Var.get_string (eval_pe_str str) in
!         Var.add_local_string var str
    
      | TP_Forbid_File(file,error_msg) ->
          log_and_print "Checking for forbidden files ...\n" ;
+         let file = Arch.backslash_to_slash file in
          let size = file_size file in
!         let test = ref false in
!         test := bigg_file_exists file game.Load.key ;
!        if !test then begin
            log_and_print "[%s] found: %d bytes\n" file size ;
            log_and_print "\n%s\n" (Dc.single_string_of_tlk_string game
            error_msg) ;
***************
*** 2494,2499 ****
--- 4117,4123 ----
  
      | TP_Print(msg) ->
          let str = Dc.single_string_of_tlk_string game msg in
+         be_silent := false ;
          let str = Var.get_string str in
          log_and_print "\n%s\n" str
  
***************
*** 2511,2517 ****
--- 4135,4225 ----
            List.iter (process_action tp) al2
          end
  
+     | TP_Define_Action_Macro(str,decl,al) ->
+         Hashtbl.replace action_macros str (decl, al)
+     
+     | TP_Define_Patch_Macro(str,decl,al) ->
+         Hashtbl.replace patch_macros str (decl, al)
+ 
+     | TP_Launch_Action_Macro(str) ->
+       let (decl, actions) =
+         try
+           Hashtbl.find action_macros (Var.get_string str)
+         with _ ->
+           failwith (Printf.sprintf "Unknown Macro: -%s-" str)
+ (*           ( [] , [] ) *)
+       in
+       List.iter (fun x -> match x with
+         TP_LocalSet(var,pe) ->
+           let pe = (eval_pe game pe) in
+           let var = eval_pe_str var in
+           Var.add_local_int32 var pe
+         | TP_LocalSprint (var,str) ->
+           let var = eval_pe_str var in
+           let (str : string) = eval_pe_tlk_str game str in
+           let str = Var.get_string str in
+           Var.add_local_string var str
+         | TP_LocalTextSprint (var,str) ->
+             let var = eval_pe_str var in
+             let str = Var.get_string (eval_pe_str str) in
+             Var.add_local_string var str
+       ) decl ;
+       List.iter (process_action tp) actions ;
+       List.iter (fun x -> match x with
+         TP_LocalSet(var,_)
+       | TP_LocalSprint (var,_)
+       | TP_LocalTextSprint (var,_) ->
+         let var = eval_pe_str var in
+         Var.remove_local var
+       ) decl ;
+ 
+     | TP_Reinclude(string_list) ->
+       let string_list = List.map Var.get_string string_list in
+       List.iter (fun file ->
+         let tph_parsed =
+           if !debug_ocaml then log_and_print "Loading %s...\n" file ;
+           let x = handle_tph_filename file in
+           Hashtbl.replace loaded_tph file x ;
+           x
+         in
+         List.iter (process_action tp) tph_parsed ;
+       ) string_list ;
+ 
+     | TP_Include(string_list) ->
+       let string_list = List.map Var.get_string string_list in
+       List.iter (fun file ->
+         let tph_parsed = if Hashtbl.mem loaded_tph file
+           then begin
+             if !debug_ocaml then log_and_print "%s is already loaded, restoring the image...\n" file ;
+             Hashtbl.find loaded_tph file
+           end
+           else begin
+             if !debug_ocaml then log_and_print "Loading %s...\n" file ;
+             let x = handle_tph_filename file in
+             Hashtbl.replace loaded_tph file x ;
+             x
+           end
+         in
+         List.iter (process_action tp) tph_parsed ;
+       ) string_list ;
+ 
+     | TP_Action_ReadLN(x) ->
+         if !interactive then begin
+           let y = read_line ()in
+           Var.set_string (eval_pe_str x) y;
+           readln_strings:= (x,y) :: !readln_strings;
+         end else begin
+           match !readln_strings with
+           | (a,b) :: tl ->
+               Var.set_string (eval_pe_str x) b;
+               readln_strings := tl
+           | [] ->
+           log_and_print "Not enough backed up entries in your replies"; failwith "Missing READLN strings"
+         end;
+ 
      | TP_Uninstall_Now(name,comp) ->
+         let comp = Int32.to_int (eval_pe game comp) in
+         let name = Var.get_string name in
          if already_installed name comp then begin
            if uninstall game handle_tp2_filename name comp false then
              ()
***************
*** 2523,2529 ****
            log_or_print "%s component #%d not present, good.\n"
              name comp 
  
!     | TP_RandomSeed(i) -> Random.init i
  
      | TP_CopyRandom(slistlist,plist,wlist) ->
          List.iter (fun slist ->
--- 4231,4266 ----
            log_or_print "%s component #%d not present, good.\n"
              name comp
  
!     | TP_RandomSeed(i) ->
!       eval_pe_warn := false ;
!       let _ = try
!           let x = Int32.to_int (eval_pe game i) in
!           Random.init x ;
!         with _ ->
!           begin
!             Random.self_init () ;
!           end
!       in
!       eval_pe_warn := true ;
! 
!     | TP_ClearMemory ->
!       log_and_print "Clearing the memory.\n" ;
!       let temp_author = Var.get_string "%TP2_AUTHOR%" in
!       let temp_lang = Var.get_string "%LANGUAGE%" in
!       let temp_name = Var.get_string "%TP2_FILE_NAME%" in
!       Var.clear_var () ;
!       Var.all_the_assoc () ;
!       Var.set_string "TP2_AUTHOR" temp_author ;
!       Var.set_string "LANGUAGE" temp_lang ;
!       Var.set_string "TP2_FILE_NAME" temp_name ;
!       Arch2.associate_these () ;
! 
!     | TP_Clear_Ids_Map ->
!       log_and_print "Clearing the IDS map.\n" ;
!       Bcs.clear_ids_map game ;
! 
!     | TP_Silent -> be_silent := true ;
!     | TP_Verbose -> be_silent := false ;
  
      | TP_CopyRandom(slistlist,plist,wlist) ->
          List.iter (fun slist ->
***************
*** 2550,2559 ****
--- 4287,4339 ----
            copy_constraint_list = wlist ;
            copy_backup = true;
            copy_at_end = true;
+           copy_save_inlined = false;
          } in
          process_action tp (TP_Copy(copy_args))
          ) slistlist
  
+     | TP_CopyAllGamFiles(pl,wl) ->
+         (* Patch the baldur.gam in the biff *)
+         let my_copy_args = {
+           copy_get_existing = true;
+           copy_use_regexp = false;
+           copy_use_glob = false ;
+           copy_file_list = [ ("baldur.gam", "override") ] ;
+           copy_patch_list = pl ;
+           copy_constraint_list = wl ;
+           copy_backup = true ;
+           copy_at_end = false ;
+           copy_save_inlined = false ;
+         } in
+         process_action tp (TP_Copy(my_copy_args)) ;
+         let file_list = ref [] in
+         let get_gam_list base_dir =
+           let dlist = list_of_files_in_directory base_dir in
+           List.iter (fun filename ->
+             let filename = base_dir ^ "/" ^ filename in
+             if is_directory filename          &&
+                filename <> base_dir ^ "/."    &&
+                filename <> base_dir ^ "/.."
+             then
+               file_list := !file_list @ [(filename ^ "/baldur.gam", filename ^ "/baldur.gam")] ;
+           ) dlist ;
+           ()
+         in
+         get_gam_list "save" ;
+         get_gam_list "mpsave" ;
+         let my_copy_args = {
+           copy_get_existing = false;
+           copy_use_regexp = false;
+           copy_use_glob = false ;
+           copy_file_list = !file_list ;
+           copy_patch_list = pl ;
+           copy_constraint_list = wl ;
+           copy_backup = false ;
+           copy_at_end = false ;
+           copy_save_inlined = false ;
+         } in
+         process_action tp (TP_Copy(my_copy_args)) ;
+ 
      | TP_Copy(copy_args) ->
          let get_existing = copy_args.copy_get_existing in
          let use_reg = copy_args.copy_use_regexp in
***************
*** 2563,2582 ****
          let clist = copy_args.copy_constraint_list in
          let make_a_backup = copy_args.copy_backup in 
          let copy_at_end = copy_args.copy_at_end in
          let worklist = ref [] in 
  
          let slist = 
            if get_existing = true && use_reg = true then begin
              let files_in_chitin = Key.list_of_key_resources game.Load.key in 
              let files_in_override = 
                if use_glob then begin
                  try 
!                   let dh = Unix.opendir "override" in
                    let lst = ref [] in 
                    (try 
                      while true do 
                        let next = Unix.readdir dh in
!                       if ((Unix.stat ("override/" ^ next)).Unix.st_kind = 
                           Unix.S_REG) then 
                          lst := (String.uppercase next) :: !lst
                      done 
--- 4343,4378 ----
          let clist = copy_args.copy_constraint_list in
          let make_a_backup = copy_args.copy_backup in
          let copy_at_end = copy_args.copy_at_end in
+         let save_inlined = copy_args.copy_save_inlined in
+         if true then begin
            let worklist = ref [] in
  
+           let bts1, bts2 = match get_existing, use_reg with
+             | false, false -> true,  true
+             | true,  false -> false, true
+             | true,  true  -> false, false
+             | _ -> failwith "COPY type internal"
+           in
+           let slist = List.map (fun (x,y) ->
+             (if bts1 then Arch.backslash_to_slash x else x),
+             (if bts2 then Arch.backslash_to_slash y else y)
+           ) slist
+           in
+ 
+           let slist = List.map (fun (x,y) -> (Var.get_string x, Var.get_string y)) slist in
+ 
            let slist =
              if get_existing = true && use_reg = true then begin
                let files_in_chitin = Key.list_of_key_resources game.Load.key in
                let files_in_override =
                  if use_glob then begin
                    try
!                     let dh = Case_ins.unix_opendir "override" in
                      let lst = ref [] in
                      (try
                        while true do
                          let next = Unix.readdir dh in
!                         if ((Case_ins.unix_stat ("override/" ^ next)).Unix.st_kind =
                             Unix.S_REG) then
                            lst := (String.uppercase next) :: !lst
                        done
***************
*** 2645,2650 ****
--- 4441,4449 ----
                else
                  Var.get_string src
              in
+             if String.uppercase src = "DIALOG.TLK" then
+               log_and_print_modder "\n\nUse COPY_LARGE rather than COPY on dialog.tlk!\n\n\n" ;
+ 
              let src_dir = Filename.dirname src in
              Var.set_string "SOURCE_DIRECTORY" src_dir ;
              Var.set_string "SOURCE_FILESPEC" src ;
***************
*** 2666,2680 ****
                buff
            in
            Var.set_int32 "SOURCE_SIZE" (Int32.of_int (String.length buff)); 
!           let orig_buff = 
!             if List.mem TP_ButOnlyIfItChanges clist then 
!               String.copy buff
!             else
!               ""
            in 
  
            (* if (buff <> "") then *) begin 
!             List.iter (fun p -> process_patch1 src game buff p) plist ; 
              let ok_to_copy = List.fold_left (fun acc elt -> acc && 
                match elt with
                | TP_Contains(s) -> begin
--- 4465,4478 ----
                  buff
              in
              Var.set_int32 "SOURCE_SIZE" (Int32.of_int (String.length buff));
!             let orig_buff = String.copy buff
              in
  
              (* if (buff <> "") then *) begin
!               if (!has_if_eval_bug) then begin try
!                   List.iter (fun p -> process_patch1 src game buff p) plist
!                 with _ -> ()
!               end;
                let ok_to_copy = List.fold_left (fun acc elt -> acc &&
                  match elt with
                  | TP_Contains(s) -> begin
***************
*** 2682,2694 ****
                    try let _ = Str.search_forward my_regexp buff 0 in
                      true
                    with _ -> 
!                     log_only "Not copying [%s] to [%s] because it does NOT contain [%s]\n" src dest s ; 
                      false
                    end
                | TP_NotContains(s) -> begin
                    let my_regexp = Str.regexp_case_fold s in
                    try let _ = Str.search_forward my_regexp buff 0 in
!                     log_only "Not copying [%s] to [%s] because it DOES contain [%s]\n" src dest s ; 
                      false
                    with _ -> 
                      true
--- 4480,4492 ----
                      try let _ = Str.search_forward my_regexp buff 0 in
                        true
                      with _ ->
!                       log_only_modder "Not copying [%s] to [%s] because it does NOT contain [%s]\n" src dest s ;
                        false
                      end
                  | TP_NotContains(s) -> begin
                      let my_regexp = Str.regexp_case_fold s in
                      try let _ = Str.search_forward my_regexp buff 0 in
!                       log_only_modder "Not copying [%s] to [%s] because it DOES contain [%s]\n" src dest s ;
                        false
                      with _ ->
                        true
***************
*** 2697,2709 ****
                    if String.length buff = size then 
                      true
                    else begin
!                     log_only "Not copying [%s] to [%s] because size is %d, NOT %d\n" src dest (String.length buff) size ; 
                      false
                    end
                | TP_Eval(pe) -> 
                    let v = eval_pe game pe in 
                    if v = Int32.zero then begin
!                     log_only "Not copying [%s] to [%s] because condition evaluates to %ld\n" src dest v ; false
                    end else true 
                | TP_ButOnlyIfItChanges -> true 
              ) true clist in 
--- 4495,4507 ----
                      if String.length buff = size then
                        true
                      else begin
!                       log_only_modder "Not copying [%s] to [%s] because size is %d, NOT %d\n" src dest (String.length buff) size ;
                        false
                      end
                  | TP_Eval(pe) ->
                      let v = eval_pe game pe in
                      if v = Int32.zero then begin
!                       log_only_modder "Not copying [%s] to [%s] because condition evaluates to %ld\n" src dest v ; false
                      end else true
                  | TP_ButOnlyIfItChanges -> true
                ) true clist in
***************
*** 2731,2741 ****
                         (String.length orig_buff)) ||
                        ((String.compare orig_buff result_buff) <> 0) 
                      in
                      changed
!                   end else true (* always copy *) ) () 
                in 
                if (it_changed) then begin 
                  let doit () = Stats.time "saving files" (fun () -> 
                    let out = 
                      try open_for_writing_internal make_a_backup dest true 
                      with e -> log_and_print 
--- 4529,4563 ----
                           (String.length orig_buff)) ||
                          ((String.compare orig_buff result_buff) <> 0)
                        in
+                       let newsrc, newdes =
+                         ( Filename.basename src, Filename.basename dest )
+                       in
+                       if !debug_boiic then log_and_print "[%s]%s->[%s]%s did%s change\n"
+                           newsrc (String.make (12 - (String.length newsrc)) ' ')
+                           newdes (String.make (12 - (String.length newdes)) ' ')
+                           (if changed then "" else "n't") ;
                        changed
!                     end else begin
!                       if (!debug_change) && (plist <> []) then begin
!                         let changed =
!                           ((String.length result_buff) <>
!                            (String.length orig_buff)) ||
!                           ((String.compare orig_buff result_buff) <> 0)
!                         in
!                         let newsrc, newdes =
!                           ( Filename.basename src, Filename.basename dest )
!                         in
!                         if !debug_change && not changed then log_and_print "Patches on [%s]%s->[%s]%s don't alter the file\n"
!                             newsrc (String.make (12 - (String.length newsrc)) ' ')
!                             newdes (String.make (12 - (String.length newdes)) ' ') ;
!                         true
!                       end else true ;
!                       (* always copy *)
!                     end ) ()
                  in
                  if (it_changed) then begin
                    let doit () = Stats.time "saving files" (fun () ->
+                     if not (save_inlined) then begin
                        let out =
                          try open_for_writing_internal make_a_backup dest true
                          with e -> log_and_print
***************
*** 2745,2760 ****
                    in
                    output_string out result_buff ;
                    close_out out ;
                  if make_a_backup then 
                    log_only "Copied [%s] to [%s]\n" src dest
                  else 
                    log_only "Copied [%s] to [%s] (NO BACKUP MADE!)\n" src dest
                  ) ()
                  in 
                  if copy_at_end then worklist := doit :: !worklist
                  else doit () 
                end else begin
!                 log_only 
                    "Not copying [%s] to [%s] because it did not change\n" 
                    src dest  
                end 
--- 4567,4594 ----
                        in
                        output_string out result_buff ;
                        close_out out ;
+                       begin (* handle read-only files! *)
+                         try
+                           Case_ins.unix_chmod dest 511 ; (* 511 = octal 0777 = a+rwx *)
+                         with e -> ()
+                           (* log_or_print "WARNING: chmod %s : %s\n" filename
+                             (Printexc.to_string e) *)
+                       end ;
                        if make_a_backup then
                          log_only "Copied [%s] to [%s]\n" src dest
                        else
                          log_only "Copied [%s] to [%s] (NO BACKUP MADE!)\n" src dest
+                     end else begin
+                       log_only_modder "Defined Inlined File [%s] (length %d)\n"
+                       dest (String.length result_buff) ;
+                       Hashtbl.add inlined_files (Arch.backslash_to_slash dest) result_buff
+                     end
                    ) ()
                    in
                    if copy_at_end then worklist := doit :: !worklist
                    else doit ()
                  end else begin
!                   log_only_modder
                      "Not copying [%s] to [%s] because it did not change\n"
                      src dest
                  end
***************
*** 2766,2773 ****
          end (* end: let copy_one_file = begin *)  
          in 
          List.iter (fun (src,dest) -> 
            if is_directory src then begin
!             let dh = Unix.opendir src in 
              (try
                while true do
                  let base = Unix.readdir dh in 
--- 4600,4709 ----
            end (* end: let copy_one_file = begin *)
            in
            List.iter (fun (src,dest) ->
+             let src = Var.get_string src in
+             if is_directory src then begin
+               let dh = Case_ins.unix_opendir src in
+               (try
+                 while true do
+                   let base = Unix.readdir dh in
+                   let source = src ^ "/" ^ base in
+                   if not (is_directory source) then
+                     copy_one_file source (dest ^ "/" ^ base)
+                 done
+               with _ -> () ) ;
+               Unix.closedir dh
+             end else copy_one_file src dest
+           ) slist ;
+           List.iter (fun f -> f ()) !worklist
+         end
+ 
+     | TP_CopyLarge(copy_large_args) ->
+         let use_glob = copy_large_args.copy_large_use_glob in
+         let slist = copy_large_args.copy_large_file_list in
+         let make_a_backup = copy_large_args.copy_large_backup in
+         let worklist = ref [] in
+ 
+         let slist =
+           List.map (fun (x,y) -> (Arch.backslash_to_slash x, Arch.backslash_to_slash y)) slist
+         in
+ 
+         let slist =
+           if use_glob then begin
+             let res = ref [] in
+             List.iter (fun (s,p) ->
+               let myfun (glob_s : string) = begin
+                 log_only "Callback from Arch.glob: %s\n" glob_s;
+                 res := (glob_s, p) :: !res
+               end in
+               log_only "Calling Arch.glob: %s\n" s;
+               let res = (Arch.glob s myfun) in
+               log_only "Arch.glob returned.\n";
+               res
+             ) slist ;
+             !res
+           end else
+             slist
+         in
+ 
+         let len = List.length slist in
+         log_and_print "Copying%s %d file%s ...\n" "" len
+           (if len = 1 then "" else "s") ;
+ 
+         let copy_one_file src dest = begin
+           let dest =
+             if use_glob then
+               dest
+             else
+               Var.get_string dest
+           in
+           let src =
+             if use_glob then
+               src
+             else
+               Var.get_string src
+           in
+           let dest =
+             if is_directory dest then
+               dest ^ "/" ^ (Filename.basename src)
+             else
+               dest
+           in
+           match String.uppercase (snd (split dest)) with
+           | ".IDS" -> Bcs.clear_ids_map game
+           | _ -> ()
+           ;
+           Stats.time "saving files" (fun () ->
+             if Hashtbl.mem inlined_files (Arch.backslash_to_slash src) then begin
+               let copy_args = {
+                 copy_get_existing = false;
+                 copy_use_regexp = false;
+                 copy_use_glob = use_glob;
+                 copy_file_list = [(src,dest)] ;
+                 copy_patch_list = [] ;
+                 (* C_L is <> [] to avoid looping *)
+                 copy_constraint_list = [TP_Eval(get_pe_int "1")] ;
+                 copy_backup = make_a_backup ;
+                 copy_at_end = false ;
+                 copy_save_inlined = false ;
+               } in
+               (* we came here from tp_copy, now we go back  :) *)
+               process_action tp (TP_Copy(copy_args))
+             end else begin
+               if make_a_backup then
+                 backup_if_extant dest ;
+               copy_large_file src dest "doing a COPY_LARGE" ;
+               if make_a_backup then
+                 log_only "Copied [%s] to [%s]\n" src dest
+               else
+                 log_only "Copied [%s] to [%s] (NO BACKUP MADE!)\n" src dest
+             end
+             ) ()
+         end (* end: let copy_one_file = begin *)
+         in
+         List.iter (fun (src,dest) ->
+           let src = Var.get_string src in
            if is_directory src then begin
!             let dh = Case_ins.unix_opendir src in
              (try
                while true do
                  let base = Unix.readdir dh in
***************
*** 2782,2794 ****
          List.iter (fun f -> f ()) !worklist
  
      | TP_Add_Music(m) -> begin
        log_and_print "Adding %s Music ...\n" m.music_name; 
        let this_music_number = get_next_line_number "SONGLIST.2DA" in 
        let music_base_name = Filename.basename m.music_file in 
        let str_to_append = Printf.sprintf "%d %s %s"
          this_music_number m.music_name music_base_name in 
  
!       let a1 = TP_Append("SONGLIST.2DA",str_to_append,[]) in
  
        let dest_music_file = "music/" ^ music_base_name in 
        let a2 = TP_Copy(
--- 4718,4740 ----
          List.iter (fun f -> f ()) !worklist
  
      | TP_Add_Music(m) -> begin
+       if is_true (eval_pe game
+         (PE_And(
+         (Pred_File_Exists(PE_LiteralString "override/SONGLIST.2DA")),
+         (Pred_File_Contains(PE_LiteralString "override/SONGLIST.2DA",
+           PE_LiteralString ("^" ^ m.music_name ^ "\\b")))))) then begin
+         let music_base_name = Filename.basename m.music_file in
+         Var.set_int32 (music_base_name) (Bcs.int_of_sym game "SONGLIST.2DA" music_base_name) ;
+         log_and_print "\n\nERROR: MUS [%s] already present! Skipping!\n\n"
+         music_base_name
+       end else begin
          log_and_print "Adding %s Music ...\n" m.music_name;
          let this_music_number = get_next_line_number "SONGLIST.2DA" in
          let music_base_name = Filename.basename m.music_file in
          let str_to_append = Printf.sprintf "%d %s %s"
            this_music_number m.music_name music_base_name in
  
!         let a1 = TP_Append("SONGLIST.2DA",str_to_append,[],true) in
  
          let dest_music_file = "music/" ^ music_base_name in
          let a2 = TP_Copy(
***************
*** 2800,2818 ****
            copy_constraint_list = [] ;
            copy_backup = true; 
            copy_at_end = false;
            } ) in 
        let action_list = [ a1 ; a2 ] in 
        List.iter (process_action tp) action_list ; 
        Var.set_int32 (m.music_name) (Int32.of_int this_music_number) ;
        log_and_print "Added %s Music\n" m.music_name; 
      end
  
      | TP_Add_Projectile(p) -> begin
          log_and_print "Adding projectile file %s ...\n" p.pro_file;
          let this_pro_name = Filename.chop_extension (Filename.basename p.pro_file) in 
          let this_pro_number = get_next_line_number "PROJECTL.IDS" in
          let a1 = TP_Append("PROJECTL.IDS", 
!                            (Printf.sprintf "%d %s" this_pro_number this_pro_name),[]) in
          let dest_pro_file = "override/" ^ (Filename.basename p.pro_file) in
          let a2 = TP_Copy(
            { copy_get_existing = false;
--- 4746,4776 ----
              copy_constraint_list = [] ;
              copy_backup = true;
              copy_at_end = false;
+             copy_save_inlined = false;
              } ) in
          let action_list = [ a1 ; a2 ] in
          List.iter (process_action tp) action_list ;
          Var.set_int32 (m.music_name) (Int32.of_int this_music_number) ;
          log_and_print "Added %s Music\n" m.music_name;
        end
+     end
  
      | TP_Add_Projectile(p) -> begin
+       if is_true (eval_pe game
+         (PE_And(
+         (Pred_File_Exists(PE_LiteralString "override/PROJECTL.IDS")),
+         (Pred_File_Contains(PE_LiteralString "override/PROJECTL.IDS",
+           PE_LiteralString ("^" ^ p.pro_file ^ "\\b")))))) then begin
+         let this_pro_name = Filename.chop_extension (Filename.basename p.pro_file) in
+         Var.set_int32 (this_pro_name) (Bcs.int_of_sym game "PROJECTL.IDS" this_pro_name) ;
+         log_and_print "\n\nERROR: PRO [%s] already present! Skipping!\n\n"
+         this_pro_name
+       end else begin
          log_and_print "Adding projectile file %s ...\n" p.pro_file;
          let this_pro_name = Filename.chop_extension (Filename.basename p.pro_file) in
          let this_pro_number = get_next_line_number "PROJECTL.IDS" in
          let a1 = TP_Append("PROJECTL.IDS",
!                            (Printf.sprintf "%d %s" this_pro_number this_pro_name),[],true) in
          let dest_pro_file = "override/" ^ (Filename.basename p.pro_file) in
          let a2 = TP_Copy(
            { copy_get_existing = false;
***************
*** 2823,2834 ****
--- 4781,4951 ----
              copy_constraint_list = [] ;
              copy_backup = true;
              copy_at_end = false;
+             copy_save_inlined = false;
              } ) in
          let action_list = [ a1 ; a2 ] in
          List.iter (process_action tp) action_list ;
          Var.set_int32 (this_pro_name) (Int32.of_int (this_pro_number + 1)) ;
          log_and_print "Added projectile file %s\n" p.pro_file;
        end
+     end
+ 
+     | TP_Add_Spell(file,kind,level,ids_name,pl,cl) ->
+       log_and_print "Adding spell %s\n" ids_name;
+       let file = Var.get_string file in
+       let ids_name = Var.get_string ids_name in
+       let kind = eval_pe game kind in
+       let level = eval_pe game level in
+       let kind = Int32.to_int kind in
+       let level = Int32.to_int level in
+       let memo = match kind with
+         | 1 -> "PR"
+         | 2 -> "WI"
+         | 3 -> "IN"
+         | 4 -> "CL"
+         | _ -> failwith "ADD_SPELL with spell type not in 1-4 range."
+       in
+       if level < 0 || level > 9 then failwith "ADD_SPELL with level outside the 0-9 range.";
+       let rec try_it n =
+         if n = 100 then failwith "Couldn't find space for the spell."
+         else if not (Load.file_exists_in_game game (Printf.sprintf "SP%s%d%s%d.SPL" memo level (if n < 10 then "0" else "") n)) then
+           n
+         else try_it (n + 1)
+       in
+       let n = try_it 1 in
+       if !debug_ocaml then log_and_print "installed as SP%s%d%s%d.SPL\n" memo level 
+                                                 (if n < 10 then "0" else "") n;
+       let number = kind * 1000 + level * 100 + n in
+         let a1 = TP_Append("SPELL.IDS",
+                            (Printf.sprintf "%d %s" number ids_name),[],true) in
+         let dest_file = "override/" ^ (Printf.sprintf "SP%s%d%s%d.SPL" memo level
+                                                 (if n < 10 then "0" else "") n) in
+         let a2 = TP_Copy(
+           { copy_get_existing = false;
+             copy_use_regexp = false;
+             copy_use_glob = false;
+             copy_file_list = [(file, dest_file)] ;
+             copy_patch_list = pl ;
+             copy_constraint_list = cl ;
+             copy_backup = true;
+             copy_at_end = false;
+             copy_save_inlined = false;
+             } ) in
+         let action_list = [ a1 ; a2 ] in
+         List.iter (process_action tp) action_list ;
+         Var.set_int32 (ids_name) (Int32.of_int (number)) ;
+         Bcs.clear_ids_map game ;
+         log_and_print "Added spell %s\n" ids_name;
+ 
+ 
+     | TP_CopyKit(oldString,newString,patches_list) ->
+       let oldString = Var.get_string oldString in
+       let newString = Var.get_string newString in
+       let patches_list = List.map (fun(a,b)-> (Var.get_string a),(Var.get_string
+          b)) patches_list in
+       let get_line file =
+         let (a,b) = split file in
+         let buff,path = Load.load_resource "getting 2DA columnns" game true a b
+         in
+         let my_regexp = Str.regexp_case_fold (Printf.sprintf "%s%s[\t ].*$"
+                        (if file = "kitlist.2da" then " " else "^") oldString) in
+         ignore(Str.search_forward my_regexp buff 0);
+         Str.matched_string buff
+       in
+       let get_column file =
+         let (a,b) = split file in
+         let buff,path = Load.load_resource "getting 2DA columnns" game true a b
+         in
+         let lines = Str.split many_newline_or_cr_regexp buff in
+         let cells = List.map (Str.split many_whitespace_regexp) lines in
+         let headers = List.nth cells 2 in
+         let rec get_where lst cnt = match lst with
+           | hd :: tl -> if hd = oldString then cnt else get_where tl (cnt + 1)
+           | [] -> failwith (Printf.sprintf "Unknown kit: %s" oldString)
+         in
+         let column = get_where headers 1 in
+         List.fold_left (fun acc elt -> Printf.sprintf "%s%s " acc (List.nth elt
+                                                                    column))
+               (if file = "weapprof.2da" then oldString ^ " " else "")
+               (List.tl (List.tl (List.tl cells)))
+       in
+       let get_entry file which =
+         let line = get_line file in
+         let split = Str.split many_whitespace_regexp line in
+         List.nth split which
+       in
+       let fix_clab which =
+         if file_exists which then which else
+           (let a = TP_Copy(
+             { copy_get_existing = true ;
+               copy_use_regexp = false;
+               copy_use_glob = false;
+               copy_file_list = [(which ^ ".2da","override")] ;
+               copy_patch_list = [] ;
+               copy_constraint_list = [] ;
+               copy_backup = true ;
+               copy_at_end = false;
+               copy_save_inlined = false;
+             } ) in
+             process_action tp a;
+             "override/" ^ which ^ ".2da"
+           )
+       in
+       let patches = Hashtbl.create 5 in
+       List.iter (fun (a,b) -> Hashtbl.add patches (String.lowercase a) b)
+         patches_list;
+       let get_clasweap file =
+         try get_line file
+         with _ -> oldString ^ " 1 1 1 1 1 1 1 1"
+       in
+       let get_it file how =
+         let o =
+           if !debug_ocaml then log_and_print "%s ... " file;
+           if Hashtbl.mem patches file then Hashtbl.find patches file else
+           match how with
+             | "line" -> get_line (file ^ ".2da")
+             | "column" -> get_column (file ^ ".2da")
+             | "clasweap" -> get_clasweap (file ^ ".2da")
+             | "clab" -> fix_clab (get_entry "kitlist.2da" 4)
+             | "lower" -> get_entry "kitlist.2da" 1
+             | "mixed" -> get_entry "kitlist.2da" 2
+             | "help" -> get_entry "kitlist.2da" 3
+             | "luabbr" -> get_entry "luabbr.2da" 1
+             | "unused" -> (get_entry "kitlist.2da" 6) ^ " " ^ (get_entry
+                 "kitlist.2da" 7)
+             | _ -> failwith (Printf.sprintf "CopyKit: %s" how)
+           in
+           if !debug_ocaml then log_and_print "~%s~\n" o;
+           Str.global_replace (Str.regexp ("^" ^ oldString^"[ \t]"))
+               (newString ^ " ") o
+       in
+       let copy_kit = {
+         kit_name = newString;
+         clasweap = get_it "clasweap" "clasweap";
+         weapprof = get_it "weapprof" "column";
+         abclasrq = get_it "abclasrq" "line";
+         abclsmod = get_it "abclsmod" "line";
+         abdcdsrq = get_it "abdcdsrq" "line";
+         abdcscrq = get_it "abdcscrq" "line";
+         dualclas = get_it "dualclas" "line";
+         alignmnt = get_it "alignmnt" "line";
+         ability_file = get_it "clab" "clab";
+         include_in = "";
+         lower = Dlg.TLK_Index (int_of_string (get_it "lower" "lower"));
+         mixed = Dlg.TLK_Index (int_of_string (get_it "mixed" "mixed"));
+         help  = Dlg.TLK_Index (int_of_string (get_it "help"  "help"));
+         tob_abbr = get_it "luabbr" "luabbr";
+         tob_start = (
+           let str = get_it "25stweap" "column" in
+           let lst = Str.split (Str.regexp "[ \t]+") str in
+           List.map (fun elt -> if elt = "$" then "" else elt) lst
+         );
+         unused_class = get_it "unusabilities" "unused";
+ 
+ (*        unused_class : string ;
+         tob_start : string list ;*)
+       }in
+       process_action tp (TP_Add_Kit(copy_kit))
  
      | TP_Add_Kit(k) -> begin
        log_and_print "Adding %s Kit ...\n" k.kit_name;
***************
*** 2837,2855 ****
          (PE_And(
          (Pred_File_Exists(PE_LiteralString "override/kitlist.2da")),
          (Pred_File_Contains(PE_LiteralString "override/kitlist.2da",
!           PE_LiteralString k.kit_name))))) then begin
          log_and_print "\n\nERROR: Kit [%s] already present! Skipping!\n\n"
          k.kit_name 
        end else begin 
!         let a1 = TP_Append("CLASWEAP.2DA",k.clasweap,[]) in
!         let a2 = TP_Append_Col("WEAPPROF.2DA",
!           ("" :: "" :: (split_apart k.weapprof)),[]) in
!         let a3 = TP_Append("ABCLASRQ.2DA",k.abclasrq,[]) in
!         let a4 = TP_Append("ABDCDSRQ.2DA",k.abdcdsrq,[]) in
!         let a5 = TP_Append("ABDCSCRQ.2DA",k.abdcscrq,[]) in
!         let a_e1 = TP_Append("ABCLSMOD.2DA",k.abclsmod,[]) in
!         let a_e2 = TP_Append("DUALCLAS.2DA",k.dualclas,[]) in
!         let a6 = TP_Append("ALIGNMNT.2DA",k.alignmnt,[]) in
          let abil_file = String.uppercase (Filename.basename k.ability_file) in 
          let abil_file_no_ext = Filename.chop_extension abil_file in 
          let dest_abil_file = "override/" ^ abil_file in 
--- 4954,4972 ----
          (PE_And(
          (Pred_File_Exists(PE_LiteralString "override/kitlist.2da")),
          (Pred_File_Contains(PE_LiteralString "override/kitlist.2da",
!           PE_LiteralString ("^" ^ k.kit_name ^ "\\b")))))) then begin
!         Var.set_int32 (k.kit_name) (Bcs.int_of_sym game "KITLIST.2DA" k.kit_name) ;
          log_and_print "\n\nERROR: Kit [%s] already present! Skipping!\n\n"
          k.kit_name
        end else begin
!         let a1 = TP_Append("CLASWEAP.2DA",k.clasweap,[],true) in
!         let a2 = TP_Append_Col("WEAPPROF.2DA",k.weapprof,2,[]) in
!         let a3 = TP_Append("ABCLASRQ.2DA",k.abclasrq,[],true) in
!         let a4 = TP_Append("ABDCDSRQ.2DA",k.abdcdsrq,[],true) in
!         let a5 = TP_Append("ABDCSCRQ.2DA",k.abdcscrq,[],true) in
!         let a_e1 = TP_Append("ABCLSMOD.2DA",k.abclsmod,[],true) in
!         let a_e2 = TP_Append("DUALCLAS.2DA",k.dualclas,[],true) in
!         let a6 = TP_Append("ALIGNMNT.2DA",k.alignmnt,[],true) in
          let abil_file = String.uppercase (Filename.basename k.ability_file) in
          let abil_file_no_ext = Filename.chop_extension abil_file in
          let dest_abil_file = "override/" ^ abil_file in
***************
*** 2862,2867 ****
--- 4979,4985 ----
              copy_constraint_list = [] ;
              copy_backup = true ;
              copy_at_end = false;
+             copy_save_inlined = false;
              } ) in
          let include_list = split_apart k.include_in in
          let lower_index = match Dc.resolve_tlk_string game k.lower with
***************
*** 2887,2912 ****
            lower_index mixed_index help_index
            abil_file_no_ext this_kit_prof_number 
            k.unused_class in
!         let a8 = TP_Append("KITLIST.2DA",append_to_kitlist,[]) in
          let include_actions = List.map (fun file -> 
            let num = get_next_line_number (file ^ ".2DA" ) in
            let str = Printf.sprintf "%d  %d" num this_kit_number in
!           TP_Append(file ^ ".2DA",str,[]) 
          ) include_list in 
          let abbr = Printf.sprintf  "%s     %s" k.kit_name k.tob_abbr in
!         let a9 = TP_Append("LUABBR.2DA",abbr,[]) in 
          let a10 = TP_Set_Col("25STWEAP.2DA",
!           ("" :: "" :: k.kit_name :: k.tob_start),this_kit_prof_number+2) in 
          let a11 = TP_Append("KIT.IDS",
            (Printf.sprintf "0x%x %s" (0x4000 + this_kit_number)
!             k.kit_name),[]) in 
          let action_list = a1 :: a2 :: a3 :: a4 :: a5 :: a6 :: a7 :: a8 :: 
!           a9 :: a10 :: a11 :: a_e1 :: a_e2 :: include_actions in
          let old_allow_missing = !Load.allow_missing in 
          Load.allow_missing := 
            "LUABBR.2DA" :: "25STWEAP.2DA" :: old_allow_missing ; 
          (* actually do it! *)
          List.iter (process_action tp) action_list ; 
          Load.allow_missing := old_allow_missing ; 
          Var.set_int32 (k.kit_name) (Int32.of_int this_kit_number) ;
          log_and_print "Added %s Kit\n" k.kit_name; 
--- 5005,5096 ----
            lower_index mixed_index help_index
            abil_file_no_ext this_kit_prof_number
            k.unused_class in
!         let a8 = TP_Append("KITLIST.2DA",append_to_kitlist,[],true) in
          let include_actions = List.map (fun file ->
            let num = get_next_line_number (file ^ ".2DA" ) in
            let str = Printf.sprintf "%d  %d" num this_kit_number in
!           TP_Append(file ^ ".2DA",str,[],true)
          ) include_list in
          let abbr = Printf.sprintf  "%s     %s" k.kit_name k.tob_abbr in
!         let a9 = TP_Append("LUABBR.2DA",abbr,[],true) in
          let a10 = TP_Set_Col("25STWEAP.2DA",
!           ("" :: "" :: k.kit_name :: k.tob_start),this_kit_prof_number+1) in
          let a11 = TP_Append("KIT.IDS",
            (Printf.sprintf "0x%x %s" (0x4000 + this_kit_number)
!             k.kit_name),[],true) in
!         let fix2da1 = TP_Copy ({
!             copy_get_existing = true;
!             copy_use_regexp = false;
!             copy_use_glob = false;
!             copy_file_list = ["weapprof.2da", "override";
!                               "25stweap.2da", "override";
!             ] ;
!             copy_patch_list = [ TP_PatchIf(PE_GT(get_pe_int "%SOURCE_SIZE%", get_pe_int "0"),[
!               TP_Read2DA(get_pe_int "2", get_pe_int "0", get_pe_int "0", "tb#kit_temp2");
!               TP_Patch2DA(get_pe_int "2", get_pe_int "0", get_pe_int "0", get_pe_int "%tb#kit_temp2% %tb#kit_temp2%");
!               TP_PatchSet(get_pe_string "tb#kit_this_is_a_temp_var",get_pe_int "0");
!               TP_Patch2DANow("tb#kit_this_is_a_temp_var", get_pe_int "0");
!             ],[])] ;
!             copy_constraint_list = [] ;
!             copy_backup = true;
!             copy_at_end = false;
!             copy_save_inlined = false;
!         }) in
!         let fix2da1a = TP_Copy ({
!             copy_get_existing = true;
!             copy_use_regexp = false;
!             copy_use_glob = false;
!             copy_file_list = ["kitlist.2da", "override"] ;
!             copy_patch_list = [ TP_PatchIf(PE_GT(get_pe_int "%SOURCE_SIZE%", get_pe_int "0"),[
!               TP_Read2DA(get_pe_int "2", get_pe_int "0", get_pe_int "0", "tb#kit_temp2a");
!               TP_Patch2DA(get_pe_int "2", get_pe_int "0", get_pe_int "0", get_pe_int "%tb#kit_temp2a% %tb#kit_temp2a%");
!               TP_PatchSet(get_pe_string "tb#kit_this_is_a_temp_var",get_pe_int "0");
!               TP_Patch2DANow("tb#kit_this_is_a_temp_var", get_pe_int "0");
!             ],[])] ;
!             copy_constraint_list = [] ;
!             copy_backup = true;
!             copy_at_end = false;
!             copy_save_inlined = false;
!         }) in
          let action_list = a1 :: a2 :: a3 :: a4 :: a5 :: a6 :: a7 :: a8 ::
!           a9 :: a10 :: a11 :: a_e1 :: a_e2 :: fix2da1 :: fix2da1a :: include_actions  in
          let old_allow_missing = !Load.allow_missing in
          Load.allow_missing :=
            "LUABBR.2DA" :: "25STWEAP.2DA" :: old_allow_missing ;
          (* actually do it! *)
          List.iter (process_action tp) action_list ;
+         let fix2da2 = TP_Copy ({
+             copy_get_existing = true;
+             copy_use_regexp = false;
+             copy_use_glob = false;
+             copy_file_list = ["weapprof.2da", "override";
+                               "25stweap.2da", "override";
+             ] ;
+             copy_patch_list = [ TP_PatchIf(PE_GT(get_pe_int "%SOURCE_SIZE%", get_pe_int "0"),[
+               TP_PatchStringTextually(None,None,"^%tb#kit_temp2%",
+                               String.make (String.length (Var.get_string_exact "%tb#kit_temp2%")) ' ',None);
+             ],[])] ;
+             copy_constraint_list = [] ;
+             copy_backup = true;
+             copy_at_end = false;
+             copy_save_inlined = false;
+         }) in
+         let fix2da2a = TP_Copy ({
+             copy_get_existing = true;
+             copy_use_regexp = false;
+             copy_use_glob = false;
+             copy_file_list = ["kitlist.2da", "override"] ;
+             copy_patch_list = [ TP_PatchIf(PE_GT(get_pe_int "%SOURCE_SIZE%", get_pe_int "0"),[
+               TP_PatchStringTextually(None,None,"^%tb#kit_temp2a%",
+                               String.make (String.length (Var.get_string_exact "%tb#kit_temp2a%")) ' ',None);
+             ],[])] ;
+             copy_constraint_list = [] ;
+             copy_backup = true;
+             copy_at_end = false;
+             copy_save_inlined = false;
+         }) in
+         process_action tp fix2da2;
+         process_action tp fix2da2a;
          Load.allow_missing := old_allow_missing ;
          Var.set_int32 (k.kit_name) (Int32.of_int this_kit_number) ;
          log_and_print "Added %s Kit\n" k.kit_name;
***************
*** 2919,2925 ****
          Dc.push_copy_trans ();
          try 
            let tra_file = Var.get_string tra_file in 
!           handle_tra_filename tra_file ;
            for i = min to max do
                Dc.set_string game i (Dlg.Trans_String(i)) false 
            done ;
--- 5103,5111 ----
          Dc.push_copy_trans ();
          try
            let tra_file = Var.get_string tra_file in
!           handle_tra_filename (Arch.backslash_to_slash tra_file) ;
!           let min = Int32.to_int (eval_pe game min) in
!           let max = Int32.to_int (eval_pe game max) in
            for i = min to max do
                Dc.set_string game i (Dlg.Trans_String(i)) false
            done ;
***************
*** 2935,2941 ****
          begin 
          let tra_file = Var.get_string tra_file in 
          Dc.push_copy_trans ();
!         handle_tra_filename tra_file
          end
        ) ; 
        List.iter (fun (s1,str) -> 
--- 5121,5127 ----
          begin
          let tra_file = Var.get_string tra_file in
          Dc.push_copy_trans ();
!         handle_tra_filename (Arch.backslash_to_slash tra_file)
          end
        ) ;
        List.iter (fun (s1,str) ->
***************
*** 2955,2973 ****
        | Some(_) -> Dc.pop_trans ())
        end
  
      | TP_Mkdir(str_l) -> begin
        let numdir = List.length str_l in 
        log_and_print "Creating %d director%s\n" numdir 
         (if numdir = 1 then "y" else "ies") ;
        List.iter (fun str ->
          try 
!           Unix.mkdir str 511 (* 511 = octal 0777 = a+rwx *)
!         with _ -> 
!           () 
        ) str_l 
        end
  
      | TP_Compile(eval,dlg_l,tra_l) -> begin
          let numd = ref 0 in
          let nums = ref 0 in 
          let handle_one_d_file filespec = match split 
--- 5141,5196 ----
        | Some(_) -> Dc.pop_trans ())
        end
  
+     | TP_String_Set_Evaluate(lst,tra_file_opt) -> begin
+       (match tra_file_opt with
+       | None -> ()
+       | Some(tra_file) ->
+         begin
+         let tra_file = Var.get_string tra_file in
+         Dc.push_copy_trans ();
+         handle_tra_filename (Arch.backslash_to_slash tra_file)
+         end
+       ) ;
+       List.iter (fun (pe,str) ->
+         let i = Int32.to_int (eval_pe game pe) in
+         if !debug_ocaml then log_and_print "Setting %d to \"%s\"\n" i
+           (Dc.single_string_of_tlk_string game str) ;
+         Dc.set_string game i str false ;
+       ) lst ;
+       (match tra_file_opt with
+       | None -> ()
+       | Some(_) -> Dc.pop_trans ())
+       end
+ 
+     | TP_Load_Tra(str_l) -> begin
+         let str_l = List.map (fun x -> Arch.backslash_to_slash (Var.get_string x)) str_l in
+         let numtra = List.length str_l in
+         log_and_print "loading %d tra file%s\n" numtra
+          (if numtra = 1 then "" else "s") ;
+         List.iter (fun str ->
+             handle_tra_filename (Var.get_string str)
+         ) str_l
+       end
+ 
      | TP_Mkdir(str_l) -> begin
+ 
+       let str_l = List.map (fun x -> Arch.backslash_to_slash x) str_l in
        let numdir = List.length str_l in
        log_and_print "Creating %d director%s\n" numdir
         (if numdir = 1 then "y" else "ies") ;
        List.iter (fun str ->
          try
!           recursive_mkdir (Var.get_string str) 511 (* 511 = octal 0777 = a+rwx *)
!         with e ->
!           (
!             log_and_print "Problem %s on %s : tp.ml\n" (Printexc.to_string e) str
!           )
        ) str_l
        end
  
      | TP_Compile(eval,dlg_l,tra_l) -> begin
+         let dlg_l =  List.map (fun x -> Arch.backslash_to_slash x) dlg_l in
+         let tra_l =  List.map (fun x -> Arch.backslash_to_slash x) tra_l in
          let numd = ref 0 in
          let nums = ref 0 in 
          let handle_one_d_file filespec = match split 
***************
*** 2978,2984 ****
          in 
          List.iter (fun filespec -> 
            if is_directory filespec then begin
!             let dh = Unix.opendir filespec in 
              (try
                while true do
                  let base = Unix.readdir dh in 
--- 5201,5207 ----
          in 
          List.iter (fun filespec ->
            if is_directory filespec then begin
!             let dh = Case_ins.unix_opendir filespec in 
              (try
                while true do
                  let base = Unix.readdir dh in 
***************
*** 3011,3017 ****
              Some(l) -> List.iter (fun path -> 
                  let my_regexp = Str.regexp_string "%s" in
                  let tra_file = Str.global_replace 
!                   my_regexp l.lang_dir_name path in
                  handle_tra_filename tra_file ;
                ) tra_l 
            | _ -> List.iter (fun tra_file -> 
--- 5234,5240 ----
              Some(l) -> List.iter (fun path ->
                  let my_regexp = Str.regexp_string "%s" in
                  let tra_file = Str.global_replace 
!                   my_regexp l.lang_dir_name (Var.get_string path) in
                  handle_tra_filename tra_file ;
                ) tra_l 
            | _ -> List.iter (fun tra_file -> 
***************
*** 3039,3048 ****
            Dc.ok_to_resolve_strings_while_loading := Some(game) ; 
            (try 
              begin 
!             match split (String.uppercase (Filename.basename d)) with
!             | _,"BAF" -> compile_baf_filename d
!             | _,"D" -> handle_d_filename d 
              | _,_ -> () 
              end 
            with e -> 
              begin 
--- 5262,5279 ----
            Dc.ok_to_resolve_strings_while_loading := Some(game) ; 
            (try 
              begin
!             let newd = if eval then "tb#_compile_eval_buffer" ^ d else d in
!             if eval then begin
!               let contents = Var.get_string (load_file d) in
!   						log_only_modder "Defined Inlined File [%s] (length %d)\n"
!                       newd (String.length contents) ;
!               Hashtbl.add inlined_files (Arch.backslash_to_slash newd) contents
!             end;
!               (match split (String.uppercase (Filename.basename d)) with
!               | _,"BAF" -> compile_baf_filename newd
!               | _,"D" -> handle_d_filename newd 
                | _,_ -> () 
+               )
              end 
            with e -> 
              begin 
***************
*** 3057,3063 ****
          in 
          List.iter (fun filespec -> 
            if is_directory filespec then begin
!             let dh = Unix.opendir filespec in 
              (try
                while true do
                  let base = Unix.readdir dh in 
--- 5288,5294 ----
          in 
          List.iter (fun filespec -> 
            if is_directory filespec then begin
!             let dh = Case_ins.unix_opendir filespec in
              (try
                while true do
                  let base = Unix.readdir dh in
***************
*** 3076,3082 ****
          end
  
      | TP_Set_Col(file,new_col_list,col_num) -> 
!         log_and_print "Setting game text column-wise ...\n" ; 
          let eight,three = split (String.uppercase file) in 
          let buff,loaded_path = Load.load_resource "SET_COLUMN" game true eight three in
          if buff = "" then 
--- 5307,5313 ----
          end
  
      | TP_Set_Col(file,new_col_list,col_num) ->
!         log_and_print_modder "Setting game text column-wise ...\n" ;
          let eight,three = split (String.uppercase file) in
          let buff,loaded_path = Load.load_resource "SET_COLUMN" game true eight three in
          if buff = "" then
***************
*** 3090,3101 ****
            end ;
            Stats.time "saving files" (fun () -> 
            let out = open_for_writing dest true in
            List.iter2 (fun orig_line new_col ->
              let line_as_cols = Str.split many_whitespace_regexp orig_line in 
              let i = ref 0 in 
              List.iter (fun orig_col -> 
                (if !i = col_num then 
!                 Printf.fprintf out "%-20s" new_col
                else
                  Printf.fprintf out "%-20s" orig_col) ;
                incr i;
--- 5321,5335 ----
            end ;
            Stats.time "saving files" (fun () ->
            let out = open_for_writing dest true in
+           let linecount = ref 0 in
            List.iter2 (fun orig_line new_col ->
              let line_as_cols = Str.split many_whitespace_regexp orig_line in
              let i = ref 0 in
+             if !linecount = 2 then incr i; (* 2nd coloumn (counting from 0) has one less entry *)
+             incr linecount;
              List.iter (fun orig_col ->
                (if !i = col_num then
!                 Printf.fprintf out "%-20s%-20s" new_col orig_col
                else
                  Printf.fprintf out "%-20s" orig_col) ;
                incr i;
***************
*** 3104,3114 ****
                  Printf.fprintf out "%-20s" new_col) ; 
              output_string out "\r\n" 
            ) buff_as_lines new_col_list ; 
!           close_out out) () ; 
            log_or_print "Set text in [%s] column-wise\n" file 
          end 
  
!     | TP_Append_Col(file,src_list,con_l) ->
          log_and_print "Appending to files column-wise ...\n" ; 
          let eight,three = split (String.uppercase file) in 
          let buff,loaded_path = Load.load_resource "APPEND_COLUMN" game true eight three in
--- 5338,5371 ----
                  Printf.fprintf out "%-20s" new_col) ;
              output_string out "\r\n"
            ) buff_as_lines new_col_list ;
!           close_out out ;
!           begin (* handle read-only files! *)
!             try
!               Case_ins.unix_chmod dest 511 ; (* 511 = octal 0777 = a+rwx *)
!             with e -> ()
!               (* log_or_print "WARNING: chmod %s : %s\n" filename
!                 (Printexc.to_string e) *)
!           end ;) () ;
            log_or_print "Set text in [%s] column-wise\n" file
          end
  
!     | TP_Append_Col(file,src,count_prepend,con_l) ->
!         let file = Arch.backslash_to_slash file in
!         let temp = Var.get_string src in
!         let src_list = Str.split (Str.regexp "[ \t]+") temp in
!         let src_list = List.map (fun elt -> if elt = "$" then "" else elt) src_list in
!         let rec prepend i string_list =
!             if i = 1 then
!               ("" :: string_list)
!             else begin
!               if i > 1 then
!                 "" :: (prepend (i-1) string_list)
!               else  (* i <= 0 *)
!                    string_list
!                end
!         in
! 
!         let src_list = prepend count_prepend src_list in
          log_and_print "Appending to files column-wise ...\n" ;
          let eight,three = split (String.uppercase file) in
          let buff,loaded_path = Load.load_resource "APPEND_COLUMN" game true eight three in
***************
*** 3160,3175 ****
              output_string out app ;
              output_string out "\r\n" 
            ) buff_as_lines src_list ; 
!           close_out out) () ; 
            log_or_print "Appended text to [%s] column-wise\n" file 
          end 
          end
  
!     | TP_Append(file,src,con_l) ->
          log_and_print "Appending to files ...\n" ; 
          let src = Var.get_string src in
          let eight,three = split (String.uppercase file) in 
!         let buff,loaded_path = Load.load_resource "APPEND" game true eight three in
          let okay = List.fold_left (fun acc elt -> acc &&
            match elt with 
              TP_Contains(s) -> begin
--- 5417,5448 ----
              output_string out app ;
              output_string out "\r\n" 
            ) buff_as_lines src_list ; 
!           close_out out ;
!           begin (* handle read-only files! *)
!             try
!               Case_ins.unix_chmod dest 511 ; (* 511 = octal 0777 = a+rwx *)
!             with e -> ()
!               (* log_or_print "WARNING: chmod %s : %s\n" filename
!                 (Printexc.to_string e) *)
!           end ;) () ;
            log_or_print "Appended text to [%s] column-wise\n" file
          end 
          end
  
!     | TP_Append(file,src,con_l,frombif) ->
!         let file = Arch.backslash_to_slash file in
!         if Filename.check_suffix(String.lowercase file) "ids" then Bcs.clear_ids_map game ;
          log_and_print "Appending to files ...\n" ;
+         let file = Var.get_string file in
          let src = Var.get_string src in
+         let buff = if frombif then begin
              let eight,three = split (String.uppercase file) in
!             let the_buff,loaded_path = Load.load_resource "APPEND" game true eight three in
!             the_buff
!           end else begin
!             load_file file
!           end
!         in
          let okay = List.fold_left (fun acc elt -> acc &&
            match elt with 
              TP_Contains(s) -> begin
***************
*** 3201,3207 ****
                  end 
          ) true con_l in 
          if okay then begin (* do the append *) 
!           let dest = "override/" ^ file in 
            Stats.time "saving files" (fun () -> 
            let out = open_for_writing dest true in
            let nice_newlines = Str.global_replace
--- 5474,5483 ----
                  end 
          ) true con_l in 
          if okay then begin (* do the append *) 
!           let dest =
!             if frombif then "override/" ^ file
!             else file
!           in
            Stats.time "saving files" (fun () -> 
            let out = open_for_writing dest true in
            let nice_newlines = Str.global_replace
***************
*** 3211,3225 ****
            output_string out "\r\n" ; *)
            output_string out src ;
            output_string out "\r\n" ;
!           close_out out) () ; 
            log_or_print "Appended text to [%s]\n" file 
          end 
  
      | TP_Extend_Top(use_reg,dest,src,pl,tra_l) 
      | TP_Extend_Bottom(use_reg,dest,src,pl,tra_l) -> begin
          log_and_print "Extending game scripts ...\n" ; 
          let dest = (Var.get_string dest) in
          let src = (Var.get_string src) in
          let dlist = 
            if use_reg = false then
              [dest]
--- 5487,5511 ----
            output_string out "\r\n" ; *)
            output_string out src ;
            output_string out "\r\n" ;
!           close_out out ;
!           begin (* handle read-only files! *)
!             try
!               Case_ins.unix_chmod dest 511 ; (* 511 = octal 0777 = a+rwx *)
!             with e -> ()
!               (* log_or_print "WARNING: chmod %s : %s\n" filename
!                 (Printexc.to_string e) *)
!           end ;) () ;
            log_or_print "Appended text to [%s]\n" file
          end 
  
      | TP_Extend_Top(use_reg,dest,src,pl,tra_l)
      | TP_Extend_Bottom(use_reg,dest,src,pl,tra_l) -> begin
+         let dest = if not use_reg then Arch.backslash_to_slash dest else dest in
+         let tra_l = List.map (fun x -> Arch.backslash_to_slash x) tra_l in
          log_and_print "Extending game scripts ...\n" ;
          let dest = (Var.get_string dest) in
          let src = (Var.get_string src) in
+         let src = Arch.backslash_to_slash src in
          let dlist =
            if use_reg = false then
              [dest]
***************
*** 3244,3250 ****
              Some(l) -> List.iter (fun path -> 
                  let my_regexp = Str.regexp_string "%s" in
                  let tra_file = Str.global_replace 
!                   my_regexp l.lang_dir_name path in
                  handle_tra_filename tra_file ;
                ) tra_l 
            | _ -> List.iter (fun tra_file -> 
--- 5530,5536 ----
              Some(l) -> List.iter (fun path ->
                  let my_regexp = Str.regexp_string "%s" in
                  let tra_file = Str.global_replace
!                   my_regexp l.lang_dir_name  (Var.get_string path) in
                  handle_tra_filename tra_file ;
                ) tra_l 
            | _ -> List.iter (fun tra_file -> 
***************
*** 3299,3305 ****
            Bcs.save_bcs game (Bcs.Save_BCS_OC(out)) (match a with 
              TP_Extend_Top(_,_,_,_,_) -> src_script @ dest_script
                                   | _ -> dest_script @ src_script) ;
!           close_out out) () ; 
            log_or_print "Extended script [%s] with [%s]\n" dest src
          ) dlist ;
          Dc.pop_trans () ; 
--- 5585,5598 ----
            Bcs.save_bcs game (Bcs.Save_BCS_OC(out)) (match a with
              TP_Extend_Top(_,_,_,_,_) -> src_script @ dest_script
                                   | _ -> dest_script @ src_script) ;
!           close_out out ;
!           begin (* handle read-only files! *)
!             try
!               Case_ins.unix_chmod destpath 511 ; (* 511 = octal 0777 = a+rwx *)
!             with e -> ()
!               (* log_or_print "WARNING: chmod %s : %s\n" filename
!                 (Printexc.to_string e) *)
!           end ;) () ;
            log_or_print "Extended script [%s] with [%s]\n" dest src
          ) dlist ;
          Dc.pop_trans () ; 
***************
*** 3309,3314 ****
--- 5602,5609 ----
          if !interactive then process_action tp (TP_At_Exit(str))
      | TP_At_Interactive_Uninstall(str) ->
          if !interactive then process_action tp (TP_At_Uninstall(str))
+     | TP_At_Interactive_Now(str) ->
+         if !interactive then process_action tp (TP_At_Now(str))
  
      | TP_At_Exit(str) ->
          begin
***************
*** 3317,3329 ****
          match b with 
          | "TP2" -> (!handle_recursive_tp2) str 
          | _ -> 
!           let str = Arch.handle_view_command str in 
            if List.mem str !execute_at_exit then
              ()
            else
              execute_at_exit := str :: !execute_at_exit 
          end 
  
      | TP_At_Uninstall(str) -> () 
      )
      with e -> (* from: let rec process_action = try *)
--- 5612,5635 ----
          match b with
          | "TP2" -> (!handle_recursive_tp2) str
          | _ ->
!           let str = Arch.handle_view_command str !skip_at_view in
            if List.mem str !execute_at_exit then
              ()
            else
              execute_at_exit := str :: !execute_at_exit
          end
  
+     | TP_At_Now(str) ->
+         begin
+         let str = Var.get_string str in
+         let a,b = split (String.uppercase str) in 
+         match b with 
+         | "TP2" -> (!handle_recursive_tp2) str 
+         | _ ->
+           let str = Arch.handle_view_command str !skip_at_view in
+           ignore (Unix.system (Arch.slash_to_backslash str))
+         end
+ 
      | TP_At_Uninstall(str) -> ()
      )
      with e -> (* from: let rec process_action = try *)
***************
*** 3341,3358 ****
  
    let subcomp_group the_comp = 
      let rec walk lst = match lst with
!     | TPM_SubComponents(ts,_) :: tl -> Some(ts)
      | hd :: tl -> walk tl
      | [] -> None
      in walk the_comp.mod_flags 
    in 
    let subcomp_predicate the_comp = 
      let rec walk lst = match lst with
!     | TPM_SubComponents(_,p) :: tl -> is_true (eval_pe game p)
      | hd :: tl -> walk tl
      | [] -> false
      in walk the_comp.mod_flags 
    in 
  
    let last_module_index = get_last_module_index tp in 
    let comp_num = ref 0 in 
--- 5647,5693 ----
  
    let subcomp_group the_comp =
      let rec walk lst = match lst with
!     | TPM_SubComponents(ts,_,_) :: tl -> Some(ts)
      | hd :: tl -> walk tl
      | [] -> None
      in walk the_comp.mod_flags
    in
    let subcomp_predicate the_comp =
      let rec walk lst = match lst with
!     | TPM_SubComponents(_,p,_) :: tl -> is_true (eval_pe game p)
!     | hd :: tl -> walk tl
!     | [] -> false
!     in walk the_comp.mod_flags
!   in
!   let subcomp_forced the_comp=
!     let rec walk lst = match lst with
!     | TPM_SubComponents(_,_,b) :: tl -> b
      | hd :: tl -> walk tl
      | [] -> false
      in walk the_comp.mod_flags
    in
+   let fails_requirements m = List.exists (fun f -> match f with
+       | TPM_RequireComponent(s,i,warn) ->
+           not (already_installed s i)
+       | TPM_ForbidComponent(s,i,warn) ->
+           (already_installed s i)
+       | TPM_Deprecated(warn) ->
+           true
+       | TPM_RequirePredicate(p,warn) ->
+           not (is_true (eval_pe game p))
+       | _ ->
+           false
+     ) m.mod_flags
+     ||
+     List.exists (fun f -> match f with
+       | TP_Require_File(file,warn) ->
+           not (bigg_file_exists file game.Load.key)
+       | TP_Forbid_File(file,warn) ->
+           bigg_file_exists file game.Load.key
+       | _ -> false
+     ) m.mod_parts
+ 
+   in
  
    let last_module_index = get_last_module_index tp in
    let comp_num = ref 0 in
***************
*** 3418,3441 ****
      with Not_found -> () 
    done ; 
  
    let module_defaults = Array.init (last_module_index+1) (fun i -> 
!       if !always_yes then
          TP_Install
!       else if !always_uninstall && (already_installed this_tp2_filename i) then
          TP_Uninstall
!       else if !always_uninstall then
          TP_Skip
        else if !sometimes_reinstall && (already_installed this_tp2_filename i) then
          TP_Install
        else if !sometimes_reinstall then
          TP_Skip
        else 
!         TP_Ask) 
    in
  
    let get_trans i = Dc.single_string_of_tlk_string game (Dlg.Trans_String(i)) in
  
!   let handle_letter tp answer can_uninstall package_name m finished i =
      let subgroup_already = 
        match subcomp_group m with
        | Some(ts) -> 
--- 5753,5791 ----
      with Not_found -> ()
    done ;
  
+   let rec hasgroup x =
+     match x with
+     | TPM_Group(c)::b -> true
+     | a::b -> hasgroup b
+     | [] -> false
+   in
+ 
    let module_defaults = Array.init (last_module_index+1) (fun i ->
!       try
!         let cli_uninstall = ref (List.exists (fun h -> h = i) !force_uninstall_these)  in
!         let cli_install   = ref (List.exists (fun h -> h = i) !force_install_these  )  in
!         if !always_yes or !cli_install then
            TP_Install
!         else if (!always_uninstall or !cli_uninstall) && (already_installed this_tp2_filename i) then
            TP_Uninstall
!         else if (!always_uninstall or !cli_uninstall) then
            TP_Skip
          else if !sometimes_reinstall && (already_installed this_tp2_filename i) then
            TP_Install
          else if !sometimes_reinstall then
            TP_Skip
+         else if (!force_install_these <> []) || (!force_uninstall_these <> []) then
+           TP_Skip
+         else if (hasgroup (get_nth_module tp i false).mod_flags) then
+           TP_Skip
          else
!           TP_Ask
!       with Not_found -> TP_Ask)
    in
  
    let get_trans i = Dc.single_string_of_tlk_string game (Dlg.Trans_String(i)) in
  
!   let handle_letter tp answer can_uninstall temp_uninst package_name m finished i =
      let subgroup_already =
        match subcomp_group m with
        | Some(ts) ->
***************
*** 3444,3465 ****
        | None -> 
            false
      in 
! 
      match answer with 
      | "Q" -> begin
          for i = 0 to last_module_index do
!           module_defaults.(i) <- TP_Skip ; 
            finished := true 
          done 
          end 
!     | "Y" when subgroup_already -> 
          log_or_print "Skipping [%s] because another subcomponent of [%s] is already installed.\n" package_name
          (match subcomp_group m with 
!           | Some(ts) -> Dc.single_string_of_tlk_string game  ts
            | None -> "???") ;
          finished := true 
  
!     | "Y" | "R" -> begin
          if can_uninstall then begin 
            try 
              (* log_and_print 
--- 5794,5824 ----
        | None ->
            false
      in
! 		let answer = if temp_uninst && answer = "N" then "R" else answer in
      match answer with
      | "Q" -> begin
          for i = 0 to last_module_index do
!           try
!             let c = get_nth_module tp i false in
!             if subcomp_forced c && not (fails_requirements c) then module_defaults.(i) <- TP_Install
!             else module_defaults.(i) <- TP_Skip ;
!             if !debug_ocaml then log_and_print "component %d is %s\n" i (match module_defaults.(i) with
!     					| TP_Install -> "Install"
!     					| TP_Skip -> "Skip"
!     					| _ -> "Internal Error");
!           with Not_found -> ();
            finished := true
          done
          end
! 
!     | "I" | "Y" when subgroup_already && not (already_installed tp.tp_filename i) ->
          log_or_print "Skipping [%s] because another subcomponent of [%s] is already installed.\n" package_name
          (match subcomp_group m with
!           | Some(ts) -> Dc.single_string_of_tlk_string_safe game  ts
            | None -> "???") ;
          finished := true
  
!     | "I" | "Y" | "R" -> begin
          if can_uninstall then begin
            try
              (* log_and_print
***************
*** 3480,3496 ****
--- 5840,6056 ----
          let strset_backup_filename =
            Printf.sprintf "%s/%d/UNSETSTR.%d" tp.backup i i
          in
+ 
+         let args_backup_filename =
+           Printf.sprintf "%s/%d/ARGS.%d" tp.backup i i
+         in
+ 
+         let readln_backup_filename =
+           Printf.sprintf "%s/%d/READLN.%d" tp.backup i i
+         in
+ 
+         if !interactive && (!Var.cli_variables = None) then begin
+           let counter = ref 0 in
+           let continue = ref true in
+           Var.cli_variables := Some([]) ;
+           while !continue do
+             let varname = Printf.sprintf "%%argv[%d]%%" !counter in
+             let varcont = Var.get_string varname in
+             if varcont = varname then begin
+               continue := false
+             end else begin
+               if !debug_ocaml then log_and_print "%%argv[%d]%% = %s\n" !counter varcont;
+               Var.cli_variables := Some(varcont :: (value_of_option !Var.cli_variables)) ;
+               incr counter;
+             end ;
+           done ;
+           Var.cli_variables := Some(value_of_option !Var.cli_variables)
+         end ;
+         if !interactive then begin
+           let outchan = Case_ins.perv_open_out_bin args_backup_filename in
+           Marshal.to_channel outchan (List.rev (value_of_option !Var.cli_variables)) [] ;
+           close_out outchan ;
+         end ;
+         if (* not !interactive && *) file_exists args_backup_filename then begin
+         (* re-loading when interactive and clearing of old argv[] variables is intended. *)
+           let counter = ref 0 in
+           let continue = ref true in
+           while !continue do
+             let varname = Printf.sprintf "%%argv[%d]%%" !counter in
+             let varcont = Var.get_string varname in
+             if varcont = varname then begin
+               continue := false
+             end else begin
+               if !debug_ocaml then log_and_print "removing the pair %%argv[%d]%% = %s\n" !counter varcont;
+               Hashtbl.remove Var.variables varname ;
+               incr counter;
+             end ;
+           done ;
+           try
+             let infile = Case_ins.perv_open_in_bin args_backup_filename in
+             let record : string list =
+               Marshal.from_channel infile
+             in
+             close_in infile ;
+             let counter = ref 0 in
+             List.iter (fun s ->
+               Var.set_string ("argv[" ^ (string_of_int !counter) ^ "]") s;
+               incr counter
+             ) record
+           with e ->
+             log_and_print "WARNING: Unable to read --args references from [%s]: %s\n"
+                                          args_backup_filename (Printexc.to_string e)
+         end ;
+ 
          log_and_print "\n%s [%s]\n"
            (* "\nInstalling [%s]\n"  *)
                ((get_trans (-1016)))
            package_name ;
          (try
+           Var.set_int32 "COMPONENT_NUMBER" (Int32.of_int i) ;
+           Var.set_int32 "INTERACTIVE" (Int32.of_int (if !interactive then 1 else 0)) ;
+ 
            List.iter (fun flag -> match flag with
              Always(al) -> List.iter (process_action tp) al
+           | TP_No_If_Eval () -> has_if_eval_bug := false ;
+           | Define_Action_Macro(str,decl,al) ->
+             Hashtbl.replace action_macros str (decl, al)
+           | Define_Patch_Macro(str,decl,al) ->
+             Hashtbl.replace patch_macros str (decl, al)
+           | Load_Macro(str_list) ->
+             List.iter (fun str ->
+               match str with
+               | "tb#factorial" ->
+                 Hashtbl.replace patch_macros "tb#factorial" (
+                   [
+                     TP_LocalSet(get_pe_string("tb#factorial_index"), get_pe_int("tb#factorial_index"))
+                   ], [
+                     TP_PatchIf (PE_Not(PE_Equal(get_pe_int("tb#factorial_index"),get_pe_int("1"))),
+                     [
+                       TP_PatchSet(get_pe_string("tb#factorial_result"),
+                         PE_Mul(get_pe_int("tb#factorial_result"),get_pe_int("tb#factorial_index"))) ;
+                       TP_PatchSet(get_pe_string("tb#factorial_index"),
+                         PE_Sub(get_pe_int("tb#factorial_index"),get_pe_int("1"))) ;
+                       TP_Launch_Patch_Macro("tb#factorial")
+                     ],[])
+                   ]
+                 ) ;
+               | "tb#fix_file_size" ->
+                 Hashtbl.replace action_macros "tb#fix_file_size" (
+                   [
+                     TP_LocalSprint(get_pe_string "file",get_pe_tlk_string "") ;
+                     TP_LocalSprint(get_pe_string "old",get_pe_tlk_string "") ;
+                     TP_LocalSet(get_pe_string "i",get_pe_int "0") ;
+                   ] ,
+                   [
+                     TP_If (
+                       PE_Not(Pred_File_Exists_In_Game(get_pe_string "tb#removedF%tb#fix_file_size_category%.txt")) ,
+                       [
+                         TP_Inlined_File("tb#fix_file_size_base.txt", " ") ;
+                         TP_Copy({
+                           copy_get_existing = false ;
+                           copy_use_regexp = false;
+                           copy_use_glob = false ;
+                           copy_file_list = [("tb#fix_file_size_base.txt", "override/tb#removedF%tb#fix_file_size_category%.txt")] ;
+                           copy_patch_list = [] ;
+                           copy_constraint_list = [] ;
+                           copy_backup = true ;
+                           copy_at_end = false ;
+                           copy_save_inlined = false ;
+                         }) ;
+                         TP_Copy({
+                           copy_get_existing = true ;
+                           copy_use_regexp = true;
+                           copy_use_glob = true ;
+                           copy_file_list = [("%tb#fix_file_size_regexp%", "override")] ;
+                           copy_patch_list = [
+                             TP_PatchIf (
+                               PE_LT(get_pe_int "%SOURCE_SIZE%", get_pe_int "%tb#fix_file_size_min%"),
+                               [
+                                 TP_PatchSprint(get_pe_string "file",
+                                   get_pe_tlk_string "%SOURCE_FILE%") ;
+                                 TP_PatchInnerAction(
+                                   [
+                                     TP_Append("tb#removedF%tb#fix_file_size_category%.txt","%file%",[],true)
+                                   ]
+                                 ) ;
+                               ] ,
+                               []
+                             ) ;
+                           ] ;
+                           copy_constraint_list = [ TP_ButOnlyIfItChanges ] ;
+                           copy_backup = true ;
+                           copy_at_end = false ;
+                           copy_save_inlined = false ;
+                         }) ;
+                         TP_Copy({
+                           copy_get_existing = true ;
+                           copy_use_regexp = false;
+                           copy_use_glob = false ;
+                           copy_file_list = [("tb#removedF%tb#fix_file_size_category%.txt", "override")] ;
+                           copy_patch_list = [
+                             TP_Read2DANow("tb#fix_file_size_list",get_pe_int "1") ;
+                             TP_PatchFor(
+                               [
+                                 TP_PatchSet(get_pe_string "i", get_pe_int "0");
+                               ],
+                               PE_LT(get_pe_int "%i%",get_pe_int "%tb#fix_file_size_list%"),
+                               [
+                                 TP_PatchSet(get_pe_string "i", PE_Add(get_pe_int "%i%",get_pe_int "1")) ;
+                               ],
+                               [
+                                 TP_Read2DAFormer("tb#fix_file_size_list", get_pe_int "%i%", get_pe_int "0", "old") ;
+                                 TP_PatchInnerAction([
+                                   TP_Copy({
+                                     copy_get_existing = true ;
+                                     copy_use_regexp = false;
+                                     copy_use_glob = false ;
+                                     copy_file_list = [("%tb#fix_file_size_target%", "override/%old%")] ;
+                                     copy_patch_list = [] ;
+                                     copy_constraint_list = [] ;
+                                     copy_backup = true ;
+                                     copy_at_end = false ;
+                                     copy_save_inlined = false ;
+                                   }) ;
+                                 ]) ;
+                               ]
+                             ) ;
+                           ] ;
+                           copy_constraint_list = [ TP_ButOnlyIfItChanges ] ;
+                           copy_backup = true ;
+                           copy_at_end = false ;
+                           copy_save_inlined = false ;
+                         }) ;
+                       ] , []) ;
+                   ]
+                 ) ;
+                 | _ ->
+                   failwith (Printf.sprintf "Unknown standard macro: -%s-" str) ;
+             ) str_list
            | _ -> ()
            ) tp.flags ;
+           if file_exists readln_backup_filename && not !interactive then begin
+             try
+               let infile = Case_ins.perv_open_in_bin readln_backup_filename in
+               let record : (tp_pe_string * string) list =
+                 Marshal.from_channel infile
+               in
+               close_in infile ;
+               readln_strings := record
+             with e ->
+               log_and_print "WARNING: Unable to read readln references from [%s]: %s\n"
+                                            args_backup_filename (Printexc.to_string e)
+           end ;
            List.iter (process_action tp) m.mod_parts ;
+           if !interactive then begin
+             let outchan = Case_ins.perv_open_out_bin readln_backup_filename in
+             Marshal.to_channel outchan (List.rev !readln_strings) [] ;
+             close_out outchan ;
+           end ;
+           readln_strings := [] ;
+           be_silent := false ;
          with e -> begin
+           be_silent := false ;
            return_value := return_value_error_tp2_component_install ;
            log_and_print "\n%s%s%s\n"
            (*  "\nERROR Installing [%s], rolling back to previous state\n" *)
***************
*** 3517,3523 ****
          if List.find_all (fun x -> x = TPM_NotInLog) m.mod_flags = [] then
            the_log := !the_log @ 
              [ ((String.uppercase this_tp2_filename),!our_lang_index,i,Some(package_name),Installed) ] 
!         else log_and_print "NOT adding a WeiDU.log record. You cannot uninstall this.\n" 
          end ;
          finished := true 
        end
--- 6077,6083 ----
          if List.find_all (fun x -> x = TPM_NotInLog) m.mod_flags = [] then
            the_log := !the_log @
              [ ((String.uppercase this_tp2_filename),!our_lang_index,i,Some(package_name),Installed) ]
!         else (* log_and_print "NOT adding a WeiDU.log record. You cannot uninstall this.\n" *) ()
          end ;
          finished := true
        end
***************
*** 3527,3532 ****
--- 6087,6096 ----
                ((get_trans (-1020)))
            package_name ;
          finished := true
+     | "U" when not can_uninstall ->
+       log_and_print "\nYou can't uninstall the non-installed component [%s] (component #%d)\n"
+                package_name i ;
+       finished := false ;
      | "U" ->
          log_and_print "\n%s%s%s%d%s\n"
           (* "\nRemoving [%s] (component #%d)\n" *)
***************
*** 3549,3554 ****
--- 6113,6134 ----
  
    let specify = ref false in
  
+   let rec findgroup flags =
+     match flags with
+       | TPM_Group(x)::b -> Some(x)
+       | a::b -> findgroup b
+       | [] -> None
+   in
+ 
+   let groups = ref [] in
+   List.iter (fun x ->
+      match findgroup x.mod_flags with
+     | Some(a) -> if not (List.mem a !groups) then begin
+       groups := a :: !groups;
+       end ;
+     | None -> ()) (List.rev tp.module_list) ;
+   let hasgroups = !groups <> [] in
+ 
    let has_ask_every = !ask_all ||
      List.exists (fun a -> a = Ask_Every_Component) tp.flags
    in
***************
*** 3556,3565 ****
    (* for big mods, ask about things in general first *) 
    if comp_num > 4 && not !always_yes && not !always_uninstall &&
       not !sometimes_reinstall && 
!      not (has_ask_every) 
    then begin
    (* add (-1000) "\nThis mod has %d distinct optional components.\nTo save time, you can choose what to do with them at a high level rather\nthan being asked about each one.\n" ; *)
!       log_and_print "\n%s %d %s" (get_trans (-1000)) comp_num (get_trans (-1001)) ;
        let finished = ref false in
  
        if !any_not_yet_installed then 
--- 6136,6145 ----
    (* for big mods, ask about things in general first *)
    if comp_num > 4 && not !always_yes && not !always_uninstall &&
       not !sometimes_reinstall &&
!      not (has_ask_every) && not (!specified_specific_components) && not hasgroups
    then begin
    (* add (-1000) "\nThis mod has %d distinct optional components.\nTo save time, you can choose what to do with them at a high level rather\nthan being asked about each one.\n" ; *)
!       log_and_print "\n%s %d %s" (Var.get_string(get_trans (-1000))) comp_num (get_trans (-1001)) ;
        let finished = ref false in
  
        if !any_not_yet_installed then
***************
*** 3575,3591 ****
              let the_comp = get_nth_module tp i false in
              match subcomp_group the_comp with
              | Some(x) ->
!               if not (any_member_of_subcomp_group_installed x) then 
!                 module_defaults.(i) <- TP_Install
              | None -> 
                if not (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Install
              with Not_found -> () 
            done 
!         | "S" ->
            for i = 0 to last_module_index do 
              try
              let the_comp = get_nth_module tp i false in
              match subcomp_group the_comp with
              | Some(x) ->
                if not (any_member_of_subcomp_group_installed x) then 
--- 6155,6175 ----
              let the_comp = get_nth_module tp i false in
              match subcomp_group the_comp with
              | Some(x) ->
!              (* if not (any_member_of_subcomp_group_installed x) then *)
!                 module_defaults.(i) <- TP_Ask
              | None ->
                if not (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Install
              with Not_found -> ()
            done
!         | "S"
!         | "Q" ->
            for i = 0 to last_module_index do
              try
              let the_comp = get_nth_module tp i false in
+             let c = get_nth_module tp i false in
+             if subcomp_forced c && not (fails_requirements c) then module_defaults.(i) <- TP_Install
+             else begin
                match subcomp_group the_comp with
                | Some(x) ->
                  if not (any_member_of_subcomp_group_installed x) then
***************
*** 3593,3598 ****
--- 6177,6183 ----
                | None ->
                  if not (already_installed this_tp2_filename i) then
                    module_defaults.(i) <- TP_Skip
+             end
              with Not_found -> ()
            done
          | "A" -> ()
***************
*** 3614,3629 ****
              let the_comp = get_nth_module tp i false in
              match subcomp_group the_comp with
              | Some(x) ->
!               if (any_member_of_subcomp_group_installed x) then 
!                 module_defaults.(i) <- TP_Install
              | None -> 
                if (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Install
              with Not_found -> () 
            done 
!         | "S" ->
            for i = 0 to last_module_index do 
              try let the_comp = get_nth_module tp i false in 
              match subcomp_group the_comp with
              | Some(x) ->
                if (any_member_of_subcomp_group_installed x) then 
--- 6199,6218 ----
              let the_comp = get_nth_module tp i false in
              match subcomp_group the_comp with
              | Some(x) ->
!              (* if not (any_member_of_subcomp_group_installed x) then *)
!                 module_defaults.(i) <- TP_Ask
              | None ->
                if (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Install
              with Not_found -> ()
            done
!         | "S"
!         | "Q" ->
            for i = 0 to last_module_index do
              try let the_comp = get_nth_module tp i false in
+             let c = get_nth_module tp i false in
+             if subcomp_forced c && not (fails_requirements c) then module_defaults.(i) <- TP_Install
+             else begin
                match subcomp_group the_comp with
                | Some(x) ->
                  if (any_member_of_subcomp_group_installed x) then
***************
*** 3631,3646 ****
              | None -> 
                if (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Skip
              with Not_found -> () 
            done 
          | "U" ->
            for i = 0 to last_module_index do 
              try let the_comp = get_nth_module tp i false in 
!             match subcomp_group the_comp with
              | Some(x) ->
                if (any_member_of_subcomp_group_installed x) then 
!                 module_defaults.(i) <- TP_Uninstall
!             | None -> 
                if (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Uninstall
              with Not_found -> () 
--- 6220,6236 ----
                | None ->
                  if (already_installed this_tp2_filename i) then
                    module_defaults.(i) <- TP_Skip
+             end
              with Not_found -> ()
            done
          | "U" ->
            for i = 0 to last_module_index do
              try let the_comp = get_nth_module tp i false in
!             ( match subcomp_group the_comp with
              | Some(x) ->
                if (any_member_of_subcomp_group_installed x) then
!                 module_defaults.(i) <- TP_Skip
!             | None -> () ) ;
                if (already_installed this_tp2_filename i) then
                  module_defaults.(i) <- TP_Uninstall
              with Not_found -> ()
***************
*** 3651,3657 ****
        done ;
    end ; 
  
!   let handle_error_generic always_yes finished package_name = (fun e ->
      return_value := return_value_error_tp2_component_install ; 
      log_and_print "ERROR: %s\n" (Printexc.to_string e) ;
      Dc.clear_state () ; 
--- 6241,6277 ----
        done ;
    end ;
  
!   let is_my_group the_comp group =
!     let rec walk lst = match lst with
!     | TPM_Group(ts) :: tl when ts = group -> true
!     | hd :: tl -> walk tl
!     | [] -> false
!     in walk the_comp.mod_flags
!   in
! 
!   (* now ask about groups *)
!   if hasgroups  && not !always_yes && not !always_uninstall &&
!      not !sometimes_reinstall && not (!specified_specific_components)
!     then List.iter (fun this_grp ->
!       let finished = ref false in
!       while not !finished do
!         finished := true ;
!         log_and_print "\n%s%s%s" (Var.get_string(get_trans (-1028)))
!                 (Dc.single_string_of_tlk_string_safe game this_grp) (get_trans (-1029)) ;
!         match String.uppercase(read_line ()) with
!         | "Y" ->
!           for i = 0 to last_module_index do
!             try
!             let the_comp = get_nth_module tp i false in
!             if is_my_group the_comp this_grp then module_defaults.(i) <- TP_Ask ;
!             with Not_found -> ()
!           done
!         | "N" -> ()
!         | _ -> finished := false
!       done ;
!   ) !groups ;
! 
!   let handle_error_generic always_yes specified_specific_components finished package_name = (fun e ->
      return_value := return_value_error_tp2_component_install ;
      log_and_print "ERROR: %s\n" (Printexc.to_string e) ;
      Dc.clear_state () ;
***************
*** 3659,3665 ****
        log_and_print "%s %s %s %s\n" ((get_trans (-1004))) !log_file 
                                      (get_trans (-1005)) tp.author) ;
      (* log_and_print "PLEASE email the file %s to %s\n" !log_file tp.author);*)
!     if !always_yes then begin
        log_and_print "Automatically Skipping [%s] because of error.\n"
          package_name ; 
        finished := true 
--- 6279,6285 ----
        log_and_print "%s %s %s %s\n" ((get_trans (-1004))) !log_file
                                      (get_trans (-1005)) tp.author) ;
      (* log_and_print "PLEASE email the file %s to %s\n" !log_file tp.author);*)
!     if !always_yes or !specified_specific_components then begin
        log_and_print "Automatically Skipping [%s] because of error.\n"
          package_name ;
        finished := true
***************
*** 3670,3676 ****
    let asked_about_comp = Hashtbl.create 255 in 
  
    let ask_about_module_with_subcomp current m subcomp handle_error = begin
!     let subcomp_group_str = Dc.single_string_of_tlk_string game subcomp in 
      if Hashtbl.mem asked_about_comp subcomp then
        log_or_print "Already Asked About [%s]\n" subcomp_group_str 
      else begin 
--- 6290,6296 ----
    let asked_about_comp = Hashtbl.create 255 in
  
    let ask_about_module_with_subcomp current m subcomp handle_error = begin
!     let subcomp_group_str = Dc.single_string_of_tlk_string_safe game subcomp in
      if Hashtbl.mem asked_about_comp subcomp then
        log_or_print "Already Asked About [%s]\n" subcomp_group_str
      else begin
***************
*** 3679,3729 ****
      let finished = ref false in 
      while not !finished do
        try 
! 
!         (if (any_already) then 
            log_and_print "\n%s%s%s\n" (get_trans (-1006)) subcomp_group_str
              (get_trans (-1025)) 
          else 
            log_and_print "\n%s%s%s\n" (get_trans (-1006)) subcomp_group_str
!             (get_trans (-1026))) ;
!         let choice_num = ref 1 in
!         let choice_ht = Hashtbl.create 255 in 
!         let already_ht = Hashtbl.create 255 in 
          for i = 0 to last_module_index do
            try let m = get_nth_module tp i false in
            match subcomp_group m with
            | Some(ts) when ts = subcomp && (subcomp_predicate m) ->
!             let this_subcomp_name = Dc.single_string_of_tlk_string 
                game m.mod_name in 
              log_and_print "%2d] %s" !choice_num this_subcomp_name ; 
              (if already_installed this_tp2_filename i then begin 
                log_and_print "%s\n" (get_trans (-1027)) ;
                Hashtbl.add already_ht () (m,i) ;
                Hashtbl.add choice_ht !choice_num (m,i,true)
!             end else log_and_print "\n" 
!             );
              Hashtbl.add choice_ht !choice_num (m,i,false) ;
              incr choice_num 
            | _ -> () 
            with Not_found -> () 
          done ;
          let answer = String.uppercase (read_line ()) in 
          (match answer with
          | "U" | "R" ->
              if Hashtbl.mem already_ht () then begin
                let (m,i) = Hashtbl.find already_ht () in 
                let can_uninstall = already_installed this_tp2_filename i in 
                let package_name = 
!                 Dc.single_string_of_tlk_string game m.mod_name in 
!               handle_letter tp answer can_uninstall 
                  package_name m finished i ;
                finished := true 
              end 
!         | "N" -> 
              finished := true; 
          | "Q" -> 
            for i = 0 to last_module_index do
!             module_defaults.(i) <- TP_Skip ;
              finished := true
            done 
          | _ -> 
--- 6299,6392 ----
      let finished = ref false in
      while not !finished do
        try
!         let choice_num = ref 1 in
!         let choice_ht = Hashtbl.create 255 in
!         let already_ht = Hashtbl.create 255 in
!         let uninstalled_because_preditate = ref false in
!         let is_forced = ref false in
!         let at_least_one_OK = ref false in
!         for i = 0 to last_module_index do
!           try let m = get_nth_module tp i false in
!           match subcomp_group m with
!           | Some(ts) when ts = subcomp && not(subcomp_predicate m) && already_installed this_tp2_filename i ->
!             let can_uninstall = already_installed this_tp2_filename i in
!             let temp_uninst   = temporarily_uninstalled this_tp2_filename i in
!             uninstalled_because_preditate := true ;
!             let package_name = Dc.single_string_of_tlk_string_safe
!               game m.mod_name in
!             log_and_print "Uninstalling the component %s because its predicate is no longer true.\n"
!               package_name ;
!             handle_letter tp "U" can_uninstall temp_uninst package_name m finished i ;
!           | Some(ts) when ts = subcomp ->
!               is_forced := !is_forced || (subcomp_forced m);
!               at_least_one_OK := !at_least_one_OK || (subcomp_predicate m)
!           | _ -> ()
!           with Not_found -> ()
!         done ;
!         let any_already = any_already && not !uninstalled_because_preditate in
!         if !at_least_one_OK then begin
!           (if (any_already) then begin
!             if not !is_forced then
                log_and_print "\n%s%s%s\n" (get_trans (-1006)) subcomp_group_str
                  (get_trans (-1025))
+             else log_and_print "\n%s%s%s\n"  (get_trans (-1006)) subcomp_group_str
+                 (get_trans (-1031))
+           end else begin
+             (if !is_forced then
+               log_and_print "\n%s%s%s\n" (get_trans (-1006)) subcomp_group_str
+                 (get_trans (-1030))
              else
                log_and_print "\n%s%s%s\n" (get_trans (-1006)) subcomp_group_str
!                 (get_trans (-1026)) )
!           end ) ;
            for i = 0 to last_module_index do
              try let m = get_nth_module tp i false in
              match subcomp_group m with
              | Some(ts) when ts = subcomp && (subcomp_predicate m) ->
!               let this_subcomp_name = Dc.single_string_of_tlk_string_safe
                  game m.mod_name in
                log_and_print "%2d] %s" !choice_num this_subcomp_name ;
                (if already_installed this_tp2_filename i then begin
                  log_and_print "%s\n" (get_trans (-1027)) ;
                  Hashtbl.add already_ht () (m,i) ;
                  Hashtbl.add choice_ht !choice_num (m,i,true)
!               end else begin
!                 log_and_print "\n" ;
                  Hashtbl.add choice_ht !choice_num (m,i,false) ;
+               end
+               );
                incr choice_num
              | _ -> ()
              with Not_found -> ()
            done ;
            let answer = String.uppercase (read_line ()) in
+           let answer = if Hashtbl.mem already_ht () then begin
+             let (m,i) = Hashtbl.find already_ht () in
+             let temp_uninst = temporarily_uninstalled this_tp2_filename i in
+ 						if temp_uninst && answer = "N" then "R" else answer
+ 					end else answer in
            (match answer with
+           | "U" when !is_forced -> finished := false ;
            | "U" | "R" ->
                if Hashtbl.mem already_ht () then begin
                  let (m,i) = Hashtbl.find already_ht () in
                  let can_uninstall = already_installed this_tp2_filename i in
+                 let temp_uninst = temporarily_uninstalled this_tp2_filename i in
                  let package_name =
!                   Dc.single_string_of_tlk_string_safe game m.mod_name in
!                 handle_letter tp answer can_uninstall temp_uninst
                    package_name m finished i ;
                  finished := true
                end
!           | "N" when any_already || not !is_forced ->
                finished := true;
            | "Q" ->
              for i = 0 to last_module_index do
!               try
!                 let c = get_nth_module tp i false in
!                 if subcomp_forced c && not (fails_requirements c) then module_defaults.(i) <- TP_Install
!                 else module_defaults.(i) <- TP_Skip ;
!               with Not_found -> ();
                finished := true
              done
            | _ ->
***************
*** 3735,3764 ****
                if Hashtbl.mem choice_ht choice then begin
                  let (m,i,already) = Hashtbl.find choice_ht choice in 
                  if (already) then
!                   finished := true
                  else begin
                    log_or_print "Uninstalling All Other Subcomponents of [%s]\n"
                      subcomp_group_str ;
                    Hashtbl.iter (fun () (m,i) -> 
                      let can_uninstall = already_installed 
                        this_tp2_filename i in 
                      let package_name = 
!                       Dc.single_string_of_tlk_string game m.mod_name in 
!                     handle_letter tp "U" can_uninstall 
                        package_name m finished i
                    ) already_ht ;
                    log_or_print "Done Uninstalling All Other Subcomponents of [%s]\n" subcomp_group_str ;
                    let can_uninstall = already_installed 
                      this_tp2_filename i in 
                    let package_name = 
!                     Dc.single_string_of_tlk_string game m.mod_name in 
!                   handle_letter tp "Y" can_uninstall 
                      package_name m finished i ;
                    finished := true
                  end 
                end 
            end 
          )
        with e -> handle_error e
  
      done 
--- 6398,6438 ----
                  if Hashtbl.mem choice_ht choice then begin
                    let (m,i,already) = Hashtbl.find choice_ht choice in
                    if (already) then
! 											let can_uninstall = already_installed
!                         this_tp2_filename i in
!                       let temp_uninst = temporarily_uninstalled
!                         this_tp2_filename i in
!                       let package_name =
!                         Dc.single_string_of_tlk_string_safe game m.mod_name in
!                       handle_letter tp "I" can_uninstall temp_uninst
!                         package_name m finished i
                    else begin
                      log_or_print "Uninstalling All Other Subcomponents of [%s]\n"
                        subcomp_group_str ;
                      Hashtbl.iter (fun () (m,i) ->
                        let can_uninstall = already_installed
                          this_tp2_filename i in
+                       let temp_uninst = temporarily_uninstalled
+                         this_tp2_filename i in
                        let package_name =
!                         Dc.single_string_of_tlk_string_safe game m.mod_name in
!                       handle_letter tp "U" can_uninstall temp_uninst
                          package_name m finished i
                      ) already_ht ;
                      log_or_print "Done Uninstalling All Other Subcomponents of [%s]\n" subcomp_group_str ;
                      let can_uninstall = already_installed
                        this_tp2_filename i in
+                    let temp_uninst = temporarily_uninstalled this_tp2_filename i in
                     let package_name =
!                       Dc.single_string_of_tlk_string_safe game m.mod_name in
!                     handle_letter tp "Y" can_uninstall temp_uninst
                        package_name m finished i ;
                      finished := true
                    end
                  end
              end
            )
+         end else finished := true ;
        with e -> handle_error e
  
      done
***************
*** 3769,3785 ****
      let finished = ref false in 
          while not !finished do try
            let can_uninstall = already_installed this_tp2_filename !current in 
            if can_uninstall then 
              (* log_and_print "\nInstall Component [%s]\n[R]e-Install, [N]o Change or [U]ninstall or [Q]uit? "  package_name *)
!             log_and_print "\n%s%s%s" (get_trans (-1006)) package_name
!               (get_trans (-1007)) 
            else 
             (* log_and_print "\nInstall Component [%s]\n[Y]es or [N]o or [Q]uit? "  package_name ; *)
!             log_and_print "\n%s%s%s" (get_trans (-1006)) package_name
!               (get_trans (-1008)) ;
            begin
            let answer = String.uppercase(read_line ()) in 
!           handle_letter tp answer can_uninstall package_name m
                        finished !current ;
            Dc.clear_state () ; 
            end
--- 6443,6458 ----
      let finished = ref false in
          while not !finished do try
            let can_uninstall = already_installed this_tp2_filename !current in
+           let temp_uninst = temporarily_uninstalled this_tp2_filename !current in
              if can_uninstall then
                (* log_and_print "\nInstall Component [%s]\n[R]e-Install, [N]o Change or [U]ninstall or [Q]uit? "  package_name *)
!               log_and_print "\n%s%s%s" (get_trans (-1006)) package_name (get_trans (-1007))
              else
               (* log_and_print "\nInstall Component [%s]\n[Y]es or [N]o or [Q]uit? "  package_name ; *)
!               log_and_print "\n%s%s%s" (get_trans (-1006)) package_name (get_trans (-1008)) ;
              begin
              let answer = String.uppercase(read_line ()) in
!             handle_letter tp answer can_uninstall temp_uninst package_name m
                          finished !current ;
              Dc.clear_state () ;
              end
***************
*** 3799,3816 ****
        ) m.mod_flags ; 
        let def = ref (module_defaults.(!current)) in 
        let can_uninstall = already_installed this_tp2_filename !current in 
        List.iter (fun f -> match f with
        | TPM_InstallByDefault -> 
          if !def = TP_Ask && (not can_uninstall) then def := TP_Install
        | _ -> ()
        ) m.mod_flags ; 
!       let package_name = Dc.single_string_of_tlk_string game m.mod_name in 
  
!       let preproc_fail msg warn already = 
          if (!def <> TP_Skip) && (!def <> TP_Uninstall) then begin
            (* WW: the "FORBID_FILE" bug -- don't uninstall things here! *)
          if (already) then 
!             def := TP_Ask  
            else begin
              let warn = Dc.single_string_of_tlk_string game warn in 
              log_and_print "\n%s: [%s]\n\t%s\n" msg package_name warn ;
--- 6472,6490 ----
        ) m.mod_flags ;
        let def = ref (module_defaults.(!current)) in
        let can_uninstall = already_installed this_tp2_filename !current in
+       let temp_uninst = temporarily_uninstalled this_tp2_filename !current in
        List.iter (fun f -> match f with
        | TPM_InstallByDefault ->
          if !def = TP_Ask && (not can_uninstall) then def := TP_Install
        | _ -> ()
        ) m.mod_flags ;
!       let package_name = Dc.single_string_of_tlk_string_safe game m.mod_name in
  
!       let preproc_fail msg warn already is_forbid_file =
          if (!def <> TP_Skip) && (!def <> TP_Uninstall) then begin
            (* WW: the "FORBID_FILE" bug -- don't uninstall things here! *)
          if (already) then
!             def := (if is_forbid_file then TP_Ask else TP_Uninstall)
            else begin
              let warn = Dc.single_string_of_tlk_string game warn in
              log_and_print "\n%s: [%s]\n\t%s\n" msg package_name warn ;
***************
*** 3836,3848 ****
            if already_installed s i && 
               not (temporarily_uninstalled s i) then
              () (* good! *) 
!           else preproc_fail "SKIPPING" warn (already_installed s i)
          end 
        | TPM_ForbidComponent(s,i,warn) -> 
          begin
            if already_installed s i && 
               not (temporarily_uninstalled s i) then
!             preproc_fail "SKIPPING" warn (already_installed s i)
            else 
              () (* good! *) 
          end 
--- 6510,6522 ----
            if already_installed s i &&
               not (temporarily_uninstalled s i) then
              () (* good! *)
!           else preproc_fail "SKIPPING" warn can_uninstall false
          end
        | TPM_ForbidComponent(s,i,warn) ->
          begin
            if already_installed s i &&
               not (temporarily_uninstalled s i) then
!             preproc_fail "SKIPPING" warn can_uninstall true
            else
              () (* good! *)
          end
***************
*** 3850,3894 ****
          begin
            if is_true (eval_pe game p) then 
              ()
!           else preproc_fail "SKIPPING" warn can_uninstall
          end 
!       | TPM_SubComponents(ts,_) -> () 
        | TPM_Designated(i) -> () (* handled above *) 
        | TPM_InstallByDefault
!       | TPM_NotInLog -> ()
        ) m.mod_flags ; 
        List.iter (fun a -> match a with
          | TP_Require_File(file,warn) ->
            begin
!             if (file_exists file) then 
                ()
!             else preproc_fail "SKIPPING" warn can_uninstall 
            end
          | TP_Forbid_File(file,warn) ->
            begin
!             if (file_exists file) then 
!               preproc_fail "SKIPPING" warn can_uninstall
              else 
                ()
            end
          | _ -> ()
        ) m.mod_parts ; 
        let finished = ref false in 
!       let handle_error = handle_error_generic always_yes finished
          package_name in 
        Dc.clear_state () ; 
        match !def with
        | TP_Install ->
          begin try 
!           handle_letter tp "Y" can_uninstall package_name m finished !current ;
            with e -> handle_error e  
          end 
        | TP_Uninstall ->
          begin try
!           handle_letter tp "U" can_uninstall package_name m finished !current ;
            with e -> handle_error e
          end 
        | TP_Skip -> 
              (*
              log_and_print "\nSkipping Component [%s] %d\n" 
              (package_name) !current ; 
--- 6524,6571 ----
          begin
            if is_true (eval_pe game p) then
              ()
!           else preproc_fail "SKIPPING" warn can_uninstall true
          end
!       | TPM_SubComponents(ts,_,_) -> ()
        | TPM_Designated(i) -> () (* handled above *)
        | TPM_InstallByDefault
!       | TPM_NotInLog
!       | TPM_Group (_)  -> ()
        ) m.mod_flags ;
        List.iter (fun a -> match a with
          | TP_Require_File(file,warn) ->
            begin
!             if (bigg_file_exists file game.Load.key) then
                ()
!             else preproc_fail "SKIPPING" warn can_uninstall false
            end
          | TP_Forbid_File(file,warn) ->
            begin
!             if (bigg_file_exists file game.Load.key) then
!               preproc_fail "SKIPPING" warn can_uninstall true
              else
                ()
            end
          | _ -> ()
        ) m.mod_parts ;
        let finished = ref false in
!       let handle_error = handle_error_generic always_yes specified_specific_components finished
          package_name in
        Dc.clear_state () ;
        match !def with
        | TP_Install ->
          begin try
!           handle_letter tp "Y" can_uninstall temp_uninst package_name m finished !current ;
            with e -> handle_error e
          end
        | TP_Uninstall ->
          begin try
!           handle_letter tp "U" can_uninstall temp_uninst package_name m finished !current ;
            with e -> handle_error e
          end
        | TP_Skip ->
+       		if temp_uninst then
+       			handle_letter tp "I" can_uninstall temp_uninst package_name m finished !current;
              (*
              log_and_print "\nSkipping Component [%s] %d\n"
              (package_name) !current ;
***************
*** 3924,3931 ****
            | hd :: tl -> process tl
            | [] -> ()
            in process m.mod_flags ;
!           let package_name = Dc.single_string_of_tlk_string game m.mod_name in 
!           let handle_error = handle_error_generic (ref false) (ref true)
              package_name in 
            try 
              let _ = Str.search_forward reg package_name 0 in
--- 6601,6608 ----
            | hd :: tl -> process tl
            | [] -> ()
            in process m.mod_flags ;
!           let package_name = Dc.single_string_of_tlk_string_safe game m.mod_name in 
!           let handle_error = handle_error_generic (ref false) (ref false) (ref true)
              package_name in
            try 
              let _ = Str.search_forward reg package_name 0 in
***************
*** 3967,3972 ****
--- 6644,6650 ----
          Dc.push_trans ();
          init_default_strings () ; 
          Var.set_string "TP2_AUTHOR" tp2.author ;
+         Var.set_string "TP2_FILE_NAME" tp2.tp_filename;
          (try
            let l = List.nth tp2.languages b in
            our_lang := Some(l) ;
***************
*** 3974,3986 ****
          (*  log_and_print "Re-Installing Using Language [%s]\n" l.lang_name ;*)
            log_and_print "%s [%s]\n" ((get_trans (-1012))) l.lang_name ; 
            Var.set_string "LANGUAGE" l.lang_dir_name ; 
!           List.iter handle_tra_filename l.lang_tra_files
          with _ -> 
            our_lang := None ; 
            our_lang_index := 0 ;
            () ) ;
          let m = get_nth_module tp2 c true in 
!         let package_name = Dc.single_string_of_tlk_string game m.mod_name in 
          let fails_requirements = List.exists (fun f -> match f with 
            | TPM_RequireComponent(s,i,warn) -> 
              begin
--- 6652,6665 ----
          (*  log_and_print "Re-Installing Using Language [%s]\n" l.lang_name ;*)
            log_and_print "%s [%s]\n" ((get_trans (-1012))) l.lang_name ;
            Var.set_string "LANGUAGE" l.lang_dir_name ;
!           Var.set_string "TP2_FILE_NAME" tp2.tp_filename ;
!           List.iter handle_tra_filename (List.map Arch.backslash_to_slash l.lang_tra_files)
          with _ -> 
            our_lang := None ; 
            our_lang_index := 0 ;
            () ) ;
          let m = get_nth_module tp2 c true in 
!         let package_name = Dc.single_string_of_tlk_string_safe game m.mod_name in 
          let fails_requirements = List.exists (fun f -> match f with
            | TPM_RequireComponent(s,i,warn) ->
              begin
***************
*** 3991,4004 ****
                  true
                end 
              end
            | _ -> false) m.mod_flags 
          in 
          begin 
          if fails_requirements then begin 
!           handle_letter tp2 "U" false package_name m (ref false) c ;
            re_installed := !re_installed @ [(a,b,c,sopt,Permanently_Uninstalled)] ;
          end else begin 
!           handle_letter tp2 "R" false package_name m (ref false) c ;
            re_installed := !re_installed @ [(a,b,c,sopt,Installed)] ;
          end  
          end ; 
--- 6670,6728 ----
                  true
                end 
              end
+           | TPM_ForbidComponent(s,i,warn) ->
+             begin
+               if not (already_installed s i) then
+                 false
+               else begin
+                 log_and_print "\n[%s] component %d %s fails component requirements, *not* Re-Installing.\n" a c (str_of_str_opt sopt);
+                 true
+               end
+             end
+           | TPM_Deprecated(warn) -> begin
+               log_and_print "\n[%s] component %d %s is deprecated, *not* Re-Installing.\n" a c (str_of_str_opt sopt);
+               true
+             end
+           | TPM_RequirePredicate(p,warn) ->
+             begin
+               if is_true (eval_pe game p) then
+                 false
+               else begin
+                 log_and_print "\n[%s] component %d %s fails component requirements, *not* Re-Installing.\n" a c (str_of_str_opt sopt);
+                 true
+               end
+             end
            | _ -> false) m.mod_flags
+           ||
+           List.exists (fun f -> match f with
+             | TP_Require_File(file,warn) ->
+               begin
+                 if (bigg_file_exists file game.Load.key) then
+                   false
+                 else begin
+                   log_and_print "\n[%s] component %d %s fails component requirements, *not* Re-Installing.\n" a c (str_of_str_opt sopt);
+                   true
+                 end
+               end
+             | TP_Forbid_File(file,warn) ->
+               begin
+                 if (bigg_file_exists file game.Load.key) then begin
+                   log_and_print "\n[%s] component %d %s fails component requirements, *not* Re-Installing.\n" a c (str_of_str_opt sopt);
+                   true
+                 end
+                 else
+                   false
+               end
+             | _ -> false
+           ) m.mod_parts
+ 
          in
          begin
          if fails_requirements then begin
!           handle_letter tp2 "U" false false package_name m (ref false) c ;
            re_installed := !re_installed @ [(a,b,c,sopt,Permanently_Uninstalled)] ;
          end else begin
!           handle_letter tp2 "R" false false package_name m (ref false) c ;
            re_installed := !re_installed @ [(a,b,c,sopt,Installed)] ;
          end
          end ; 
***************
*** 4016,4022 ****
  
    the_log := result ; 
  
!   save_log game handle_tp2_filename handle_tra_filename ; 
  
    Load.allow_missing := old_allow_missing ; 
    game.Load.script_style <- old_script_style ; 
--- 6740,6746 ----
  
    the_log := result ; 
  
!   save_log game handle_tp2_filename handle_tra_filename get_tra_list_filename ;
  
    Load.allow_missing := old_allow_missing ;
    game.Load.script_style <- old_script_style ; 
